/* ClockApplet.c generated by valac 0.40.19, the Vala compiler
 * generated from ClockApplet.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2014-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <libpeas/peas.h>
#include "plugin.h"
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gdesktopappinfo.h>


#define TYPE_CLOCK_PLUGIN (clock_plugin_get_type ())
#define CLOCK_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK_PLUGIN, ClockPlugin))
#define CLOCK_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK_PLUGIN, ClockPluginClass))
#define IS_CLOCK_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK_PLUGIN))
#define IS_CLOCK_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK_PLUGIN))
#define CLOCK_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK_PLUGIN, ClockPluginClass))

typedef struct _ClockPlugin ClockPlugin;
typedef struct _ClockPluginClass ClockPluginClass;
typedef struct _ClockPluginPrivate ClockPluginPrivate;
enum  {
	CLOCK_PLUGIN_0_PROPERTY,
	CLOCK_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* clock_plugin_properties[CLOCK_PLUGIN_NUM_PROPERTIES];

#define TYPE_CLOCK_APPLET (clock_applet_get_type ())
#define CLOCK_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK_APPLET, ClockApplet))
#define CLOCK_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK_APPLET, ClockAppletClass))
#define IS_CLOCK_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK_APPLET))
#define IS_CLOCK_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK_APPLET))
#define CLOCK_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK_APPLET, ClockAppletClass))

typedef struct _ClockApplet ClockApplet;
typedef struct _ClockAppletClass ClockAppletClass;
typedef enum  {
	CLOCK_FORMAT_TWENTYFOUR = 0,
	CLOCK_FORMAT_TWELVE = 1
} ClockFormat;


#define TYPE_CLOCK_FORMAT (clock_format_get_type ())
typedef struct _ClockAppletPrivate ClockAppletPrivate;
enum  {
	CLOCK_APPLET_0_PROPERTY,
	CLOCK_APPLET_NUM_PROPERTIES
};
static GParamSpec* clock_applet_properties[CLOCK_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ClockPlugin {
	PeasExtensionBase parent_instance;
	ClockPluginPrivate * priv;
};

struct _ClockPluginClass {
	PeasExtensionBaseClass parent_class;
};

struct _ClockApplet {
	BudgieApplet parent_instance;
	ClockAppletPrivate * priv;
	GtkEventBox* widget;
	GtkBox* layout;
	GtkLabel* clock;
	GtkLabel* date_label;
	GtkLabel* seconds_label;
	gboolean ampm;
	GSettings* settings;
};

struct _ClockAppletClass {
	BudgieAppletClass parent_class;
};

struct _ClockAppletPrivate {
	GDateTime* time;
	BudgiePopover* popover;
	GAppInfo* calprov;
	GtkButton* cal_button;
	GtkCheckButton* clock_format;
	GtkCheckButton* check_seconds;
	GtkCheckButton* check_date;
	gulong check_id;
	GtkOrientation orient;
	BudgiePopoverManager* manager;
};

struct _Block1Data {
	int _ref_count_;
	ClockApplet* self;
	GtkStack* stack;
};


static gpointer clock_plugin_parent_class = NULL;
static BudgiePluginIface * clock_plugin_budgie_plugin_parent_iface = NULL;
static GType clock_plugin_type_id = 0;
static gpointer clock_applet_parent_class = NULL;
static GType clock_applet_type_id = 0;

GType clock_plugin_register_type (GTypeModule * module);
GType clock_plugin_get_type (void) G_GNUC_CONST;
static BudgieApplet* clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                  const gchar* uuid);
ClockApplet* clock_applet_new (void);
ClockApplet* clock_applet_construct (GType object_type);
GType clock_applet_register_type (GTypeModule * module);
GType clock_applet_get_type (void) G_GNUC_CONST;
ClockPlugin* clock_plugin_new (void);
ClockPlugin* clock_plugin_construct (GType object_type);
GType clock_format_get_type (void) G_GNUC_CONST;
#define CALENDAR_MIME "text/calendar"
#define CLOCK_APPLET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CLOCK_APPLET, ClockAppletPrivate))
static GtkButton* clock_applet_new_directional_button (ClockApplet* self,
                                                const gchar* label_str,
                                                GtkPositionType arrow_direction);
static GtkButton* clock_applet_new_plain_button (ClockApplet* self,
                                          const gchar* label_str);
static void clock_applet_real_panel_position_changed (BudgieApplet* base,
                                               BudgiePanelPosition position);
gboolean clock_applet_update_clock (ClockApplet* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void clock_applet_on_date_activate (ClockApplet* self);
static void _clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void clock_applet_on_cal_activate (ClockApplet* self);
static void _clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda5_ (ClockApplet* self);
static void ___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda7_ (Block1Data* _data1_);
static void ___lambda7__budgie_popover_closed (BudgiePopover* _sender,
                                        gpointer self);
static gboolean __lambda8_ (ClockApplet* self,
                     GdkEventButton* e);
static gboolean ___lambda8__gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self);
static gboolean _clock_applet_update_clock_gsource_func (gpointer self);
void clock_applet_on_settings_change (ClockApplet* self,
                                      const gchar* key);
static void _clock_applet_on_settings_change_g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static void clock_applet_update_cal (ClockApplet* self);
static void _clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                          gpointer self);
static void clock_applet_real_update_popovers (BudgieApplet* base,
                                        BudgiePopoverManager* manager);
void clock_applet_update_date (ClockApplet* self);
void clock_applet_update_seconds (ClockApplet* self);
static void clock_applet_finalize (GObject * obj);
void peas_register_types (GTypeModule* module);
GType clock_plugin_register_type (GTypeModule * module);
GType clock_applet_register_type (GTypeModule * module);


static BudgieApplet*
clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                    const gchar* uuid)
{
	ClockPlugin * self;
	BudgieApplet* result = NULL;
	ClockApplet* _tmp0_;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) base;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = clock_applet_new ();
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 209 "ClockApplet.c"
}


ClockPlugin*
clock_plugin_construct (GType object_type)
{
	ClockPlugin * self = NULL;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) g_object_new (object_type, NULL);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return self;
#line 221 "ClockApplet.c"
}


ClockPlugin*
clock_plugin_new (void)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return clock_plugin_construct (TYPE_CLOCK_PLUGIN);
#line 230 "ClockApplet.c"
}


static void
clock_plugin_class_init (ClockPluginClass * klass)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_plugin_parent_class = g_type_class_peek_parent (klass);
#line 239 "ClockApplet.c"
}


static void
clock_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) clock_plugin_real_get_panel_widget;
#line 250 "ClockApplet.c"
}


static void
clock_plugin_instance_init (ClockPlugin * self)
{
}


GType
clock_plugin_get_type (void)
{
	return clock_plugin_type_id;
}


GType
clock_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockPlugin), 0, (GInstanceInitFunc) clock_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) clock_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	clock_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "ClockPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, clock_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return clock_plugin_type_id;
}


GType
clock_format_get_type (void)
{
	static volatile gsize clock_format_type_id__volatile = 0;
	if (g_once_init_enter (&clock_format_type_id__volatile)) {
		static const GEnumValue values[] = {{CLOCK_FORMAT_TWENTYFOUR, "CLOCK_FORMAT_TWENTYFOUR", "twentyfour"}, {CLOCK_FORMAT_TWELVE, "CLOCK_FORMAT_TWELVE", "twelve"}, {0, NULL, NULL}};
		GType clock_format_type_id;
		clock_format_type_id = g_enum_register_static ("ClockFormat", values);
		g_once_init_leave (&clock_format_type_id__volatile, clock_format_type_id);
	}
	return clock_format_type_id__volatile;
}


static GtkButton*
clock_applet_new_directional_button (ClockApplet* self,
                                     const gchar* label_str,
                                     GtkPositionType arrow_direction)
{
	GtkButton* result = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp2_;
	GtkButton* button = NULL;
	GtkButton* _tmp3_;
	GtkImage* image = NULL;
	GtkImage* _tmp4_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkButton* _tmp24_;
	GtkBox* _tmp25_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	box = _tmp0_;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = box;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_FILL);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (label_str);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	label = _tmp2_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp3_ = (GtkButton*) gtk_button_new ();
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	button = _tmp3_;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp4_ = (GtkImage*) gtk_image_new ();
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp4_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	image = _tmp4_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (arrow_direction == GTK_POS_RIGHT) {
#line 349 "ClockApplet.c"
		GtkImage* _tmp5_;
		GtkBox* _tmp6_;
		GtkLabel* _tmp7_;
		GtkBox* _tmp8_;
		GtkImage* _tmp9_;
		GtkImage* _tmp10_;
		GtkLabel* _tmp11_;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp5_ = image;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_image_set_from_icon_name (_tmp5_, "go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp6_ = box;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp7_ = label;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_box_pack_start (_tmp6_, (GtkWidget*) _tmp7_, TRUE, TRUE, (guint) 0);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp8_ = box;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp9_ = image;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_box_pack_end (_tmp8_, (GtkWidget*) _tmp9_, FALSE, FALSE, (guint) 1);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp10_ = image;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp10_, 6);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp11_ = label;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 6);
#line 381 "ClockApplet.c"
	} else {
		GtkImage* _tmp12_;
		GtkBox* _tmp13_;
		GtkImage* _tmp14_;
		GtkBox* _tmp15_;
		GtkLabel* _tmp16_;
		GtkImage* _tmp17_;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp12_ = image;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_image_set_from_icon_name (_tmp12_, "go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp13_ = box;
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp14_ = image;
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp15_ = box;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp16_ = label;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp17_ = image;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 6);
#line 409 "ClockApplet.c"
	}
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp18_ = label;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp19_ = label;
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp19_, "margin", 0, NULL);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp20_ = box;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp20_, "margin", 0, NULL);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp21_ = box;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp21_, (guint) 0);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp22_ = button;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_FLAT);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp24_ = button;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp25_ = box;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	result = button;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (image);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (label);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (box);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 449 "ClockApplet.c"
}


static GtkButton*
clock_applet_new_plain_button (ClockApplet* self,
                               const gchar* label_str)
{
	GtkButton* result = NULL;
	GtkButton* ret = NULL;
	GtkButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label (label_str);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	ret = _tmp0_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) ret);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_halign (_tmp1_, GTK_ALIGN_START);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) ret);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	result = ret;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 484 "ClockApplet.c"
}


static void
clock_applet_real_panel_position_changed (BudgieApplet* base,
                                          BudgiePanelPosition position)
{
	ClockApplet * self;
	gboolean _tmp0_ = FALSE;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkOrientation _tmp3_;
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 503 "ClockApplet.c"
	} else {
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 507 "ClockApplet.c"
	}
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_VERTICAL;
#line 513 "ClockApplet.c"
	} else {
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 517 "ClockApplet.c"
	}
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->seconds_label;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_label_set_text (_tmp1_, "");
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = self->layout;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->priv->orient;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp2_, _tmp3_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 531 "ClockApplet.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return _data1_;
#line 542 "ClockApplet.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 553 "ClockApplet.c"
		ClockApplet* self;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		self = _data1_->self;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (_data1_->stack);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (self);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_slice_free (Block1Data, _data1_);
#line 563 "ClockApplet.c"
	}
}


static void
_clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_on_date_activate ((ClockApplet*) self);
#line 574 "ClockApplet.c"
}


static void
_clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_on_cal_activate ((ClockApplet*) self);
#line 584 "ClockApplet.c"
}


static void
__lambda4_ (Block1Data* _data1_)
{
	ClockApplet* self;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = _data1_->self;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_set_visible_child_name (_data1_->stack, "prefs");
#line 596 "ClockApplet.c"
}


static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	__lambda4_ (self);
#line 606 "ClockApplet.c"
}


static void
__lambda5_ (ClockApplet* self)
{
	ClockFormat f = 0;
	GSettings* _tmp0_;
	ClockFormat _tmp1_ = 0;
	ClockFormat _tmp2_;
	ClockFormat newf = 0;
	GSettings* _tmp3_;
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->settings;
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	f = (ClockFormat) g_settings_get_enum (_tmp0_, "clock-format");
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = f;
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp2_ == CLOCK_FORMAT_TWELVE) {
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp1_ = CLOCK_FORMAT_TWENTYFOUR;
#line 629 "ClockApplet.c"
	} else {
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp1_ = CLOCK_FORMAT_TWELVE;
#line 633 "ClockApplet.c"
	}
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	newf = _tmp1_;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->settings;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_settings_set_enum (_tmp3_, "clock-format", (gint) newf);
#line 641 "ClockApplet.c"
}


static void
___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	__lambda5_ ((ClockApplet*) self);
#line 651 "ClockApplet.c"
}


static void
__lambda6_ (Block1Data* _data1_)
{
	ClockApplet* self;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = _data1_->self;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_set_visible_child_name (_data1_->stack, "root");
#line 663 "ClockApplet.c"
}


static void
___lambda6__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	__lambda6_ (self);
#line 673 "ClockApplet.c"
}


static void
__lambda7_ (Block1Data* _data1_)
{
	ClockApplet* self;
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = _data1_->self;
#line 202 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_set_visible_child_name (_data1_->stack, "root");
#line 685 "ClockApplet.c"
}


static void
___lambda7__budgie_popover_closed (BudgiePopover* _sender,
                                   gpointer self)
{
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	__lambda7_ (self);
#line 695 "ClockApplet.c"
}


static gboolean
__lambda8_ (ClockApplet* self,
            GdkEventButton* e)
{
	gboolean result = FALSE;
	guint _tmp0_;
	BudgiePopover* _tmp1_;
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = e->button;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp0_ != ((guint) 1)) {
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return result;
#line 716 "ClockApplet.c"
	}
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->popover;
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp1_)) {
#line 722 "ClockApplet.c"
		BudgiePopover* _tmp2_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp2_ = self->priv->popover;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 728 "ClockApplet.c"
	} else {
		BudgiePopoverManager* _tmp3_;
		GtkEventBox* _tmp4_;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = self->priv->manager;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp4_ = self->widget;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		budgie_popover_manager_show_popover (_tmp3_, (GtkWidget*) _tmp4_);
#line 738 "ClockApplet.c"
	}
#line 214 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	result = GDK_EVENT_STOP;
#line 214 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 744 "ClockApplet.c"
}


static gboolean
___lambda8__gtk_widget_button_press_event (GtkWidget* _sender,
                                           GdkEventButton* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda8_ ((ClockApplet*) self, event);
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 757 "ClockApplet.c"
}


static gboolean
_clock_applet_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_applet_update_clock ((ClockApplet*) self);
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 768 "ClockApplet.c"
}


static void
_clock_applet_on_settings_change_g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_on_settings_change ((ClockApplet*) self, key);
#line 779 "ClockApplet.c"
}


static void
_clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                     gpointer self)
{
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_cal ((ClockApplet*) self);
#line 789 "ClockApplet.c"
}


ClockApplet*
clock_applet_construct (GType object_type)
{
	ClockApplet * self = NULL;
	Block1Data* _data1_;
	GtkEventBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkLabel* _tmp2_;
	GDateTime* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkBox* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkBox* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GSettings* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkEventBox* _tmp27_;
	BudgiePopover* _tmp28_;
	GtkStack* _tmp29_;
	GtkStyleContext* _tmp30_;
	BudgiePopover* _tmp31_;
	GtkBox* menu = NULL;
	GtkBox* _tmp32_;
	GtkBox* _tmp33_;
	GtkButton* time_button = NULL;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkBox* _tmp37_;
	GtkBox* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* sub_button = NULL;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	GtkBox* _tmp42_;
	GtkButton* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	GtkBox* _tmp46_;
	GtkCheckButton* _tmp47_;
	GtkCheckButton* _tmp48_;
	GtkWidget* _tmp49_;
	GValue _tmp50_ = {0};
	GSettings* _tmp51_;
	GtkCheckButton* _tmp52_;
	GSettings* _tmp53_;
	GtkLabel* _tmp54_;
	GtkCheckButton* _tmp55_;
	GtkCheckButton* _tmp56_;
	GtkWidget* _tmp57_;
	GValue _tmp58_ = {0};
	GSettings* _tmp59_;
	GtkCheckButton* _tmp60_;
	GSettings* _tmp61_;
	GtkLabel* _tmp62_;
	GtkCheckButton* _tmp63_;
	GtkCheckButton* _tmp64_;
	GtkWidget* _tmp65_;
	GValue _tmp66_ = {0};
	GtkCheckButton* _tmp67_;
	gulong _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkBox* _tmp73_;
	GtkSeparator* _tmp74_;
	GtkSeparator* _tmp75_;
	GtkBox* _tmp76_;
	GtkCheckButton* _tmp77_;
	GtkBox* _tmp78_;
	GtkCheckButton* _tmp79_;
	GtkBox* _tmp80_;
	GtkCheckButton* _tmp81_;
	GtkBox* _tmp82_;
	BudgiePopover* _tmp83_;
	GtkEventBox* _tmp84_;
	GSettings* _tmp85_;
	GAppInfo* _tmp86_;
	GAppInfoMonitor* monitor = NULL;
	GAppInfoMonitor* _tmp87_;
	GtkButton* _tmp88_;
	GAppInfo* _tmp89_;
	GtkButton* _tmp90_;
	GtkEventBox* _tmp91_;
	BudgiePopover* _tmp92_;
	GtkWidget* _tmp93_;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_data1_->_ref_count_ = 1;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) g_object_new (object_type, NULL);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_data1_->self = g_object_ref (self);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = (GtkEventBox*) gtk_event_box_new ();
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->widget = _tmp0_;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp1_);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->layout = _tmp1_;
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new ("");
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->clock = _tmp2_;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp3_ = g_date_time_new_now_local ();
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->time = _tmp3_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->widget;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp5_ = self->layout;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->layout;
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp7_ = self->clock;
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp6_, (GtkWidget*) _tmp7_, FALSE, FALSE, (guint) 0);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp8_ = self->layout;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp8_, "margin", 0, NULL);
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp9_ = self->layout;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp9_, (guint) 0);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new ("");
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp10_);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->seconds_label = _tmp10_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp11_ = self->seconds_label;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp12_, "dim-label");
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp13_ = self->layout;
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp14_ = self->seconds_label;
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp15_ = self->seconds_label;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp15_, TRUE);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp16_ = self->seconds_label;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp16_);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new ("");
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp17_);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->date_label = _tmp17_;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp18_ = self->layout;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp19_ = self->date_label;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp18_, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) 0);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp20_ = self->date_label;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp20_, TRUE);
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp21_ = self->date_label;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp21_);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp22_ = self->clock;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp23_ = self->seconds_label;
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp24_ = self->date_label;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_CENTER);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp25_ = g_settings_new ("org.gnome.desktop.interface");
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->settings = _tmp25_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp26_, "budgie-clock-applet");
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp27_ = self->widget;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp28_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp27_);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp28_);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->popover = _tmp28_;
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp29_ = (GtkStack*) gtk_stack_new ();
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp29_);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_data1_->stack = _tmp29_;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _data1_->stack);
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp30_, "clock-applet-stack");
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp31_ = self->priv->popover;
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _data1_->stack);
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_set_homogeneous (_data1_->stack, TRUE);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_set_transition_type (_data1_->stack, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp32_);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	menu = _tmp32_;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp33_ = menu;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp33_, (guint) 6);
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp34_ = clock_applet_new_plain_button (self, _ ("Time and date settings"));
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	time_button = _tmp34_;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp35_ = clock_applet_new_plain_button (self, _ ("Calendar"));
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->cal_button = _tmp35_;
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (time_button, "clicked", (GCallback) _clock_applet_on_date_activate_gtk_button_clicked, self, 0);
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp36_ = self->priv->cal_button;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) _clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp37_ = menu;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp37_, (GtkWidget*) time_button, FALSE, FALSE, (guint) 0);
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp38_ = menu;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp39_ = self->priv->cal_button;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp38_, (GtkWidget*) _tmp39_, FALSE, FALSE, (guint) 0);
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp40_ = clock_applet_new_directional_button (self, _ ("Preferences"), GTK_POS_RIGHT);
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	sub_button = _tmp40_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp41_ = sub_button;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_data (_tmp41_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp42_ = menu;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp43_ = sub_button;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_end (_tmp42_, (GtkWidget*) _tmp43_, FALSE, FALSE, (guint) 2);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp44_ = menu;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_add_named (_data1_->stack, (GtkWidget*) _tmp44_, "root");
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp45_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp45_);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (menu);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	menu = _tmp45_;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp46_ = menu;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp46_, (guint) 6);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp47_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Show date"));
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp47_);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->check_date);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->check_date = _tmp47_;
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp48_ = self->priv->check_date;
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp49_ = gtk_bin_get_child ((GtkBin*) _tmp48_);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_init (&_tmp50_, G_TYPE_INT);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_set_int (&_tmp50_, 8);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set_property ((GObject*) _tmp49_, "margin-start", &_tmp50_);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	G_IS_VALUE (&_tmp50_) ? (g_value_unset (&_tmp50_), NULL) : NULL;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp51_ = self->settings;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp52_ = self->priv->check_date;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_settings_bind (_tmp51_, "clock-show-date", (GObject*) _tmp52_, "active", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_SET);
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp53_ = self->settings;
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp54_ = self->date_label;
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_settings_bind (_tmp53_, "clock-show-date", (GObject*) _tmp54_, "visible", G_SETTINGS_BIND_DEFAULT);
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp55_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Show seconds"));
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp55_);
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->check_seconds);
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->check_seconds = _tmp55_;
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp56_ = self->priv->check_seconds;
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp57_ = gtk_bin_get_child ((GtkBin*) _tmp56_);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_init (&_tmp58_, G_TYPE_INT);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_set_int (&_tmp58_, 8);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set_property ((GObject*) _tmp57_, "margin-start", &_tmp58_);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	G_IS_VALUE (&_tmp58_) ? (g_value_unset (&_tmp58_), NULL) : NULL;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp59_ = self->settings;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp60_ = self->priv->check_seconds;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_settings_bind (_tmp59_, "clock-show-seconds", (GObject*) _tmp60_, "active", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_SET);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp61_ = self->settings;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp62_ = self->seconds_label;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_settings_bind (_tmp61_, "clock-show-seconds", (GObject*) _tmp62_, "visible", G_SETTINGS_BIND_DEFAULT);
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp63_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use 24 hour time"));
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp63_);
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->clock_format);
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->clock_format = _tmp63_;
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp64_ = self->priv->clock_format;
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp65_ = gtk_bin_get_child ((GtkBin*) _tmp64_);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_init (&_tmp66_, G_TYPE_INT);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_value_set_int (&_tmp66_, 8);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_set_property ((GObject*) _tmp65_, "margin-start", &_tmp66_);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	G_IS_VALUE (&_tmp66_) ? (g_value_unset (&_tmp66_), NULL) : NULL;
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp67_ = self->priv->clock_format;
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp68_ = g_signal_connect_object ((GtkToggleButton*) _tmp67_, "toggled", (GCallback) ___lambda5__gtk_toggle_button_toggled, self, G_CONNECT_AFTER);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->check_id = _tmp68_;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp69_ = clock_applet_new_directional_button (self, _ ("Preferences"), GTK_POS_LEFT);
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (sub_button);
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	sub_button = _tmp69_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp70_ = sub_button;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_data (_tmp70_, "clicked", (GCallback) ___lambda6__gtk_button_clicked, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp71_ = menu;
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp72_ = sub_button;
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp71_, (GtkWidget*) _tmp72_, FALSE, FALSE, (guint) 0);
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp73_ = menu;
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp74_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp74_);
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp75_ = _tmp74_;
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp73_, (GtkWidget*) _tmp75_, FALSE, FALSE, (guint) 2);
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (_tmp75_);
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp76_ = menu;
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp77_ = self->priv->check_date;
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp76_, (GtkWidget*) _tmp77_, FALSE, FALSE, (guint) 0);
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp78_ = menu;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp79_ = self->priv->check_seconds;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp78_, (GtkWidget*) _tmp79_, FALSE, FALSE, (guint) 0);
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp80_ = menu;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp81_ = self->priv->clock_format;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp80_, (GtkWidget*) _tmp81_, FALSE, FALSE, (guint) 0);
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp82_ = menu;
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_stack_add_named (_data1_->stack, (GtkWidget*) _tmp82_, "prefs");
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp83_ = self->priv->popover;
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_data (_tmp83_, "closed", (GCallback) ___lambda7__budgie_popover_closed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp84_ = self->widget;
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp84_, "button-press-event", (GCallback) ___lambda8__gtk_widget_button_press_event, self, 0);
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 1, _clock_applet_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp85_ = self->settings;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp85_, "changed", (GCallback) _clock_applet_on_settings_change_g_settings_changed, self, 0);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp86_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->calprov = _tmp86_;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp87_ = g_app_info_monitor_get ();
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	monitor = _tmp87_;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (monitor, "changed", (GCallback) _clock_applet_update_cal_g_app_info_monitor_changed, self, 0);
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp88_ = self->priv->cal_button;
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp89_ = self->priv->calprov;
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp88_, _tmp89_ != NULL);
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp90_ = self->priv->cal_button;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp90_, "clicked", (GCallback) _clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_cal (self);
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp91_ = self->widget;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp91_);
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_on_settings_change (self, "clock-format");
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp92_ = self->priv->popover;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp93_ = gtk_bin_get_child ((GtkBin*) _tmp92_);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_show_all (_tmp93_);
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (monitor);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (sub_button);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (time_button);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (menu);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	block1_data_unref (_data1_);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_data1_ = NULL;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return self;
#line 1328 "ClockApplet.c"
}


ClockApplet*
clock_applet_new (void)
{
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return clock_applet_construct (TYPE_CLOCK_APPLET);
#line 1337 "ClockApplet.c"
}


static void
clock_applet_update_cal (ClockApplet* self)
{
	GAppInfo* _tmp0_;
	GtkButton* _tmp1_;
	GAppInfo* _tmp2_;
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 241 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 241 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 241 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->calprov = _tmp0_;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->cal_button;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->calprov;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 1361 "ClockApplet.c"
}


static void
clock_applet_on_date_activate (ClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 247 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 247 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = g_desktop_app_info_new ("gnome-datetime-panel.desktop");
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	app_info = _tmp1_;
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = app_info;
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp2_ == NULL) {
#line 251 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 251 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1391 "ClockApplet.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = app_info;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1401 "ClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		e = _inner_error0_;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_inner_error0_ = NULL;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp4_ = e;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp5_ = _tmp4_->message;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_message ("ClockApplet.vala:256: Unable to launch gnome-datetime-panel.desktop: %" \
"s", _tmp5_);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_error_free0 (e);
#line 1423 "ClockApplet.c"
	}
	__finally0:
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1436 "ClockApplet.c"
	}
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (app_info);
#line 1440 "ClockApplet.c"
}


static void
clock_applet_on_cal_activate (ClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GAppInfo* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 260 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 264 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->calprov;
#line 264 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp1_ == NULL) {
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1462 "ClockApplet.c"
	}
	{
		GAppInfo* _tmp2_;
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp2_ = self->priv->calprov;
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_app_info_launch (_tmp2_, NULL, NULL, &_inner_error0_);
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1472 "ClockApplet.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GAppInfo* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		e = _inner_error0_;
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_inner_error0_ = NULL;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = self->priv->calprov;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp4_ = g_app_info_get_name (_tmp3_);
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp5_ = e;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp6_ = _tmp5_->message;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_message ("ClockApplet.vala:270: Unable to launch %s: %s", _tmp4_, _tmp6_);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_error_free0 (e);
#line 1500 "ClockApplet.c"
	}
	__finally1:
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1511 "ClockApplet.c"
	}
}


static void
clock_applet_real_update_popovers (BudgieApplet* base,
                                   BudgiePopoverManager* manager)
{
	ClockApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->manager = manager;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->widget;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->popover;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, _tmp1_);
#line 1533 "ClockApplet.c"
}


void
clock_applet_on_settings_change (ClockApplet* self,
                                 const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	static GQuark _tmp1_label0 = 0;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	static GQuark _tmp1_label1 = 0;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	static GQuark _tmp1_label2 = 0;
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = key;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("clock-format")))) {
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		switch (0) {
#line 1561 "ClockApplet.c"
			default:
			{
				GtkCheckButton* _tmp3_;
				gulong _tmp4_;
				ClockFormat f = 0;
				GSettings* _tmp5_;
				ClockFormat _tmp6_;
				GtkCheckButton* _tmp7_;
				ClockFormat _tmp8_;
				GtkCheckButton* _tmp9_;
				gulong _tmp10_;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp3_ = self->priv->clock_format;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp4_ = self->priv->check_id;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				g_signal_handler_block ((void*) _tmp3_, _tmp4_);
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp5_ = self->settings;
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				f = (ClockFormat) g_settings_get_enum (_tmp5_, key);
#line 286 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp6_ = f;
#line 286 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				self->ampm = _tmp6_ == CLOCK_FORMAT_TWELVE;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp7_ = self->priv->clock_format;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp8_ = f;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, _tmp8_ == CLOCK_FORMAT_TWENTYFOUR);
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				clock_applet_update_clock (self);
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp9_ = self->priv->clock_format;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				_tmp10_ = self->priv->check_id;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				g_signal_handler_unblock ((void*) _tmp9_, _tmp10_);
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				break;
#line 1603 "ClockApplet.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("clock-show-seconds")))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("clock-show-date"))))) {
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		switch (0) {
#line 1609 "ClockApplet.c"
			default:
			{
#line 293 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				clock_applet_update_clock (self);
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
				break;
#line 1616 "ClockApplet.c"
			}
		}
	}
}


/**
     * Update the date if necessary
     */
void
clock_applet_update_date (ClockApplet* self)
{
	GtkCheckButton* _tmp0_;
	gchar* ftime = NULL;
	GtkOrientation _tmp1_;
	gchar* old = NULL;
	GtkLabel* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* ctime = NULL;
	GDateTime* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
#line 302 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->check_date;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1652 "ClockApplet.c"
	}
#line 308 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->orient;
#line 308 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1658 "ClockApplet.c"
		gchar* _tmp2_;
#line 309 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("%x");
#line 309 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 309 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1666 "ClockApplet.c"
	} else {
		gchar* _tmp3_;
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = g_strdup ("<small>%b %d</small>");
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp3_;
#line 1675 "ClockApplet.c"
	}
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->date_label;
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp5_ = gtk_label_get_label (_tmp4_);
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	old = _tmp6_;
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp7_ = self->priv->time;
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp8_ = ftime;
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp9_ = g_date_time_format (_tmp7_, _tmp8_);
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	ctime = _tmp9_;
#line 317 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp10_ = old;
#line 317 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp11_ = ctime;
#line 317 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1707 "ClockApplet.c"
	}
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp12_ = self->date_label;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp13_ = ctime;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp12_, _tmp13_);
#line 302 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 302 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 302 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1721 "ClockApplet.c"
}


/**
     * Update the seconds if necessary
     */
void
clock_applet_update_seconds (ClockApplet* self)
{
	GtkCheckButton* _tmp0_;
	gchar* ftime = NULL;
	GtkOrientation _tmp1_;
	gchar* old = NULL;
	GtkLabel* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* ctime = NULL;
	GDateTime* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->check_seconds;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1754 "ClockApplet.c"
	}
#line 333 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->orient;
#line 333 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1760 "ClockApplet.c"
		gchar* _tmp2_;
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("");
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1768 "ClockApplet.c"
	} else {
		gchar* _tmp3_;
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = g_strdup ("<big>%S</big>");
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp3_;
#line 1777 "ClockApplet.c"
	}
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->date_label;
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp5_ = gtk_label_get_label (_tmp4_);
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	old = _tmp6_;
#line 341 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp7_ = self->priv->time;
#line 341 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp8_ = ftime;
#line 341 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp9_ = g_date_time_format (_tmp7_, _tmp8_);
#line 341 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	ctime = _tmp9_;
#line 342 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp10_ = old;
#line 342 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp11_ = ctime;
#line 342 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return;
#line 1809 "ClockApplet.c"
	}
#line 346 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp12_ = self->seconds_label;
#line 346 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp13_ = ctime;
#line 346 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp12_, _tmp13_);
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1823 "ClockApplet.c"
}


/**
     * This is called once every second, updating the time
     */
gboolean
clock_applet_update_clock (ClockApplet* self)
{
	gboolean result = FALSE;
	GDateTime* _tmp0_;
	gchar* format = NULL;
	gboolean _tmp1_;
	GtkOrientation _tmp4_;
	gboolean _tmp8_;
	gchar* ftime = NULL;
	GtkOrientation _tmp11_;
	gchar* old = NULL;
	GtkLabel* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* ctime = NULL;
	GDateTime* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GtkLabel* _tmp24_;
	const gchar* _tmp25_;
#line 352 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->time = _tmp0_;
#line 358 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->ampm;
#line 358 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp1_) {
#line 1865 "ClockApplet.c"
		gchar* _tmp2_;
#line 359 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("%l:%M");
#line 359 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 359 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		format = _tmp2_;
#line 1873 "ClockApplet.c"
	} else {
		gchar* _tmp3_;
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp3_ = g_strdup ("%H:%M");
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		format = _tmp3_;
#line 1882 "ClockApplet.c"
	}
#line 364 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->priv->orient;
#line 364 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp4_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1888 "ClockApplet.c"
		GtkCheckButton* _tmp5_;
#line 365 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp5_ = self->priv->check_seconds;
#line 365 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_)) {
#line 1894 "ClockApplet.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 366 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
			_tmp6_ = format;
#line 366 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
			_tmp7_ = g_strconcat (_tmp6_, ":%S", NULL);
#line 366 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
			_g_free0 (format);
#line 366 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
			format = _tmp7_;
#line 1905 "ClockApplet.c"
		}
	}
#line 370 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp8_ = self->ampm;
#line 370 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp8_) {
#line 1912 "ClockApplet.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 371 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp9_ = format;
#line 371 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp10_ = g_strconcat (_tmp9_, " %p", NULL);
#line 371 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 371 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		format = _tmp10_;
#line 1923 "ClockApplet.c"
	}
#line 375 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp11_ = self->priv->orient;
#line 375 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (_tmp11_ == GTK_ORIENTATION_HORIZONTAL) {
#line 1929 "ClockApplet.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 376 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp12_ = format;
#line 376 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp13_ = g_strdup_printf (" %s ", _tmp12_);
#line 376 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 376 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp13_;
#line 1940 "ClockApplet.c"
	} else {
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp14_ = format;
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_tmp15_ = g_strdup_printf (" <small>%s</small> ", _tmp14_);
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		ftime = _tmp15_;
#line 1952 "ClockApplet.c"
	}
#line 381 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_date (self);
#line 382 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_update_seconds (self);
#line 385 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp16_ = self->clock;
#line 385 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp17_ = gtk_label_get_label (_tmp16_);
#line 385 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 385 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	old = _tmp18_;
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp19_ = self->priv->time;
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp20_ = ftime;
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp21_ = g_date_time_format (_tmp19_, _tmp20_);
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	ctime = _tmp21_;
#line 387 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp22_ = old;
#line 387 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp23_ = ctime;
#line 387 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp22_, _tmp23_) == 0) {
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		result = TRUE;
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
		return result;
#line 1992 "ClockApplet.c"
	}
#line 391 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp24_ = self->clock;
#line 391 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp25_ = ctime;
#line 391 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp24_, _tmp25_);
#line 392 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_free0 (format);
#line 394 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return result;
#line 2014 "ClockApplet.c"
}


static void
clock_applet_class_init (ClockAppletClass * klass)
{
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_type_class_add_private (klass, sizeof (ClockAppletPrivate));
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) clock_applet_real_panel_position_changed;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) clock_applet_real_update_popovers;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_applet_finalize;
#line 2031 "ClockApplet.c"
}


static void
clock_applet_instance_init (ClockApplet * self)
{
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv = CLOCK_APPLET_GET_PRIVATE (self);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->ampm = FALSE;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->popover = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->calprov = NULL;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self->priv->manager = NULL;
#line 2050 "ClockApplet.c"
}


static void
clock_applet_finalize (GObject * obj)
{
	ClockApplet * self;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK_APPLET, ClockApplet);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->clock_format);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->check_seconds);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->check_date);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (clock_applet_parent_class)->finalize (obj);
#line 2088 "ClockApplet.c"
}


GType
clock_applet_get_type (void)
{
	return clock_applet_type_id;
}


GType
clock_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockApplet), 0, (GInstanceInitFunc) clock_applet_instance_init, NULL };
	clock_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "ClockApplet", &g_define_type_info, 0);
	return clock_applet_type_id;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 403 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 2113 "ClockApplet.c"
}


void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	g_return_if_fail (module != NULL);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_plugin_register_type (module);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	clock_applet_register_type (module);
#line 403 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 403 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	objmodule = _tmp0_;
#line 404 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_CLOCK_PLUGIN);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (objmodule);
#line 2136 "ClockApplet.c"
}



