/* DesktopHelper.c generated by valac 0.40.19, the Vala compiler
 * generated from DesktopHelper.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <gio/gio.h>
#include <libwnck/libwnck.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>


#define TYPE_DESKTOP_HELPER (desktop_helper_get_type ())
#define DESKTOP_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_HELPER, DesktopHelper))
#define DESKTOP_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_HELPER, DesktopHelperClass))
#define IS_DESKTOP_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_HELPER))
#define IS_DESKTOP_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_HELPER))
#define DESKTOP_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_HELPER, DesktopHelperClass))

typedef struct _DesktopHelper DesktopHelper;
typedef struct _DesktopHelperClass DesktopHelperClass;
typedef struct _DesktopHelperPrivate DesktopHelperPrivate;
enum  {
	DESKTOP_HELPER_0_PROPERTY,
	DESKTOP_HELPER_NUM_PROPERTIES
};
static GParamSpec* desktop_helper_properties[DESKTOP_HELPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_ICON_BUTTON (icon_button_get_type ())
#define ICON_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_BUTTON, IconButton))
#define ICON_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_BUTTON, IconButtonClass))
#define IS_ICON_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_BUTTON))
#define IS_ICON_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_BUTTON))
#define ICON_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_BUTTON, IconButtonClass))

typedef struct _IconButton IconButton;
typedef struct _IconButtonClass IconButtonClass;

#define TYPE_BUTTON_WRAPPER (button_wrapper_get_type ())
#define BUTTON_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUTTON_WRAPPER, ButtonWrapper))
#define BUTTON_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUTTON_WRAPPER, ButtonWrapperClass))
#define IS_BUTTON_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUTTON_WRAPPER))
#define IS_BUTTON_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUTTON_WRAPPER))
#define BUTTON_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUTTON_WRAPPER, ButtonWrapperClass))

typedef struct _ButtonWrapper ButtonWrapper;
typedef struct _ButtonWrapperClass ButtonWrapperClass;
typedef struct _ButtonWrapperPrivate ButtonWrapperPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;

struct _DesktopHelper {
	GObject parent_instance;
	DesktopHelperPrivate * priv;
	gint panel_size;
	gint icon_size;
	GtkOrientation orientation;
	BudgiePanelPosition panel_position;
	gboolean lock_icons;
};

struct _DesktopHelperClass {
	GObjectClass parent_class;
};

struct _DesktopHelperPrivate {
	GSettings* settings;
	WnckScreen* screen;
	GtkBox* icon_layout;
};

struct _ButtonWrapper {
	GtkRevealer parent_instance;
	ButtonWrapperPrivate * priv;
	IconButton* button;
};

struct _ButtonWrapperClass {
	GtkRevealerClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	DesktopHelper* self;
	GList* list;
	WnckClassGroup* class_group;
};


static gpointer desktop_helper_parent_class = NULL;
static GType desktop_helper_type_id = 0;

GType desktop_helper_register_type (GTypeModule * module);
GType desktop_helper_get_type (void) G_GNUC_CONST;
#define DESKTOP_HELPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DESKTOP_HELPER, DesktopHelperPrivate))
DesktopHelper* desktop_helper_new (GSettings* settings,
                                   GtkBox* icon_layout);
DesktopHelper* desktop_helper_construct (GType object_type,
                                         GSettings* settings,
                                         GtkBox* icon_layout);
void desktop_helper_update_pinned (DesktopHelper* self);
GType icon_button_register_type (GTypeModule * module);
GType icon_button_get_type (void) G_GNUC_CONST;
GType button_wrapper_register_type (GTypeModule * module);
GType button_wrapper_get_type (void) G_GNUC_CONST;
gboolean icon_button_is_pinned (IconButton* self);
GDesktopAppInfo* icon_button_get_appinfo (IconButton* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GList* desktop_helper_get_stacked_for_classgroup (DesktopHelper* self,
                                                  WnckClassGroup* class_group);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda19_ (Block1Data* _data1_,
                  WnckWindow* window);
WnckWorkspace* desktop_helper_get_active_workspace (DesktopHelper* self);
static void ___lambda19__gfunc (gconstpointer data,
                         gpointer self);
WnckWindow* desktop_helper_get_active_window (DesktopHelper* self);
static void desktop_helper_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const GtkTargetEntry DESKTOP_HELPER_targets[3] = {{"application/x-icon-tasklist-launcher-id", (guint) 0, (guint) 0}, {"text/uri-list", (guint) 0, (guint) 0}, {"application/x-desktop", (guint) 0, (guint) 0}};

/**
     * Handle initial bootstrap of the desktop helper
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return self ? g_object_ref (self) : NULL;
#line 159 "DesktopHelper.c"
}


DesktopHelper*
desktop_helper_construct (GType object_type,
                          GSettings* settings,
                          GtkBox* icon_layout)
{
	DesktopHelper * self = NULL;
	GSettings* _tmp0_;
	GtkBox* _tmp1_;
	WnckScreen* _tmp2_;
	WnckScreen* _tmp3_;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self = (DesktopHelper*) g_object_new (object_type, NULL);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->settings);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->settings = _tmp0_;
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = _g_object_ref0 (icon_layout);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->icon_layout);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->icon_layout = _tmp1_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp2_ = wnck_screen_get_default ();
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->screen);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->screen = _tmp3_;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return self;
#line 197 "DesktopHelper.c"
}


DesktopHelper*
desktop_helper_new (GSettings* settings,
                    GtkBox* icon_layout)
{
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return desktop_helper_construct (TYPE_DESKTOP_HELPER, settings, icon_layout);
#line 207 "DesktopHelper.c"
}


/**
     * Using our icon_layout, update the per-instance "pinned-launchers" key
     * Keeping with pinned internally for compatibility.
     */
static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	for (i = 0; i < stack_length; i++) {
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			return TRUE;
#line 227 "DesktopHelper.c"
		}
	}
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return FALSE;
#line 232 "DesktopHelper.c"
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	if ((*length) == (*size)) {
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 248 "DesktopHelper.c"
	}
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	(*array)[(*length)++] = value;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	(*array)[*length] = NULL;
#line 254 "DesktopHelper.c"
}


void
desktop_helper_update_pinned (DesktopHelper* self)
{
	gchar** buttons = NULL;
	gchar** _tmp0_;
	gint buttons_length1;
	gint _buttons_size_;
	GtkBox* _tmp1_;
	GList* _tmp2_;
	GSettings* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	buttons = _tmp0_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	buttons_length1 = 0;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_buttons_size_ = buttons_length1;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = self->priv->icon_layout;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 284 "DesktopHelper.c"
	{
		GList* widget_collection = NULL;
		GList* widget_it = NULL;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		widget_collection = _tmp2_;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
#line 292 "DesktopHelper.c"
			GtkWidget* _tmp3_;
			GtkWidget* widget = NULL;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			_tmp3_ = _g_object_ref0 ((GtkWidget*) widget_it->data);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			widget = _tmp3_;
#line 299 "DesktopHelper.c"
			{
				IconButton* button = NULL;
				GtkWidget* _tmp4_;
				IconButton* _tmp5_;
				IconButton* _tmp6_;
				IconButton* _tmp7_;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_tmp4_ = widget;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_tmp5_ = (IS_BUTTON_WRAPPER (_tmp4_) ? ((ButtonWrapper*) _tmp4_) : NULL)->button;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				button = _tmp6_;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_tmp7_ = button;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				if (icon_button_is_pinned (_tmp7_)) {
#line 318 "DesktopHelper.c"
					IconButton* _tmp8_;
					GDesktopAppInfo* _tmp9_;
					GDesktopAppInfo* _tmp10_;
					gboolean _tmp11_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					_tmp8_ = button;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					_tmp9_ = icon_button_get_appinfo (_tmp8_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					_tmp10_ = _tmp9_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					_tmp11_ = _tmp10_ != NULL;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					_g_object_unref0 (_tmp10_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
					if (_tmp11_) {
#line 335 "DesktopHelper.c"
						gchar* id = NULL;
						IconButton* _tmp12_;
						GDesktopAppInfo* _tmp13_;
						GDesktopAppInfo* _tmp14_;
						const gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						const gchar* _tmp18_;
						gchar** _tmp19_;
						gint _tmp19__length1;
						gchar** _tmp20_;
						gint _tmp20__length1;
						const gchar* _tmp21_;
						gchar* _tmp22_;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp12_ = button;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp13_ = icon_button_get_appinfo (_tmp12_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp14_ = _tmp13_;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp15_ = g_app_info_get_id ((GAppInfo*) _tmp14_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp16_ = g_strdup (_tmp15_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp17_ = _tmp16_;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_g_object_unref0 (_tmp14_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						id = _tmp17_;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp18_ = id;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp19_ = buttons;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp19__length1 = buttons_length1;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						if (_vala_string_array_contains (_tmp19_, _tmp19__length1, _tmp18_)) {
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
							_g_free0 (id);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
							_g_object_unref0 (button);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
							_g_object_unref0 (widget);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
							continue;
#line 382 "DesktopHelper.c"
						}
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp20_ = buttons;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp20__length1 = buttons_length1;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp21_ = id;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_tmp22_ = g_strdup (_tmp21_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_vala_array_add1 (&buttons, &buttons_length1, &_buttons_size_, _tmp22_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
						_g_free0 (id);
#line 396 "DesktopHelper.c"
					}
				}
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_g_object_unref0 (button);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
				_g_object_unref0 (widget);
#line 403 "DesktopHelper.c"
			}
		}
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		(widget_collection == NULL) ? NULL : (widget_collection = (g_list_free (widget_collection), NULL));
#line 408 "DesktopHelper.c"
	}
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp23_ = self->priv->settings;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp24_ = buttons;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp24__length1 = buttons_length1;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_settings_set_strv (_tmp23_, "pinned-launchers", _tmp24_);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	buttons = (_vala_array_free (buttons, buttons_length1, (GDestroyNotify) g_free), NULL);
#line 420 "DesktopHelper.c"
}


/**
     * Grab the list of windows stacked for the given class_group
     */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return _data1_;
#line 434 "DesktopHelper.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 445 "DesktopHelper.c"
		DesktopHelper* self;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		self = _data1_->self;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		(_data1_->list == NULL) ? NULL : (_data1_->list = (g_list_free (_data1_->list), NULL));
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_g_object_unref0 (_data1_->class_group);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_g_object_unref0 (self);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		g_slice_free (Block1Data, _data1_);
#line 457 "DesktopHelper.c"
	}
}


static void
__lambda19_ (Block1Data* _data1_,
             WnckWindow* window)
{
	DesktopHelper* self;
	gboolean _tmp0_ = FALSE;
	WnckClassGroup* _tmp1_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self = _data1_->self;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_if_fail (window != NULL);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = wnck_window_get_class_group (window);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	if (_tmp1_ == _data1_->class_group) {
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp0_ = !wnck_window_is_skip_tasklist (window);
#line 479 "DesktopHelper.c"
	} else {
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp0_ = FALSE;
#line 483 "DesktopHelper.c"
	}
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	if (_tmp0_) {
#line 487 "DesktopHelper.c"
		WnckWorkspace* workspace = NULL;
		WnckWorkspace* _tmp2_;
		WnckWorkspace* _tmp3_;
		WnckWorkspace* _tmp4_;
		WnckWorkspace* _tmp5_;
		WnckWorkspace* _tmp6_;
		WnckWorkspace* _tmp7_;
		gboolean _tmp8_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp2_ = wnck_window_get_workspace (window);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		workspace = _tmp3_;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp4_ = workspace;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		if (_tmp4_ == NULL) {
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			_g_object_unref0 (workspace);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			return;
#line 510 "DesktopHelper.c"
		}
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp5_ = workspace;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp6_ = desktop_helper_get_active_workspace (self);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp7_ = _tmp6_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_tmp8_ = _tmp5_ == _tmp7_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_g_object_unref0 (_tmp7_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		if (_tmp8_) {
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
			_data1_->list = g_list_append (_data1_->list, window);
#line 526 "DesktopHelper.c"
		}
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
		_g_object_unref0 (workspace);
#line 530 "DesktopHelper.c"
	}
}


static void
___lambda19__gfunc (gconstpointer data,
                    gpointer self)
{
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	__lambda19_ (self, (WnckWindow*) data);
#line 541 "DesktopHelper.c"
}


GList*
desktop_helper_get_stacked_for_classgroup (DesktopHelper* self,
                                           WnckClassGroup* class_group)
{
	GList* result = NULL;
	Block1Data* _data1_;
	WnckClassGroup* _tmp0_;
	WnckScreen* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_val_if_fail (class_group != NULL, NULL);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_->_ref_count_ = 1;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_->self = g_object_ref (self);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp0_ = _g_object_ref0 (class_group);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (_data1_->class_group);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_->class_group = _tmp0_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_->list = NULL;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = self->priv->screen;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp2_ = wnck_screen_get_windows_stacked (_tmp1_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_list_foreach (_tmp2_, ___lambda19__gfunc, _data1_);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp3_ = g_list_copy (_data1_->list);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	result = _tmp3_;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	block1_data_unref (_data1_);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_data1_ = NULL;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return result;
#line 589 "DesktopHelper.c"
}


/**
     * Return the currently active window
     */
WnckWindow*
desktop_helper_get_active_window (DesktopHelper* self)
{
	WnckWindow* result = NULL;
	WnckScreen* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp0_ = self->priv->screen;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = wnck_screen_get_active_window (_tmp0_);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	result = _tmp2_;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return result;
#line 615 "DesktopHelper.c"
}


/**
     * Return the currently active workspace
     */
WnckWorkspace*
desktop_helper_get_active_workspace (DesktopHelper* self)
{
	WnckWorkspace* result = NULL;
	WnckScreen* _tmp0_;
	WnckWorkspace* _tmp1_;
	WnckWorkspace* _tmp2_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp0_ = self->priv->screen;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp1_ = wnck_screen_get_active_workspace (_tmp0_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	result = _tmp2_;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	return result;
#line 641 "DesktopHelper.c"
}


static void
desktop_helper_class_init (DesktopHelperClass * klass)
{
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	desktop_helper_parent_class = g_type_class_peek_parent (klass);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	g_type_class_add_private (klass, sizeof (DesktopHelperPrivate));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_helper_finalize;
#line 654 "DesktopHelper.c"
}


static void
desktop_helper_instance_init (DesktopHelper * self)
{
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv = DESKTOP_HELPER_GET_PRIVATE (self);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->settings = NULL;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->screen = NULL;
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->priv->icon_layout = NULL;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->panel_size = 40;
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->icon_size = 32;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->orientation = GTK_ORIENTATION_HORIZONTAL;
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self->lock_icons = FALSE;
#line 679 "DesktopHelper.c"
}


static void
desktop_helper_finalize (GObject * obj)
{
	DesktopHelper * self;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DESKTOP_HELPER, DesktopHelper);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->settings);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->screen);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	_g_object_unref0 (self->priv->icon_layout);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/DesktopHelper.vala"
	G_OBJECT_CLASS (desktop_helper_parent_class)->finalize (obj);
#line 697 "DesktopHelper.c"
}


/**
 * Trivial helper for IconTasklist - i.e. desktop lookups
 */
GType
desktop_helper_get_type (void)
{
	return desktop_helper_type_id;
}


GType
desktop_helper_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopHelper), 0, (GInstanceInitFunc) desktop_helper_instance_init, NULL };
	desktop_helper_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "DesktopHelper", &g_define_type_info, 0);
	return desktop_helper_type_id;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



