/* Icon.c generated by valac 0.40.19, the Vala compiler
 * generated from Icon.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2017-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define TYPE_ICON (icon_get_type ())
#define ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON, Icon))
#define ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON, IconClass))
#define IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON))
#define IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON))
#define ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON, IconClass))

typedef struct _Icon Icon;
typedef struct _IconClass IconClass;
typedef struct _IconPrivate IconPrivate;
enum  {
	ICON_0_PROPERTY,
	ICON_BOUNCE_PROPERTY,
	ICON_ATTENTION_PROPERTY,
	ICON_ICON_OPACITY_PROPERTY,
	ICON_NUM_PROPERTIES
};
static GParamSpec* icon_properties[ICON_NUM_PROPERTIES];

#define BUDGIE_TASK_LIST_TYPE_ANIMATION (budgie_task_list_animation_get_type ())
#define BUDGIE_TASK_LIST_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimation))
#define BUDGIE_TASK_LIST_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))
#define BUDGIE_TASK_LIST_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))

typedef struct _BudgieTaskListAnimation BudgieTaskListAnimation;
typedef struct _BudgieTaskListAnimationClass BudgieTaskListAnimationClass;
typedef struct _BudgieTaskListAnimationPrivate BudgieTaskListAnimationPrivate;
typedef gdouble (*BudgieTaskListTweenFunc) (gdouble factor, gpointer user_data);

#define BUDGIE_TASK_LIST_TYPE_PROP_CHANGE (budgie_task_list_prop_change_get_type ())
typedef struct _BudgieTaskListPropChange BudgieTaskListPropChange;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef void (*BudgieTaskListAnimCompletionFunc) (BudgieTaskListAnimation* src, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block17Data Block17Data;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _Icon {
	GtkImage parent_instance;
	IconPrivate * priv;
	gboolean waiting;
};

struct _IconClass {
	GtkImageClass parent_class;
};

struct _IconPrivate {
	gint widget_width;
	gint widget_height;
	BudgiePanelPosition panel_position;
	gint wait_cycle_counter;
	gint attention_cycle_counter;
	gdouble bounce_amount;
	gdouble attention_amount;
};

struct _BudgieTaskListPropChange {
	gchar* property;
	GValue old;
	GValue new;
};

struct _BudgieTaskListAnimation {
	GObject parent_instance;
	BudgieTaskListAnimationPrivate * priv;
	gint64 start_time;
	gint64 length;
	BudgieTaskListTweenFunc tween;
	gpointer tween_target;
	BudgieTaskListPropChange* changes;
	gint changes_length1;
	GtkWidget* widget;
	GObject* object;
	guint id;
	gboolean can_anim;
	gint64 elapsed;
	gboolean no_reset;
};

struct _BudgieTaskListAnimationClass {
	GObjectClass parent_class;
};

struct _Block17Data {
	int _ref_count_;
	Icon* self;
	BudgieTaskListAnimation* wait_animation;
	BudgieTaskListAnimation* wait_animation1;
};


static gpointer icon_parent_class = NULL;
static GType icon_type_id = 0;

#define MAX_CYCLES 12
GType icon_register_type (GTypeModule * module);
GType icon_get_type (void) G_GNUC_CONST;
#define ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ICON, IconPrivate))
Icon* icon_new (void);
Icon* icon_construct (GType object_type);
void icon_on_size_allocate (Icon* self,
                            GtkAllocation* allocation);
static void _icon_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                      GtkAllocation* allocation,
                                                      gpointer self);
void icon_animate_attention (Icon* self,
                             BudgiePanelPosition* position);
GType budgie_task_list_animation_register_type (GTypeModule * module);
GType budgie_task_list_animation_get_type (void) G_GNUC_CONST;
BudgieTaskListAnimation* budgie_task_list_animation_new (void);
BudgieTaskListAnimation* budgie_task_list_animation_construct (GType object_type);
GType budgie_task_list_prop_change_get_type (void) G_GNUC_CONST;
BudgieTaskListPropChange* budgie_task_list_prop_change_dup (const BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_free (BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_copy (const BudgieTaskListPropChange* self,
                                        BudgieTaskListPropChange* dest);
void budgie_task_list_prop_change_destroy (BudgieTaskListPropChange* self);
#define BUDGIE_TASK_LIST_MSECOND ((gint64) 1000)
gdouble budgie_task_list_sine_ease_in (gdouble p);
static gdouble _budgie_task_list_sine_ease_in_budgie_task_list_tween_func (gdouble factor,
                                                                    gpointer self);
static void _vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                                gint array_length);
void budgie_task_list_animation_start (BudgieTaskListAnimation* self,
                                       BudgieTaskListAnimCompletionFunc compl,
                                       gpointer compl_target);
static void __lambda14_ (Icon* self,
                  BudgieTaskListAnimation* a);
static void ___lambda14__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                         gpointer self);
void icon_animate_wait (Icon* self);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void __lambda15_ (Icon* self);
void icon_set_icon_opacity (Icon* self,
                            gdouble value);
static void ___lambda15__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                         gpointer self);
static gboolean __lambda16_ (Block17Data* _data17_);
void budgie_task_list_animation_stop (BudgieTaskListAnimation* self);
static void __lambda17_ (Icon* self,
                  BudgieTaskListAnimation* a);
static void ___lambda17__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                         gpointer self);
static gboolean ___lambda16__gsource_func (gpointer self);
void icon_animate_launch (Icon* self,
                          BudgiePanelPosition position);
gdouble budgie_task_list_elastic_ease_out (gdouble p);
static gdouble _budgie_task_list_elastic_ease_out_budgie_task_list_tween_func (gdouble factor,
                                                                        gpointer self);
gdouble icon_get_bounce (Icon* self);
static void __lambda18_ (Icon* self,
                  BudgieTaskListAnimation* a);
void icon_set_bounce (Icon* self,
                      gdouble value);
static void ___lambda18__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                         gpointer self);
static gboolean icon_real_draw (GtkWidget* base,
                         cairo_t* cr);
gdouble icon_get_attention (Icon* self);
void icon_set_attention (Icon* self,
                         gdouble value);
gdouble icon_get_icon_opacity (Icon* self);
static void icon_finalize (GObject * obj);
static void _vala_icon_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_icon_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);


static void
_icon_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                 GtkAllocation* allocation,
                                                 gpointer self)
{
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_on_size_allocate ((Icon*) self, allocation);
#line 214 "Icon.c"
}


Icon*
icon_construct (GType object_type)
{
	Icon * self = NULL;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self = (Icon*) g_object_new (object_type, NULL);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _icon_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return self;
#line 228 "Icon.c"
}


Icon*
icon_new (void)
{
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return icon_construct (TYPE_ICON);
#line 237 "Icon.c"
}


void
icon_on_size_allocate (Icon* self,
                       GtkAllocation* allocation)
{
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (allocation != NULL);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = *allocation;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp1_ = _tmp0_.width;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->widget_width = _tmp1_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp2_ = *allocation;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_ = _tmp2_.height;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->widget_height = _tmp3_;
#line 265 "Icon.c"
}


static gdouble
_budgie_task_list_sine_ease_in_budgie_task_list_tween_func (gdouble factor,
                                                            gpointer self)
{
	gdouble result;
	result = budgie_task_list_sine_ease_in (factor);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 277 "Icon.c"
}


static void
_vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                           gint array_length)
{
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (array != NULL) {
#line 287 "Icon.c"
		int i;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			budgie_task_list_prop_change_destroy (&array[i]);
#line 293 "Icon.c"
		}
	}
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_free (array);
#line 298 "Icon.c"
}


static void
__lambda14_ (Icon* self,
             BudgieTaskListAnimation* a)
{
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_animate_attention (self, NULL);
#line 308 "Icon.c"
}


static void
___lambda14__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                    gpointer self)
{
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	__lambda14_ ((Icon*) self, src);
#line 318 "Icon.c"
}


void
icon_animate_attention (Icon* self,
                        BudgiePanelPosition* position)
{
	gint _tmp0_;
	gint _tmp1_;
	BudgieTaskListAnimation* attention_animation = NULL;
	BudgieTaskListAnimation* _tmp2_;
	BudgieTaskListAnimation* _tmp3_;
	BudgieTaskListAnimation* _tmp4_;
	BudgieTaskListAnimation* _tmp5_;
	gint _tmp6_;
	BudgieTaskListAnimation* _tmp28_;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (position != NULL) {
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self->priv->panel_position = *position;
#line 341 "Icon.c"
	}
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->priv->attention_cycle_counter;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp0_ == 6) {
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self->priv->attention_amount = (gdouble) 0;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self->priv->attention_cycle_counter = 0;
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		return;
#line 353 "Icon.c"
	}
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp1_ = self->priv->attention_cycle_counter;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->attention_cycle_counter = _tmp1_ + 1;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp2_ = budgie_task_list_animation_new ();
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	attention_animation = _tmp2_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_ = attention_animation;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_->widget = (GtkWidget*) self;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp4_ = attention_animation;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp4_->length = 50 * BUDGIE_TASK_LIST_MSECOND;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_ = attention_animation;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_->tween = _budgie_task_list_sine_ease_in_budgie_task_list_tween_func;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_->tween_target = NULL;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp6_ = self->priv->attention_cycle_counter;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if ((_tmp6_ % 2) == 0) {
#line 381 "Icon.c"
		BudgieTaskListAnimation* _tmp7_;
		gchar* _tmp8_;
		GValue _tmp9_ = {0};
		GValue _tmp10_ = {0};
		BudgieTaskListPropChange _tmp11_ = {0};
		BudgieTaskListPropChange* _tmp12_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp7_ = attention_animation;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp8_ = g_strdup ("attention");
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_set_double (&_tmp9_, -5.0);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_init (&_tmp10_, G_TYPE_DOUBLE);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_set_double (&_tmp10_, 5.0);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		memset (&_tmp11_, 0, sizeof (BudgieTaskListPropChange));
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_g_free0 (_tmp11_.property);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp11_.property = _tmp8_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		G_IS_VALUE (&_tmp11_.old) ? (g_value_unset (&_tmp11_.old), NULL) : NULL;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp11_.old = _tmp9_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		G_IS_VALUE (&_tmp11_.new) ? (g_value_unset (&_tmp11_.new), NULL) : NULL;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp11_.new = _tmp10_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp12_ = g_new0 (BudgieTaskListPropChange, 1);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp12_[0] = _tmp11_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp7_->changes = (_vala_BudgieTaskListPropChange_array_free (_tmp7_->changes, _tmp7_->changes_length1), NULL);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp7_->changes = _tmp12_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp7_->changes_length1 = 1;
#line 424 "Icon.c"
	} else {
		gint _tmp13_;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp13_ = self->priv->attention_cycle_counter;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		if (_tmp13_ == 5) {
#line 431 "Icon.c"
			BudgieTaskListAnimation* _tmp14_;
			gchar* _tmp15_;
			GValue _tmp16_ = {0};
			GValue _tmp17_ = {0};
			BudgieTaskListPropChange _tmp18_ = {0};
			BudgieTaskListPropChange* _tmp19_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp14_ = attention_animation;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp15_ = g_strdup ("attention");
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_init (&_tmp16_, G_TYPE_DOUBLE);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_set_double (&_tmp16_, 5.0);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_init (&_tmp17_, G_TYPE_DOUBLE);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_set_double (&_tmp17_, 0.0);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			memset (&_tmp18_, 0, sizeof (BudgieTaskListPropChange));
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_g_free0 (_tmp18_.property);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp18_.property = _tmp15_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			G_IS_VALUE (&_tmp18_.old) ? (g_value_unset (&_tmp18_.old), NULL) : NULL;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp18_.old = _tmp16_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			G_IS_VALUE (&_tmp18_.new) ? (g_value_unset (&_tmp18_.new), NULL) : NULL;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp18_.new = _tmp17_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp19_ = g_new0 (BudgieTaskListPropChange, 1);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp19_[0] = _tmp18_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp14_->changes = (_vala_BudgieTaskListPropChange_array_free (_tmp14_->changes, _tmp14_->changes_length1), NULL);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp14_->changes = _tmp19_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp14_->changes_length1 = 1;
#line 474 "Icon.c"
		} else {
			gdouble _tmp20_ = 0.0;
			gint _tmp21_;
			BudgieTaskListAnimation* _tmp22_;
			gchar* _tmp23_;
			GValue _tmp24_ = {0};
			GValue _tmp25_ = {0};
			BudgieTaskListPropChange _tmp26_ = {0};
			BudgieTaskListPropChange* _tmp27_;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp21_ = self->priv->attention_cycle_counter;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			if (_tmp21_ == 1) {
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp20_ = 0.0;
#line 490 "Icon.c"
			} else {
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp20_ = 5.0;
#line 494 "Icon.c"
			}
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp22_ = attention_animation;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp23_ = g_strdup ("attention");
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_init (&_tmp24_, G_TYPE_DOUBLE);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_set_double (&_tmp24_, _tmp20_);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_init (&_tmp25_, G_TYPE_DOUBLE);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			g_value_set_double (&_tmp25_, -5.0);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			memset (&_tmp26_, 0, sizeof (BudgieTaskListPropChange));
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_g_free0 (_tmp26_.property);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp26_.property = _tmp23_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			G_IS_VALUE (&_tmp26_.old) ? (g_value_unset (&_tmp26_.old), NULL) : NULL;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp26_.old = _tmp24_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			G_IS_VALUE (&_tmp26_.new) ? (g_value_unset (&_tmp26_.new), NULL) : NULL;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp26_.new = _tmp25_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp27_ = g_new0 (BudgieTaskListPropChange, 1);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp27_[0] = _tmp26_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp22_->changes = (_vala_BudgieTaskListPropChange_array_free (_tmp22_->changes, _tmp22_->changes_length1), NULL);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp22_->changes = _tmp27_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp22_->changes_length1 = 1;
#line 532 "Icon.c"
		}
	}
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp28_ = attention_animation;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	budgie_task_list_animation_start (_tmp28_, ___lambda14__budgie_task_list_anim_completion_func, self);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_object_unref0 (attention_animation);
#line 541 "Icon.c"
}


static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return _data17_;
#line 552 "Icon.c"
}


static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 563 "Icon.c"
		Icon* self;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self = _data17_->self;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_g_object_unref0 (_data17_->wait_animation1);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_g_object_unref0 (_data17_->wait_animation);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_g_object_unref0 (self);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_slice_free (Block17Data, _data17_);
#line 575 "Icon.c"
	}
}


static void
__lambda15_ (Icon* self)
{
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_set_icon_opacity (self, 0.3);
#line 585 "Icon.c"
}


static void
___lambda15__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                    gpointer self)
{
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	__lambda15_ ((Icon*) self);
#line 595 "Icon.c"
}


static void
__lambda17_ (Icon* self,
             BudgieTaskListAnimation* a)
{
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_set_icon_opacity (self, 1.0);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_animate_wait (self);
#line 607 "Icon.c"
}


static void
___lambda17__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                    gpointer self)
{
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	__lambda17_ ((Icon*) self, src);
#line 617 "Icon.c"
}


static gboolean
__lambda16_ (Block17Data* _data17_)
{
	Icon* self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	BudgieTaskListAnimation* _tmp3_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self = _data17_->self;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->waiting;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (!_tmp0_) {
#line 634 "Icon.c"
		BudgieTaskListAnimation* _tmp1_;
		BudgieTaskListAnimation* _tmp2_;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp1_ = _data17_->wait_animation;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		budgie_task_list_animation_stop (_tmp1_);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp2_ = _data17_->wait_animation1;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		budgie_task_list_animation_stop (_tmp2_);
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		icon_set_icon_opacity (self, 1.0);
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		result = FALSE;
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		return result;
#line 651 "Icon.c"
	}
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_ = _data17_->wait_animation1;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	budgie_task_list_animation_start (_tmp3_, ___lambda17__budgie_task_list_anim_completion_func, self);
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	result = FALSE;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 661 "Icon.c"
}


static gboolean
___lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda16_ (self);
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 672 "Icon.c"
}


void
icon_animate_wait (Icon* self)
{
	Block17Data* _data17_;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	BudgieTaskListAnimation* _tmp3_;
	BudgieTaskListAnimation* _tmp4_;
	BudgieTaskListAnimation* _tmp5_;
	BudgieTaskListAnimation* _tmp6_;
	BudgieTaskListAnimation* _tmp7_;
	gchar* _tmp8_;
	GValue _tmp9_ = {0};
	GValue _tmp10_ = {0};
	BudgieTaskListPropChange _tmp11_ = {0};
	BudgieTaskListPropChange* _tmp12_;
	BudgieTaskListAnimation* _tmp13_;
	BudgieTaskListAnimation* _tmp14_;
	BudgieTaskListAnimation* _tmp15_;
	BudgieTaskListAnimation* _tmp16_;
	BudgieTaskListAnimation* _tmp17_;
	gchar* _tmp18_;
	GValue _tmp19_ = {0};
	GValue _tmp20_ = {0};
	BudgieTaskListPropChange _tmp21_ = {0};
	BudgieTaskListPropChange* _tmp22_;
	BudgieTaskListAnimation* _tmp23_;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_->_ref_count_ = 1;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_->self = g_object_ref (self);
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->waiting;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (!_tmp0_) {
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self->priv->wait_cycle_counter = 0;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		block17_data_unref (_data17_);
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_data17_ = NULL;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		return;
#line 724 "Icon.c"
	}
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp1_ = self->priv->wait_cycle_counter;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp1_ == MAX_CYCLES) {
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		self->priv->wait_cycle_counter = 0;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		block17_data_unref (_data17_);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_data17_ = NULL;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		return;
#line 738 "Icon.c"
	}
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp2_ = self->priv->wait_cycle_counter;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->wait_cycle_counter = _tmp2_ + 1;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_ = budgie_task_list_animation_new ();
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_->wait_animation = _tmp3_;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp4_ = _data17_->wait_animation;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp4_->widget = (GtkWidget*) self;
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_ = _data17_->wait_animation;
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_->length = 700 * BUDGIE_TASK_LIST_MSECOND;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp6_ = _data17_->wait_animation;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp6_->tween = _budgie_task_list_sine_ease_in_budgie_task_list_tween_func;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp6_->tween_target = NULL;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_ = _data17_->wait_animation;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp8_ = g_strdup ("icon_opacity");
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp9_, 1.0);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp10_, G_TYPE_DOUBLE);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp10_, 0.3);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	memset (&_tmp11_, 0, sizeof (BudgieTaskListPropChange));
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_free0 (_tmp11_.property);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp11_.property = _tmp8_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp11_.old) ? (g_value_unset (&_tmp11_.old), NULL) : NULL;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp11_.old = _tmp9_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp11_.new) ? (g_value_unset (&_tmp11_.new), NULL) : NULL;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp11_.new = _tmp10_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp12_ = g_new0 (BudgieTaskListPropChange, 1);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp12_[0] = _tmp11_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_->changes = (_vala_BudgieTaskListPropChange_array_free (_tmp7_->changes, _tmp7_->changes_length1), NULL);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_->changes = _tmp12_;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_->changes_length1 = 1;
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp13_ = budgie_task_list_animation_new ();
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_->wait_animation1 = _tmp13_;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_ = _data17_->wait_animation1;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_->widget = (GtkWidget*) self;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp15_ = _data17_->wait_animation1;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp15_->length = 700 * BUDGIE_TASK_LIST_MSECOND;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp16_ = _data17_->wait_animation1;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp16_->tween = _budgie_task_list_sine_ease_in_budgie_task_list_tween_func;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp16_->tween_target = NULL;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp17_ = _data17_->wait_animation1;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp18_ = g_strdup ("icon_opacity");
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp19_, G_TYPE_DOUBLE);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp19_, 0.3);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp20_, G_TYPE_DOUBLE);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp20_, 1.0);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	memset (&_tmp21_, 0, sizeof (BudgieTaskListPropChange));
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_free0 (_tmp21_.property);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp21_.property = _tmp18_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp21_.old) ? (g_value_unset (&_tmp21_.old), NULL) : NULL;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp21_.old = _tmp19_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp21_.new) ? (g_value_unset (&_tmp21_.new), NULL) : NULL;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp21_.new = _tmp20_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp22_ = g_new0 (BudgieTaskListPropChange, 1);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp22_[0] = _tmp21_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp17_->changes = (_vala_BudgieTaskListPropChange_array_free (_tmp17_->changes, _tmp17_->changes_length1), NULL);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp17_->changes = _tmp22_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp17_->changes_length1 = 1;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp23_ = _data17_->wait_animation;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	budgie_task_list_animation_start (_tmp23_, ___lambda15__budgie_task_list_anim_completion_func, self);
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 700, ___lambda16__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	block17_data_unref (_data17_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_data17_ = NULL;
#line 862 "Icon.c"
}


static gdouble
_budgie_task_list_elastic_ease_out_budgie_task_list_tween_func (gdouble factor,
                                                                gpointer self)
{
	gdouble result;
	result = budgie_task_list_elastic_ease_out (factor);
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 874 "Icon.c"
}


static void
__lambda18_ (Icon* self,
             BudgieTaskListAnimation* a)
{
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_set_bounce (self, 0.0);
#line 884 "Icon.c"
}


static void
___lambda18__budgie_task_list_anim_completion_func (BudgieTaskListAnimation* src,
                                                    gpointer self)
{
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	__lambda18_ ((Icon*) self, src);
#line 894 "Icon.c"
}


void
icon_animate_launch (Icon* self,
                     BudgiePanelPosition position)
{
	gdouble old_value = 0.0;
	gboolean _tmp0_ = FALSE;
	BudgieTaskListAnimation* launch_animation = NULL;
	BudgieTaskListAnimation* _tmp7_;
	gchar* _tmp8_;
	gdouble _tmp9_;
	GValue _tmp10_ = {0};
	gdouble _tmp11_;
	gdouble _tmp12_;
	GValue _tmp13_ = {0};
	BudgieTaskListPropChange _tmp14_ = {0};
	BudgieTaskListPropChange* _tmp15_;
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->panel_position = position;
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (position == BUDGIE_PANEL_POSITION_TOP) {
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp0_ = TRUE;
#line 922 "Icon.c"
	} else {
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_BOTTOM;
#line 926 "Icon.c"
	}
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp0_) {
#line 930 "Icon.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp1_ = self->priv->widget_height;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp2_ = gtk_image_get_pixel_size ((GtkImage*) self);
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp3_ = _tmp2_;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		old_value = (gdouble) ((_tmp1_ - _tmp3_) / 2);
#line 942 "Icon.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp4_ = self->priv->widget_width;
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp5_ = gtk_image_get_pixel_size ((GtkImage*) self);
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp6_ = _tmp5_;
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		old_value = (gdouble) ((_tmp4_ - _tmp6_) / 2);
#line 955 "Icon.c"
	}
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_ = budgie_task_list_animation_new ();
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation = _tmp7_;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->widget = (GtkWidget*) self;
#line 189 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->length = 1200 * BUDGIE_TASK_LIST_MSECOND;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->tween = _budgie_task_list_elastic_ease_out_budgie_task_list_tween_func;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->tween_target = NULL;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp8_ = g_strdup ("bounce");
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp9_ = old_value;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp10_, G_TYPE_DOUBLE);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp10_, _tmp9_);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp11_ = icon_get_bounce (self);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp12_ = _tmp11_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_init (&_tmp13_, G_TYPE_DOUBLE);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_value_set_double (&_tmp13_, _tmp12_);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	memset (&_tmp14_, 0, sizeof (BudgieTaskListPropChange));
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_free0 (_tmp14_.property);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_.property = _tmp8_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp14_.old) ? (g_value_unset (&_tmp14_.old), NULL) : NULL;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_.old = _tmp10_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_IS_VALUE (&_tmp14_.new) ? (g_value_unset (&_tmp14_.new), NULL) : NULL;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_.new = _tmp13_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp15_ = g_new0 (BudgieTaskListPropChange, 1);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp15_[0] = _tmp14_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->changes = (_vala_BudgieTaskListPropChange_array_free (launch_animation->changes, launch_animation->changes_length1), NULL);
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->changes = _tmp15_;
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	launch_animation->changes_length1 = 1;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	budgie_task_list_animation_start (launch_animation, ___lambda18__budgie_task_list_anim_completion_func, self);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_object_unref0 (launch_animation);
#line 1013 "Icon.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return self ? g_object_ref (self) : NULL;
#line 1022 "Icon.c"
}


static gboolean
icon_real_draw (GtkWidget* base,
                cairo_t* cr)
{
	Icon * self;
	gboolean result = FALSE;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	GdkWindow* window = NULL;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	cairo_surface_t* buffer = NULL;
	GdkWindow* _tmp4_;
	GtkAllocation _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkAllocation _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_t* cr2 = NULL;
	cairo_surface_t* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	gint x = 0;
	gint y = 0;
	BudgiePanelPosition _tmp19_;
	cairo_surface_t* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self = (Icon*) base;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	alloc = _tmp0_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	window = _tmp2_;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp3_ = window;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp3_ == NULL) {
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		result = GDK_EVENT_STOP;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_g_object_unref0 (window);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		return result;
#line 1085 "Icon.c"
	}
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp4_ = window;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp5_ = alloc;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp6_ = _tmp5_.width;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp7_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp8_ = _tmp7_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp9_ = alloc;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp10_ = _tmp9_.height;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp11_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp12_ = _tmp11_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp13_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp14_ = _tmp13_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp15_ = gdk_window_create_similar_image_surface (_tmp4_, (gint) CAIRO_FORMAT_ARGB32, _tmp6_ * _tmp8_, _tmp10_ * _tmp12_, _tmp14_);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	buffer = _tmp15_;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp16_ = buffer;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp17_ = cairo_create (_tmp16_);
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	cr2 = _tmp17_;
#line 220 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp18_ = cr2;
#line 220 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	GTK_WIDGET_CLASS (icon_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_get_type (), GtkImage), _tmp18_);
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	x = 0;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	y = 0;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp19_ = self->priv->panel_position;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp19_ == BUDGIE_PANEL_POSITION_LEFT) {
#line 1131 "Icon.c"
		gint _tmp20_;
		gdouble _tmp21_;
		gint _tmp22_;
		gdouble _tmp23_;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp20_ = x;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp21_ = self->priv->bounce_amount;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		x = _tmp20_ + ((gint) _tmp21_);
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp22_ = y;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp23_ = self->priv->attention_amount;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		y = _tmp22_ + ((gint) _tmp23_);
#line 1148 "Icon.c"
	} else {
		BudgiePanelPosition _tmp24_;
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		_tmp24_ = self->priv->panel_position;
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		if (_tmp24_ == BUDGIE_PANEL_POSITION_RIGHT) {
#line 1155 "Icon.c"
			gint _tmp25_;
			gdouble _tmp26_;
			gint _tmp27_;
			gdouble _tmp28_;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp25_ = x;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp26_ = self->priv->bounce_amount;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			x = _tmp25_ - ((gint) _tmp26_);
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp27_ = y;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp28_ = self->priv->attention_amount;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			y = _tmp27_ + ((gint) _tmp28_);
#line 1172 "Icon.c"
		} else {
			BudgiePanelPosition _tmp29_;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			_tmp29_ = self->priv->panel_position;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
			if (_tmp29_ == BUDGIE_PANEL_POSITION_TOP) {
#line 1179 "Icon.c"
				gint _tmp30_;
				gdouble _tmp31_;
				gint _tmp32_;
				gdouble _tmp33_;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp30_ = y;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp31_ = self->priv->bounce_amount;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				y = _tmp30_ + ((gint) _tmp31_);
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp32_ = x;
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp33_ = self->priv->attention_amount;
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				x = _tmp32_ + ((gint) _tmp33_);
#line 1196 "Icon.c"
			} else {
				gint _tmp34_;
				gdouble _tmp35_;
				gint _tmp36_;
				gdouble _tmp37_;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp34_ = y;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp35_ = self->priv->bounce_amount;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				y = _tmp34_ - ((gint) _tmp35_);
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp36_ = x;
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				_tmp37_ = self->priv->attention_amount;
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
				x = _tmp36_ + ((gint) _tmp37_);
#line 1214 "Icon.c"
			}
		}
	}
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp38_ = buffer;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp39_ = x;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp40_ = y;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	cairo_set_source_surface (cr, _tmp38_, (gdouble) _tmp39_, (gdouble) _tmp40_);
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	cairo_paint (cr);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	result = TRUE;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_cairo_destroy0 (cr2);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_cairo_surface_destroy0 (buffer);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_g_object_unref0 (window);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 1238 "Icon.c"
}


gdouble
icon_get_bounce (Icon* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->priv->bounce_amount;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 1255 "Icon.c"
}


void
icon_set_bounce (Icon* self,
                 gdouble value)
{
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->bounce_amount = value;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_BOUNCE_PROPERTY]);
#line 1271 "Icon.c"
}


gdouble
icon_get_attention (Icon* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->priv->attention_amount;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	result = _tmp0_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 1288 "Icon.c"
}


void
icon_set_attention (Icon* self,
                    gdouble value)
{
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->attention_amount = value;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_ATTENTION_PROPERTY]);
#line 1304 "Icon.c"
}


gdouble
icon_get_icon_opacity (Icon* self)
{
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = gtk_widget_get_opacity ((GtkWidget*) self);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp1_ = _tmp0_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	result = _tmp1_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	return result;
#line 1324 "Icon.c"
}


void
icon_set_icon_opacity (Icon* self,
                       gdouble value)
{
	gboolean _tmp0_;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	_tmp0_ = self->waiting;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	if (_tmp0_) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		gtk_widget_set_opacity ((GtkWidget*) self, value);
#line 1341 "Icon.c"
	} else {
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		gtk_widget_set_opacity ((GtkWidget*) self, 1.0);
#line 1345 "Icon.c"
	}
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_ICON_OPACITY_PROPERTY]);
#line 1349 "Icon.c"
}


static void
icon_class_init (IconClass * klass)
{
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	icon_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_type_class_add_private (klass, sizeof (IconPrivate));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) icon_real_draw;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_get_property;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_set_property;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_finalize;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BOUNCE_PROPERTY, icon_properties[ICON_BOUNCE_PROPERTY] = g_param_spec_double ("bounce", "bounce", "bounce", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_ATTENTION_PROPERTY, icon_properties[ICON_ATTENTION_PROPERTY] = g_param_spec_double ("attention", "attention", "attention", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_ICON_OPACITY_PROPERTY, icon_properties[ICON_ICON_OPACITY_PROPERTY] = g_param_spec_double ("icon-opacity", "icon-opacity", "icon-opacity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1374 "Icon.c"
}


static void
icon_instance_init (Icon * self)
{
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv = ICON_GET_PRIVATE (self);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->widget_width = 36;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->widget_height = 30;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->waiting = FALSE;
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->wait_cycle_counter = 0;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->attention_cycle_counter = 0;
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->bounce_amount = 0.0;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self->priv->attention_amount = 0.0;
#line 1399 "Icon.c"
}


static void
icon_finalize (GObject * obj)
{
	Icon * self;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON, Icon);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	G_OBJECT_CLASS (icon_parent_class)->finalize (obj);
#line 1411 "Icon.c"
}


GType
icon_get_type (void)
{
	return icon_type_id;
}


GType
icon_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Icon), 0, (GInstanceInitFunc) icon_instance_init, NULL };
	icon_type_id = g_type_module_register_type (module, gtk_image_get_type (), "Icon", &g_define_type_info, 0);
	return icon_type_id;
}


static void
_vala_icon_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Icon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON, Icon);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_BOUNCE_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_set_double (value, icon_get_bounce (self));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_ATTENTION_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_set_double (value, icon_get_attention (self));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_ICON_OPACITY_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		g_value_set_double (value, icon_get_icon_opacity (self));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 1459 "Icon.c"
		default:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 1465 "Icon.c"
	}
}


static void
_vala_icon_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Icon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON, Icon);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_BOUNCE_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		icon_set_bounce (self, g_value_get_double (value));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_ATTENTION_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		icon_set_attention (self, g_value_get_double (value));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		case ICON_ICON_OPACITY_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		icon_set_icon_opacity (self, g_value_get_double (value));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 1498 "Icon.c"
		default:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/Icon.vala"
		break;
#line 1504 "Icon.c"
	}
}



