/* animation.c generated by valac 0.40.19, the Vala compiler
 * generated from animation.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
/**<Target value for end of animation */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

typedef gdouble (*BudgieTaskListTweenFunc) (gdouble factor, gpointer user_data);

#define BUDGIE_TASK_LIST_TYPE_ANIMATION (budgie_task_list_animation_get_type ())
#define BUDGIE_TASK_LIST_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimation))
#define BUDGIE_TASK_LIST_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))
#define BUDGIE_TASK_LIST_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))

typedef struct _BudgieTaskListAnimation BudgieTaskListAnimation;
typedef struct _BudgieTaskListAnimationClass BudgieTaskListAnimationClass;
typedef void (*BudgieTaskListAnimCompletionFunc) (BudgieTaskListAnimation* src, gpointer user_data);

#define BUDGIE_TASK_LIST_TYPE_PROP_CHANGE (budgie_task_list_prop_change_get_type ())
typedef struct _BudgieTaskListPropChange BudgieTaskListPropChange;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BudgieTaskListAnimationPrivate BudgieTaskListAnimationPrivate;
enum  {
	BUDGIE_TASK_LIST_ANIMATION_0_PROPERTY,
	BUDGIE_TASK_LIST_ANIMATION_NUM_PROPERTIES
};
static GParamSpec* budgie_task_list_animation_properties[BUDGIE_TASK_LIST_ANIMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BudgieTaskListPropChange {
	gchar* property;
	GValue old;
	GValue new;
};

struct _BudgieTaskListAnimation {
	GObject parent_instance;
	BudgieTaskListAnimationPrivate * priv;
	gint64 start_time;
	gint64 length;
	BudgieTaskListTweenFunc tween;
	gpointer tween_target;
	BudgieTaskListPropChange* changes;
	gint changes_length1;
	GtkWidget* widget;
	GObject* object;
	guint id;
	gboolean can_anim;
	gint64 elapsed;
	gboolean no_reset;
};

struct _BudgieTaskListAnimationClass {
	GObjectClass parent_class;
};

struct _BudgieTaskListAnimationPrivate {
	BudgieTaskListAnimCompletionFunc compl;
	gpointer compl_target;
	GDestroyNotify compl_target_destroy_notify;
};


static gpointer budgie_task_list_animation_parent_class = NULL;
static GType budgie_task_list_animation_type_id = 0;

GType budgie_task_list_animation_register_type (GTypeModule * module);
GType budgie_task_list_animation_get_type (void) G_GNUC_CONST;
GType budgie_task_list_prop_change_get_type (void) G_GNUC_CONST;
BudgieTaskListPropChange* budgie_task_list_prop_change_dup (const BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_free (BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_copy (const BudgieTaskListPropChange* self,
                                        BudgieTaskListPropChange* dest);
void budgie_task_list_prop_change_destroy (BudgieTaskListPropChange* self);
#define BUDGIE_TASK_LIST_ANIMATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationPrivate))
static void _vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                                gint array_length);
static gboolean budgie_task_list_animation_tick_callback (BudgieTaskListAnimation* self,
                                                   GtkWidget* widget,
                                                   GdkFrameClock* frame);
void budgie_task_list_animation_start (BudgieTaskListAnimation* self,
                                       BudgieTaskListAnimCompletionFunc compl,
                                       gpointer compl_target);
static gboolean _budgie_task_list_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                                      GdkFrameClock* frame_clock,
                                                                      gpointer self);
void budgie_task_list_animation_stop (BudgieTaskListAnimation* self);
BudgieTaskListAnimation* budgie_task_list_animation_new (void);
BudgieTaskListAnimation* budgie_task_list_animation_construct (GType object_type);
static void budgie_task_list_animation_finalize (GObject * obj);
gdouble budgie_task_list_sine_ease_in_out (gdouble p);
gdouble budgie_task_list_sine_ease_in (gdouble p);
gdouble budgie_task_list_sine_ease_out (gdouble p);
gdouble budgie_task_list_elastic_ease_in (gdouble p);
gdouble budgie_task_list_elastic_ease_out (gdouble p);
gdouble budgie_task_list_back_ease_in (gdouble p);
gdouble budgie_task_list_back_ease_out (gdouble p);
gdouble budgie_task_list_expo_ease_in (gdouble p);
gdouble budgie_task_list_expo_ease_out (gdouble p);
gdouble budgie_task_list_quad_ease_in (gdouble p);
gdouble budgie_task_list_quad_ease_out (gdouble p);
gdouble budgie_task_list_quad_ease_in_out (gdouble p);
gdouble budgie_task_list_circ_ease_in (gdouble p);
gdouble budgie_task_list_circ_ease_out (gdouble p);
#define BUDGIE_TASK_LIST_MSECOND ((gint64) 1000)


void
budgie_task_list_prop_change_copy (const BudgieTaskListPropChange* self,
                                   BudgieTaskListPropChange* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GValue _tmp2_;
	GValue _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	GValue _tmp6_;
	GValue _tmp7_ = {0};
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp0_ = (*self).property;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_g_free0 ((*dest).property);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	(*dest).property = _tmp1_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp2_ = (*self).old;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp3_ = _tmp2_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (G_IS_VALUE (&_tmp3_)) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		g_value_init (&_tmp4_, G_VALUE_TYPE (&_tmp3_));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		g_value_copy (&_tmp3_, &_tmp4_);
#line 159 "animation.c"
	} else {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp4_ = _tmp3_;
#line 163 "animation.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_IS_VALUE (&(*dest).old) ? (g_value_unset (&(*dest).old), NULL) : NULL;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	(*dest).old = _tmp4_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp5_ = (*self).new;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp6_ = _tmp5_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (G_IS_VALUE (&_tmp6_)) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		g_value_copy (&_tmp6_, &_tmp7_);
#line 179 "animation.c"
	} else {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp7_ = _tmp6_;
#line 183 "animation.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_IS_VALUE (&(*dest).new) ? (g_value_unset (&(*dest).new), NULL) : NULL;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	(*dest).new = _tmp7_;
#line 189 "animation.c"
}


void
budgie_task_list_prop_change_destroy (BudgieTaskListPropChange* self)
{
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_g_free0 ((*self).property);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_IS_VALUE (&(*self).old) ? (g_value_unset (&(*self).old), NULL) : NULL;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_IS_VALUE (&(*self).new) ? (g_value_unset (&(*self).new), NULL) : NULL;
#line 202 "animation.c"
}


BudgieTaskListPropChange*
budgie_task_list_prop_change_dup (const BudgieTaskListPropChange* self)
{
	BudgieTaskListPropChange* dup;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	dup = g_new0 (BudgieTaskListPropChange, 1);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	budgie_task_list_prop_change_copy (self, dup);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return dup;
#line 216 "animation.c"
}


void
budgie_task_list_prop_change_free (BudgieTaskListPropChange* self)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	budgie_task_list_prop_change_destroy (self);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_free (self);
#line 227 "animation.c"
}


GType
budgie_task_list_prop_change_get_type (void)
{
	static volatile gsize budgie_task_list_prop_change_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_task_list_prop_change_type_id__volatile)) {
		GType budgie_task_list_prop_change_type_id;
		budgie_task_list_prop_change_type_id = g_boxed_type_register_static ("BudgieTaskListPropChange", (GBoxedCopyFunc) budgie_task_list_prop_change_dup, (GBoxedFreeFunc) budgie_task_list_prop_change_free);
		g_once_init_leave (&budgie_task_list_prop_change_type_id__volatile, budgie_task_list_prop_change_type_id);
	}
	return budgie_task_list_prop_change_type_id__volatile;
}


static void
_vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                           gint array_length)
{
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (array != NULL) {
#line 250 "animation.c"
		int i;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			budgie_task_list_prop_change_destroy (&array[i]);
#line 256 "animation.c"
		}
	}
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_free (array);
#line 261 "animation.c"
}


static gboolean
budgie_task_list_animation_tick_callback (BudgieTaskListAnimation* self,
                                          GtkWidget* widget,
                                          GdkFrameClock* frame)
{
	gboolean result = FALSE;
	gint64 time = 0LL;
	gfloat factor = 0.0F;
	gint64 elapsed = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp25_;
	gint64 _tmp26_;
	BudgieTaskListPropChange* _tmp27_;
	gint _tmp27__length1;
	gboolean _tmp48_;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_return_val_if_fail (frame != NULL, FALSE);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	time = gdk_frame_clock_get_frame_time (frame);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	factor = 0.0f;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp0_ = time;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp1_ = self->start_time;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	elapsed = _tmp0_ - _tmp1_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp4_ = elapsed;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp5_ = self->length;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (_tmp4_ >= _tmp5_) {
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp3_ = TRUE;
#line 309 "animation.c"
	} else {
		guint _tmp6_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp6_ = self->id;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp3_ = _tmp6_ == ((guint) 0);
#line 316 "animation.c"
	}
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (_tmp3_) {
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp2_ = TRUE;
#line 322 "animation.c"
	} else {
		gboolean _tmp7_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp7_ = self->can_anim;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp2_ = !_tmp7_;
#line 329 "animation.c"
	}
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (_tmp2_) {
#line 333 "animation.c"
		guint _tmp8_;
		gboolean _tmp22_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp8_ = self->id;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		if (_tmp8_ > ((guint) 0)) {
#line 340 "animation.c"
			BudgieTaskListPropChange* _tmp9_;
			gint _tmp9__length1;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			_tmp9_ = self->changes;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			_tmp9__length1 = self->changes_length1;
#line 347 "animation.c"
			{
				BudgieTaskListPropChange* p_collection = NULL;
				gint p_collection_length1 = 0;
				gint _p_collection_size_ = 0;
				gint p_it = 0;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				p_collection = _tmp9_;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				p_collection_length1 = _tmp9__length1;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 359 "animation.c"
					BudgieTaskListPropChange _tmp10_;
					BudgieTaskListPropChange _tmp11_ = {0};
					BudgieTaskListPropChange p = {0};
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp10_ = p_collection[p_it];
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					budgie_task_list_prop_change_copy (&_tmp10_, &_tmp11_);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					p = _tmp11_;
#line 369 "animation.c"
					{
						GObject* _tmp12_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
						_tmp12_ = self->object;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
						if (_tmp12_ == NULL) {
#line 376 "animation.c"
							BudgieTaskListPropChange _tmp13_;
							const gchar* _tmp14_;
							BudgieTaskListPropChange _tmp15_;
							GValue _tmp16_;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp13_ = p;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp14_ = _tmp13_.property;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp15_ = p;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp16_ = _tmp15_.new;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							g_object_set_property ((GObject*) widget, _tmp14_, &_tmp16_);
#line 391 "animation.c"
						} else {
							GObject* _tmp17_;
							BudgieTaskListPropChange _tmp18_;
							const gchar* _tmp19_;
							BudgieTaskListPropChange _tmp20_;
							GValue _tmp21_;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp17_ = self->object;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp18_ = p;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp19_ = _tmp18_.property;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp20_ = p;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							_tmp21_ = _tmp20_.new;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
							g_object_set_property (_tmp17_, _tmp19_, &_tmp21_);
#line 410 "animation.c"
						}
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
						budgie_task_list_prop_change_destroy (&p);
#line 414 "animation.c"
					}
				}
			}
		}
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		self->id = (guint) 0;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp22_ = self->can_anim;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		if (_tmp22_) {
#line 425 "animation.c"
			BudgieTaskListAnimCompletionFunc _tmp23_;
			void* _tmp23__target;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			self->can_anim = FALSE;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			_tmp23_ = self->priv->compl;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			_tmp23__target = self->priv->compl_target;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			if (_tmp23_ != NULL) {
#line 436 "animation.c"
				BudgieTaskListAnimCompletionFunc _tmp24_;
				void* _tmp24__target;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp24_ = self->priv->compl;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp24__target = self->priv->compl_target;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp24_ (self, _tmp24__target);
#line 445 "animation.c"
			}
		}
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		gtk_widget_queue_draw (widget);
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		result = FALSE;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		return result;
#line 454 "animation.c"
	}
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp25_ = elapsed;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp26_ = self->length;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	factor = CLAMP (((gfloat) _tmp25_) / _tmp26_, (gfloat) 0, 1.0f);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp27_ = self->changes;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp27__length1 = self->changes_length1;
#line 466 "animation.c"
	{
		BudgieTaskListPropChange* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		c_collection = _tmp27_;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		c_collection_length1 = _tmp27__length1;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 478 "animation.c"
			BudgieTaskListPropChange _tmp28_;
			BudgieTaskListPropChange _tmp29_ = {0};
			BudgieTaskListPropChange c = {0};
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			_tmp28_ = c_collection[c_it];
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			budgie_task_list_prop_change_copy (&_tmp28_, &_tmp29_);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
			c = _tmp29_;
#line 488 "animation.c"
			{
				gdouble old = 0.0;
				gdouble new = 0.0;
				BudgieTaskListTweenFunc _tmp30_;
				void* _tmp30__target;
				gdouble delta = 0.0;
				gdouble _tmp33_;
				gdouble _tmp34_;
				gfloat _tmp35_;
				gdouble nprop = 0.0;
				gdouble _tmp36_;
				gdouble _tmp37_;
				GObject* _tmp38_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				old = g_value_get_double (&c.old);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				new = g_value_get_double (&c.new);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp30_ = self->tween;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp30__target = self->tween_target;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				if (_tmp30_ != NULL) {
#line 512 "animation.c"
					BudgieTaskListTweenFunc _tmp31_;
					void* _tmp31__target;
					gfloat _tmp32_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp31_ = self->tween;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp31__target = self->tween_target;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp32_ = factor;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					factor = (gfloat) _tmp31_ ((gdouble) _tmp32_, _tmp31__target);
#line 524 "animation.c"
				}
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp33_ = new;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp34_ = old;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp35_ = factor;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				delta = (_tmp33_ - _tmp34_) * _tmp35_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp36_ = old;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp37_ = delta;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				nprop = (gdouble) (_tmp36_ + _tmp37_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				_tmp38_ = self->object;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				if (_tmp38_ == NULL) {
#line 544 "animation.c"
					BudgieTaskListPropChange _tmp39_;
					const gchar* _tmp40_;
					gdouble _tmp41_;
					GValue _tmp42_ = {0};
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp39_ = c;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp40_ = _tmp39_.property;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp41_ = nprop;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_value_init (&_tmp42_, G_TYPE_DOUBLE);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_value_set_double (&_tmp42_, _tmp41_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_object_set_property ((GObject*) widget, _tmp40_, &_tmp42_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					G_IS_VALUE (&_tmp42_) ? (g_value_unset (&_tmp42_), NULL) : NULL;
#line 563 "animation.c"
				} else {
					GObject* _tmp43_;
					BudgieTaskListPropChange _tmp44_;
					const gchar* _tmp45_;
					gdouble _tmp46_;
					GValue _tmp47_ = {0};
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp43_ = self->object;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp44_ = c;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp45_ = _tmp44_.property;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					_tmp46_ = nprop;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_value_init (&_tmp47_, G_TYPE_DOUBLE);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_value_set_double (&_tmp47_, _tmp46_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					g_object_set_property (_tmp43_, _tmp45_, &_tmp47_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
					G_IS_VALUE (&_tmp47_) ? (g_value_unset (&_tmp47_), NULL) : NULL;
#line 586 "animation.c"
				}
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
				budgie_task_list_prop_change_destroy (&c);
#line 590 "animation.c"
			}
		}
	}
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	gtk_widget_queue_draw (widget);
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp48_ = self->can_anim;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = _tmp48_;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 602 "animation.c"
}


/**
     * Start this animation by attaching ourselves to the GdkFrameClock
     *
     * @param compl A completion callback to execute when this animation completes
     */
static gboolean
_budgie_task_list_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                             GdkFrameClock* frame_clock,
                                                             gpointer self)
{
	gboolean result;
	result = budgie_task_list_animation_tick_callback ((BudgieTaskListAnimation*) self, widget, frame_clock);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 620 "animation.c"
}


void
budgie_task_list_animation_start (BudgieTaskListAnimation* self,
                                  BudgieTaskListAnimCompletionFunc compl,
                                  gpointer compl_target)
{
	gboolean _tmp0_;
	GtkWidget* _tmp3_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_return_if_fail (self != NULL);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp0_ = self->no_reset;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (!_tmp0_) {
#line 637 "animation.c"
		GtkWidget* _tmp1_;
		GdkFrameClock* _tmp2_;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp1_ = self->widget;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp2_ = gtk_widget_get_frame_clock (_tmp1_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		self->start_time = gdk_frame_clock_get_frame_time (_tmp2_);
#line 646 "animation.c"
	}
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl = compl;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target = compl_target;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->can_anim = TRUE;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp3_ = self->widget;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->id = gtk_widget_add_tick_callback (_tmp3_, _budgie_task_list_animation_tick_callback_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 668 "animation.c"
}


/**
     * Stop a running animation
     */
void
budgie_task_list_animation_stop (BudgieTaskListAnimation* self)
{
	guint _tmp0_;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->can_anim = FALSE;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_tmp0_ = self->id;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 687 "animation.c"
		GtkWidget* _tmp1_;
		guint _tmp2_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp1_ = self->widget;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp2_ = self->id;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		gtk_widget_remove_tick_callback (_tmp1_, _tmp2_);
#line 696 "animation.c"
	}
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->id = (guint) 0;
#line 700 "animation.c"
}


BudgieTaskListAnimation*
budgie_task_list_animation_construct (GType object_type)
{
	BudgieTaskListAnimation * self = NULL;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self = (BudgieTaskListAnimation*) g_object_new (object_type, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return self;
#line 712 "animation.c"
}


BudgieTaskListAnimation*
budgie_task_list_animation_new (void)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return budgie_task_list_animation_construct (BUDGIE_TASK_LIST_TYPE_ANIMATION);
#line 721 "animation.c"
}


static void
budgie_task_list_animation_class_init (BudgieTaskListAnimationClass * klass)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	budgie_task_list_animation_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	g_type_class_add_private (klass, sizeof (BudgieTaskListAnimationPrivate));
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_task_list_animation_finalize;
#line 734 "animation.c"
}


static void
budgie_task_list_animation_instance_init (BudgieTaskListAnimation * self)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv = BUDGIE_TASK_LIST_ANIMATION_GET_PRIVATE (self);
#line 743 "animation.c"
}


static void
budgie_task_list_animation_finalize (GObject * obj)
{
	BudgieTaskListAnimation * self;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimation);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->changes = (_vala_BudgieTaskListPropChange_array_free (self->changes, self->changes_length1), NULL);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	_g_object_unref0 (self->object);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	G_OBJECT_CLASS (budgie_task_list_animation_parent_class)->finalize (obj);
#line 767 "animation.c"
}


/**
 * Utility to struct to enable easier animations
 * Inspired by Clutter. 
 */
GType
budgie_task_list_animation_get_type (void)
{
	return budgie_task_list_animation_type_id;
}


GType
budgie_task_list_animation_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieTaskListAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_task_list_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieTaskListAnimation), 0, (GInstanceInitFunc) budgie_task_list_animation_instance_init, NULL };
	budgie_task_list_animation_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "BudgieTaskListAnimation", &g_define_type_info, 0);
	return budgie_task_list_animation_type_id;
}


gdouble
budgie_task_list_sine_ease_in_out (gdouble p)
{
	gdouble result = 0.0;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = 0.5 * (1 - cos (p * G_PI));
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 799 "animation.c"
}


gdouble
budgie_task_list_sine_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = sin ((p - 1) * G_PI_2) + 1;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 811 "animation.c"
}


gdouble
budgie_task_list_sine_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = sin (p * G_PI_2);
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 823 "animation.c"
}


gdouble
budgie_task_list_elastic_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = sin ((13 * G_PI_2) * p) * pow ((gdouble) 2, 10 * (p - 1));
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 835 "animation.c"
}


gdouble
budgie_task_list_elastic_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = (sin ((-13 * G_PI_2) * (p + 1)) * pow ((gdouble) 2, -10 * p)) + 1;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 847 "animation.c"
}


gdouble
budgie_task_list_back_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = ((p * p) * p) - (p * sin (p * G_PI));
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 859 "animation.c"
}


gdouble
budgie_task_list_back_ease_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble f = 0.0;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	f = 1 - p;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = 1 - (((f * f) * f) - (f * sin (f * G_PI)));
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 874 "animation.c"
}


gdouble
budgie_task_list_expo_ease_in (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (p == 0.0) {
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = p;
#line 887 "animation.c"
	} else {
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = pow ((gdouble) 2, 10 * (p - 1));
#line 891 "animation.c"
	}
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = _tmp0_;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 897 "animation.c"
}


gdouble
budgie_task_list_expo_ease_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (p == 1.0) {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = p;
#line 910 "animation.c"
	} else {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = 1 - pow ((gdouble) 2, -10 * p);
#line 914 "animation.c"
	}
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = _tmp0_;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 920 "animation.c"
}


gdouble
budgie_task_list_quad_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = p * p;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 932 "animation.c"
}


gdouble
budgie_task_list_quad_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = -(p * (p - 2));
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 944 "animation.c"
}


gdouble
budgie_task_list_quad_ease_in_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	if (p < 0.5) {
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = (2 * p) * p;
#line 957 "animation.c"
	} else {
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
		_tmp0_ = (((-2 * p) * p) + (4 * p)) - 1;
#line 961 "animation.c"
	}
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = _tmp0_;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 967 "animation.c"
}


gdouble
budgie_task_list_circ_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = 1 - sqrt (1 - (p * p));
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 979 "animation.c"
}


gdouble
budgie_task_list_circ_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	result = sqrt ((2 - p) * p);
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/icon-tasklist/animation.vala"
	return result;
#line 991 "animation.c"
}



