/* MountHelper.c generated by valac 0.40.19, the Vala compiler
 * generated from MountHelper.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_MOUNT_HELPER (mount_helper_get_type ())
#define MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_HELPER, MountHelper))
#define MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_HELPER, MountHelperClass))
#define IS_MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_HELPER))
#define IS_MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_HELPER))
#define MOUNT_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_HELPER, MountHelperClass))

typedef struct _MountHelper MountHelper;
typedef struct _MountHelperClass MountHelperClass;
typedef struct _MountHelperPrivate MountHelperPrivate;
enum  {
	MOUNT_HELPER_0_PROPERTY,
	MOUNT_HELPER_NUM_PROPERTIES
};
static GParamSpec* mount_helper_properties[MOUNT_HELPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MOUNT_HELPER_SEND_MESSAGE_SIGNAL,
	MOUNT_HELPER_PASSWORD_ASKED_SIGNAL,
	MOUNT_HELPER_REQUEST_MOUNT_SIGNAL,
	MOUNT_HELPER_NUM_SIGNALS
};
static guint mount_helper_signals[MOUNT_HELPER_NUM_SIGNALS] = {0};

struct _MountHelper {
	GMountOperation parent_instance;
	MountHelperPrivate * priv;
};

struct _MountHelperClass {
	GMountOperationClass parent_class;
};

struct _MountHelperPrivate {
	GtkRevealer* revealer;
	GtkEntry* password_entry;
	GtkButton* unlock_button;
};


static gpointer mount_helper_parent_class = NULL;
static GType mount_helper_type_id = 0;

GType mount_helper_register_type (GTypeModule * module);
GType mount_helper_get_type (void) G_GNUC_CONST;
#define MOUNT_HELPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MOUNT_HELPER, MountHelperPrivate))
MountHelper* mount_helper_new (void);
MountHelper* mount_helper_construct (GType object_type);
static void mount_helper_handle_password (MountHelper* self,
                                   const gchar* message,
                                   const gchar* default_user,
                                   const gchar* default_domain,
                                   GAskPasswordFlags flags);
static void _mount_helper_handle_password_g_mount_operation_ask_password (GMountOperation* _sender,
                                                                   const gchar* message,
                                                                   const gchar* default_user,
                                                                   const gchar* default_domain,
                                                                   GAskPasswordFlags flags,
                                                                   gpointer self);
static void mount_helper_handle_block (MountHelper* self);
static void _mount_helper_handle_block_g_mount_operation_show_processes (GMountOperation* _sender,
                                                                  const gchar* message,
                                                                  GArray* processes,
                                                                  gchar** choices,
                                                                  gpointer self);
static void mount_helper_handle_aborted (MountHelper* self);
static void _mount_helper_handle_aborted_g_mount_operation_aborted (GMountOperation* _sender,
                                                             gpointer self);
GtkRevealer* mount_helper_get_encryption_form (MountHelper* self);
static void mount_helper_on_entry_changed (MountHelper* self);
static void _mount_helper_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self);
static void mount_helper_do_unlock (MountHelper* self);
static void _mount_helper_do_unlock_gtk_entry_activate (GtkEntry* _sender,
                                                 gpointer self);
static void _mount_helper_do_unlock_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self);
GtkEntry* mount_helper_get_password_entry (MountHelper* self);
static void mount_helper_finalize (GObject * obj);


static void
_mount_helper_handle_password_g_mount_operation_ask_password (GMountOperation* _sender,
                                                              const gchar* message,
                                                              const gchar* default_user,
                                                              const gchar* default_domain,
                                                              GAskPasswordFlags flags,
                                                              gpointer self)
{
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_handle_password ((MountHelper*) self, message, default_user, default_domain, flags);
#line 117 "MountHelper.c"
}


static void
_mount_helper_handle_block_g_mount_operation_show_processes (GMountOperation* _sender,
                                                             const gchar* message,
                                                             GArray* processes,
                                                             gchar** choices,
                                                             gpointer self)
{
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_handle_block ((MountHelper*) self);
#line 130 "MountHelper.c"
}


static void
_mount_helper_handle_aborted_g_mount_operation_aborted (GMountOperation* _sender,
                                                        gpointer self)
{
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_handle_aborted ((MountHelper*) self);
#line 140 "MountHelper.c"
}


MountHelper*
mount_helper_construct (GType object_type)
{
	MountHelper * self = NULL;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self = (MountHelper*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_mount_operation_set_password_save ((GMountOperation*) self, G_PASSWORD_SAVE_FOR_SESSION);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object ((GMountOperation*) self, "ask-password", (GCallback) _mount_helper_handle_password_g_mount_operation_ask_password, self, 0);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object ((GMountOperation*) self, "show-processes", (GCallback) _mount_helper_handle_block_g_mount_operation_show_processes, self, 0);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object ((GMountOperation*) self, "aborted", (GCallback) _mount_helper_handle_aborted_g_mount_operation_aborted, self, 0);
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	return self;
#line 160 "MountHelper.c"
}


MountHelper*
mount_helper_new (void)
{
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	return mount_helper_construct (TYPE_MOUNT_HELPER);
#line 169 "MountHelper.c"
}


static void
mount_helper_handle_password (MountHelper* self,
                              const gchar* message,
                              const gchar* default_user,
                              const gchar* default_domain,
                              GAskPasswordFlags flags)
{
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (message != NULL);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (default_user != NULL);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (default_domain != NULL);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_emit (self, mount_helper_signals[MOUNT_HELPER_PASSWORD_ASKED_SIGNAL], 0);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_mount_operation_reply ((GMountOperation*) self, G_MOUNT_OPERATION_HANDLED);
#line 192 "MountHelper.c"
}


static void
mount_helper_handle_block (MountHelper* self)
{
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_emit (self, mount_helper_signals[MOUNT_HELPER_SEND_MESSAGE_SIGNAL], 0, _ ("Volume is in use by other processes"));
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_mount_operation_reply ((GMountOperation*) self, G_MOUNT_OPERATION_HANDLED);
#line 205 "MountHelper.c"
}


static void
mount_helper_handle_aborted (MountHelper* self)
{
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_emit (self, mount_helper_signals[MOUNT_HELPER_SEND_MESSAGE_SIGNAL], 0, _ ("Operation aborted"));
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_mount_operation_reply ((GMountOperation*) self, G_MOUNT_OPERATION_HANDLED);
#line 218 "MountHelper.c"
}


static void
_mount_helper_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                     gpointer self)
{
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_on_entry_changed ((MountHelper*) self);
#line 228 "MountHelper.c"
}


static void
_mount_helper_do_unlock_gtk_entry_activate (GtkEntry* _sender,
                                            gpointer self)
{
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_do_unlock ((MountHelper*) self);
#line 238 "MountHelper.c"
}


static void
_mount_helper_do_unlock_gtk_button_clicked (GtkButton* _sender,
                                            gpointer self)
{
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_do_unlock ((MountHelper*) self);
#line 248 "MountHelper.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	return self ? g_object_ref (self) : NULL;
#line 257 "MountHelper.c"
}


GtkRevealer*
mount_helper_get_encryption_form (MountHelper* self)
{
	GtkRevealer* result = NULL;
	GtkRevealer* _tmp0_;
	GtkBox* unlock_box = NULL;
	GtkBox* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkRevealer* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkRevealer* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkButton* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp0_ = (GtkRevealer*) gtk_revealer_new ();
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_object_ref_sink (_tmp0_);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->revealer);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self->priv->revealer = _tmp0_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_object_ref_sink (_tmp1_);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	unlock_box = _tmp1_;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) unlock_box);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_style_context_add_class (_tmp2_, "unlock-area");
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp3_ = self->priv->revealer;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) unlock_box);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp4_ = (GtkEntry*) gtk_entry_new ();
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_object_ref_sink (_tmp4_);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self->priv->password_entry = _tmp4_;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp5_ = self->priv->password_entry;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_entry_set_placeholder_text (_tmp5_, _ ("Type your password"));
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp6_ = self->priv->password_entry;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_entry_set_input_purpose (_tmp6_, GTK_INPUT_PURPOSE_PASSWORD);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp7_ = self->priv->password_entry;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_entry_set_visibility (_tmp7_, FALSE);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp8_ = self->priv->password_entry;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_box_pack_start (unlock_box, (GtkWidget*) _tmp8_, TRUE, TRUE, (guint) 0);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("changes-allow-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_object_ref_sink (_tmp9_);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->unlock_button);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self->priv->unlock_button = _tmp9_;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp10_ = self->priv->unlock_button;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp11_ = self->priv->unlock_button;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_box_pack_end (unlock_box, (GtkWidget*) _tmp11_, FALSE, FALSE, (guint) 0);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp12_ = self->priv->revealer;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp12_);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp13_ = self->priv->password_entry;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object ((GtkEditable*) _tmp13_, "changed", (GCallback) _mount_helper_on_entry_changed_gtk_editable_changed, self, 0);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp14_ = self->priv->password_entry;
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) _mount_helper_do_unlock_gtk_entry_activate, self, 0);
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp15_ = self->priv->unlock_button;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_connect_object (_tmp15_, "clicked", (GCallback) _mount_helper_do_unlock_gtk_button_clicked, self, 0);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp16_ = self->priv->revealer;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	result = _tmp17_;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (unlock_box);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	return result;
#line 374 "MountHelper.c"
}


static void
mount_helper_on_entry_changed (MountHelper* self)
{
	GtkButton* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp0_ = self->priv->unlock_button;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp1_ = self->priv->password_entry;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp3_ = strlen (_tmp2_);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp4_ = _tmp3_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp4_ > 0);
#line 400 "MountHelper.c"
}


static void
mount_helper_do_unlock (MountHelper* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	GtkRevealer* _tmp2_;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp0_ = self->priv->password_entry;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
		return;
#line 422 "MountHelper.c"
	}
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp2_ = self->priv->revealer;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp3_ = self->priv->password_entry;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp4_ = gtk_entry_get_text (_tmp3_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_mount_operation_set_password ((GMountOperation*) self, _tmp4_);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_signal_emit (self, mount_helper_signals[MOUNT_HELPER_REQUEST_MOUNT_SIGNAL], 0);
#line 436 "MountHelper.c"
}


GtkEntry*
mount_helper_get_password_entry (MountHelper* self)
{
	GtkEntry* result = NULL;
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp0_ = self->priv->password_entry;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	result = _tmp1_;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	return result;
#line 456 "MountHelper.c"
}


static void
mount_helper_class_init (MountHelperClass * klass)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	g_type_class_add_private (klass, sizeof (MountHelperPrivate));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	G_OBJECT_CLASS (klass)->finalize = mount_helper_finalize;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_signals[MOUNT_HELPER_SEND_MESSAGE_SIGNAL] = g_signal_new ("send-message", TYPE_MOUNT_HELPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_signals[MOUNT_HELPER_PASSWORD_ASKED_SIGNAL] = g_signal_new ("password-asked", TYPE_MOUNT_HELPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	mount_helper_signals[MOUNT_HELPER_REQUEST_MOUNT_SIGNAL] = g_signal_new ("request-mount", TYPE_MOUNT_HELPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 475 "MountHelper.c"
}


static void
mount_helper_instance_init (MountHelper * self)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self->priv = MOUNT_HELPER_GET_PRIVATE (self);
#line 484 "MountHelper.c"
}


static void
mount_helper_finalize (GObject * obj)
{
	MountHelper * self;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MOUNT_HELPER, MountHelper);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->revealer);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	_g_object_unref0 (self->priv->unlock_button);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountHelper.vala"
	G_OBJECT_CLASS (mount_helper_parent_class)->finalize (obj);
#line 502 "MountHelper.c"
}


GType
mount_helper_get_type (void)
{
	return mount_helper_type_id;
}


GType
mount_helper_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MountHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mount_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MountHelper), 0, (GInstanceInitFunc) mount_helper_instance_init, NULL };
	mount_helper_type_id = g_type_module_register_type (module, g_mount_operation_get_type (), "MountHelper", &g_define_type_info, 0);
	return mount_helper_type_id;
}



