/* MountItem.c generated by valac 0.40.19, the Vala compiler
 * generated from MountItem.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_LIST_ITEM (list_item_get_type ())
#define LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIST_ITEM, ListItem))
#define LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIST_ITEM, ListItemClass))
#define IS_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIST_ITEM))
#define IS_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIST_ITEM))
#define LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIST_ITEM, ListItemClass))

typedef struct _ListItem ListItem;
typedef struct _ListItemClass ListItemClass;
typedef struct _ListItemPrivate ListItemPrivate;

#define TYPE_MOUNT_ITEM (mount_item_get_type ())
#define MOUNT_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ITEM, MountItem))
#define MOUNT_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ITEM, MountItemClass))
#define IS_MOUNT_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ITEM))
#define IS_MOUNT_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ITEM))
#define MOUNT_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ITEM, MountItemClass))

typedef struct _MountItem MountItem;
typedef struct _MountItemClass MountItemClass;
typedef struct _MountItemPrivate MountItemPrivate;

#define TYPE_MOUNT_HELPER (mount_helper_get_type ())
#define MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_HELPER, MountHelper))
#define MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_HELPER, MountHelperClass))
#define IS_MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_HELPER))
#define IS_MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_HELPER))
#define MOUNT_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_HELPER, MountHelperClass))

typedef struct _MountHelper MountHelper;
typedef struct _MountHelperClass MountHelperClass;
enum  {
	MOUNT_ITEM_0_PROPERTY,
	MOUNT_ITEM_NUM_PROPERTIES
};
static GParamSpec* mount_item_properties[MOUNT_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ListItem {
	GtkBox parent_instance;
	ListItemPrivate * priv;
	gchar* item_class;
	gchar* category_name;
	GtkToolButton* name_button;
	GtkOverlay* overlay;
	GtkSpinner* spin;
};

struct _ListItemClass {
	GtkBoxClass parent_class;
	void (*cancel_operation) (ListItem* self);
};

struct _MountItem {
	ListItem parent_instance;
	MountItemPrivate * priv;
};

struct _MountItemClass {
	ListItemClass parent_class;
};

struct _MountItemPrivate {
	MountHelper* operation;
	GMount* mount;
};

struct _Block2Data {
	int _ref_count_;
	MountItem* self;
	GMount* mount;
};


static gpointer mount_item_parent_class = NULL;
static GType mount_item_type_id = 0;

GType list_item_register_type (GTypeModule * module);
GType list_item_get_type (void) G_GNUC_CONST;
GType mount_item_register_type (GTypeModule * module);
GType mount_item_get_type (void) G_GNUC_CONST;
GType mount_helper_register_type (GTypeModule * module);
GType mount_helper_get_type (void) G_GNUC_CONST;
#define MOUNT_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MOUNT_ITEM, MountItemPrivate))
MountItem* mount_item_new (GMount* mount,
                           const gchar* class);
MountItem* mount_item_construct (GType object_type,
                                 GMount* mount,
                                 const gchar* class);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
ListItem* list_item_construct (GType object_type);
void list_item_set_button (ListItem* self,
                           const gchar* label,
                           GtkImage* image,
                           gboolean spinner,
                           gboolean offset_spinner);
GtkImage* list_item_get_icon (ListItem* self,
                              GIcon* icon);
MountHelper* mount_helper_new (void);
MountHelper* mount_helper_construct (GType object_type);
static void __lambda10_ (Block2Data* _data2_);
static void mount_item_do_eject (MountItem* self);
static void mount_item_do_unmount (MountItem* self);
static void ___lambda10__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda11_ (Block2Data* _data2_);
void list_item_open_directory (ListItem* self,
                               GFile* root);
static void ___lambda11__gtk_tool_button_clicked (GtkToolButton* _sender,
                                           gpointer self);
static void mount_item_on_eject (MountItem* self,
                          GObject* obj,
                          GAsyncResult* res);
static void _mount_item_on_eject_gasync_ready_callback (GObject* source_object,
                                                 GAsyncResult* res,
                                                 gpointer self);
static void mount_item_on_unmount (MountItem* self,
                            GObject* obj,
                            GAsyncResult* res);
static void _mount_item_on_unmount_gasync_ready_callback (GObject* source_object,
                                                   GAsyncResult* res,
                                                   gpointer self);
static void mount_item_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "MountItem.c"
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	return _data2_;
#line 171 "MountItem.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 182 "MountItem.c"
		MountItem* self;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		self = _data2_->self;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_g_object_unref0 (_data2_->mount);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_g_object_unref0 (self);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_slice_free (Block2Data, _data2_);
#line 192 "MountItem.c"
	}
}


static void
__lambda10_ (Block2Data* _data2_)
{
	MountItem* self;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self = _data2_->self;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (g_mount_can_eject (_data2_->mount)) {
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		mount_item_do_eject (self);
#line 207 "MountItem.c"
	} else {
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		mount_item_do_unmount (self);
#line 211 "MountItem.c"
	}
}


static void
___lambda10__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	__lambda10_ (self);
#line 222 "MountItem.c"
}


static void
__lambda11_ (Block2Data* _data2_)
{
	MountItem* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self = _data2_->self;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp0_ = g_mount_get_root (_data2_->mount);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp1_ = _tmp0_;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	list_item_open_directory ((ListItem*) self, _tmp1_);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (_tmp1_);
#line 242 "MountItem.c"
}


static void
___lambda11__gtk_tool_button_clicked (GtkToolButton* _sender,
                                      gpointer self)
{
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	__lambda11_ (self);
#line 252 "MountItem.c"
}


MountItem*
mount_item_construct (GType object_type,
                      GMount* mount,
                      const gchar* class)
{
	MountItem * self = NULL;
	Block2Data* _data2_;
	GMount* _tmp0_;
	gchar* _tmp1_;
	GMount* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	static GQuark _tmp5_label0 = 0;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	static GQuark _tmp5_label1 = 0;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	static GQuark _tmp5_label2 = 0;
#line 275 "MountItem.c"
	gchar* _tmp11_;
	gchar* _tmp12_;
	GIcon* _tmp13_;
	GIcon* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	MountHelper* _tmp17_;
	GtkButton* unmount_button = NULL;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkOverlay* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkToolButton* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GtkToolButton* _tmp34_;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_data2_->_ref_count_ = 1;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (_data2_->mount);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_data2_->mount = _tmp0_;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self = (MountItem*) list_item_construct (object_type);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_data2_->self = g_object_ref (self);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp1_ = g_strdup (class);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (((ListItem*) self)->item_class);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	((ListItem*) self)->item_class = _tmp1_;
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp2_ = _g_object_ref0 (_data2_->mount);
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (self->priv->mount);
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self->priv->mount = _tmp2_;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp3_ = ((ListItem*) self)->item_class;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp4_ = _tmp3_;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("device")))) {
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		switch (0) {
#line 337 "MountItem.c"
			default:
			{
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				if (g_mount_can_eject (_data2_->mount)) {
#line 342 "MountItem.c"
					gchar* _tmp7_;
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					_tmp7_ = g_strdup (_ ("Removable devices"));
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					_g_free0 (((ListItem*) self)->category_name);
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					((ListItem*) self)->category_name = _tmp7_;
#line 350 "MountItem.c"
				} else {
					gchar* _tmp8_;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					_tmp8_ = g_strdup (_ ("Local volumes"));
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					_g_free0 (((ListItem*) self)->category_name);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
					((ListItem*) self)->category_name = _tmp8_;
#line 359 "MountItem.c"
				}
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				break;
#line 363 "MountItem.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("network")))) {
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		switch (0) {
#line 369 "MountItem.c"
			default:
			{
				gchar* _tmp9_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				_tmp9_ = g_strdup (_ ("Network folders"));
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				_g_free0 (((ListItem*) self)->category_name);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				((ListItem*) self)->category_name = _tmp9_;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				break;
#line 381 "MountItem.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string (NULL)))) {
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		switch (0) {
#line 387 "MountItem.c"
			default:
			{
				gchar* _tmp10_;
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				_tmp10_ = g_strdup (_ ("Other"));
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				_g_free0 (((ListItem*) self)->category_name);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				((ListItem*) self)->category_name = _tmp10_;
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				break;
#line 399 "MountItem.c"
			}
		}
	} else {
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		switch (0) {
#line 405 "MountItem.c"
			default:
			{
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
				break;
#line 410 "MountItem.c"
			}
		}
	}
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp11_ = g_mount_get_name (_data2_->mount);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp12_ = _tmp11_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp13_ = g_mount_get_symbolic_icon (_data2_->mount);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp14_ = _tmp13_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp15_ = list_item_get_icon ((ListItem*) self, _tmp14_);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp16_ = _tmp15_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	list_item_set_button ((ListItem*) self, _tmp12_, _tmp16_, FALSE, FALSE);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (_tmp16_);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (_tmp14_);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (_tmp12_);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp17_ = mount_helper_new ();
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (self->priv->operation);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self->priv->operation = _tmp17_;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp18_ = (GtkButton*) gtk_button_new_from_icon_name ("media-eject-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_object_ref_sink (_tmp18_);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	unmount_button = _tmp18_;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp19_ = unmount_button;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _tmp19_);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_style_context_add_class (_tmp20_, "unmount-button");
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp21_ = unmount_button;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_button_set_relief (_tmp21_, GTK_RELIEF_NONE);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp22_ = unmount_button;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp22_, FALSE);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp23_ = unmount_button;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp24_ = ((ListItem*) self)->overlay;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp25_ = unmount_button;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_overlay_add_overlay (_tmp24_, (GtkWidget*) _tmp25_);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp26_ = unmount_button;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_signal_connect_data (_tmp26_, "clicked", (GCallback) ___lambda10__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (g_mount_can_eject (_data2_->mount)) {
#line 476 "MountItem.c"
		GtkButton* _tmp27_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp27_ = unmount_button;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Eject"));
#line 482 "MountItem.c"
	} else {
		GtkButton* _tmp28_;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp28_ = unmount_button;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp28_, _ ("Unmount"));
#line 489 "MountItem.c"
	}
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp29_ = ((ListItem*) self)->name_button;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp30_ = g_mount_get_name (_data2_->mount);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp31_ = _tmp30_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp32_ = g_strdup_printf (_ ("Open \"%s\""), _tmp31_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp33_ = _tmp32_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	gtk_tool_item_set_tooltip_text ((GtkToolItem*) _tmp29_, _tmp33_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (_tmp33_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (_tmp31_);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp34_ = ((ListItem*) self)->name_button;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_signal_connect_data (_tmp34_, "clicked", (GCallback) ___lambda11__gtk_tool_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (unmount_button);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	block2_data_unref (_data2_);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_data2_ = NULL;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	return self;
#line 519 "MountItem.c"
}


MountItem*
mount_item_new (GMount* mount,
                const gchar* class)
{
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	return mount_item_construct (TYPE_MOUNT_ITEM, mount, class);
#line 529 "MountItem.c"
}


static void
_mount_item_on_eject_gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self)
{
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	mount_item_on_eject ((MountItem*) self, source_object, res);
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_object_unref (self);
#line 542 "MountItem.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1515 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = self;
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 556 "MountItem.c"
}


static void
mount_item_do_eject (MountItem* self)
{
	GMount* _tmp0_;
	MountHelper* _tmp1_;
	gchar* safe_remove = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	GMount* _tmp4_;
	GDrive* _tmp5_;
	GDrive* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* device_name = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp0_ = self->priv->mount;
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp1_ = self->priv->operation;
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_mount_eject_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, (GMountOperation*) _tmp1_, NULL, _mount_item_on_eject_gasync_ready_callback, g_object_ref (self));
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp2_ = g_strdup (_ ("You can now safely remove"));
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	safe_remove = _tmp2_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp4_ = self->priv->mount;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp5_ = g_mount_get_drive (_tmp4_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp6_ = _tmp5_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp7_ = g_drive_get_name (_tmp6_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp8_ = _tmp7_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (_tmp6_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp3_ = _tmp8_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (_tmp3_ == NULL) {
#line 608 "MountItem.c"
		gchar* _tmp9_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp9_ = g_strdup (_ ("Unknown Device"));
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_g_free0 (_tmp3_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp3_ = _tmp9_;
#line 616 "MountItem.c"
	}
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp10_ = _tmp3_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp3_ = NULL;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	device_name = _tmp10_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp11_ = safe_remove;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp12_ = string_to_string (_tmp11_);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp13_ = string_to_string (device_name);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp14_ = g_strconcat (_tmp12_, " \"", _tmp13_, "\"", NULL);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp15_ = _tmp14_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_signal_emit_by_name ((ListItem*) self, "send-message", _tmp15_);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (_tmp15_);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (device_name);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (_tmp3_);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_free0 (safe_remove);
#line 644 "MountItem.c"
}


static void
mount_item_on_eject (MountItem* self,
                     GObject* obj,
                     GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (self != NULL);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (res != NULL);
#line 658 "MountItem.c"
	{
		GMount* _tmp0_;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp0_ = self->priv->mount;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_mount_eject_with_operation_finish (_tmp0_, res, &_inner_error0_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "MountItem.c"
			goto __catch5_g_error;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		e = _inner_error0_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_inner_error0_ = NULL;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("Error while ejecting device"));
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp1_ = e;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp2_ = _tmp1_->message;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_warning ("MountItem.vala:89: %s", _tmp2_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_g_error_free0 (e);
#line 691 "MountItem.c"
	}
	__finally5:
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_clear_error (&_inner_error0_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		return;
#line 702 "MountItem.c"
	}
}


static void
_mount_item_on_unmount_gasync_ready_callback (GObject* source_object,
                                              GAsyncResult* res,
                                              gpointer self)
{
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	mount_item_on_unmount ((MountItem*) self, source_object, res);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_object_unref (self);
#line 716 "MountItem.c"
}


static void
mount_item_do_unmount (MountItem* self)
{
	GMount* _tmp0_;
	MountHelper* _tmp1_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp0_ = self->priv->mount;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_tmp1_ = self->priv->operation;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, (GMountOperation*) _tmp1_, NULL, _mount_item_on_unmount_gasync_ready_callback, g_object_ref (self));
#line 733 "MountItem.c"
}


static void
mount_item_on_unmount (MountItem* self,
                       GObject* obj,
                       GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_return_if_fail (res != NULL);
#line 747 "MountItem.c"
	{
		GMount* _tmp0_;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp0_ = self->priv->mount;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_mount_unmount_with_operation_finish (_tmp0_, res, &_inner_error0_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "MountItem.c"
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		e = _inner_error0_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_inner_error0_ = NULL;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("Error while unmounting volume"));
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp1_ = e;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_tmp2_ = _tmp1_->message;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_warning ("MountItem.vala:106: %s", _tmp2_);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		_g_error_free0 (e);
#line 780 "MountItem.c"
	}
	__finally6:
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		g_clear_error (&_inner_error0_);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
		return;
#line 791 "MountItem.c"
	}
}


static void
mount_item_class_init (MountItemClass * klass)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	mount_item_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	g_type_class_add_private (klass, sizeof (MountItemPrivate));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	G_OBJECT_CLASS (klass)->finalize = mount_item_finalize;
#line 805 "MountItem.c"
}


static void
mount_item_instance_init (MountItem * self)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self->priv = MOUNT_ITEM_GET_PRIVATE (self);
#line 814 "MountItem.c"
}


static void
mount_item_finalize (GObject * obj)
{
	MountItem * self;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MOUNT_ITEM, MountItem);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (self->priv->operation);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	_g_object_unref0 (self->priv->mount);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/MountItem.vala"
	G_OBJECT_CLASS (mount_item_parent_class)->finalize (obj);
#line 830 "MountItem.c"
}


GType
mount_item_get_type (void)
{
	return mount_item_type_id;
}


GType
mount_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MountItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mount_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MountItem), 0, (GInstanceInitFunc) mount_item_instance_init, NULL };
	mount_item_type_id = g_type_module_register_type (module, TYPE_LIST_ITEM, "MountItem", &g_define_type_info, 0);
	return mount_item_type_id;
}



