/* VolumeItem.c generated by valac 0.40.19, the Vala compiler
 * generated from VolumeItem.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_LIST_ITEM (list_item_get_type ())
#define LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIST_ITEM, ListItem))
#define LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIST_ITEM, ListItemClass))
#define IS_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIST_ITEM))
#define IS_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIST_ITEM))
#define LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIST_ITEM, ListItemClass))

typedef struct _ListItem ListItem;
typedef struct _ListItemClass ListItemClass;
typedef struct _ListItemPrivate ListItemPrivate;

#define TYPE_VOLUME_ITEM (volume_item_get_type ())
#define VOLUME_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VOLUME_ITEM, VolumeItem))
#define VOLUME_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VOLUME_ITEM, VolumeItemClass))
#define IS_VOLUME_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VOLUME_ITEM))
#define IS_VOLUME_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VOLUME_ITEM))
#define VOLUME_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VOLUME_ITEM, VolumeItemClass))

typedef struct _VolumeItem VolumeItem;
typedef struct _VolumeItemClass VolumeItemClass;
typedef struct _VolumeItemPrivate VolumeItemPrivate;

#define TYPE_MOUNT_HELPER (mount_helper_get_type ())
#define MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_HELPER, MountHelper))
#define MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_HELPER, MountHelperClass))
#define IS_MOUNT_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_HELPER))
#define IS_MOUNT_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_HELPER))
#define MOUNT_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_HELPER, MountHelperClass))

typedef struct _MountHelper MountHelper;
typedef struct _MountHelperClass MountHelperClass;
enum  {
	VOLUME_ITEM_0_PROPERTY,
	VOLUME_ITEM_NUM_PROPERTIES
};
static GParamSpec* volume_item_properties[VOLUME_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ListItem {
	GtkBox parent_instance;
	ListItemPrivate * priv;
	gchar* item_class;
	gchar* category_name;
	GtkToolButton* name_button;
	GtkOverlay* overlay;
	GtkSpinner* spin;
};

struct _ListItemClass {
	GtkBoxClass parent_class;
	void (*cancel_operation) (ListItem* self);
};

struct _VolumeItem {
	ListItem parent_instance;
	VolumeItemPrivate * priv;
};

struct _VolumeItemClass {
	ListItemClass parent_class;
};

struct _VolumeItemPrivate {
	MountHelper* operation;
	GtkRevealer* unlock_revealer;
	GVolume* volume;
	gboolean first_try;
};


static gpointer volume_item_parent_class = NULL;
static GType volume_item_type_id = 0;

GType list_item_register_type (GTypeModule * module);
GType list_item_get_type (void) G_GNUC_CONST;
GType volume_item_register_type (GTypeModule * module);
GType volume_item_get_type (void) G_GNUC_CONST;
GType mount_helper_register_type (GTypeModule * module);
GType mount_helper_get_type (void) G_GNUC_CONST;
#define VOLUME_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VOLUME_ITEM, VolumeItemPrivate))
VolumeItem* volume_item_new (GVolume* volume);
VolumeItem* volume_item_construct (GType object_type,
                                   GVolume* volume);
ListItem* list_item_construct (GType object_type);
void list_item_set_button (ListItem* self,
                           const gchar* label,
                           GtkImage* image,
                           gboolean spinner,
                           gboolean offset_spinner);
GtkImage* list_item_get_icon (ListItem* self,
                              GIcon* icon);
MountHelper* mount_helper_new (void);
MountHelper* mount_helper_construct (GType object_type);
static void __lambda8_ (VolumeItem* self,
                 const gchar* message);
static void ___lambda8__mount_helper_send_message (MountHelper* _sender,
                                            const gchar* message,
                                            gpointer self);
static void volume_item_on_password_asked (VolumeItem* self);
static void _volume_item_on_password_asked_mount_helper_password_asked (MountHelper* _sender,
                                                                 gpointer self);
static void volume_item_do_mount (VolumeItem* self);
static void _volume_item_do_mount_mount_helper_request_mount (MountHelper* _sender,
                                                       gpointer self);
static void volume_item_on_eject_button_clicked (VolumeItem* self);
static void _volume_item_on_eject_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void volume_item_on_name_button_clicked (VolumeItem* self);
static void _volume_item_on_name_button_clicked_gtk_tool_button_clicked (GtkToolButton* _sender,
                                                                  gpointer self);
static void volume_item_on_eject (VolumeItem* self,
                           GObject* obj,
                           GAsyncResult* res);
static void _volume_item_on_eject_gasync_ready_callback (GObject* source_object,
                                                  GAsyncResult* res,
                                                  gpointer self);
GtkEntry* mount_helper_get_password_entry (MountHelper* self);
GtkRevealer* mount_helper_get_encryption_form (MountHelper* self);
static void volume_item_on_mount (VolumeItem* self,
                           GObject* obj,
                           GAsyncResult* res);
static void _volume_item_on_mount_gasync_ready_callback (GObject* source_object,
                                                  GAsyncResult* res,
                                                  gpointer self);
void list_item_open_directory (ListItem* self,
                               GFile* root);
static void volume_item_real_cancel_operation (ListItem* base);
static void volume_item_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "VolumeItem.c"
}


static void
__lambda8_ (VolumeItem* self,
            const gchar* message)
{
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (message != NULL);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_signal_emit_by_name ((ListItem*) self, "send-message", message);
#line 175 "VolumeItem.c"
}


static void
___lambda8__mount_helper_send_message (MountHelper* _sender,
                                       const gchar* message,
                                       gpointer self)
{
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	__lambda8_ ((VolumeItem*) self, message);
#line 186 "VolumeItem.c"
}


static void
_volume_item_on_password_asked_mount_helper_password_asked (MountHelper* _sender,
                                                            gpointer self)
{
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_on_password_asked ((VolumeItem*) self);
#line 196 "VolumeItem.c"
}


static void
_volume_item_do_mount_mount_helper_request_mount (MountHelper* _sender,
                                                  gpointer self)
{
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_do_mount ((VolumeItem*) self);
#line 206 "VolumeItem.c"
}


static void
_volume_item_on_eject_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_on_eject_button_clicked ((VolumeItem*) self);
#line 216 "VolumeItem.c"
}


static void
_volume_item_on_name_button_clicked_gtk_tool_button_clicked (GtkToolButton* _sender,
                                                             gpointer self)
{
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_on_name_button_clicked ((VolumeItem*) self);
#line 226 "VolumeItem.c"
}


VolumeItem*
volume_item_construct (GType object_type,
                       GVolume* volume)
{
	VolumeItem * self = NULL;
	gchar* _tmp0_;
	GVolume* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	static GQuark _tmp4_label0 = 0;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	static GQuark _tmp4_label1 = 0;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	static GQuark _tmp4_label2 = 0;
#line 246 "VolumeItem.c"
	gchar* _tmp10_;
	gchar* _tmp11_;
	GIcon* _tmp12_;
	GIcon* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkToolButton* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	MountHelper* _tmp21_;
	MountHelper* _tmp22_;
	MountHelper* _tmp23_;
	MountHelper* _tmp24_;
	GtkToolButton* _tmp35_;
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_val_if_fail (volume != NULL, NULL);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self = (VolumeItem*) list_item_construct (object_type);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = g_volume_get_identifier (volume, "class");
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_free0 (((ListItem*) self)->item_class);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	((ListItem*) self)->item_class = _tmp0_;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp1_ = _g_object_ref0 (volume);
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (self->priv->volume);
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv->volume = _tmp1_;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp2_ = ((ListItem*) self)->item_class;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp3_ = _tmp2_;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("device")))) {
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		switch (0) {
#line 289 "VolumeItem.c"
			default:
			{
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				if (g_volume_can_eject (volume)) {
#line 294 "VolumeItem.c"
					gchar* _tmp6_;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					_tmp6_ = g_strdup (_ ("Removable devices"));
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					_g_free0 (((ListItem*) self)->category_name);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					((ListItem*) self)->category_name = _tmp6_;
#line 302 "VolumeItem.c"
				} else {
					gchar* _tmp7_;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					_tmp7_ = g_strdup (_ ("Local volumes"));
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					_g_free0 (((ListItem*) self)->category_name);
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
					((ListItem*) self)->category_name = _tmp7_;
#line 311 "VolumeItem.c"
				}
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				break;
#line 315 "VolumeItem.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("network")))) {
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		switch (0) {
#line 321 "VolumeItem.c"
			default:
			{
				gchar* _tmp8_;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_tmp8_ = g_strdup (_ ("Network folders"));
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_g_free0 (((ListItem*) self)->category_name);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				((ListItem*) self)->category_name = _tmp8_;
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				break;
#line 333 "VolumeItem.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string (NULL)))) {
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		switch (0) {
#line 339 "VolumeItem.c"
			default:
			{
				gchar* _tmp9_;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_tmp9_ = g_strdup (_ ("Other"));
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_g_free0 (((ListItem*) self)->category_name);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				((ListItem*) self)->category_name = _tmp9_;
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				break;
#line 351 "VolumeItem.c"
			}
		}
	} else {
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		switch (0) {
#line 357 "VolumeItem.c"
			default:
			{
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				break;
#line 362 "VolumeItem.c"
			}
		}
	}
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp10_ = g_volume_get_name (volume);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp11_ = _tmp10_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp12_ = g_volume_get_symbolic_icon (volume);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp13_ = _tmp12_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp14_ = list_item_get_icon ((ListItem*) self, _tmp13_);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp15_ = _tmp14_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	list_item_set_button ((ListItem*) self, _tmp11_, _tmp15_, TRUE, g_volume_can_eject (volume));
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (_tmp15_);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (_tmp13_);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_free0 (_tmp11_);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp16_ = ((ListItem*) self)->name_button;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp17_ = g_volume_get_name (volume);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp18_ = _tmp17_;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp19_ = g_strdup_printf (_ ("Mount and open \"%s\""), _tmp18_);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp20_ = _tmp19_;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_tool_item_set_tooltip_text ((GtkToolItem*) _tmp16_, _tmp20_);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_free0 (_tmp20_);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_free0 (_tmp18_);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp21_ = mount_helper_new ();
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (self->priv->operation);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv->operation = _tmp21_;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp22_ = self->priv->operation;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_signal_connect_object (_tmp22_, "send-message", (GCallback) ___lambda8__mount_helper_send_message, self, 0);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp23_ = self->priv->operation;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_signal_connect_object (_tmp23_, "password-asked", (GCallback) _volume_item_on_password_asked_mount_helper_password_asked, self, 0);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp24_ = self->priv->operation;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_signal_connect_object (_tmp24_, "request-mount", (GCallback) _volume_item_do_mount_mount_helper_request_mount, self, 0);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (g_volume_can_eject (volume)) {
#line 422 "VolumeItem.c"
		GtkButton* eject_button = NULL;
		GtkButton* _tmp25_;
		GtkButton* _tmp26_;
		GtkStyleContext* _tmp27_;
		GtkButton* _tmp28_;
		GtkButton* _tmp29_;
		GtkButton* _tmp30_;
		GtkButton* _tmp31_;
		GtkOverlay* _tmp32_;
		GtkButton* _tmp33_;
		GtkButton* _tmp34_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp25_ = (GtkButton*) gtk_button_new_from_icon_name ("media-eject-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_object_ref_sink (_tmp25_);
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		eject_button = _tmp25_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp26_ = eject_button;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_style_context_add_class (_tmp27_, "unmount-button");
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp28_ = eject_button;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_button_set_relief (_tmp28_, GTK_RELIEF_NONE);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp29_ = eject_button;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_set_can_focus ((GtkWidget*) _tmp29_, FALSE);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp30_ = eject_button;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_END);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp31_ = eject_button;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp31_, _ ("Eject"));
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp32_ = ((ListItem*) self)->overlay;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp33_ = eject_button;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_overlay_add_overlay (_tmp32_, (GtkWidget*) _tmp33_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp34_ = eject_button;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_signal_connect_object (_tmp34_, "clicked", (GCallback) _volume_item_on_eject_button_clicked_gtk_button_clicked, self, 0);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (eject_button);
#line 474 "VolumeItem.c"
	}
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp35_ = ((ListItem*) self)->name_button;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) _volume_item_on_name_button_clicked_gtk_tool_button_clicked, self, 0);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	return self;
#line 482 "VolumeItem.c"
}


VolumeItem*
volume_item_new (GVolume* volume)
{
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	return volume_item_construct (TYPE_VOLUME_ITEM, volume);
#line 491 "VolumeItem.c"
}


static void
_volume_item_on_eject_gasync_ready_callback (GObject* source_object,
                                             GAsyncResult* res,
                                             gpointer self)
{
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_on_eject ((VolumeItem*) self, source_object, res);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_object_unref (self);
#line 504 "VolumeItem.c"
}


static void
volume_item_on_eject_button_clicked (VolumeItem* self)
{
	GVolume* _tmp0_;
	MountHelper* _tmp1_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = self->priv->volume;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp1_ = self->priv->operation;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_volume_eject_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, (GMountOperation*) _tmp1_, NULL, _volume_item_on_eject_gasync_ready_callback, g_object_ref (self));
#line 521 "VolumeItem.c"
}


static void
volume_item_on_name_button_clicked (VolumeItem* self)
{
	GtkRevealer* _tmp0_;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = self->priv->unlock_revealer;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (_tmp0_ == NULL) {
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		volume_item_do_mount (self);
#line 537 "VolumeItem.c"
	} else {
		GtkRevealer* _tmp1_;
		GtkRevealer* _tmp2_;
		GtkRevealer* _tmp3_;
		MountHelper* _tmp4_;
		GtkEntry* _tmp5_;
		GtkEntry* _tmp6_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp1_ = self->priv->unlock_revealer;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		if (!gtk_revealer_get_child_revealed (_tmp1_)) {
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
			g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("Enter the encryption passphrase to unlock this volume"));
#line 551 "VolumeItem.c"
		}
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp2_ = self->priv->unlock_revealer;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp3_ = self->priv->unlock_revealer;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_revealer_set_reveal_child (_tmp2_, !gtk_revealer_get_child_revealed (_tmp3_));
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp4_ = self->priv->operation;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp5_ = mount_helper_get_password_entry (_tmp4_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp6_ = _tmp5_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (_tmp6_);
#line 569 "VolumeItem.c"
	}
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1515 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = self;
#line 1516 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 584 "VolumeItem.c"
}


static void
volume_item_on_eject (VolumeItem* self,
                      GObject* obj,
                      GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (res != NULL);
#line 598 "VolumeItem.c"
	{
		GVolume* _tmp0_;
		gchar* safe_remove = NULL;
		gchar* _tmp1_;
		gchar* device_name = NULL;
		GVolume* _tmp2_;
		GDrive* _tmp3_;
		GDrive* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp0_ = self->priv->volume;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_volume_eject_with_operation_finish (_tmp0_, res, &_inner_error0_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "VolumeItem.c"
			goto __catch3_g_error;
		}
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp1_ = g_strdup (_ ("You can now safely remove"));
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		safe_remove = _tmp1_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp2_ = self->priv->volume;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp3_ = g_volume_get_drive (_tmp2_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp4_ = _tmp3_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp5_ = g_drive_get_name (_tmp4_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp6_ = _tmp5_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (_tmp4_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		device_name = _tmp6_;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp7_ = safe_remove;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp8_ = string_to_string (_tmp7_);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp9_ = device_name;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp10_ = string_to_string (_tmp9_);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp11_ = g_strconcat (_tmp8_, " \"", _tmp10_, "\"", NULL);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp12_ = _tmp11_;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_signal_emit_by_name ((ListItem*) self, "send-message", _tmp12_);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_free0 (_tmp12_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_free0 (device_name);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_free0 (safe_remove);
#line 662 "VolumeItem.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		e = _inner_error0_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_inner_error0_ = NULL;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp13_ = e;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp14_ = _tmp13_->message;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_signal_emit_by_name ((ListItem*) self, "send-message", _tmp14_);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp15_ = e;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp16_ = _tmp15_->message;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_warning ("VolumeItem.vala:92: %s", _tmp16_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_error_free0 (e);
#line 690 "VolumeItem.c"
	}
	__finally3:
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_clear_error (&_inner_error0_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		return;
#line 701 "VolumeItem.c"
	}
}


static void
volume_item_on_password_asked (VolumeItem* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp4_;
	MountHelper* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = self->priv->unlock_revealer;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (_tmp0_ == NULL) {
#line 720 "VolumeItem.c"
		MountHelper* _tmp1_;
		GtkRevealer* _tmp2_;
		GtkRevealer* _tmp3_;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp1_ = self->priv->operation;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp2_ = mount_helper_get_encryption_form (_tmp1_);
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (self->priv->unlock_revealer);
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		self->priv->unlock_revealer = _tmp2_;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp3_ = self->priv->unlock_revealer;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp3_, TRUE, TRUE, (guint) 0);
#line 736 "VolumeItem.c"
	}
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp4_ = self->priv->unlock_revealer;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_revealer_set_reveal_child (_tmp4_, TRUE);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp5_ = self->priv->operation;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp6_ = mount_helper_get_password_entry (_tmp5_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp7_ = _tmp6_;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (_tmp7_);
#line 752 "VolumeItem.c"
}


static void
_volume_item_on_mount_gasync_ready_callback (GObject* source_object,
                                             GAsyncResult* res,
                                             gpointer self)
{
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_on_mount ((VolumeItem*) self, source_object, res);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_object_unref (self);
#line 765 "VolumeItem.c"
}


static void
volume_item_do_mount (VolumeItem* self)
{
	GtkSpinner* _tmp0_;
	GVolume* _tmp1_;
	MountHelper* _tmp2_;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = ((ListItem*) self)->spin;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_spinner_start (_tmp0_);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp1_ = self->priv->volume;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp2_ = self->priv->operation;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_volume_mount (_tmp1_, G_MOUNT_MOUNT_NONE, (GMountOperation*) _tmp2_, NULL, _volume_item_on_mount_gasync_ready_callback, g_object_ref (self));
#line 787 "VolumeItem.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1475 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1475 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1476 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 807 "VolumeItem.c"
}


static void
volume_item_on_mount (VolumeItem* self,
                      GObject* obj,
                      GAsyncResult* res)
{
	GtkSpinner* _tmp13_;
	GtkRevealer* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (self != NULL);
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_return_if_fail (res != NULL);
#line 823 "VolumeItem.c"
	{
		GVolume* _tmp0_;
		GVolume* _tmp1_;
		GMount* _tmp2_;
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp0_ = self->priv->volume;
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_volume_mount_finish (_tmp0_, res, &_inner_error0_);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 837 "VolumeItem.c"
			goto __catch4_g_error;
		}
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp1_ = self->priv->volume;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp2_ = g_volume_get_mount (_tmp1_);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp3_ = _tmp2_;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp4_ = g_mount_get_root (_tmp3_);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp5_ = _tmp4_;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		list_item_open_directory ((ListItem*) self, _tmp5_);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (_tmp5_);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (_tmp3_);
#line 856 "VolumeItem.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		e = _inner_error0_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_inner_error0_ = NULL;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp6_ = e;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp7_ = _tmp6_->message;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		if (string_contains (_tmp7_, "No key available with this passphrase")) {
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
			g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("The password you entered is incorrect"));
#line 878 "VolumeItem.c"
		} else {
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
			_tmp9_ = self->priv->first_try;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
			if (_tmp9_) {
#line 886 "VolumeItem.c"
				GtkRevealer* _tmp10_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_tmp10_ = self->priv->unlock_revealer;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_tmp8_ = _tmp10_ != NULL;
#line 892 "VolumeItem.c"
			} else {
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				_tmp8_ = FALSE;
#line 896 "VolumeItem.c"
			}
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
			if (_tmp8_) {
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("Enter the encryption passphrase to unlock this volume"));
#line 902 "VolumeItem.c"
			} else {
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
				g_signal_emit_by_name ((ListItem*) self, "send-message", _ ("An unknown error occurred while attempting to mount this volume"));
#line 906 "VolumeItem.c"
			}
		}
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp11_ = e;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp12_ = _tmp11_->message;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_message ("VolumeItem.vala:125: %s", _tmp12_);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_error_free0 (e);
#line 917 "VolumeItem.c"
	}
	__finally4:
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		g_clear_error (&_inner_error0_);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		return;
#line 928 "VolumeItem.c"
	}
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp13_ = ((ListItem*) self)->spin;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_spinner_stop (_tmp13_);
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp14_ = self->priv->unlock_revealer;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (_tmp14_ != NULL) {
#line 938 "VolumeItem.c"
		GtkRevealer* _tmp15_;
		MountHelper* _tmp16_;
		GtkEntry* _tmp17_;
		GtkEntry* _tmp18_;
#line 129 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp15_ = self->priv->unlock_revealer;
#line 129 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, TRUE);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp16_ = self->priv->operation;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp17_ = mount_helper_get_password_entry (_tmp16_);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_tmp18_ = _tmp17_;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp18_);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		_g_object_unref0 (_tmp18_);
#line 957 "VolumeItem.c"
	}
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv->first_try = FALSE;
#line 961 "VolumeItem.c"
}


static void
volume_item_real_cancel_operation (ListItem* base)
{
	VolumeItem * self;
	GtkRevealer* _tmp0_;
	GtkEntry* entry = NULL;
	MountHelper* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkRevealer* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkRevealer* _tmp6_;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self = (VolumeItem*) base;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp0_ = self->priv->unlock_revealer;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	if (_tmp0_ == NULL) {
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
		return;
#line 985 "VolumeItem.c"
	}
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp1_ = self->priv->operation;
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp2_ = mount_helper_get_password_entry (_tmp1_);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	entry = _tmp2_;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp3_ = entry;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_entry_set_text (_tmp3_, "");
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp4_ = self->priv->unlock_revealer;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_revealer_set_transition_type (_tmp4_, GTK_REVEALER_TRANSITION_TYPE_NONE);
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp5_ = self->priv->unlock_revealer;
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_revealer_set_reveal_child (_tmp5_, FALSE);
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_tmp6_ = self->priv->unlock_revealer;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	gtk_revealer_set_transition_type (_tmp6_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (entry);
#line 1011 "VolumeItem.c"
}


static void
volume_item_class_init (VolumeItemClass * klass)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	volume_item_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	g_type_class_add_private (klass, sizeof (VolumeItemPrivate));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	((ListItemClass *) klass)->cancel_operation = (void (*) (ListItem*)) volume_item_real_cancel_operation;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	G_OBJECT_CLASS (klass)->finalize = volume_item_finalize;
#line 1026 "VolumeItem.c"
}


static void
volume_item_instance_init (VolumeItem * self)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv = VOLUME_ITEM_GET_PRIVATE (self);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv->unlock_revealer = NULL;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self->priv->first_try = TRUE;
#line 1039 "VolumeItem.c"
}


static void
volume_item_finalize (GObject * obj)
{
	VolumeItem * self;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VOLUME_ITEM, VolumeItem);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (self->priv->operation);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (self->priv->unlock_revealer);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	_g_object_unref0 (self->priv->volume);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/places-indicator/VolumeItem.vala"
	G_OBJECT_CLASS (volume_item_parent_class)->finalize (obj);
#line 1057 "VolumeItem.c"
}


GType
volume_item_get_type (void)
{
	return volume_item_type_id;
}


GType
volume_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (VolumeItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) volume_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VolumeItem), 0, (GInstanceInitFunc) volume_item_instance_init, NULL };
	volume_item_type_id = g_type_module_register_type (module, TYPE_LIST_ITEM, "VolumeItem", &g_define_type_info, 0);
	return volume_item_type_id;
}



