/* BluetoothIndicator.c generated by valac 0.40.19, the Vala compiler
 * generated from BluetoothIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 * Copyright (C) 2015 Alberts Muktupāvels
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BluetoothIndicator is largely inspired by gnome-flashback.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <bluetooth-client.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <bluetooth-enums.h>
#include <stdlib.h>
#include <gio/gdesktopappinfo.h>


#define TYPE_RFKILL (rfkill_get_type ())
#define RFKILL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RFKILL, Rfkill))
#define IS_RFKILL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RFKILL))
#define RFKILL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_RFKILL, RfkillIface))

typedef struct _Rfkill Rfkill;
typedef struct _RfkillIface RfkillIface;

#define TYPE_RFKILL_PROXY (rfkill_proxy_get_type ())
typedef GDBusProxy RfkillProxy;
typedef GDBusProxyClass RfkillProxyClass;

#define TYPE_BLUETOOTH_INDICATOR (bluetooth_indicator_get_type ())
#define BLUETOOTH_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH_INDICATOR, BluetoothIndicator))
#define BLUETOOTH_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLUETOOTH_INDICATOR, BluetoothIndicatorClass))
#define IS_BLUETOOTH_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH_INDICATOR))
#define IS_BLUETOOTH_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLUETOOTH_INDICATOR))
#define BLUETOOTH_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLUETOOTH_INDICATOR, BluetoothIndicatorClass))

typedef struct _BluetoothIndicator BluetoothIndicator;
typedef struct _BluetoothIndicatorClass BluetoothIndicatorClass;
typedef struct _BluetoothIndicatorPrivate BluetoothIndicatorPrivate;
enum  {
	BLUETOOTH_INDICATOR_0_PROPERTY,
	BLUETOOTH_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* bluetooth_indicator_properties[BLUETOOTH_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothIndicatorSetupDbusData BluetoothIndicatorSetupDbusData;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RfkillIface {
	GTypeInterface parent_iface;
	gboolean (*get_BluetoothAirplaneMode) (Rfkill* self);
	void (*set_BluetoothAirplaneMode) (Rfkill* self, gboolean value);
};

struct _BluetoothIndicator {
	GtkBin parent_instance;
	BluetoothIndicatorPrivate * priv;
	GtkImage* image;
	GtkEventBox* ebox;
	BudgiePopover* popover;
};

struct _BluetoothIndicatorClass {
	GtkBinClass parent_class;
};

struct _BluetoothIndicatorPrivate {
	BluetoothClient* client;
	GtkTreeModel* model;
	Rfkill* killer;
	GDBusProxy* db;
	GtkCheckButton* radio_airplane;
	gulong radio_id;
	GtkButton* send_to;
};

struct _BluetoothIndicatorSetupDbusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	BluetoothIndicator* self;
	Rfkill* _tmp0_;
	Rfkill* _tmp1_;
	Rfkill* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_;
};


static GType rfkill_type_id = 0;
static gpointer bluetooth_indicator_parent_class = NULL;
static GType bluetooth_indicator_type_id = 0;

GType rfkill_register_type (GTypeModule * module);
GType rfkill_get_type (void) G_GNUC_CONST;
GType rfkill_proxy_get_type (void) G_GNUC_CONST;
void rfkill_proxy_register_dynamic_type (GTypeModule* module);
guint rfkill_register_object (void* object,
                              GDBusConnection* connection,
                              const gchar* path,
                              GError** error);
gboolean rfkill_get_BluetoothAirplaneMode (Rfkill* self);
void rfkill_set_BluetoothAirplaneMode (Rfkill* self,
                                       gboolean value);
static void rfkill_proxy_g_signal (GDBusProxy* proxy,
                            const gchar* sender_name,
                            const gchar* signal_name,
                            GVariant* parameters);
static gboolean rfkill_dbus_proxy_get_BluetoothAirplaneMode (Rfkill* self);
static void rfkill_dbus_proxy_set_BluetoothAirplaneMode (Rfkill* self,
                                                  gboolean value);
static void rfkill_proxy_rfkill_interface_init (RfkillIface* iface);
static void rfkill_dbus_interface_method_call (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* method_name,
                                        GVariant* parameters,
                                        GDBusMethodInvocation* invocation,
                                        gpointer user_data);
static GVariant* rfkill_dbus_interface_get_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GError** error,
                                              gpointer user_data);
static GVariant* _dbus_rfkill_get_BluetoothAirplaneMode (Rfkill* self);
static gboolean rfkill_dbus_interface_set_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GVariant* value,
                                             GError** error,
                                             gpointer user_data);
static void _dbus_rfkill_set_BluetoothAirplaneMode (Rfkill* self,
                                             GVariant* _value);
static void _rfkill_unregister_object (gpointer user_data);
GType bluetooth_indicator_register_type (GTypeModule * module);
GType bluetooth_indicator_get_type (void) G_GNUC_CONST;
#define BLUETOOTH_INDICATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BLUETOOTH_INDICATOR, BluetoothIndicatorPrivate))
BluetoothIndicator* bluetooth_indicator_new (void);
BluetoothIndicator* bluetooth_indicator_construct (GType object_type);
static gboolean bluetooth_indicator_on_button_release_event (BluetoothIndicator* self,
                                                      GdkEventButton* e);
static gboolean _bluetooth_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                       GdkEventButton* event,
                                                                                       gpointer self);
static void bluetooth_indicator_on_settings_activate (BluetoothIndicator* self);
static void _bluetooth_indicator_on_settings_activate_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void bluetooth_indicator_on_send_file (BluetoothIndicator* self);
static void _bluetooth_indicator_on_send_file_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void bluetooth_indicator_on_set_airplane (BluetoothIndicator* self);
static void _bluetooth_indicator_on_set_airplane_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void __lambda4_ (BluetoothIndicator* self);
static void bluetooth_indicator_resync (BluetoothIndicator* self);
static void ___lambda4__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                             GtkTreePath* path,
                                             GtkTreeIter* iter,
                                             gpointer self);
static void __lambda5_ (BluetoothIndicator* self);
static void ___lambda5__gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                             GtkTreePath* path,
                                             gpointer self);
static void __lambda6_ (BluetoothIndicator* self);
static void ___lambda6__gtk_tree_model_row_inserted (GtkTreeModel* _sender,
                                              GtkTreePath* path,
                                              GtkTreeIter* iter,
                                              gpointer self);
static void bluetooth_indicator_setup_dbus (BluetoothIndicator* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void bluetooth_indicator_setup_dbus_finish (BluetoothIndicator* self,
                                            GAsyncResult* _res_);
static void __lambda7_ (BluetoothIndicator* self);
static void bluetooth_indicator_sync_rfkill (BluetoothIndicator* self);
static void ___lambda7__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void bluetooth_indicator_setup_dbus_data_free (gpointer _data);
static void bluetooth_indicator_setup_dbus_async_ready_wrapper (GObject *source_object,
                                                         GAsyncResult *res,
                                                         void *user_data);
static gboolean bluetooth_indicator_setup_dbus_co (BluetoothIndicatorSetupDbusData* _data_);
static void bluetooth_indicator_setup_dbus_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static gboolean bluetooth_indicator_get_default_adapter (BluetoothIndicator* self,
                                                  GtkTreeIter* adapter);
static gint bluetooth_indicator_get_n_devices (BluetoothIndicator* self);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void bluetooth_indicator_on_airplane_change (BluetoothIndicator* self);
static void _bluetooth_indicator_on_airplane_change_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                GVariant* changed_properties,
                                                                                gchar** invalidated_properties,
                                                                                gpointer self);
static void bluetooth_indicator_finalize (GObject * obj);

static const GDBusMethodInfo * const _rfkill_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _rfkill_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _rfkill_dbus_property_info_BluetoothAirplaneMode = {-1, "BluetoothAirplaneMode", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _rfkill_dbus_property_info[] = {&_rfkill_dbus_property_info_BluetoothAirplaneMode, NULL};
static const GDBusInterfaceInfo _rfkill_dbus_interface_info = {-1, "org.gnome.SettingsDaemon.Rfkill", (GDBusMethodInfo **) (&_rfkill_dbus_method_info), (GDBusSignalInfo **) (&_rfkill_dbus_signal_info), (GDBusPropertyInfo **) (&_rfkill_dbus_property_info), NULL};
static const GDBusInterfaceVTable _rfkill_dbus_interface_vtable = {rfkill_dbus_interface_method_call, rfkill_dbus_interface_get_property, rfkill_dbus_interface_set_property};

gboolean
rfkill_get_BluetoothAirplaneMode (Rfkill* self)
{
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return RFKILL_GET_INTERFACE (self)->get_BluetoothAirplaneMode (self);
#line 242 "BluetoothIndicator.c"
}


void
rfkill_set_BluetoothAirplaneMode (Rfkill* self,
                                  gboolean value)
{
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	RFKILL_GET_INTERFACE (self)->set_BluetoothAirplaneMode (self, value);
#line 254 "BluetoothIndicator.c"
}


static void
rfkill_default_init (RfkillIface * iface)
{
}


GType
rfkill_get_type (void)
{
	return rfkill_type_id;
}


GType
rfkill_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (RfkillIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rfkill_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	rfkill_type_id = g_type_module_register_type (module, G_TYPE_INTERFACE, "Rfkill", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (rfkill_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (rfkill_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) rfkill_proxy_get_type);
	g_type_set_qdata (rfkill_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SettingsDaemon.Rfkill");
	g_type_set_qdata (rfkill_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_rfkill_dbus_interface_info));
	g_type_set_qdata (rfkill_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) rfkill_register_object);
	return rfkill_type_id;
}


G_DEFINE_DYNAMIC_TYPE_EXTENDED (RfkillProxy, rfkill_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE_DYNAMIC (TYPE_RFKILL, rfkill_proxy_rfkill_interface_init) )
static void
rfkill_proxy_class_init (RfkillProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = rfkill_proxy_g_signal;
}


static void
rfkill_proxy_g_signal (GDBusProxy* proxy,
                       const gchar* sender_name,
                       const gchar* signal_name,
                       GVariant* parameters)
{
}


static void
rfkill_proxy_class_finalize (RfkillProxyClass* klass)
{
}


void
rfkill_proxy_register_dynamic_type (GTypeModule* module)
{
	rfkill_proxy_register_type (module);
}


static void
rfkill_proxy_init (RfkillProxy* self)
{
}


static gboolean
rfkill_dbus_proxy_get_BluetoothAirplaneMode (Rfkill* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "BluetoothAirplaneMode");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Rfkill"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("BluetoothAirplaneMode"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp0_ = FALSE;
			return _tmp0_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
rfkill_dbus_proxy_set_BluetoothAirplaneMode (Rfkill* self,
                                             gboolean value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Rfkill"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("BluetoothAirplaneMode"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static void
rfkill_proxy_rfkill_interface_init (RfkillIface* iface)
{
	iface->get_BluetoothAirplaneMode = rfkill_dbus_proxy_get_BluetoothAirplaneMode;
	iface->set_BluetoothAirplaneMode = rfkill_dbus_proxy_set_BluetoothAirplaneMode;
}


static void
rfkill_dbus_interface_method_call (GDBusConnection* connection,
                                   const gchar* sender,
                                   const gchar* object_path,
                                   const gchar* interface_name,
                                   const gchar* method_name,
                                   GVariant* parameters,
                                   GDBusMethodInvocation* invocation,
                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant*
_dbus_rfkill_get_BluetoothAirplaneMode (Rfkill* self)
{
	gboolean result;
	GVariant* _reply;
	result = rfkill_get_BluetoothAirplaneMode (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant*
rfkill_dbus_interface_get_property (GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* property_name,
                                    GError** error,
                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "BluetoothAirplaneMode") == 0) {
		return _dbus_rfkill_get_BluetoothAirplaneMode (object);
	}
	return NULL;
}


static void
_dbus_rfkill_set_BluetoothAirplaneMode (Rfkill* self,
                                        GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	rfkill_set_BluetoothAirplaneMode (self, value);
}


static gboolean
rfkill_dbus_interface_set_property (GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* property_name,
                                    GVariant* value,
                                    GError** error,
                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "BluetoothAirplaneMode") == 0) {
		_dbus_rfkill_set_BluetoothAirplaneMode (object, value);
		return TRUE;
	}
	return FALSE;
}


guint
rfkill_register_object (gpointer object,
                        GDBusConnection* connection,
                        const gchar* path,
                        GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_rfkill_dbus_interface_info), &_rfkill_dbus_interface_vtable, data, _rfkill_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void
_rfkill_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static gboolean
_bluetooth_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self)
{
	gboolean result;
	result = bluetooth_indicator_on_button_release_event ((BluetoothIndicator*) self, event);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return result;
#line 501 "BluetoothIndicator.c"
}


static void
_bluetooth_indicator_on_settings_activate_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_settings_activate ((BluetoothIndicator*) self);
#line 511 "BluetoothIndicator.c"
}


static void
_bluetooth_indicator_on_send_file_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_send_file ((BluetoothIndicator*) self);
#line 521 "BluetoothIndicator.c"
}


static void
_bluetooth_indicator_on_set_airplane_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_set_airplane ((BluetoothIndicator*) self);
#line 532 "BluetoothIndicator.c"
}


static void
__lambda4_ (BluetoothIndicator* self)
{
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 541 "BluetoothIndicator.c"
}


static void
___lambda4__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                        GtkTreePath* path,
                                        GtkTreeIter* iter,
                                        gpointer self)
{
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__lambda4_ ((BluetoothIndicator*) self);
#line 553 "BluetoothIndicator.c"
}


static void
__lambda5_ (BluetoothIndicator* self)
{
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 562 "BluetoothIndicator.c"
}


static void
___lambda5__gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                        GtkTreePath* path,
                                        gpointer self)
{
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__lambda5_ ((BluetoothIndicator*) self);
#line 573 "BluetoothIndicator.c"
}


static void
__lambda6_ (BluetoothIndicator* self)
{
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 582 "BluetoothIndicator.c"
}


static void
___lambda6__gtk_tree_model_row_inserted (GtkTreeModel* _sender,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__lambda6_ ((BluetoothIndicator*) self);
#line 594 "BluetoothIndicator.c"
}


static void
__lambda7_ (BluetoothIndicator* self)
{
	Rfkill* _tmp0_;
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->killer;
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_tmp0_ == NULL) {
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return;
#line 608 "BluetoothIndicator.c"
	}
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_sync_rfkill (self);
#line 612 "BluetoothIndicator.c"
}


static void
___lambda7__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__lambda7_ ((BluetoothIndicator*) self);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_unref (self);
#line 625 "BluetoothIndicator.c"
}


BluetoothIndicator*
bluetooth_indicator_construct (GType object_type)
{
	BluetoothIndicator * self = NULL;
	GtkImage* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkImage* _tmp4_;
	GtkEventBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkEventBox* _tmp7_;
	BudgiePopover* _tmp8_;
	GtkBox* box = NULL;
	GtkBox* _tmp9_;
	BudgiePopover* _tmp10_;
	GtkButton* button = NULL;
	GtkButton* _tmp11_;
	GtkWidget* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkWidget* _tmp16_;
	GtkButton* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkSeparator* sep = NULL;
	GtkSeparator* _tmp21_;
	GtkCheckButton* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkWidget* _tmp24_;
	GValue _tmp25_ = {0};
	GtkCheckButton* _tmp26_;
	gulong _tmp27_;
	GtkCheckButton* _tmp28_;
	BluetoothClient* _tmp29_;
	BluetoothClient* _tmp30_;
	GtkTreeModel* _tmp31_;
	GtkTreeModel* _tmp32_;
	GtkTreeModel* _tmp33_;
	GtkTreeModel* _tmp34_;
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self = (BluetoothIndicator*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("bluetooth-active-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp0_);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->image);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->image = _tmp0_;
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp1_ = (GtkEventBox*) gtk_event_box_new ();
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->ebox = _tmp1_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->ebox;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->ebox;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->image;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp5_ = self->ebox;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp5_, (gint) GDK_BUTTON_RELEASE_MASK);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp6_ = self->ebox;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp6_, "button-release-event", (GCallback) _bluetooth_indicator_on_button_release_event_gtk_widget_button_release_event, self, 0);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp7_ = self->ebox;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp8_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp7_);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp8_);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->popover);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->popover = _tmp8_;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp9_);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	box = _tmp9_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 6);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp10_ = self->popover;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) box);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp11_ = (GtkButton*) gtk_button_new_with_label (_ ("Bluetooth Settings"));
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp11_);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	button = _tmp11_;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp12_ = gtk_bin_get_child ((GtkBin*) button);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign (_tmp12_, GTK_ALIGN_START);
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) button);
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp13_, GTK_STYLE_CLASS_FLAT);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (button, "clicked", (GCallback) _bluetooth_indicator_on_settings_activate_gtk_button_clicked, self, 0);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_with_label (_ ("Send Files"));
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp14_);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->send_to);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->send_to = _tmp14_;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp15_ = self->priv->send_to;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp16_ = gtk_bin_get_child ((GtkBin*) _tmp15_);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_halign (_tmp16_, GTK_ALIGN_START);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp17_ = self->priv->send_to;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_FLAT);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp19_ = self->priv->send_to;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp19_, "clicked", (GCallback) _bluetooth_indicator_on_send_file_gtk_button_clicked, self, 0);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp20_ = self->priv->send_to;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp21_);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	sep = _tmp21_;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) sep, FALSE, FALSE, (guint) 1);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp22_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Bluetooth Airplane Mode"));
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_ref_sink (_tmp22_);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->radio_airplane);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->radio_airplane = _tmp22_;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp23_ = self->priv->radio_airplane;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp24_ = gtk_bin_get_child ((GtkBin*) _tmp23_);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_value_init (&_tmp25_, G_TYPE_INT);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_value_set_int (&_tmp25_, 4);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_set_property ((GObject*) _tmp24_, "margin", &_tmp25_);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	G_IS_VALUE (&_tmp25_) ? (g_value_unset (&_tmp25_), NULL) : NULL;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp26_ = self->priv->radio_airplane;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp27_ = g_signal_connect_object ((GObject*) _tmp26_, "notify::active", (GCallback) _bluetooth_indicator_on_set_airplane_g_object_notify, self, G_CONNECT_AFTER);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->radio_id = _tmp27_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp28_ = self->priv->radio_airplane;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp28_, FALSE, FALSE, (guint) 0);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) box);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp29_ = bluetooth_client_new ();
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->client);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->client = _tmp29_;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp30_ = self->priv->client;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp31_ = bluetooth_client_get_model (_tmp30_);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->model);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->model = _tmp31_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp32_ = self->priv->model;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp32_, "row-changed", (GCallback) ___lambda4__gtk_tree_model_row_changed, self, 0);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp33_ = self->priv->model;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp33_, "row-deleted", (GCallback) ___lambda5__gtk_tree_model_row_deleted, self, 0);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp34_ = self->priv->model;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp34_, "row-inserted", (GCallback) ___lambda6__gtk_tree_model_row_inserted, self, 0);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_setup_dbus (self, ___lambda7__gasync_ready_callback, g_object_ref (self));
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (sep);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (button);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (box);
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return self;
#line 855 "BluetoothIndicator.c"
}


BluetoothIndicator*
bluetooth_indicator_new (void)
{
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return bluetooth_indicator_construct (TYPE_BLUETOOTH_INDICATOR);
#line 864 "BluetoothIndicator.c"
}


static gboolean
bluetooth_indicator_on_button_release_event (BluetoothIndicator* self,
                                             GdkEventButton* e)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = e->button;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_tmp0_ == ((guint) GDK_BUTTON_MIDDLE)) {
#line 882 "BluetoothIndicator.c"
		Rfkill* _tmp1_;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp1_ = self->priv->killer;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp1_ != NULL) {
#line 888 "BluetoothIndicator.c"
			Rfkill* _tmp2_;
			Rfkill* _tmp3_;
			gboolean _tmp4_;
			gboolean _tmp5_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp2_ = self->priv->killer;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp3_ = self->priv->killer;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp4_ = rfkill_get_BluetoothAirplaneMode (_tmp3_);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp5_ = _tmp4_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			rfkill_set_BluetoothAirplaneMode (_tmp2_, !_tmp5_);
#line 903 "BluetoothIndicator.c"
		}
	} else {
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		result = GDK_EVENT_PROPAGATE;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return result;
#line 910 "BluetoothIndicator.c"
	}
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	result = GDK_EVENT_STOP;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return result;
#line 916 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_setup_dbus_data_free (gpointer _data)
{
	BluetoothIndicatorSetupDbusData* _data_;
	_data_ = _data;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (_data_->self);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_slice_free (BluetoothIndicatorSetupDbusData, _data_);
#line 929 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_setup_dbus_async_ready_wrapper (GObject *source_object,
                                                    GAsyncResult *res,
                                                    void *user_data)
{
	BluetoothIndicatorSetupDbusData* _task_data_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_task_data_->_callback_ != NULL) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 945 "BluetoothIndicator.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_task_data_->_task_complete_ = TRUE;
#line 949 "BluetoothIndicator.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 958 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_setup_dbus (BluetoothIndicator* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	BluetoothIndicatorSetupDbusData* _data_;
	BluetoothIndicator* _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_ = g_slice_new0 (BluetoothIndicatorSetupDbusData);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->_callback_ = _callback_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, bluetooth_indicator_setup_dbus_async_ready_wrapper, _user_data_);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_callback_ == NULL) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_task_complete_ = TRUE;
#line 979 "BluetoothIndicator.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_indicator_setup_dbus_data_free);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->self = _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_setup_dbus_co (_data_);
#line 989 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_setup_dbus_finish (BluetoothIndicator* self,
                                       GAsyncResult* _res_)
{
	BluetoothIndicatorSetupDbusData* _data_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1000 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_setup_dbus_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	BluetoothIndicatorSetupDbusData* _data_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_ = _user_data_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->_source_object_ = source_object;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->_res_ = _res_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_data_->_task_complete_ = TRUE;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_setup_dbus_co (_data_);
#line 1020 "BluetoothIndicator.c"
}


static gboolean
bluetooth_indicator_setup_dbus_co (BluetoothIndicatorSetupDbusData* _data_)
{
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	switch (_data_->_state_) {
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		case 0:
#line 1031 "BluetoothIndicator.c"
		goto _state_0;
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		case 1:
#line 1035 "BluetoothIndicator.c"
		goto _state_1;
		default:
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_assert_not_reached ();
#line 1040 "BluetoothIndicator.c"
	}
	_state_0:
	{
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_state_ = 1;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_async_initable_new_async (TYPE_RFKILL_PROXY, 0, NULL, bluetooth_indicator_setup_dbus_ready, _data_, "g-flags", 0, "g-name", "org.gnome.SettingsDaemon.Rfkill", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SettingsDaemon/Rfkill", "g-interface-name", "org.gnome.SettingsDaemon.Rfkill", "g-interface-info", g_type_get_qdata (TYPE_RFKILL, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 1050 "BluetoothIndicator.c"
		_state_1:
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp1_ = (Rfkill*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp0_ = (Rfkill*) _data_->_tmp1_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1058 "BluetoothIndicator.c"
			goto __catch3_g_error;
		}
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp0_ = NULL;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (_data_->self->priv->killer);
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->self->priv->killer = _data_->_tmp2_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1071 "BluetoothIndicator.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->e = _data_->_inner_error0_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_inner_error0_ = NULL;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (_data_->self->priv->killer);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->self->priv->killer = NULL;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp3_ = _data_->e;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_warning ("BluetoothIndicator.vala:117: Unable to contact RfKill manager: %s", _data_->_tmp4_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (_data_->e);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_data_->_state_ != 0) {
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			while (!_data_->_task_complete_) {
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1100 "BluetoothIndicator.c"
			}
		}
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_object_unref (_data_->_async_result);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 1107 "BluetoothIndicator.c"
	}
	__finally3:
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_object_unref (_data_->_async_result);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return FALSE;
#line 1120 "BluetoothIndicator.c"
	}
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_data_->_state_ != 0) {
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		while (!_data_->_task_complete_) {
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1130 "BluetoothIndicator.c"
		}
	}
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_object_unref (_data_->_async_result);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return FALSE;
#line 1137 "BluetoothIndicator.c"
}


static gboolean
bluetooth_indicator_get_default_adapter (BluetoothIndicator* self,
                                         GtkTreeIter* adapter)
{
	GtkTreeIter _vala_adapter = {0};
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->model;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = gtk_tree_model_get_iter_first (_tmp0_, &_tmp1_);
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	iter = _tmp1_;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (!_tmp2_) {
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		result = FALSE;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (adapter) {
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			*adapter = _vala_adapter;
#line 1167 "BluetoothIndicator.c"
		}
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return result;
#line 1171 "BluetoothIndicator.c"
	}
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	while (TRUE) {
#line 1175 "BluetoothIndicator.c"
		gboolean is_default = FALSE;
		GtkTreeModel* _tmp3_;
		GtkTreeIter _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		GtkTreeModel* _tmp8_;
		gboolean _tmp9_;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp3_ = self->priv->model;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp4_ = iter;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		gtk_tree_model_get (_tmp3_, &_tmp4_, BLUETOOTH_COLUMN_DEFAULT, &_tmp5_, -1, -1);
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		is_default = _tmp5_;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp6_ = is_default;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp6_) {
#line 1195 "BluetoothIndicator.c"
			GtkTreeIter _tmp7_;
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp7_ = iter;
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_vala_adapter = _tmp7_;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			result = TRUE;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			if (adapter) {
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
				*adapter = _vala_adapter;
#line 1207 "BluetoothIndicator.c"
			}
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			return result;
#line 1211 "BluetoothIndicator.c"
		}
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp8_ = self->priv->model;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp9_ = gtk_tree_model_iter_next (_tmp8_, &iter);
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (!_tmp9_) {
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			break;
#line 1221 "BluetoothIndicator.c"
		}
	}
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	result = FALSE;
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (adapter) {
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		*adapter = _vala_adapter;
#line 1230 "BluetoothIndicator.c"
	}
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return result;
#line 1234 "BluetoothIndicator.c"
}


static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 1243 "BluetoothIndicator.c"
}


static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 1252 "BluetoothIndicator.c"
}


static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 1261 "BluetoothIndicator.c"
}


static gint
bluetooth_indicator_get_n_devices (BluetoothIndicator* self)
{
	gint result = 0;
	GtkTreeIter iter = {0};
	GtkTreeIter* adapter = NULL;
	gint n_devices = 0;
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkTreeIter _tmp2_;
	GtkTreeIter* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean _tmp7_;
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	n_devices = 0;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp1_ = bluetooth_indicator_get_default_adapter (self, &_tmp0_);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__vala_GtkTreeIter_free0 (adapter);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = _tmp0_;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp3_ = __vala_GtkTreeIter_copy0 (&_tmp2_);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	adapter = _tmp3_;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (!_tmp1_) {
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		result = -1;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		__vala_GtkTreeIter_free0 (adapter);
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return result;
#line 1302 "BluetoothIndicator.c"
	}
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->priv->model;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp5_ = adapter;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp7_ = gtk_tree_model_iter_children (_tmp4_, &_tmp6_, _tmp5_);
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	iter = _tmp6_;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (!_tmp7_) {
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		result = 0;
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		__vala_GtkTreeIter_free0 (adapter);
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return result;
#line 1320 "BluetoothIndicator.c"
	}
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	while (TRUE) {
#line 1324 "BluetoothIndicator.c"
		gboolean con = FALSE;
		GtkTreeModel* _tmp8_;
		GtkTreeIter _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_;
		GtkTreeModel* _tmp13_;
		gboolean _tmp14_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp8_ = self->priv->model;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp9_ = iter;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		gtk_tree_model_get (_tmp8_, &_tmp9_, BLUETOOTH_COLUMN_CONNECTED, &_tmp10_, -1, -1);
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		con = _tmp10_;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp11_ = con;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp11_) {
#line 1344 "BluetoothIndicator.c"
			gint _tmp12_;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp12_ = n_devices;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			n_devices = _tmp12_ + 1;
#line 1350 "BluetoothIndicator.c"
		}
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp13_ = self->priv->model;
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp14_ = gtk_tree_model_iter_next (_tmp13_, &iter);
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (!_tmp14_) {
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			break;
#line 1360 "BluetoothIndicator.c"
		}
	}
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	result = n_devices;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	__vala_GtkTreeIter_free0 (adapter);
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	return result;
#line 1369 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_resync (BluetoothIndicator* self)
{
	gint n_devices = 0;
	gchar* lbl = NULL;
	Rfkill* _tmp0_;
	gint _tmp8_;
	GtkImage* _tmp15_;
	const gchar* _tmp16_;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	n_devices = bluetooth_indicator_get_n_devices (self);
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	lbl = NULL;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->killer;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_tmp0_ != NULL) {
#line 1392 "BluetoothIndicator.c"
		Rfkill* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp1_ = self->priv->killer;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp2_ = rfkill_get_BluetoothAirplaneMode (_tmp1_);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp3_ = _tmp2_;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp3_) {
#line 1404 "BluetoothIndicator.c"
			GtkImage* _tmp4_;
			gchar* _tmp5_;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp4_ = self->image;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			gtk_image_set_from_icon_name (_tmp4_, "bluetooth-disabled-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp5_ = g_strdup (_ ("Bluetooth is disabled"));
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_free0 (lbl);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			lbl = _tmp5_;
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			n_devices = 0;
#line 1419 "BluetoothIndicator.c"
		} else {
			GtkImage* _tmp6_;
			gchar* _tmp7_;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp6_ = self->image;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			gtk_image_set_from_icon_name (_tmp6_, "bluetooth-active-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp7_ = g_strdup (_ ("Bluetooth is active"));
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_free0 (lbl);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			lbl = _tmp7_;
#line 1433 "BluetoothIndicator.c"
		}
	}
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp8_ = n_devices;
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_tmp8_ > 0) {
#line 1440 "BluetoothIndicator.c"
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		GtkButton* _tmp12_;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp9_ = n_devices;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp10_ = n_devices;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp11_ = g_strdup_printf (ngettext ("Connected to %d device", "Connected to %d devices", (gulong) _tmp9_), _tmp10_);
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_free0 (lbl);
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		lbl = _tmp11_;
#line 189 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp12_ = self->priv->send_to;
#line 189 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
#line 1459 "BluetoothIndicator.c"
	} else {
		gint _tmp13_;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp13_ = n_devices;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp13_ < 0) {
#line 191 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			gtk_widget_hide ((GtkWidget*) self);
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_free0 (lbl);
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			return;
#line 1472 "BluetoothIndicator.c"
		} else {
			GtkButton* _tmp14_;
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp14_ = self->priv->send_to;
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 1479 "BluetoothIndicator.c"
		}
	}
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp15_ = self->image;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp16_ = lbl;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _tmp16_);
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_free0 (lbl);
#line 1492 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_on_settings_activate (BluetoothIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 202 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->popover;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("gnome-bluetooth-panel.desktop");
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	app_info = _tmp1_;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = app_info;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (_tmp2_ == NULL) {
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (app_info);
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return;
#line 1522 "BluetoothIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp3_ = app_info;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1532 "BluetoothIndicator.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		e = _inner_error0_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_inner_error0_ = NULL;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp4_ = e;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_message ("BluetoothIndicator.vala:213: Unable to launch gnome-bluetooth-panel.de" \
"sktop: %s", _tmp5_);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (e);
#line 1554 "BluetoothIndicator.c"
	}
	__finally4:
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (app_info);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return;
#line 1567 "BluetoothIndicator.c"
	}
#line 202 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (app_info);
#line 1571 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_on_send_file (BluetoothIndicator* self)
{
	BudgiePopover* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->popover;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 1586 "BluetoothIndicator.c"
	{
		GAppInfo* app_info = NULL;
		GAppInfo* _tmp1_;
		GAppInfo* _tmp2_;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp1_ = g_app_info_create_from_commandline ("bluetooth-sendto", "Bluetooth Transfer", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		app_info = _tmp1_;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1597 "BluetoothIndicator.c"
			goto __catch5_g_error;
		}
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp2_ = app_info;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (_tmp2_ == NULL) {
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_object_unref0 (app_info);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			return;
#line 1608 "BluetoothIndicator.c"
		}
		{
			GAppInfo* _tmp3_;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp3_ = app_info;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			g_app_info_launch (_tmp3_, NULL, NULL, &_inner_error0_);
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1618 "BluetoothIndicator.c"
				goto __catch6_g_error;
			}
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			e = _inner_error0_;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_inner_error0_ = NULL;
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp4_ = e;
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_tmp5_ = _tmp4_->message;
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			g_message ("BluetoothIndicator.vala:230: Unable to launch bluetooth-sendto: %s", _tmp5_);
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_error_free0 (e);
#line 1640 "BluetoothIndicator.c"
		}
		__finally6:
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
			_g_object_unref0 (app_info);
#line 1647 "BluetoothIndicator.c"
			goto __catch5_g_error;
		}
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_object_unref0 (app_info);
#line 1652 "BluetoothIndicator.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		e = _inner_error0_;
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_inner_error0_ = NULL;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp6_ = e;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp7_ = _tmp6_->message;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_message ("BluetoothIndicator.vala:233: Unable to create bluetooth-sendto AppInfo" \
": %s", _tmp7_);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (e);
#line 1672 "BluetoothIndicator.c"
	}
	__finally5:
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return;
#line 1683 "BluetoothIndicator.c"
	}
}


static void
bluetooth_indicator_on_set_airplane (BluetoothIndicator* self)
{
	gboolean s = FALSE;
	GtkCheckButton* _tmp0_;
	BudgiePopover* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->radio_airplane;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	s = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 1701 "BluetoothIndicator.c"
	{
		Rfkill* _tmp1_;
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp1_ = self->priv->killer;
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		rfkill_set_BluetoothAirplaneMode (_tmp1_, s);
#line 1708 "BluetoothIndicator.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		e = _inner_error0_;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_inner_error0_ = NULL;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp2_ = e;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_tmp3_ = _tmp2_->message;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_message ("BluetoothIndicator.vala:245: Error setting airplane mode: %s", _tmp3_);
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		_g_error_free0 (e);
#line 1728 "BluetoothIndicator.c"
	}
	__finally7:
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
		return;
#line 1739 "BluetoothIndicator.c"
	}
#line 247 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp4_ = self->popover;
#line 247 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 1745 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_on_airplane_change (BluetoothIndicator* self)
{
	GtkCheckButton* _tmp0_;
	gulong _tmp1_;
	GtkCheckButton* _tmp2_;
	Rfkill* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkCheckButton* _tmp6_;
	gulong _tmp7_;
#line 251 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->radio_airplane;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp1_ = self->priv->radio_id;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_handler_block (_tmp0_, _tmp1_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->priv->radio_airplane;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp3_ = self->priv->killer;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp4_ = rfkill_get_BluetoothAirplaneMode (_tmp3_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp5_ = _tmp4_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, _tmp5_);
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp6_ = self->priv->radio_airplane;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp7_ = self->priv->radio_id;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_handler_unblock (_tmp6_, _tmp7_);
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 1786 "BluetoothIndicator.c"
}


static void
_bluetooth_indicator_on_airplane_change_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self)
{
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_airplane_change ((BluetoothIndicator*) self);
#line 1798 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_sync_rfkill (BluetoothIndicator* self)
{
	Rfkill* _tmp0_;
	GDBusProxy* _tmp1_;
	GDBusProxy* _tmp2_;
#line 259 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_return_if_fail (self != NULL);
#line 261 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp0_ = self->priv->killer;
#line 261 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_dbus_proxy_get_type ()) ? ((GDBusProxy*) _tmp0_) : NULL);
#line 261 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->db);
#line 261 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->db = _tmp1_;
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_tmp2_ = self->priv->db;
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_signal_connect_object (_tmp2_, "g-properties-changed", (GCallback) _bluetooth_indicator_on_airplane_change_g_dbus_proxy_g_properties_changed, self, 0);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_resync (self);
#line 264 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_on_airplane_change (self);
#line 1826 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_class_init (BluetoothIndicatorClass * klass)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	bluetooth_indicator_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	g_type_class_add_private (klass, sizeof (BluetoothIndicatorPrivate));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_indicator_finalize;
#line 1839 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_instance_init (BluetoothIndicator * self)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv = BLUETOOTH_INDICATOR_GET_PRIVATE (self);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->image = NULL;
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->ebox = NULL;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->client = NULL;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->model = NULL;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->popover = NULL;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->killer = NULL;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self->priv->db = NULL;
#line 1862 "BluetoothIndicator.c"
}


static void
bluetooth_indicator_finalize (GObject * obj)
{
	BluetoothIndicator * self;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLUETOOTH_INDICATOR, BluetoothIndicator);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->image);
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->client);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->model);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->popover);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->killer);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->db);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->radio_airplane);
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	_g_object_unref0 (self->priv->send_to);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/BluetoothIndicator.vala"
	G_OBJECT_CLASS (bluetooth_indicator_parent_class)->finalize (obj);
#line 1892 "BluetoothIndicator.c"
}


GType
bluetooth_indicator_get_type (void)
{
	return bluetooth_indicator_type_id;
}


GType
bluetooth_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothIndicator), 0, (GInstanceInitFunc) bluetooth_indicator_instance_init, NULL };
	bluetooth_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "BluetoothIndicator", &g_define_type_info, 0);
	return bluetooth_indicator_type_id;
}



