/* PowerIndicator.c generated by valac 0.40.19, the Vala compiler
 * generated from PowerIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <upower.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include "plugin.h"
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>


#define TYPE_BATTERY_ICON (battery_icon_get_type ())
#define BATTERY_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATTERY_ICON, BatteryIcon))
#define BATTERY_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATTERY_ICON, BatteryIconClass))
#define IS_BATTERY_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATTERY_ICON))
#define IS_BATTERY_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATTERY_ICON))
#define BATTERY_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATTERY_ICON, BatteryIconClass))

typedef struct _BatteryIcon BatteryIcon;
typedef struct _BatteryIconClass BatteryIconClass;
typedef struct _BatteryIconPrivate BatteryIconPrivate;
enum  {
	BATTERY_ICON_0_PROPERTY,
	BATTERY_ICON_BATTERY_PROPERTY,
	BATTERY_ICON_LABEL_VISIBLE_PROPERTY,
	BATTERY_ICON_NUM_PROPERTIES
};
static GParamSpec* battery_icon_properties[BATTERY_ICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_POWER_INDICATOR (power_indicator_get_type ())
#define POWER_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POWER_INDICATOR, PowerIndicator))
#define POWER_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POWER_INDICATOR, PowerIndicatorClass))
#define IS_POWER_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POWER_INDICATOR))
#define IS_POWER_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POWER_INDICATOR))
#define POWER_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POWER_INDICATOR, PowerIndicatorClass))

typedef struct _PowerIndicator PowerIndicator;
typedef struct _PowerIndicatorClass PowerIndicatorClass;
typedef struct _PowerIndicatorPrivate PowerIndicatorPrivate;
enum  {
	POWER_INDICATOR_0_PROPERTY,
	POWER_INDICATOR_CLIENT_PROPERTY,
	POWER_INDICATOR_LABEL_VISIBLE_PROPERTY,
	POWER_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* power_indicator_properties[POWER_INDICATOR_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _BatteryIcon {
	GtkBox parent_instance;
	BatteryIconPrivate * priv;
};

struct _BatteryIconClass {
	GtkBoxClass parent_class;
};

struct _BatteryIconPrivate {
	UpDevice* _battery;
	gboolean changing;
	GtkImage* image;
	GtkLabel* percent_label;
};

struct _PowerIndicator {
	GtkBin parent_instance;
	PowerIndicatorPrivate * priv;
	GtkEventBox* ebox;
	BudgiePopover* popover;
};

struct _PowerIndicatorClass {
	GtkBinClass parent_class;
};

struct _PowerIndicatorPrivate {
	GtkBox* widget;
	UpClient* _client;
	GHashTable* devices;
	gboolean _label_visible;
	GtkCheckButton* check_percent;
	GSettings* battery_settings;
};


static gpointer battery_icon_parent_class = NULL;
static GType battery_icon_type_id = 0;
static gpointer power_indicator_parent_class = NULL;
static GType power_indicator_type_id = 0;

GType battery_icon_register_type (GTypeModule * module);
GType battery_icon_get_type (void) G_GNUC_CONST;
#define BATTERY_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BATTERY_ICON, BatteryIconPrivate))
BatteryIcon* battery_icon_new (UpDevice* battery);
BatteryIcon* battery_icon_construct (GType object_type,
                                     UpDevice* battery);
void battery_icon_update_ui (BatteryIcon* self,
                             UpDevice* battery);
static void battery_icon_on_battery_change (BatteryIcon* self,
                                     GObject* o,
                                     GParamSpec* sp);
static void _battery_icon_on_battery_change_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
UpDevice* battery_icon_get_battery (BatteryIcon* self);
void battery_icon_set_battery (BatteryIcon* self,
                               UpDevice* value);
gboolean battery_icon_get_label_visible (BatteryIcon* self);
void battery_icon_set_label_visible (BatteryIcon* self,
                                     gboolean value);
static void battery_icon_finalize (GObject * obj);
static void _vala_battery_icon_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_battery_icon_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
GType power_indicator_register_type (GTypeModule * module);
GType power_indicator_get_type (void) G_GNUC_CONST;
#define POWER_INDICATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_POWER_INDICATOR, PowerIndicatorPrivate))
PowerIndicator* power_indicator_new (void);
PowerIndicator* power_indicator_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void power_indicator_update_labels (PowerIndicator* self);
static void _power_indicator_update_labels_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void power_indicator_open_power_settings (PowerIndicator* self);
static void _power_indicator_open_power_settings_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
void power_indicator_set_client (PowerIndicator* self,
                                 UpClient* value);
static void power_indicator_sync_devices (PowerIndicator* self);
UpClient* power_indicator_get_client (PowerIndicator* self);
static void power_indicator_on_device_added (PowerIndicator* self,
                                      UpDevice* device);
static void _power_indicator_on_device_added_up__client_device_added (UpClient* _sender,
                                                               UpDevice* device,
                                                               gpointer self);
static void power_indicator_on_device_removed (PowerIndicator* self,
                                        const gchar* object_path);
static void _power_indicator_on_device_removed_up__client_device_removed (UpClient* _sender,
                                                                   const gchar* object_path,
                                                                   gpointer self);
static void power_indicator_toggle_show (PowerIndicator* self);
void power_indicator_change_orientation (PowerIndicator* self,
                                         GtkOrientation orient);
gboolean power_indicator_get_label_visible (PowerIndicator* self);
static gboolean power_indicator_is_interesting (PowerIndicator* self,
                                         UpDevice* device);
static void __lambda10_ (PowerIndicator* self,
                  UpDevice* device);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
void power_indicator_set_label_visible (PowerIndicator* self,
                                        gboolean value);
static void power_indicator_finalize (GObject * obj);
static void _vala_power_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_power_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


static void
_battery_icon_on_battery_change_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_on_battery_change ((BatteryIcon*) self, _sender, pspec);
#line 201 "PowerIndicator.c"
}


BatteryIcon*
battery_icon_construct (GType object_type,
                        UpDevice* battery)
{
	BatteryIcon * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self = (BatteryIcon*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, "spacing", 0, NULL);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp0_, "battery-icon");
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new ("");
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->percent_label);
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->percent_label = _tmp1_;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = self->priv->percent_label;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp3_, "percent-label");
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp4_ = self->priv->percent_label;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp5_ = self->priv->percent_label;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 4);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp6_ = self->priv->percent_label;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp6_, FALSE, FALSE, (guint) 0);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp7_ = self->priv->percent_label;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp7_, TRUE);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp8_ = (GtkImage*) gtk_image_new ();
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp8_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->image = _tmp8_;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp9_ = self->priv->image;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp10_ = self->priv->image;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_image_set_pixel_size (_tmp10_, 0);
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp11_ = self->priv->image;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp11_, FALSE, FALSE, (guint) 0);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_update_ui (self, battery);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_signal_connect_object ((GObject*) battery, "notify", (GCallback) _battery_icon_on_battery_change_g_object_notify, self, 0);
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return self;
#line 286 "PowerIndicator.c"
}


BatteryIcon*
battery_icon_new (UpDevice* battery)
{
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return battery_icon_construct (TYPE_BATTERY_ICON, battery);
#line 295 "PowerIndicator.c"
}


static void
battery_icon_on_battery_change (BatteryIcon* self,
                                GObject* o,
                                GParamSpec* sp)
{
	gboolean _tmp0_;
	UpDevice* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (o != NULL);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (sp != NULL);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->changing;
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (_tmp0_) {
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 319 "PowerIndicator.c"
	}
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->changing = TRUE;
#line 323 "PowerIndicator.c"
	{
		UpDevice* _tmp1_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp1_ = self->priv->_battery;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		up_device_refresh_sync (_tmp1_, NULL, &_inner_error0_);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "PowerIndicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		e = _inner_error0_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_inner_error0_ = NULL;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp2_ = e;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp3_ = _tmp2_->message;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_warning ("PowerIndicator.vala:68: Failed to refresh battery: %s", _tmp3_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_error_free0 (e);
#line 354 "PowerIndicator.c"
	}
	__finally0:
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 365 "PowerIndicator.c"
	}
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp4_ = self->priv->_battery;
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_update_ui (self, _tmp4_);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->changing = FALSE;
#line 373 "PowerIndicator.c"
}


void
battery_icon_update_ui (BatteryIcon* self,
                        UpDevice* battery)
{
	gchar* tip = NULL;
	gchar* image_name = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	guint _tmp10_;
	guint _tmp11_;
	gchar* labe = NULL;
	gdouble _tmp48_;
	gdouble _tmp49_;
	gchar* _tmp50_;
	gchar* old = NULL;
	GtkLabel* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp58_;
	GtkImage* _tmp59_;
	const gchar* _tmp60_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (battery != NULL);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_set_battery (self, battery);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "percentage", &_tmp0_, NULL);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = _tmp0_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (_tmp1_ <= ((gdouble) 10)) {
#line 412 "PowerIndicator.c"
		gchar* _tmp2_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp2_ = g_strdup ("battery-empty");
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_free0 (image_name);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		image_name = _tmp2_;
#line 420 "PowerIndicator.c"
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_object_get (battery, "percentage", &_tmp3_, NULL);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp4_ = _tmp3_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (_tmp4_ <= ((gdouble) 35)) {
#line 430 "PowerIndicator.c"
			gchar* _tmp5_;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp5_ = g_strdup ("battery-low");
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (image_name);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			image_name = _tmp5_;
#line 438 "PowerIndicator.c"
		} else {
			gdouble _tmp6_;
			gdouble _tmp7_;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp6_, NULL);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp7_ = _tmp6_;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			if (_tmp7_ <= ((gdouble) 75)) {
#line 448 "PowerIndicator.c"
				gchar* _tmp8_;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp8_ = g_strdup ("battery-good");
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_g_free0 (image_name);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				image_name = _tmp8_;
#line 456 "PowerIndicator.c"
			} else {
				gchar* _tmp9_;
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp9_ = g_strdup ("battery-full");
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_g_free0 (image_name);
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				image_name = _tmp9_;
#line 465 "PowerIndicator.c"
			}
		}
	}
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "state", &_tmp10_, NULL);
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp11_ = _tmp10_;
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (_tmp11_ == ((guint) 4)) {
#line 475 "PowerIndicator.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp12_ = g_strdup ("battery-full-charged-symbolic");
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_free0 (image_name);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		image_name = _tmp12_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp13_ = g_strdup (_ ("Battery fully charged."));
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_free0 (tip);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		tip = _tmp13_;
#line 490 "PowerIndicator.c"
	} else {
		guint _tmp14_;
		guint _tmp15_;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_object_get (battery, "state", &_tmp14_, NULL);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp15_ = _tmp14_;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (_tmp15_ == ((guint) 1)) {
#line 500 "PowerIndicator.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* time_to_full_str = NULL;
			gchar* _tmp18_;
			gint time_to_full = 0;
			gint64 _tmp19_;
			gint64 _tmp20_;
			gint _tmp21_;
			gdouble _tmp28_;
			gdouble _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp16_ = image_name;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp17_ = g_strconcat (_tmp16_, "-charging-symbolic", NULL);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (image_name);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			image_name = _tmp17_;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp18_ = g_strdup (_ ("Unknown"));
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			time_to_full_str = _tmp18_;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-full", &_tmp19_, NULL);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp20_ = _tmp19_;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			time_to_full = (gint) _tmp20_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp21_ = time_to_full;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			if (_tmp21_ > 0) {
#line 537 "PowerIndicator.c"
				gint hours = 0;
				gint _tmp22_;
				gint minutes = 0;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gchar* _tmp27_;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp22_ = time_to_full;
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				hours = _tmp22_ / (60 * 60);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp23_ = time_to_full;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp24_ = hours;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				minutes = (_tmp23_ / 60) - (_tmp24_ * 60);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp25_ = hours;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp26_ = minutes;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_tmp27_ = g_strdup_printf ("%d:%02d", _tmp25_, _tmp26_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				_g_free0 (time_to_full_str);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
				time_to_full_str = _tmp27_;
#line 566 "PowerIndicator.c"
			}
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp28_, NULL);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp29_ = _tmp28_;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp30_ = time_to_full_str;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp31_ = g_strdup_printf (": %d%% (%s)", (gint) _tmp29_, _tmp30_);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp32_ = _tmp31_;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp33_ = g_strconcat (_ ("Battery charging"), _tmp32_, NULL);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (tip);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			tip = _tmp33_;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (_tmp32_);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (time_to_full_str);
#line 588 "PowerIndicator.c"
		} else {
			const gchar* _tmp34_;
			gchar* _tmp35_;
			gint hours = 0;
			gint64 _tmp36_;
			gint64 _tmp37_;
			gint minutes = 0;
			gint64 _tmp38_;
			gint64 _tmp39_;
			gint _tmp40_;
			gdouble _tmp41_;
			gdouble _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp34_ = image_name;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp35_ = g_strconcat (_tmp34_, "-symbolic", NULL);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (image_name);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			image_name = _tmp35_;
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-empty", &_tmp36_, NULL);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp37_ = _tmp36_;
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			hours = ((gint) _tmp37_) / (60 * 60);
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-empty", &_tmp38_, NULL);
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp39_ = _tmp38_;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp40_ = hours;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			minutes = (((gint) _tmp39_) / 60) - (_tmp40_ * 60);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp41_, NULL);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp42_ = _tmp41_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp43_ = hours;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp44_ = minutes;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp45_ = g_strdup_printf (": %d%% (%d:%02d)", (gint) _tmp42_, _tmp43_, _tmp44_);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp46_ = _tmp45_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_tmp47_ = g_strconcat (_ ("Battery remaining"), _tmp46_, NULL);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (tip);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			tip = _tmp47_;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			_g_free0 (_tmp46_);
#line 648 "PowerIndicator.c"
		}
	}
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "percentage", &_tmp48_, NULL);
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp49_ = _tmp48_;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp50_ = g_strdup_printf ("%d%%", (gint) _tmp49_);
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	labe = _tmp50_;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp51_ = self->priv->percent_label;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp52_ = gtk_label_get_label (_tmp51_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp53_ = g_strdup (_tmp52_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	old = _tmp53_;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp54_ = old;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp55_ = labe;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (g_strcmp0 (_tmp54_, _tmp55_) != 0) {
#line 673 "PowerIndicator.c"
		GtkLabel* _tmp56_;
		const gchar* _tmp57_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp56_ = self->priv->percent_label;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp57_ = labe;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		gtk_label_set_text (_tmp56_, _tmp57_);
#line 682 "PowerIndicator.c"
	}
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp58_ = tip;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp58_);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp59_ = self->priv->image;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp60_ = image_name;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_image_set_from_icon_name (_tmp59_, _tmp60_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_free0 (old);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_free0 (labe);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_free0 (image_name);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_free0 (tip);
#line 704 "PowerIndicator.c"
}


UpDevice*
battery_icon_get_battery (BatteryIcon* self)
{
	UpDevice* result;
	UpDevice* _tmp0_;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_battery;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	result = _tmp0_;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return result;
#line 721 "PowerIndicator.c"
}


void
battery_icon_set_battery (BatteryIcon* self,
                          UpDevice* value)
{
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (battery_icon_get_battery (self) != value) {
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		self->priv->_battery = value;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, battery_icon_properties[BATTERY_ICON_BATTERY_PROPERTY]);
#line 737 "PowerIndicator.c"
	}
}


gboolean
battery_icon_get_label_visible (BatteryIcon* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->percent_label;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = _tmp1_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	result = _tmp2_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return result;
#line 761 "PowerIndicator.c"
}


void
battery_icon_set_label_visible (BatteryIcon* self,
                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->percent_label;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_notify_by_pspec ((GObject *) self, battery_icon_properties[BATTERY_ICON_LABEL_VISIBLE_PROPERTY]);
#line 778 "PowerIndicator.c"
}


static void
battery_icon_class_init (BatteryIconClass * klass)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_type_class_add_private (klass, sizeof (BatteryIconPrivate));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_battery_icon_get_property;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_battery_icon_set_property;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = battery_icon_finalize;
#line 795 "PowerIndicator.c"
	/** The battery associated with this icon */
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BATTERY_ICON_BATTERY_PROPERTY, battery_icon_properties[BATTERY_ICON_BATTERY_PROPERTY] = g_param_spec_object ("battery", "battery", "battery", up_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 799 "PowerIndicator.c"
	/**
	     * Expose a simple property so the UI can update whether we show
	     * labels or not
	     */
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BATTERY_ICON_LABEL_VISIBLE_PROPERTY, battery_icon_properties[BATTERY_ICON_LABEL_VISIBLE_PROPERTY] = g_param_spec_boolean ("label-visible", "label-visible", "label-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 806 "PowerIndicator.c"
}


static void
battery_icon_instance_init (BatteryIcon * self)
{
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv = BATTERY_ICON_GET_PRIVATE (self);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->changing = FALSE;
#line 817 "PowerIndicator.c"
}


static void
battery_icon_finalize (GObject * obj)
{
	BatteryIcon * self;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATTERY_ICON, BatteryIcon);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->percent_label);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (battery_icon_parent_class)->finalize (obj);
#line 833 "PowerIndicator.c"
}


GType
battery_icon_get_type (void)
{
	return battery_icon_type_id;
}


GType
battery_icon_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BatteryIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) battery_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatteryIcon), 0, (GInstanceInitFunc) battery_icon_instance_init, NULL };
	battery_icon_type_id = g_type_module_register_type (module, gtk_box_get_type (), "BatteryIcon", &g_define_type_info, 0);
	return battery_icon_type_id;
}


static void
_vala_battery_icon_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	BatteryIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BATTERY_ICON, BatteryIcon);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_BATTERY_PROPERTY:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_value_set_object (value, battery_icon_get_battery (self));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_LABEL_VISIBLE_PROPERTY:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_value_set_boolean (value, battery_icon_get_label_visible (self));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 875 "PowerIndicator.c"
		default:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 881 "PowerIndicator.c"
	}
}


static void
_vala_battery_icon_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	BatteryIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BATTERY_ICON, BatteryIcon);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_BATTERY_PROPERTY:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		battery_icon_set_battery (self, g_value_get_object (value));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_LABEL_VISIBLE_PROPERTY:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		battery_icon_set_label_visible (self, g_value_get_boolean (value));
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 908 "PowerIndicator.c"
		default:
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 914 "PowerIndicator.c"
	}
}


static void
_g_free0_ (gpointer var)
{
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	var = (g_free (var), NULL);
#line 924 "PowerIndicator.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 933 "PowerIndicator.c"
}


static void
_power_indicator_update_labels_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_update_labels ((PowerIndicator*) self);
#line 944 "PowerIndicator.c"
}


static void
_power_indicator_open_power_settings_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_open_power_settings ((PowerIndicator*) self);
#line 954 "PowerIndicator.c"
}


static void
_power_indicator_on_device_added_up__client_device_added (UpClient* _sender,
                                                          UpDevice* device,
                                                          gpointer self)
{
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_added ((PowerIndicator*) self, device);
#line 965 "PowerIndicator.c"
}


static void
_power_indicator_on_device_removed_up__client_device_removed (UpClient* _sender,
                                                              const gchar* object_path,
                                                              gpointer self)
{
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_removed ((PowerIndicator*) self, object_path);
#line 976 "PowerIndicator.c"
}


PowerIndicator*
power_indicator_construct (GType object_type)
{
	PowerIndicator * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkEventBox* _tmp8_;
	BudgiePopover* _tmp9_;
	GtkBox* box = NULL;
	GtkBox* _tmp10_;
	BudgiePopover* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkCheckButton* _tmp15_;
	GtkWidget* _tmp16_;
	GValue _tmp17_ = {0};
	GtkCheckButton* _tmp18_;
	GSettings* _tmp19_;
	GtkCheckButton* _tmp20_;
	GtkSeparator* sep = NULL;
	GtkSeparator* _tmp21_;
	GtkButton* button = NULL;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkWidget* _tmp24_;
	UpClient* _tmp25_;
	UpClient* _tmp26_;
	UpClient* _tmp27_;
	UpClient* _tmp28_;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self = (PowerIndicator*) g_object_new (object_type, NULL);
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = g_str_hash;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_str_equal;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->devices = _tmp2_;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp3_ = (GtkEventBox*) gtk_event_box_new ();
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp3_);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->ebox = _tmp3_;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp4_ = self->ebox;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->widget);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->widget = _tmp5_;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp6_ = self->ebox;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp7_ = self->priv->widget;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp8_ = self->ebox;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp9_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp8_);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp9_);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->popover);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->popover = _tmp9_;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp10_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp10_);
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	box = _tmp10_;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 6);
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp11_ = self->popover;
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) box);
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp12_ = g_settings_new ("org.gnome.desktop.interface");
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->battery_settings);
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->battery_settings = _tmp12_;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp13_ = self->priv->battery_settings;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_settings_bind (_tmp13_, "show-battery-percentage", (GObject*) self, "label-visible", G_SETTINGS_BIND_GET);
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_signal_connect_object ((GObject*) self, "notify::label-visible", (GCallback) _power_indicator_update_labels_g_object_notify, self, G_CONNECT_AFTER);
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp14_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Show battery percentage"));
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp14_);
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->check_percent);
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->check_percent = _tmp14_;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp15_ = self->priv->check_percent;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp16_ = gtk_bin_get_child ((GtkBin*) _tmp15_);
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_value_init (&_tmp17_, G_TYPE_INT);
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_value_set_int (&_tmp17_, 4);
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_set_property ((GObject*) _tmp16_, "margin", &_tmp17_);
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp18_ = self->priv->check_percent;
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp19_ = self->priv->battery_settings;
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp20_ = self->priv->check_percent;
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_settings_bind (_tmp19_, "show-battery-percentage", (GObject*) _tmp20_, "active", G_SETTINGS_BIND_DEFAULT);
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp21_);
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	sep = _tmp21_;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) sep, FALSE, FALSE, (guint) 1);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp22_ = (GtkButton*) gtk_button_new_with_label (_ ("Power settings"));
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp22_);
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	button = _tmp22_;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) button);
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_FLAT);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (button, "clicked", (GCallback) _power_indicator_open_power_settings_gtk_button_clicked, self, 0);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp24_ = gtk_bin_get_child ((GtkBin*) button);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_set_halign (_tmp24_, GTK_ALIGN_START);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) box);
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp25_ = up_client_new ();
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp26_ = _tmp25_;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_set_client (self, _tmp26_);
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (_tmp26_);
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_sync_devices (self);
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp27_ = self->priv->_client;
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (_tmp27_, "device-added", (GCallback) _power_indicator_on_device_added_up__client_device_added, self, 0);
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp28_ = self->priv->_client;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (_tmp28_, "device-removed", (GCallback) _power_indicator_on_device_removed_up__client_device_removed, self, 0);
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (button);
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (sep);
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (box);
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return self;
#line 1174 "PowerIndicator.c"
}


PowerIndicator*
power_indicator_new (void)
{
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return power_indicator_construct (TYPE_POWER_INDICATOR);
#line 1183 "PowerIndicator.c"
}


void
power_indicator_change_orientation (PowerIndicator* self,
                                    GtkOrientation orient)
{
	gint spacing = 0;
	BatteryIcon* icon = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp0_;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	spacing = 0;
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (orient == GTK_ORIENTATION_VERTICAL) {
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		spacing = 5;
#line 1203 "PowerIndicator.c"
	}
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	icon = NULL;
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_hash_table_iter_init (&iter, _tmp0_);
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	while (TRUE) {
#line 1213 "PowerIndicator.c"
		gconstpointer _tmp1_ = NULL;
		gboolean _tmp2_;
		BatteryIcon* _tmp3_;
		gint _tmp4_;
		BatteryIcon* _tmp5_;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp2_ = g_hash_table_iter_next (&iter, (gpointer*) NULL, (gpointer*) (&_tmp1_));
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		icon = _tmp1_;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (!_tmp2_) {
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			break;
#line 1227 "PowerIndicator.c"
		}
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp3_ = icon;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp4_ = spacing;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		gtk_box_set_spacing ((GtkBox*) _tmp3_, _tmp4_);
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp5_ = icon;
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp5_, orient);
#line 1239 "PowerIndicator.c"
	}
}


static void
power_indicator_update_labels (PowerIndicator* self)
{
	BatteryIcon* icon = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp0_;
	GtkWidget* _tmp5_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	icon = NULL;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_hash_table_iter_init (&iter, _tmp0_);
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	while (TRUE) {
#line 1261 "PowerIndicator.c"
		gconstpointer _tmp1_ = NULL;
		gboolean _tmp2_;
		BatteryIcon* _tmp3_;
		gboolean _tmp4_;
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp2_ = g_hash_table_iter_next (&iter, (gpointer*) NULL, (gpointer*) (&_tmp1_));
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		icon = _tmp1_;
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (!_tmp2_) {
#line 208 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
			break;
#line 1274 "PowerIndicator.c"
		}
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp3_ = icon;
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp4_ = self->priv->_label_visible;
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		battery_icon_set_label_visible (_tmp3_, _tmp4_);
#line 1282 "PowerIndicator.c"
	}
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp5_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_queue_draw (_tmp5_);
#line 1288 "PowerIndicator.c"
}


static gboolean
power_indicator_is_interesting (PowerIndicator* self,
                                UpDevice* device)
{
	gboolean result = FALSE;
	guint _tmp0_;
	guint _tmp1_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (device != NULL, FALSE);
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_get (device, "kind", &_tmp0_, NULL);
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = _tmp0_;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (_tmp1_ != ((guint) UP_DEVICE_KIND_BATTERY)) {
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		result = FALSE;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return result;
#line 1313 "PowerIndicator.c"
	}
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	result = TRUE;
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return result;
#line 1319 "PowerIndicator.c"
}


static void
power_indicator_open_power_settings (PowerIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->popover;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("gnome-power-panel.desktop");
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	app_info = _tmp1_;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = app_info;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (_tmp2_ == NULL) {
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (app_info);
#line 230 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 1349 "PowerIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp3_ = app_info;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1359 "PowerIndicator.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		e = _inner_error0_;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_inner_error0_ = NULL;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp4_ = e;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_message ("PowerIndicator.vala:236: Unable to launch gnome-power-panel.desktop: %" \
"s", _tmp5_);
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_error_free0 (e);
#line 1381 "PowerIndicator.c"
	}
	__finally1:
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (app_info);
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 1394 "PowerIndicator.c"
	}
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (app_info);
#line 1398 "PowerIndicator.c"
}


/**
     * Add a new device to the tree
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 1410 "PowerIndicator.c"
}


static void
power_indicator_on_device_added (PowerIndicator* self,
                                 UpDevice* device)
{
	gchar* object_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	BatteryIcon* icon = NULL;
	BatteryIcon* _tmp7_;
	BatteryIcon* _tmp8_;
	gboolean _tmp9_;
	GHashTable* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	BatteryIcon* _tmp13_;
	BatteryIcon* _tmp14_;
	GtkBox* _tmp15_;
	BatteryIcon* _tmp16_;
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (device != NULL);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = up_device_get_object_path (device);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	object_path = _tmp1_;
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = self->priv->devices;
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp3_ = object_path;
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (g_hash_table_contains (_tmp2_, _tmp3_)) {
#line 1450 "PowerIndicator.c"
		GHashTable* _tmp4_;
		const gchar* _tmp5_;
		gconstpointer _tmp6_;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp4_ = self->priv->devices;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp5_ = object_path;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		battery_icon_update_ui ((BatteryIcon*) _tmp6_, device);
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_free0 (object_path);
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 1466 "PowerIndicator.c"
	}
#line 251 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (!power_indicator_is_interesting (self, device)) {
#line 252 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_free0 (object_path);
#line 252 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 1474 "PowerIndicator.c"
	}
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp7_ = battery_icon_new (device);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp7_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	icon = _tmp7_;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp8_ = icon;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp9_ = self->priv->_label_visible;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	battery_icon_set_label_visible (_tmp8_, _tmp9_);
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp10_ = self->priv->devices;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp11_ = object_path;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp13_ = icon;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_hash_table_insert (_tmp10_, _tmp12_, _tmp14_);
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp15_ = self->priv->widget;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp16_ = icon;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 258 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (icon);
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_free0 (object_path);
#line 1512 "PowerIndicator.c"
}


static void
power_indicator_toggle_show (PowerIndicator* self)
{
	GHashTable* _tmp0_;
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 264 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 264 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (g_hash_table_size (_tmp0_) < ((guint) 1)) {
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1528 "PowerIndicator.c"
	} else {
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 1532 "PowerIndicator.c"
	}
}


/**
     * Remove a device from our display
     */
static void
power_indicator_on_device_removed (PowerIndicator* self,
                                   const gchar* object_path)
{
	GHashTable* _tmp0_;
	BatteryIcon* icon = NULL;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GtkBox* _tmp3_;
	BatteryIcon* _tmp4_;
	GHashTable* _tmp5_;
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (object_path != NULL);
#line 275 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 275 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (!g_hash_table_contains (_tmp0_, object_path)) {
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		return;
#line 1561 "PowerIndicator.c"
	}
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = self->priv->devices;
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp2_ = g_hash_table_lookup (_tmp1_, object_path);
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	icon = (BatteryIcon*) _tmp2_;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp3_ = self->priv->widget;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp4_ = icon;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp5_ = self->priv->devices;
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_hash_table_remove (_tmp5_, object_path);
#line 281 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 1581 "PowerIndicator.c"
}


static void
__lambda10_ (PowerIndicator* self,
             UpDevice* device)
{
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (device != NULL);
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_added (self, device);
#line 1593 "PowerIndicator.c"
}


static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	__lambda10_ ((PowerIndicator*) self, (UpDevice*) data);
#line 1603 "PowerIndicator.c"
}


static void
power_indicator_sync_devices (PowerIndicator* self)
{
	GPtrArray* devices = NULL;
	UpClient* _tmp0_;
	GPtrArray* _tmp1_;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_client;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp1_ = up_client_get_devices (_tmp0_);
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	devices = _tmp1_;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_ptr_array_foreach (devices, ___lambda10__gfunc, self);
#line 293 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_ptr_array_unref0 (devices);
#line 1627 "PowerIndicator.c"
}


UpClient*
power_indicator_get_client (PowerIndicator* self)
{
	UpClient* result;
	UpClient* _tmp0_;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_client;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	result = _tmp0_;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return result;
#line 1644 "PowerIndicator.c"
}


void
power_indicator_set_client (PowerIndicator* self,
                            UpClient* value)
{
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (power_indicator_get_client (self) != value) {
#line 1656 "PowerIndicator.c"
		UpClient* _tmp0_;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (self->priv->_client);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		self->priv->_client = _tmp0_;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_CLIENT_PROPERTY]);
#line 1666 "PowerIndicator.c"
	}
}


gboolean
power_indicator_get_label_visible (PowerIndicator* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_label_visible;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	result = _tmp0_;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	return result;
#line 1684 "PowerIndicator.c"
}


void
power_indicator_set_label_visible (PowerIndicator* self,
                                   gboolean value)
{
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	if (power_indicator_get_label_visible (self) != value) {
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		self->priv->_label_visible = value;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_LABEL_VISIBLE_PROPERTY]);
#line 1700 "PowerIndicator.c"
	}
}


static void
power_indicator_class_init (PowerIndicatorClass * klass)
{
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	power_indicator_parent_class = g_type_class_peek_parent (klass);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_type_class_add_private (klass, sizeof (PowerIndicatorPrivate));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_indicator_get_property;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_indicator_set_property;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = power_indicator_finalize;
#line 1718 "PowerIndicator.c"
	/** Our upower client */
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_CLIENT_PROPERTY, power_indicator_properties[POWER_INDICATOR_CLIENT_PROPERTY] = g_param_spec_object ("client", "client", "client", up_client_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_LABEL_VISIBLE_PROPERTY, power_indicator_properties[POWER_INDICATOR_LABEL_VISIBLE_PROPERTY] = g_param_spec_boolean ("label-visible", "label-visible", "label-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1724 "PowerIndicator.c"
}


static void
power_indicator_instance_init (PowerIndicator * self)
{
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv = POWER_INDICATOR_GET_PRIVATE (self);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->ebox = NULL;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->popover = NULL;
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->widget = NULL;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self->priv->_label_visible = FALSE;
#line 1741 "PowerIndicator.c"
}


static void
power_indicator_finalize (GObject * obj)
{
	PowerIndicator * self;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_POWER_INDICATOR, PowerIndicator);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->popover);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->widget);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->_client);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->check_percent);
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->battery_settings);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (power_indicator_parent_class)->finalize (obj);
#line 1767 "PowerIndicator.c"
}


GType
power_indicator_get_type (void)
{
	return power_indicator_type_id;
}


GType
power_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerIndicator), 0, (GInstanceInitFunc) power_indicator_instance_init, NULL };
	power_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "PowerIndicator", &g_define_type_info, 0);
	return power_indicator_type_id;
}


static void
_vala_power_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_POWER_INDICATOR, PowerIndicator);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_CLIENT_PROPERTY:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_value_set_object (value, power_indicator_get_client (self));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_LABEL_VISIBLE_PROPERTY:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		g_value_set_boolean (value, power_indicator_get_label_visible (self));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 1809 "PowerIndicator.c"
		default:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 1815 "PowerIndicator.c"
	}
}


static void
_vala_power_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_POWER_INDICATOR, PowerIndicator);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_CLIENT_PROPERTY:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		power_indicator_set_client (self, g_value_get_object (value));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_LABEL_VISIBLE_PROPERTY:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		power_indicator_set_label_visible (self, g_value_get_boolean (value));
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 1842 "PowerIndicator.c"
		default:
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/PowerIndicator.vala"
		break;
#line 1848 "PowerIndicator.c"
	}
}



