/* SoundIndicator.c generated by valac 0.40.19, the Vala compiler
 * generated from SoundIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 * 
 * Copyright © 2015-2019 Budgie Desktop Developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gvc-mixer-stream.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>


#define TYPE_SOUND_INDICATOR (sound_indicator_get_type ())
#define SOUND_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_INDICATOR, SoundIndicator))
#define SOUND_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_INDICATOR, SoundIndicatorClass))
#define IS_SOUND_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_INDICATOR))
#define IS_SOUND_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_INDICATOR))
#define SOUND_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_INDICATOR, SoundIndicatorClass))

typedef struct _SoundIndicator SoundIndicator;
typedef struct _SoundIndicatorClass SoundIndicatorClass;
typedef struct _SoundIndicatorPrivate SoundIndicatorPrivate;
enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_WIDGET_PROPERTY,
	SOUND_INDICATOR_MIXER_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SoundIndicator {
	GtkBin parent_instance;
	SoundIndicatorPrivate * priv;
	guint32 unmuted_volume_val;
	GtkEventBox* ebox;
	BudgiePopover* popover;
};

struct _SoundIndicatorClass {
	GtkBinClass parent_class;
};

struct _SoundIndicatorPrivate {
	GtkImage* _widget;
	GvcMixerControl* _mixer;
	GvcMixerStream* stream;
	GtkScale* volume_scale;
	gdouble step_size;
	gulong notify_id;
	gulong scale_id;
};


static gpointer sound_indicator_parent_class = NULL;
static GType sound_indicator_type_id = 0;

#define MIXER_NAME "Budgie Volume Control"
GType sound_indicator_register_type (GTypeModule * module);
GType sound_indicator_get_type (void) G_GNUC_CONST;
#define SOUND_INDICATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOUND_INDICATOR, SoundIndicatorPrivate))
SoundIndicator* sound_indicator_new (void);
SoundIndicator* sound_indicator_construct (GType object_type);
void sound_indicator_set_widget (SoundIndicator* self,
                                 GtkImage* value);
GtkImage* sound_indicator_get_widget (SoundIndicator* self);
void sound_indicator_set_mixer (SoundIndicator* self,
                                GvcMixerControl* value);
GvcMixerControl* sound_indicator_get_mixer (SoundIndicator* self);
void sound_indicator_on_state_change (SoundIndicator* self,
                                      guint new_state);
static void _sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                       guint new_state,
                                                                       gpointer self);
static void sound_indicator_on_sink_changed (SoundIndicator* self,
                                      guint id);
static void _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void sound_indicator_create_sound_popover (SoundIndicator* self);
gboolean sound_indicator_on_scroll_event (SoundIndicator* self,
                                          GdkEventScroll* event);
static gboolean _sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                   GdkEventScroll* event,
                                                                   gpointer self);
static gboolean sound_indicator_on_button_release_event (SoundIndicator* self,
                                                  GdkEventButton* e);
static gboolean _sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static void __lambda8_ (SoundIndicator* self);
static void sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                              gdouble increment);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_indicator_on_scale_changed (SoundIndicator* self);
static void _sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                gpointer self);
static void __lambda9_ (SoundIndicator* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_indicator_open_sound_settings (SoundIndicator* self);
static void _sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void sound_indicator_set_default_mixer (SoundIndicator* self);
static void sound_indicator_on_notify (SoundIndicator* self,
                                GObject* o,
                                GParamSpec* p);
static void _sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
void sound_indicator_update_volume (SoundIndicator* self);
static void sound_indicator_finalize (GObject * obj);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


static void
_sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                  guint new_state,
                                                                  gpointer self)
{
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_on_state_change ((SoundIndicator*) self, new_state);
#line 154 "SoundIndicator.c"
}


static void
_sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_on_sink_changed ((SoundIndicator*) self, id);
#line 165 "SoundIndicator.c"
}


static gboolean
_sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                          GdkEventScroll* event,
                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_scroll_event ((SoundIndicator*) self, event);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 178 "SoundIndicator.c"
}


static gboolean
_sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_button_release_event ((SoundIndicator*) self, event);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 191 "SoundIndicator.c"
}


SoundIndicator*
sound_indicator_construct (GType object_type)
{
	SoundIndicator * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkImage* _tmp4_;
	GtkEventBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkEventBox* _tmp7_;
	GvcMixerControl* _tmp8_;
	GvcMixerControl* _tmp9_;
	GvcMixerControl* _tmp10_;
	GvcMixerControl* _tmp11_;
	GvcMixerControl* _tmp12_;
	GtkStyleContext* _tmp13_;
	BudgiePopover* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self = (SoundIndicator*) g_object_new (object_type, NULL);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp0_);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = _tmp0_;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_set_widget (self, _tmp1_);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (_tmp1_);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp2_);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->ebox = _tmp2_;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->ebox;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->_widget;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->ebox;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_set ((GtkWidget*) _tmp5_, "margin", 0, NULL);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->ebox;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp6_, (guint) 0);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp7_ = self->ebox;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp8_ = gvc_mixer_control_new (MIXER_NAME);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp9_ = _tmp8_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_set_mixer (self, _tmp9_);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (_tmp9_);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->_mixer;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp10_, "state-changed", (GCallback) _sound_indicator_on_state_change_gvc_mixer_control_state_changed, self, 0);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp11_ = self->priv->_mixer;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp11_, "default-sink-changed", (GCallback) _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed, self, 0);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp12_ = self->priv->_mixer;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gvc_mixer_control_open (_tmp12_);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_create_sound_popover (self);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 61 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp13_, "sound-applet");
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp14_ = self->popover;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp15_, "sound-popover");
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp16_ = self->ebox;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp16_, (gint) GDK_SCROLL_MASK);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp17_ = self->ebox;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp17_, (gint) GDK_BUTTON_RELEASE_MASK);
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp18_ = self->ebox;
#line 67 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "scroll-event", (GCallback) _sound_indicator_on_scroll_event_gtk_widget_scroll_event, self, 0);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp19_ = self->ebox;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp19_, "button-release-event", (GCallback) _sound_indicator_on_button_release_event_gtk_widget_button_release_event, self, 0);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return self;
#line 309 "SoundIndicator.c"
}


SoundIndicator*
sound_indicator_new (void)
{
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return sound_indicator_construct (TYPE_SOUND_INDICATOR);
#line 318 "SoundIndicator.c"
}


static gboolean
sound_indicator_on_button_release_event (SoundIndicator* self,
                                         GdkEventButton* e)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = e->button;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp0_ == ((guint) GDK_BUTTON_MIDDLE)) {
#line 336 "SoundIndicator.c"
		gboolean is_muted = FALSE;
		GvcMixerStream* _tmp1_;
		gboolean _tmp2_;
		GvcMixerStream* _tmp6_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp1_ = self->priv->stream;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		is_muted = gvc_mixer_stream_get_volume (_tmp1_) == ((guint32) 0);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp2_ = is_muted;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		if (_tmp2_) {
#line 349 "SoundIndicator.c"
			GvcMixerStream* _tmp3_;
			guint32 _tmp4_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp3_ = self->priv->stream;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp4_ = self->unmuted_volume_val;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			gvc_mixer_stream_set_volume (_tmp3_, _tmp4_);
#line 358 "SoundIndicator.c"
		} else {
			GvcMixerStream* _tmp5_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp5_ = self->priv->stream;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			gvc_mixer_stream_set_volume (_tmp5_, (guint32) 0);
#line 365 "SoundIndicator.c"
		}
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp6_ = self->priv->stream;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp6_);
#line 371 "SoundIndicator.c"
	} else {
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		result = GDK_EVENT_PROPAGATE;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		return result;
#line 377 "SoundIndicator.c"
	}
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	result = GDK_EVENT_STOP;
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 383 "SoundIndicator.c"
}


/**
     * Create the GtkPopover to display on primary click action, with an adjustable
     * scale
     */
static void
__lambda8_ (SoundIndicator* self)
{
	gdouble _tmp0_;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->step_size;
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_adjust_volume_increment (self, -_tmp0_);
#line 399 "SoundIndicator.c"
}


static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	__lambda8_ ((SoundIndicator*) self);
#line 409 "SoundIndicator.c"
}


static void
_sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                           gpointer self)
{
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_on_scale_changed ((SoundIndicator*) self);
#line 419 "SoundIndicator.c"
}


static void
__lambda9_ (SoundIndicator* self)
{
	gdouble _tmp0_;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->step_size;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_adjust_volume_increment (self, +_tmp0_);
#line 431 "SoundIndicator.c"
}


static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	__lambda9_ ((SoundIndicator*) self);
#line 441 "SoundIndicator.c"
}


static void
_sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_open_sound_settings ((SoundIndicator*) self);
#line 451 "SoundIndicator.c"
}


static void
sound_indicator_create_sound_popover (SoundIndicator* self)
{
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp2_;
	GtkBox* popover_box = NULL;
	GtkBox* _tmp3_;
	BudgiePopover* _tmp4_;
	GtkButton* sub_button = NULL;
	GtkButton* _tmp5_;
	GtkButton* plus_button = NULL;
	GtkButton* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	GtkScale* _tmp9_;
	gulong _tmp10_;
	GtkScale* _tmp11_;
	GtkScale* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkScale* _tmp17_;
	GtkScale* _tmp18_;
	GtkSeparator* sep = NULL;
	GtkSeparator* _tmp19_;
	GtkButton* button = NULL;
	GtkButton* _tmp20_;
	GtkWidget* _tmp21_;
	GtkStyleContext* _tmp22_;
	BudgiePopover* _tmp23_;
	GtkWidget* _tmp24_;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->ebox;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp0_);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->popover);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->popover = _tmp1_;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp2_);
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	main_box = _tmp2_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) main_box, (guint) 6);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp3_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	popover_box = _tmp3_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (main_box, (GtkWidget*) popover_box, FALSE, FALSE, (guint) 0);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->popover;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) main_box);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sub_button = _tmp5_;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp6_);
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	plus_button = _tmp6_;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (popover_box, (GtkWidget*) sub_button, FALSE, FALSE, (guint) 1);
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (sub_button, "clicked", (GCallback) ___lambda8__gtk_button_clicked, self, 0);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp7_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 1);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp7_);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 115 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv->volume_scale = _tmp7_;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp8_ = self->priv->volume_scale;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (popover_box, (GtkWidget*) _tmp8_, FALSE, FALSE, (guint) 0);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp9_ = self->priv->volume_scale;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp10_ = g_signal_connect_object ((GtkRange*) _tmp9_, "value-changed", (GCallback) _sound_indicator_on_scale_changed_gtk_range_value_changed, self, 0);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv->scale_id = _tmp10_;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (popover_box, (GtkWidget*) plus_button, FALSE, FALSE, (guint) 1);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (plus_button, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp11_ = self->priv->volume_scale;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_scale_set_draw_value (_tmp11_, FALSE);
#line 129 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp12_ = self->priv->volume_scale;
#line 129 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp12_, 140, -1);
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) sub_button);
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp13_, "flat");
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) sub_button);
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp14_, "image-button");
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) plus_button);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp15_, "flat");
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) plus_button);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp16_, "image-button");
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_can_focus ((GtkWidget*) sub_button, FALSE);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_can_focus ((GtkWidget*) plus_button, FALSE);
#line 140 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp17_ = self->priv->volume_scale;
#line 140 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp17_, FALSE);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp18_ = self->priv->volume_scale;
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_range_set_inverted ((GtkRange*) _tmp18_, FALSE);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp19_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp19_);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sep = _tmp19_;
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (main_box, (GtkWidget*) sep, FALSE, FALSE, (guint) 1);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp20_ = (GtkButton*) gtk_button_new_with_label (_ ("Sound settings"));
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp20_);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	button = _tmp20_;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp21_ = gtk_bin_get_child ((GtkBin*) button);
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_halign (_tmp21_, GTK_ALIGN_START);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) button);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp22_, GTK_STYLE_CLASS_FLAT);
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (button, "clicked", (GCallback) _sound_indicator_open_sound_settings_gtk_button_clicked, self, 0);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (main_box, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp23_ = self->popover;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp24_ = gtk_bin_get_child ((GtkBin*) _tmp23_);
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all (_tmp24_);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (button);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (sep);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (plus_button);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (sub_button);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (popover_box);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (main_box);
#line 639 "SoundIndicator.c"
}


static void
sound_indicator_on_sink_changed (SoundIndicator* self,
                                 guint id)
{
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_set_default_mixer (self);
#line 651 "SoundIndicator.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 660 "SoundIndicator.c"
}


static void
_sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_on_notify ((SoundIndicator*) self, _sender, pspec);
#line 671 "SoundIndicator.c"
}


static void
sound_indicator_set_default_mixer (SoundIndicator* self)
{
	GvcMixerStream* _tmp0_;
	GvcMixerControl* _tmp3_;
	GvcMixerStream* _tmp4_;
	GvcMixerStream* _tmp5_;
	GvcMixerStream* _tmp6_;
	gulong _tmp7_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->stream;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp0_ != NULL) {
#line 690 "SoundIndicator.c"
		GvcMixerStream* _tmp1_;
		gulong _tmp2_;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp1_ = self->priv->stream;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp2_ = self->priv->notify_id;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_signal_handler_disconnect (_tmp1_, _tmp2_);
#line 699 "SoundIndicator.c"
	}
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->_mixer;
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp4_ = gvc_mixer_control_get_default_sink (_tmp3_);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->stream);
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv->stream = _tmp5_;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->priv->stream;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp7_ = g_signal_connect_object ((GObject*) _tmp6_, "notify", (GCallback) _sound_indicator_on_notify_g_object_notify, self, 0);
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv->notify_id = _tmp7_;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_update_volume (self);
#line 719 "SoundIndicator.c"
}


static void
sound_indicator_on_notify (SoundIndicator* self,
                           GObject* o,
                           GParamSpec* p)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = p->name;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (g_strcmp0 (_tmp1_, "volume") == 0) {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 738 "SoundIndicator.c"
	} else {
		const gchar* _tmp2_;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp2_ = p->name;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "is-muted") == 0;
#line 745 "SoundIndicator.c"
	}
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 174 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		sound_indicator_update_volume (self);
#line 751 "SoundIndicator.c"
	}
}


/**
     * Called when something changes on the mixer, i.e. we connected
     * This is where we hook into the stream for changes
     */
void
sound_indicator_on_state_change (SoundIndicator* self,
                                 guint new_state)
{
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 184 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (new_state == ((guint) GVC_STATE_READY)) {
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		sound_indicator_set_default_mixer (self);
#line 770 "SoundIndicator.c"
	}
}


/**
     * Update from scroll events. turn volume up + down.
     */
gboolean
sound_indicator_on_scroll_event (SoundIndicator* self,
                                 GdkEventScroll* event)
{
	gboolean result = FALSE;
	GvcMixerStream* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	guint32 orig_vol = 0U;
	guint32 _tmp2_;
	GdkScrollDirection _tmp3_;
	gdouble max_amp = 0.0;
	GvcMixerControl* _tmp10_;
	gdouble norm = 0.0;
	GvcMixerControl* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	guint32 _tmp15_;
	gdouble _tmp16_;
	guint32 _tmp18_;
	gdouble _tmp19_;
	GtkScale* _tmp21_;
	gulong _tmp22_;
	GvcMixerStream* _tmp23_;
	guint32 _tmp24_;
	GtkScale* _tmp26_;
	gulong _tmp27_;
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->stream;
#line 194 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (_tmp0_ != NULL, FALSE);
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol = gvc_mixer_stream_get_volume (_tmp1_);
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp2_ = vol;
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	orig_vol = _tmp2_;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = event->direction;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	switch (_tmp3_) {
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case GDK_SCROLL_UP:
#line 827 "SoundIndicator.c"
		{
			guint32 _tmp4_;
			gdouble _tmp5_;
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp4_ = vol;
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp5_ = self->priv->step_size;
#line 201 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			vol = _tmp4_ + ((guint32) _tmp5_);
#line 202 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			break;
#line 839 "SoundIndicator.c"
		}
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case GDK_SCROLL_DOWN:
#line 843 "SoundIndicator.c"
		{
			guint32 _tmp6_;
			gdouble _tmp7_;
			guint32 _tmp8_;
			guint32 _tmp9_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp6_ = vol;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp7_ = self->priv->step_size;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			vol = _tmp6_ - ((guint32) _tmp7_);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp8_ = vol;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp9_ = orig_vol;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			if (_tmp8_ > _tmp9_) {
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				vol = (guint32) 0;
#line 863 "SoundIndicator.c"
			}
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			break;
#line 867 "SoundIndicator.c"
		}
		default:
		{
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			result = FALSE;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			return result;
#line 875 "SoundIndicator.c"
		}
	}
#line 216 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->_mixer;
#line 216 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	max_amp = gvc_mixer_control_get_vol_max_amplified (_tmp10_);
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp11_ = self->priv->_mixer;
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	norm = gvc_mixer_control_get_vol_max_norm (_tmp11_);
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp12_ = max_amp;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp13_ = norm;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp12_ < _tmp13_) {
#line 892 "SoundIndicator.c"
		gdouble _tmp14_;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp14_ = norm;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		max_amp = _tmp14_;
#line 898 "SoundIndicator.c"
	}
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp15_ = vol;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp16_ = max_amp;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (((gdouble) _tmp15_) > _tmp16_) {
#line 906 "SoundIndicator.c"
		gdouble _tmp17_;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp17_ = max_amp;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		vol = (guint32) _tmp17_;
#line 912 "SoundIndicator.c"
	}
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp18_ = vol;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp19_ = norm;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (((gdouble) _tmp18_) >= _tmp19_) {
#line 920 "SoundIndicator.c"
		gdouble _tmp20_;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp20_ = norm;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		vol = (guint32) _tmp20_;
#line 926 "SoundIndicator.c"
	}
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp21_ = self->priv->volume_scale;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp22_ = self->priv->scale_id;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp21_, _tmp22_);
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp23_ = self->priv->stream;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp24_ = vol;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp23_, _tmp24_)) {
#line 940 "SoundIndicator.c"
		GvcMixerStream* _tmp25_;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp25_ = self->priv->stream;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp25_);
#line 946 "SoundIndicator.c"
	}
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp26_ = self->priv->volume_scale;
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp27_ = self->priv->scale_id;
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp26_, _tmp27_);
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	result = TRUE;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 958 "SoundIndicator.c"
}


/**
     * Update our icon when something changed (volume/mute)
     */
void
sound_indicator_update_volume (SoundIndicator* self)
{
	gdouble vol_norm = 0.0;
	GvcMixerControl* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	gint n = 0;
	guint32 _tmp2_;
	gdouble _tmp3_;
	gchar* image_name = NULL;
	gboolean _tmp4_ = FALSE;
	GvcMixerStream* _tmp5_;
	GtkImage* _tmp12_;
	const gchar* _tmp13_;
	gdouble vol_max = 0.0;
	GvcMixerControl* _tmp14_;
	gdouble _tmp15_;
	gfloat pct = 0.0F;
	guint32 _tmp16_;
	gdouble _tmp17_;
	guint ipct = 0U;
	gfloat _tmp18_;
	GtkImage* _tmp19_;
	guint _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkScale* _tmp25_;
	gulong _tmp26_;
	GtkScale* _tmp27_;
	gdouble _tmp28_;
	guint32 _tmp29_;
	gdouble _tmp30_;
	GtkScale* _tmp35_;
	GtkAdjustment* _tmp36_;
	gdouble _tmp37_;
	GtkScale* _tmp38_;
	gulong _tmp39_;
	GvcMixerStream* _tmp40_;
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_mixer;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol_norm = gvc_mixer_control_get_vol_max_norm (_tmp0_);
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol = gvc_mixer_stream_get_volume (_tmp1_);
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp2_ = vol;
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = vol_norm;
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	n = ((gint) floor ((3 * _tmp2_) / _tmp3_)) + 1;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->stream;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_get_is_muted (_tmp5_)) {
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp4_ = TRUE;
#line 1028 "SoundIndicator.c"
	} else {
		guint32 _tmp6_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp6_ = vol;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp4_ = _tmp6_ <= ((guint32) 0);
#line 1035 "SoundIndicator.c"
	}
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp4_) {
#line 1039 "SoundIndicator.c"
		gchar* _tmp7_;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp7_ = g_strdup ("audio-volume-muted-symbolic");
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_free0 (image_name);
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		image_name = _tmp7_;
#line 1047 "SoundIndicator.c"
	} else {
		gint _tmp8_;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp8_ = n;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		switch (_tmp8_) {
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			case 1:
#line 1056 "SoundIndicator.c"
			{
				gchar* _tmp9_;
#line 259 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_tmp9_ = g_strdup ("audio-volume-low-symbolic");
#line 259 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 259 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				image_name = _tmp9_;
#line 260 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				break;
#line 1067 "SoundIndicator.c"
			}
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			case 2:
#line 1071 "SoundIndicator.c"
			{
				gchar* _tmp10_;
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_tmp10_ = g_strdup ("audio-volume-medium-symbolic");
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 262 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				image_name = _tmp10_;
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				break;
#line 1082 "SoundIndicator.c"
			}
			default:
			{
				gchar* _tmp11_;
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_tmp11_ = g_strdup ("audio-volume-high-symbolic");
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				image_name = _tmp11_;
#line 266 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
				break;
#line 1095 "SoundIndicator.c"
			}
		}
	}
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp12_ = self->priv->_widget;
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp13_ = image_name;
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_image_set_from_icon_name (_tmp12_, _tmp13_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp14_ = self->priv->_mixer;
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol_max = gvc_mixer_control_get_vol_max_amplified (_tmp14_);
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp15_ = vol_max;
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv->step_size = _tmp15_ / 20;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp16_ = vol;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp17_ = vol_norm;
#line 277 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	pct = (((gfloat) _tmp16_) / ((gfloat) _tmp17_)) * 100;
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp18_ = pct;
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	ipct = (guint) _tmp18_;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp19_ = self->priv->_widget;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp20_ = ipct;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp21_ = g_strdup_printf ("%u", _tmp20_);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp22_ = _tmp21_;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp23_ = g_strconcat (_tmp22_, "%", NULL);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp24_ = _tmp23_;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _tmp24_);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_free0 (_tmp24_);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_free0 (_tmp22_);
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp25_ = self->priv->volume_scale;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp26_ = self->priv->scale_id;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp25_, _tmp26_);
#line 283 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp27_ = self->priv->volume_scale;
#line 283 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp28_ = vol_norm;
#line 283 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_range_set_range ((GtkRange*) _tmp27_, (gdouble) 0, _tmp28_);
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp29_ = vol;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp30_ = vol_norm;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (((gdouble) _tmp29_) > _tmp30_) {
#line 1159 "SoundIndicator.c"
		GtkScale* _tmp31_;
		guint32 _tmp32_;
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp31_ = self->priv->volume_scale;
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp32_ = vol;
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp31_, (gdouble) _tmp32_);
#line 1168 "SoundIndicator.c"
	} else {
		GtkScale* _tmp33_;
		guint32 _tmp34_;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp33_ = self->priv->volume_scale;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp34_ = vol;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp33_, (gdouble) _tmp34_);
#line 1178 "SoundIndicator.c"
	}
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp35_ = self->priv->volume_scale;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp36_ = gtk_range_get_adjustment ((GtkRange*) _tmp35_);
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp37_ = self->priv->step_size;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_adjustment_set_page_increment (_tmp36_, _tmp37_);
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp38_ = self->priv->volume_scale;
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp39_ = self->priv->scale_id;
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp38_, _tmp39_);
#line 292 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 293 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 295 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp40_ = self->priv->stream;
#line 295 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_get_volume (_tmp40_) != ((guint32) 0)) {
#line 1202 "SoundIndicator.c"
		GvcMixerStream* _tmp41_;
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp41_ = self->priv->stream;
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		self->unmuted_volume_val = gvc_mixer_stream_get_volume (_tmp41_);
#line 1208 "SoundIndicator.c"
	}
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_free0 (image_name);
#line 1212 "SoundIndicator.c"
}


/**
     * The scale changed value - update the stream volume to match
     */
static void
sound_indicator_on_scale_changed (SoundIndicator* self)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gdouble scale_value = 0.0;
	GtkScale* _tmp3_;
	GtkScale* _tmp4_;
	gulong _tmp5_;
	GvcMixerStream* _tmp6_;
	gdouble _tmp7_;
	GtkScale* _tmp9_;
	gulong _tmp10_;
#line 303 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp1_ == NULL) {
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 1240 "SoundIndicator.c"
	} else {
		GvcMixerControl* _tmp2_;
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp2_ = self->priv->_mixer;
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1247 "SoundIndicator.c"
	}
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		return;
#line 1253 "SoundIndicator.c"
	}
#line 308 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->volume_scale;
#line 308 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	scale_value = gtk_range_get_value ((GtkRange*) _tmp3_);
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->volume_scale;
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->scale_id;
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp4_, _tmp5_);
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->priv->stream;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp7_ = scale_value;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp6_, (guint32) _tmp7_)) {
#line 1271 "SoundIndicator.c"
		GvcMixerStream* _tmp8_;
#line 313 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp8_ = self->priv->stream;
#line 313 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp8_);
#line 1277 "SoundIndicator.c"
	}
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp9_ = self->priv->volume_scale;
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->scale_id;
#line 315 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp9_, _tmp10_);
#line 1285 "SoundIndicator.c"
}


/**
     * Adjust the volume by a given +/- increment and bounds limit it
     */
static void
sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                         gdouble increment)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gint32 vol = 0;
	GvcMixerStream* _tmp3_;
	gdouble max_norm = 0.0;
	GvcMixerControl* _tmp4_;
	gint32 _tmp5_;
	gint32 _tmp6_;
	GtkScale* _tmp10_;
	gulong _tmp11_;
	GvcMixerStream* _tmp12_;
	gint32 _tmp13_;
	GtkScale* _tmp15_;
	gulong _tmp16_;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp1_ == NULL) {
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 1318 "SoundIndicator.c"
	} else {
		GvcMixerControl* _tmp2_;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp2_ = self->priv->_mixer;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1325 "SoundIndicator.c"
	}
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		return;
#line 1331 "SoundIndicator.c"
	}
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->stream;
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol = (gint32) gvc_mixer_stream_get_volume (_tmp3_);
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->_mixer;
#line 327 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	max_norm = gvc_mixer_control_get_vol_max_norm (_tmp4_);
#line 328 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp5_ = vol;
#line 328 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	vol = _tmp5_ + ((gint32) increment);
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp6_ = vol;
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp6_ < ((gint32) 0)) {
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		vol = (gint32) 0;
#line 1351 "SoundIndicator.c"
	} else {
		gint32 _tmp7_;
		gdouble _tmp8_;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp7_ = vol;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp8_ = max_norm;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		if (((gdouble) _tmp7_) > _tmp8_) {
#line 1361 "SoundIndicator.c"
			gdouble _tmp9_;
#line 333 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			_tmp9_ = max_norm;
#line 333 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
			vol = (gint32) _tmp9_;
#line 1367 "SoundIndicator.c"
		}
	}
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->volume_scale;
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp11_ = self->priv->scale_id;
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp10_, _tmp11_);
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp12_ = self->priv->stream;
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp13_ = vol;
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp12_, (guint32) _tmp13_)) {
#line 1382 "SoundIndicator.c"
		GvcMixerStream* _tmp14_;
#line 338 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp14_ = self->priv->stream;
#line 338 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp14_);
#line 1388 "SoundIndicator.c"
	}
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp15_ = self->priv->volume_scale;
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp16_ = self->priv->scale_id;
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp15_, _tmp16_);
#line 1396 "SoundIndicator.c"
}


static void
sound_indicator_open_sound_settings (SoundIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 344 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 345 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->popover;
#line 345 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 347 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("gnome-sound-panel.desktop");
#line 347 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	app_info = _tmp1_;
#line 349 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp2_ = app_info;
#line 349 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (_tmp2_ == NULL) {
#line 350 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (app_info);
#line 350 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		return;
#line 1426 "SoundIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp3_ = app_info;
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1436 "SoundIndicator.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		e = _inner_error0_;
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_inner_error0_ = NULL;
#line 356 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp4_ = e;
#line 356 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 356 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_message ("SoundIndicator.vala:356: Unable to launch gnome-sound-panel.desktop: %" \
"s", _tmp5_);
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_error_free0 (e);
#line 1458 "SoundIndicator.c"
	}
	__finally2:
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (app_info);
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 353 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		return;
#line 1471 "SoundIndicator.c"
	}
#line 344 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (app_info);
#line 1475 "SoundIndicator.c"
}


GtkImage*
sound_indicator_get_widget (SoundIndicator* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_widget;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	result = _tmp0_;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 1492 "SoundIndicator.c"
}


void
sound_indicator_set_widget (SoundIndicator* self,
                            GtkImage* value)
{
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (sound_indicator_get_widget (self) != value) {
#line 1504 "SoundIndicator.c"
		GtkImage* _tmp0_;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (self->priv->_widget);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		self->priv->_widget = _tmp0_;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY]);
#line 1514 "SoundIndicator.c"
	}
}


GvcMixerControl*
sound_indicator_get_mixer (SoundIndicator* self)
{
	GvcMixerControl* result;
	GvcMixerControl* _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_mixer;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	result = _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	return result;
#line 1532 "SoundIndicator.c"
}


void
sound_indicator_set_mixer (SoundIndicator* self,
                           GvcMixerControl* value)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	if (sound_indicator_get_mixer (self) != value) {
#line 1544 "SoundIndicator.c"
		GvcMixerControl* _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (self->priv->_mixer);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		self->priv->_mixer = _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY]);
#line 1554 "SoundIndicator.c"
	}
}


static void
sound_indicator_class_init (SoundIndicatorClass * klass)
{
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_type_class_add_private (klass, sizeof (SoundIndicatorPrivate));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
#line 1572 "SoundIndicator.c"
	/** Current image to display */
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_WIDGET_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1576 "SoundIndicator.c"
	/** Our mixer */
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_MIXER_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY] = g_param_spec_object ("mixer", "mixer", "mixer", gvc_mixer_control_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1580 "SoundIndicator.c"
}


static void
sound_indicator_instance_init (SoundIndicator * self)
{
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->priv = SOUND_INDICATOR_GET_PRIVATE (self);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self->unmuted_volume_val = (guint32) 0;
#line 1591 "SoundIndicator.c"
}


static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->_widget);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->_mixer);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->stream);
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->popover);
#line 35 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
#line 1615 "SoundIndicator.c"
}


GType
sound_indicator_get_type (void)
{
	return sound_indicator_type_id;
}


GType
sound_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	sound_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "SoundIndicator", &g_define_type_info, 0);
	return sound_indicator_type_id;
}


static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_WIDGET_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_value_set_object (value, sound_indicator_get_widget (self));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_MIXER_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		g_value_set_object (value, sound_indicator_get_mixer (self));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 1657 "SoundIndicator.c"
		default:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 1663 "SoundIndicator.c"
	}
}


static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_WIDGET_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		sound_indicator_set_widget (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_MIXER_PROPERTY:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		sound_indicator_set_mixer (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 1690 "SoundIndicator.c"
		default:
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/applets/status/SoundIndicator.vala"
		break;
#line 1696 "SoundIndicator.c"
	}
}



