/* settings.c generated by valac 0.40.19, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright (C) 2017-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>
#include <stdlib.h>
#include <libnotify/notify.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define BUDGIE_TYPE_POWER_SCREEN (budgie_power_screen_get_type ())
#define BUDGIE_POWER_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_POWER_SCREEN, BudgiePowerScreen))
#define BUDGIE_IS_POWER_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_POWER_SCREEN))
#define BUDGIE_POWER_SCREEN_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BUDGIE_TYPE_POWER_SCREEN, BudgiePowerScreenIface))

typedef struct _BudgiePowerScreen BudgiePowerScreen;
typedef struct _BudgiePowerScreenIface BudgiePowerScreenIface;

#define BUDGIE_TYPE_POWER_SCREEN_PROXY (budgie_power_screen_proxy_get_type ())
typedef GDBusProxy BudgiePowerScreenProxy;
typedef GDBusProxyClass BudgiePowerScreenProxyClass;
typedef enum  {
	BUDGIE_BUTTON_POSITION_LEFT = 1 << 0,
	BUDGIE_BUTTON_POSITION_TRADITIONAL = 1 << 1
} BudgieButtonPosition;


#define BUDGIE_TYPE_BUTTON_POSITION (budgie_button_position_get_type ())

#define BUDGIE_TYPE_SETTINGS_MANAGER (budgie_settings_manager_get_type ())
#define BUDGIE_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManager))
#define BUDGIE_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManagerClass))
#define BUDGIE_IS_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_SETTINGS_MANAGER))
#define BUDGIE_IS_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_SETTINGS_MANAGER))
#define BUDGIE_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManagerClass))

typedef struct _BudgieSettingsManager BudgieSettingsManager;
typedef struct _BudgieSettingsManagerClass BudgieSettingsManagerClass;
typedef struct _BudgieSettingsManagerPrivate BudgieSettingsManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
typedef struct _BudgieParamSpecSettingsManager BudgieParamSpecSettingsManager;

struct _BudgiePowerScreenIface {
	GTypeInterface parent_iface;
	gint32 (*get_brightness) (BudgiePowerScreen* self);
	void (*set_brightness) (BudgiePowerScreen* self, gint32 value);
};

struct _BudgieSettingsManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BudgieSettingsManagerPrivate * priv;
};

struct _BudgieSettingsManagerClass {
	GTypeClass parent_class;
	void (*finalize) (BudgieSettingsManager *self);
};

struct _BudgieSettingsManagerPrivate {
	GApplication* _parent_app;
	GSettings* mutter_settings;
	GSettings* gnome_desktop_settings;
	GSettings* gnome_power_settings;
	BudgiePowerScreen* gnome_power_props;
	GSettings* gnome_session_settings;
	GSettings* gnome_sound_settings;
	GSettings* gnome_wm_settings;
	GSettings* raven_settings;
	GSettings* wm_settings;
	GSettings* xoverrides;
	gint32* default_brightness;
	guint32* default_idle_delay;
	gboolean* default_idle_dim;
	gint* default_sleep_inactive_ac_timeout;
	gint* default_sleep_inactive_battery_timeout;
	gchar* caffeine_full_cup;
	gchar* caffeine_empty_cup;
	NotifyNotification* caffeine_notification;
	gboolean temporary_notification_disabled;
};

struct _BudgieParamSpecSettingsManager {
	GParamSpec parent_instance;
};


static gpointer budgie_settings_manager_parent_class = NULL;

GType budgie_power_screen_get_type (void) G_GNUC_CONST;
GType budgie_power_screen_proxy_get_type (void) G_GNUC_CONST;
guint budgie_power_screen_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
gint32 budgie_power_screen_get_brightness (BudgiePowerScreen* self);
void budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                         gint32 value);
static void budgie_power_screen_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters);
static gint32 budgie_power_screen_dbus_proxy_get_brightness (BudgiePowerScreen* self);
static void budgie_power_screen_dbus_proxy_set_brightness (BudgiePowerScreen* self,
                                                    gint32 value);
static void budgie_power_screen_proxy_budgie_power_screen_interface_init (BudgiePowerScreenIface* iface);
static void budgie_power_screen_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data);
static GVariant* budgie_power_screen_dbus_interface_get_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GError** error,
                                                           gpointer user_data);
static GVariant* _dbus_budgie_power_screen_get_brightness (BudgiePowerScreen* self);
static gboolean budgie_power_screen_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data);
static void _dbus_budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                               GVariant* _value);
static void _budgie_power_screen_unregister_object (gpointer user_data);
GType budgie_button_position_get_type (void) G_GNUC_CONST;
gpointer budgie_settings_manager_ref (gpointer instance);
void budgie_settings_manager_unref (gpointer instance);
GParamSpec* budgie_param_spec_settings_manager (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void budgie_value_set_settings_manager (GValue* value,
                                        gpointer v_object);
void budgie_value_take_settings_manager (GValue* value,
                                         gpointer v_object);
gpointer budgie_value_get_settings_manager (const GValue* value);
GType budgie_settings_manager_get_type (void) G_GNUC_CONST;
#define BUDGIE_SETTINGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManagerPrivate))
static gint32* _int32_dup (gint32* self);
static guint32* _uint32_dup (guint32* self);
static gboolean* _bool_dup (gboolean* self);
static gint* _int_dup (gint* self);
BudgieSettingsManager* budgie_settings_manager_new (void);
BudgieSettingsManager* budgie_settings_manager_construct (GType object_type);
static void budgie_settings_manager_set_supported_caffeine_icons (BudgieSettingsManager* self);
static void budgie_settings_manager_fetch_defaults (BudgieSettingsManager* self);
static void budgie_settings_manager_enforce_mutter_settings (BudgieSettingsManager* self);
static void budgie_settings_manager_on_raven_sound_overdrive_change (BudgieSettingsManager* self);
static void _budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed (GSettings* _sender,
                                                                                  const gchar* key,
                                                                                  gpointer self);
static void budgie_settings_manager_update_idle_delay (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_idle_delay_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static void budgie_settings_manager_update_idle_dim (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_idle_dim_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void budgie_settings_manager_update_ac_timeout (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_ac_timeout_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static void budgie_settings_manager_update_battery_timeout (BudgieSettingsManager* self);
static void _budgie_settings_manager_update_battery_timeout_g_settings_changed (GSettings* _sender,
                                                                         const gchar* key,
                                                                         gpointer self);
static void budgie_settings_manager_on_wm_settings_changed (BudgieSettingsManager* self,
                                                     const gchar* key);
static void _budgie_settings_manager_on_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                         const gchar* key,
                                                                         gpointer self);
static void budgie_settings_manager_caffeine_settings_sync (BudgieSettingsManager* self);
static void budgie_settings_manager_change_brightness (BudgieSettingsManager* self,
                                                gint32 value);
static gboolean budgie_settings_manager_do_disable (BudgieSettingsManager* self);
static gboolean budgie_settings_manager_get_caffeine_mode (BudgieSettingsManager* self);
static void budgie_settings_manager_reset_values (BudgieSettingsManager* self);
void budgie_settings_manager_do_disable_quietly (BudgieSettingsManager* self);
static void budgie_settings_manager_get_power_defaults (BudgieSettingsManager* self);
static GVariant* budgie_settings_manager_new_filtered_xsetting (BudgieSettingsManager* self,
                                                         const gchar* button_layout);
static void budgie_settings_manager_set_button_style (BudgieSettingsManager* self,
                                               BudgieButtonPosition style);
static void budgie_settings_manager_set_caffeine_mode (BudgieSettingsManager* self,
                                                gboolean enabled,
                                                gboolean disable_notification);
static void budgie_settings_manager_set_focus_mode (BudgieSettingsManager* self,
                                             gboolean enable);
static GVariant* _variant_new1 (const gchar* value);
static gboolean ____lambda14_ (BudgieSettingsManager* self);
static gboolean _____lambda14__gsource_func (gpointer self);
static gboolean _budgie_settings_manager_do_disable_gsource_func (gpointer self);
static gboolean ___lambda15_ (BudgieSettingsManager* self);
static gboolean ____lambda15__gsource_func (gpointer self);
static GVariant* _variant_new2 (const gchar* value);
GApplication* budgie_settings_manager_get_parent_app (BudgieSettingsManager* self);
void budgie_settings_manager_set_parent_app (BudgieSettingsManager* self,
                                             GApplication* value);
static void budgie_settings_manager_finalize (BudgieSettingsManager * obj);

static const GDBusMethodInfo * const _budgie_power_screen_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _budgie_power_screen_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _budgie_power_screen_dbus_property_info_brightness = {-1, "Brightness", "i", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _budgie_power_screen_dbus_property_info[] = {&_budgie_power_screen_dbus_property_info_brightness, NULL};
static const GDBusInterfaceInfo _budgie_power_screen_dbus_interface_info = {-1, "org.gnome.SettingsDaemon.Power.Screen", (GDBusMethodInfo **) (&_budgie_power_screen_dbus_method_info), (GDBusSignalInfo **) (&_budgie_power_screen_dbus_signal_info), (GDBusPropertyInfo **) (&_budgie_power_screen_dbus_property_info), NULL};
static const GDBusInterfaceVTable _budgie_power_screen_dbus_interface_vtable = {budgie_power_screen_dbus_interface_method_call, budgie_power_screen_dbus_interface_get_property, budgie_power_screen_dbus_interface_set_property};

gint32
budgie_power_screen_get_brightness (BudgiePowerScreen* self)
{
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return BUDGIE_POWER_SCREEN_GET_INTERFACE (self)->get_brightness (self);
#line 249 "settings.c"
}


void
budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                    gint32 value)
{
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	BUDGIE_POWER_SCREEN_GET_INTERFACE (self)->set_brightness (self, value);
#line 261 "settings.c"
}


static void
budgie_power_screen_default_init (BudgiePowerScreenIface * iface)
{
}


GType
budgie_power_screen_get_type (void)
{
	static volatile gsize budgie_power_screen_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_power_screen_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BudgiePowerScreenIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_power_screen_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType budgie_power_screen_type_id;
		budgie_power_screen_type_id = g_type_register_static (G_TYPE_INTERFACE, "BudgiePowerScreen", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (budgie_power_screen_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) budgie_power_screen_proxy_get_type);
		g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SettingsDaemon.Power.Screen");
		g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_budgie_power_screen_dbus_interface_info));
		g_type_set_qdata (budgie_power_screen_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) budgie_power_screen_register_object);
		g_once_init_leave (&budgie_power_screen_type_id__volatile, budgie_power_screen_type_id);
	}
	return budgie_power_screen_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (BudgiePowerScreenProxy, budgie_power_screen_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BUDGIE_TYPE_POWER_SCREEN, budgie_power_screen_proxy_budgie_power_screen_interface_init) )
static void
budgie_power_screen_proxy_class_init (BudgiePowerScreenProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = budgie_power_screen_proxy_g_signal;
}


static void
budgie_power_screen_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters)
{
}


static void
budgie_power_screen_proxy_init (BudgiePowerScreenProxy* self)
{
}


static gint32
budgie_power_screen_dbus_proxy_get_brightness (BudgiePowerScreen* self)
{
	GVariant *_inner_reply;
	gint32 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Brightness");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Power.Screen"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Brightness"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint32 _tmp19_ = 0;
			return _tmp19_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
budgie_power_screen_dbus_proxy_set_brightness (BudgiePowerScreen* self,
                                               gint32 value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.SettingsDaemon.Power.Screen"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Brightness"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static void
budgie_power_screen_proxy_budgie_power_screen_interface_init (BudgiePowerScreenIface* iface)
{
	iface->get_brightness = budgie_power_screen_dbus_proxy_get_brightness;
	iface->set_brightness = budgie_power_screen_dbus_proxy_set_brightness;
}


static void
budgie_power_screen_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant*
_dbus_budgie_power_screen_get_brightness (BudgiePowerScreen* self)
{
	gint32 result;
	GVariant* _reply;
	result = budgie_power_screen_get_brightness (self);
	_reply = g_variant_new_int32 (result);
	return _reply;
}


static GVariant*
budgie_power_screen_dbus_interface_get_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Brightness") == 0) {
		return _dbus_budgie_power_screen_get_brightness (object);
	}
	return NULL;
}


static void
_dbus_budgie_power_screen_set_brightness (BudgiePowerScreen* self,
                                          GVariant* _value)
{
	gint32 value = 0;
	value = g_variant_get_int32 (_value);
	budgie_power_screen_set_brightness (self, value);
}


static gboolean
budgie_power_screen_dbus_interface_set_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GVariant* value,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Brightness") == 0) {
		_dbus_budgie_power_screen_set_brightness (object, value);
		return TRUE;
	}
	return FALSE;
}


guint
budgie_power_screen_register_object (gpointer object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_budgie_power_screen_dbus_interface_info), &_budgie_power_screen_dbus_interface_vtable, data, _budgie_power_screen_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void
_budgie_power_screen_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


/**
 * The button layout style as set in budgie
 */
GType
budgie_button_position_get_type (void)
{
	static volatile gsize budgie_button_position_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_button_position_type_id__volatile)) {
		static const GEnumValue values[] = {{BUDGIE_BUTTON_POSITION_LEFT, "BUDGIE_BUTTON_POSITION_LEFT", "left"}, {BUDGIE_BUTTON_POSITION_TRADITIONAL, "BUDGIE_BUTTON_POSITION_TRADITIONAL", "traditional"}, {0, NULL, NULL}};
		GType budgie_button_position_type_id;
		budgie_button_position_type_id = g_enum_register_static ("BudgieButtonPosition", values);
		g_once_init_leave (&budgie_button_position_type_id__volatile, budgie_button_position_type_id);
	}
	return budgie_button_position_type_id__volatile;
}


static gint32*
_int32_dup (gint32* self)
{
	gint32* dup;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	dup = g_new0 (gint32, 1);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gint32));
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return dup;
#line 511 "settings.c"
}


static gpointer
__int32_dup0 (gpointer self)
{
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self ? _int32_dup (self) : NULL;
#line 520 "settings.c"
}


static guint32*
_uint32_dup (guint32* self)
{
	guint32* dup;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	dup = g_new0 (guint32, 1);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	memcpy (dup, self, sizeof (guint32));
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return dup;
#line 534 "settings.c"
}


static gpointer
__uint32_dup0 (gpointer self)
{
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self ? _uint32_dup (self) : NULL;
#line 543 "settings.c"
}


static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	dup = g_new0 (gboolean, 1);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return dup;
#line 557 "settings.c"
}


static gpointer
__bool_dup0 (gpointer self)
{
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self ? _bool_dup (self) : NULL;
#line 566 "settings.c"
}


static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	dup = g_new0 (gint, 1);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	memcpy (dup, self, sizeof (gint));
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return dup;
#line 580 "settings.c"
}


static gpointer
__int_dup0 (gpointer self)
{
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self ? _int_dup (self) : NULL;
#line 589 "settings.c"
}


static void
_budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed (GSettings* _sender,
                                                                             const gchar* key,
                                                                             gpointer self)
{
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_on_raven_sound_overdrive_change ((BudgieSettingsManager*) self);
#line 600 "settings.c"
}


static void
_budgie_settings_manager_update_idle_delay_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_idle_delay ((BudgieSettingsManager*) self);
#line 611 "settings.c"
}


static void
_budgie_settings_manager_update_idle_dim_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_idle_dim ((BudgieSettingsManager*) self);
#line 622 "settings.c"
}


static void
_budgie_settings_manager_update_ac_timeout_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_ac_timeout ((BudgieSettingsManager*) self);
#line 633 "settings.c"
}


static void
_budgie_settings_manager_update_battery_timeout_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self)
{
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_battery_timeout ((BudgieSettingsManager*) self);
#line 644 "settings.c"
}


static void
_budgie_settings_manager_on_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self)
{
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_on_wm_settings_changed ((BudgieSettingsManager*) self, key);
#line 655 "settings.c"
}


BudgieSettingsManager*
budgie_settings_manager_construct (GType object_type)
{
	BudgieSettingsManager* self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self = (BudgieSettingsManager*) g_type_create_instance (object_type);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	notify_init ("com.solus-project.budgie-daemon");
#line 71 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_set_supported_caffeine_icons (self);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = g_settings_new ("org.gnome.mutter");
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->mutter_settings);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->mutter_settings = _tmp0_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = g_settings_new ("org.gnome.desktop.interface");
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_desktop_settings = _tmp1_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = g_settings_new ("org.gnome.settings-daemon.plugins.power");
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_settings);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_power_settings = _tmp2_;
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = g_settings_new ("org.gnome.desktop.session");
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_session_settings);
#line 77 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_session_settings = _tmp3_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = g_settings_new ("org.gnome.desktop.sound");
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_sound_settings);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_sound_settings = _tmp4_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = g_settings_new ("org.gnome.desktop.wm.preferences");
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_wm_settings);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_wm_settings = _tmp5_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = g_settings_new ("com.solus-project.budgie-raven");
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->raven_settings = _tmp6_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = g_settings_new ("org.gnome.settings-daemon.plugins.xsettings");
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->xoverrides);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->xoverrides = _tmp7_;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp8_ = g_settings_new ("com.solus-project.budgie-wm");
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->wm_settings = _tmp8_;
#line 739 "settings.c"
	{
		BudgiePowerScreen* _tmp9_ = NULL;
		BudgiePowerScreen* _tmp10_;
		BudgiePowerScreen* _tmp11_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp10_ = (BudgiePowerScreen*) g_initable_new (BUDGIE_TYPE_POWER_SCREEN_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.SettingsDaemon.Power", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SettingsDaemon/Power", "g-interface-name", "org.gnome.SettingsDaemon.Power.Screen", "g-interface-info", g_type_get_qdata (BUDGIE_TYPE_POWER_SCREEN, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp9_ = (BudgiePowerScreen*) _tmp10_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 752 "settings.c"
				goto __catch7_g_io_error;
			}
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return NULL;
#line 761 "settings.c"
		}
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp11_ = _tmp9_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp9_ = NULL;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_object_unref0 (self->priv->gnome_power_props);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->gnome_power_props = _tmp11_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_object_unref0 (_tmp9_);
#line 773 "settings.c"
	}
	goto __finally7;
	__catch7_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		e = _inner_error0_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_inner_error0_ = NULL;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp12_ = e;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp13_ = _tmp12_->message;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_warning ("settings.vala:87: Failed to acquire bus for org.gnome.SettingsDaemon.P" \
"ower: %s\n", _tmp13_);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_error_free0 (e);
#line 793 "settings.c"
	}
	__finally7:
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_clear_error (&_inner_error0_);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		return NULL;
#line 804 "settings.c"
	}
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_fetch_defaults (self);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_enforce_mutter_settings (self);
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp14_ = self->priv->raven_settings;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp14_, "changed::allow-volume-overdrive", (GCallback) _budgie_settings_manager_on_raven_sound_overdrive_change_g_settings_changed, self);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp15_ = self->priv->gnome_session_settings;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp15_, "changed::idle-delay", (GCallback) _budgie_settings_manager_update_idle_delay_g_settings_changed, self);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp16_ = self->priv->gnome_power_settings;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp16_, "changed::idle-dim", (GCallback) _budgie_settings_manager_update_idle_dim_g_settings_changed, self);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp17_ = self->priv->gnome_power_settings;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp17_, "changed::sleep-inactive-ac-timeout", (GCallback) _budgie_settings_manager_update_ac_timeout_g_settings_changed, self);
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp18_ = self->priv->gnome_power_settings;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp18_, "changed::sleep-inactive-battery-timeout", (GCallback) _budgie_settings_manager_update_battery_timeout_g_settings_changed, self);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp19_ = self->priv->wm_settings;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_connect (_tmp19_, "changed", (GCallback) _budgie_settings_manager_on_wm_settings_changed_g_settings_changed, self);
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_on_wm_settings_changed (self, "button-style");
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self;
#line 838 "settings.c"
}


BudgieSettingsManager*
budgie_settings_manager_new (void)
{
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return budgie_settings_manager_construct (BUDGIE_TYPE_SETTINGS_MANAGER);
#line 847 "settings.c"
}


/**
     * caffeine_settings_sync will call to sync / ensure write operations for session and power, which are relevant to Caffeine Mode
     */
static void
budgie_settings_manager_caffeine_settings_sync (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_apply (_tmp0_);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_power_settings;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_apply (_tmp1_);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = self->priv->gnome_session_settings;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_sync ();
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = self->priv->gnome_power_settings;
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_sync ();
#line 879 "settings.c"
}


/**
     * change_brightness will attempt to change our brightness in the power properties
     */
static void
budgie_settings_manager_change_brightness (BudgieSettingsManager* self,
                                           gint32 value)
{
	BudgiePowerScreen* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_props;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp0_ != NULL) {
#line 898 "settings.c"
		{
			BudgiePowerScreen* _tmp1_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp1_ = self->priv->gnome_power_props;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			budgie_power_screen_set_brightness (_tmp1_, value);
#line 905 "settings.c"
		}
		goto __finally8;
		__catch8_g_error:
		{
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_inner_error0_ = NULL;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_warning ("settings.vala:122: Error: Failed to change change the brightness durin" \
"g Caffeine Mode toggle.");
#line 916 "settings.c"
		}
		__finally8:
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return;
#line 927 "settings.c"
		}
	}
}


/**
     * do_disable is triggered when our timeout is called
     */
static gboolean
budgie_settings_manager_do_disable (BudgieSettingsManager* self)
{
	gboolean result = FALSE;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (budgie_settings_manager_get_caffeine_mode (self)) {
#line 944 "settings.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = self->priv->wm_settings;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_boolean (_tmp0_, "caffeine-mode", FALSE);
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = self->priv->wm_settings;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_sync ();
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_reset_values (self);
#line 957 "settings.c"
	}
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	result = FALSE;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 963 "settings.c"
}


/**
     * do_disable_quietly will quietly disable Caffeine Mode
     */
void
budgie_settings_manager_do_disable_quietly (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 144 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = TRUE;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->wm_settings;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_boolean (_tmp0_, "caffeine-mode", FALSE);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->wm_settings;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_sync ();
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_reset_values (self);
#line 989 "settings.c"
}


/**
     * enforce_mutter_settings will apply Mutter schema changes to BudgieWM for supported keys
     */
static void
budgie_settings_manager_enforce_mutter_settings (BudgieSettingsManager* self)
{
	gboolean center_windows = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->mutter_settings;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	center_windows = g_settings_get_boolean (_tmp0_, "center-new-windows");
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->wm_settings;
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_boolean (_tmp1_, "center-windows", center_windows);
#line 1012 "settings.c"
}


/**
     * fetch_defaults will fetch the default values for various idle, sleep, and brightness settings
     */
static void
budgie_settings_manager_fetch_defaults (BudgieSettingsManager* self)
{
	BudgiePowerScreen* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (budgie_settings_manager_get_caffeine_mode (self)) {
#line 1028 "settings.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_session_settings;
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_reset (_tmp0_, "idle-delay");
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = self->priv->gnome_power_settings;
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_reset (_tmp1_, "idle-dim");
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp2_ = self->priv->gnome_power_settings;
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_reset (_tmp2_, "sleep-inactive-ac-timeout");
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp3_ = self->priv->gnome_power_settings;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_reset (_tmp3_, "sleep-inactive-battery-timeout");
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_caffeine_settings_sync (self);
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->temporary_notification_disabled = TRUE;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = self->priv->wm_settings;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_boolean (_tmp4_, "caffeine-mode", FALSE);
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = self->priv->wm_settings;
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_sync ();
#line 1063 "settings.c"
	}
#line 175 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_get_power_defaults (self);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = self->priv->gnome_power_props;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp6_ != NULL) {
#line 1071 "settings.c"
		{
			BudgiePowerScreen* _tmp7_;
			gint32 _tmp8_;
			gint32 _tmp9_;
			gint32* _tmp10_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp7_ = self->priv->gnome_power_props;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp8_ = budgie_power_screen_get_brightness (_tmp7_);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp9_ = _tmp8_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp10_ = __int32_dup0 (&_tmp9_);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (self->priv->default_brightness);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			self->priv->default_brightness = _tmp10_;
#line 1089 "settings.c"
		}
		goto __finally9;
		__catch9_g_error:
		{
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_inner_error0_ = NULL;
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_warning ("settings.vala:181: Could not set default value.");
#line 1100 "settings.c"
		}
		__finally9:
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return;
#line 1111 "settings.c"
		}
	}
}


/**
     * get_caffeine_mode will get the current Caffeine Mode status
     */
static gboolean
budgie_settings_manager_get_caffeine_mode (BudgieSettingsManager* self)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
#line 189 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->wm_settings;
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	result = g_settings_get_boolean (_tmp0_, "caffeine-mode");
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1133 "settings.c"
}


/**
     * get_power_defaults will call all of our update defaults functions
     */
static void
budgie_settings_manager_get_power_defaults (BudgieSettingsManager* self)
{
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_ac_timeout (self);
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_battery_timeout (self);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_idle_delay (self);
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_update_idle_dim (self);
#line 1153 "settings.c"
}


/**
     * Create a new xsettings override based on the *Existing* key so that
     * we don't dump any settings like Gdk/ScaleFactor, etc.
     */
static GVariant*
budgie_settings_manager_new_filtered_xsetting (BudgieSettingsManager* self,
                                               const gchar* button_layout)
{
	GVariant* result = NULL;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GVariantBuilder* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariantBuilder* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* existing_vars = NULL;
	GSettings* _tmp10_;
	GVariant* _tmp11_;
	GVariantIter* it = NULL;
	GVariant* _tmp12_;
	GVariantIter* _tmp13_;
	gchar* k = NULL;
	GVariant* v = NULL;
	GVariantBuilder* _tmp21_;
	GVariant* _tmp22_;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (button_layout != NULL, NULL);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = g_variant_type_new ("a{sv}");
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = _tmp0_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = _tmp2_;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_type_free0 (_tmp1_);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	builder = _tmp3_;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = builder;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = g_variant_new_int32 ((gint32) 0);
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_variant_ref_sink (_tmp5_);
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = _tmp5_;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_variant_builder_add (_tmp4_, "{sv}", "Gtk/ShellShowsAppMenu", _tmp6_, NULL);
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (_tmp6_);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = builder;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp8_ = g_variant_new_string (button_layout);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_variant_ref_sink (_tmp8_);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp9_ = _tmp8_;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_variant_builder_add (_tmp7_, "{sv}", "Gtk/DecorationLayout", _tmp9_, NULL);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (_tmp9_);
#line 214 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp10_ = self->priv->xoverrides;
#line 214 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp11_ = g_settings_get_value (_tmp10_, "overrides");
#line 214 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	existing_vars = _tmp11_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp12_ = existing_vars;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp13_ = g_variant_iter_new (_tmp12_);
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	it = _tmp13_;
#line 216 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	k = NULL;
#line 217 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	v = NULL;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	while (TRUE) {
#line 1245 "settings.c"
		GVariantIter* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		GVariantBuilder* _tmp18_;
		const gchar* _tmp19_;
		GVariant* _tmp20_;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp14_ = it;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (!g_variant_iter_next (_tmp14_, "{sv}", &k, &v, NULL)) {
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			break;
#line 1258 "settings.c"
		}
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp16_ = k;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (g_strcmp0 (_tmp16_, "Gtk/ShellShowsAppMenu") == 0) {
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp15_ = TRUE;
#line 1266 "settings.c"
		} else {
			const gchar* _tmp17_;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp17_ = k;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp15_ = g_strcmp0 (_tmp17_, "Gtk/DecorationLayout") == 0;
#line 1273 "settings.c"
		}
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp15_) {
#line 220 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			continue;
#line 1279 "settings.c"
		}
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp18_ = builder;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp19_ = k;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp20_ = v;
#line 222 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_variant_builder_add (_tmp18_, "{sv}", _tmp19_, _tmp20_, NULL);
#line 1289 "settings.c"
	}
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp21_ = builder;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp22_ = g_variant_builder_end (_tmp21_);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_variant_ref_sink (_tmp22_);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	result = _tmp22_;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (v);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (k);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_iter_free0 (it);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (existing_vars);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_builder_unref0 (builder);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1311 "settings.c"
}


static void
budgie_settings_manager_on_raven_sound_overdrive_change (BudgieSettingsManager* self)
{
	gboolean allow_volume_overdrive = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->raven_settings;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	allow_volume_overdrive = g_settings_get_boolean (_tmp0_, "allow-volume-overdrive");
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_sound_settings;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_boolean (_tmp1_, "allow-volume-above-100-percent", allow_volume_overdrive);
#line 1331 "settings.c"
}


static void
budgie_settings_manager_on_wm_settings_changed (BudgieSettingsManager* self,
                                                const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label0 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label1 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label2 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label3 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label4 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	static GQuark _tmp1_label5 = 0;
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 232 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (key != NULL);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = key;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("attach-modal-dialogs")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1365 "settings.c"
			default:
			{
				gboolean attach = FALSE;
				GSettings* _tmp3_;
				GSettings* _tmp4_;
				gboolean _tmp5_;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp3_ = self->priv->wm_settings;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				attach = g_settings_get_boolean (_tmp3_, key);
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp4_ = self->priv->mutter_settings;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp5_ = attach;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_settings_set_boolean (_tmp4_, "attach-modal-dialogs", _tmp5_);
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1384 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("button-style")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1390 "settings.c"
			default:
			{
				BudgieButtonPosition style = 0;
				GSettings* _tmp6_;
				BudgieButtonPosition _tmp7_;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp6_ = self->priv->wm_settings;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				style = (BudgieButtonPosition) g_settings_get_enum (_tmp6_, key);
#line 241 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp7_ = style;
#line 241 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				budgie_settings_manager_set_button_style (self, _tmp7_);
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1406 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("center-windows")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1412 "settings.c"
			default:
			{
				gboolean center = FALSE;
				GSettings* _tmp8_;
				GSettings* _tmp9_;
				gboolean _tmp10_;
#line 244 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp8_ = self->priv->wm_settings;
#line 244 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				center = g_settings_get_boolean (_tmp8_, key);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp9_ = self->priv->mutter_settings;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp10_ = center;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_settings_set_boolean (_tmp9_, "center-new-windows", _tmp10_);
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1431 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("caffeine-mode")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1437 "settings.c"
			default:
			{
				gboolean enabled = FALSE;
				GSettings* _tmp11_;
				gboolean _tmp12_;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp11_ = self->priv->wm_settings;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				enabled = g_settings_get_boolean (_tmp11_, key);
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp12_ = enabled;
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				budgie_settings_manager_set_caffeine_mode (self, _tmp12_, FALSE);
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1453 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("edge-tiling")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1459 "settings.c"
			default:
			{
				gboolean edge_setting = FALSE;
				GSettings* _tmp13_;
				GSettings* _tmp14_;
				gboolean _tmp15_;
#line 252 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp13_ = self->priv->wm_settings;
#line 252 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				edge_setting = g_settings_get_boolean (_tmp13_, key);
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp14_ = self->priv->mutter_settings;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp15_ = edge_setting;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_settings_set_boolean (_tmp14_, "edge-tiling", _tmp15_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1478 "settings.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("focus-mode")))) {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1484 "settings.c"
			default:
			{
				gboolean mode = FALSE;
				GSettings* _tmp16_;
				gboolean _tmp17_;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp16_ = self->priv->wm_settings;
#line 256 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				mode = g_settings_get_boolean (_tmp16_, key);
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp17_ = mode;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				budgie_settings_manager_set_focus_mode (self, _tmp17_);
#line 258 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1500 "settings.c"
			}
		}
	} else {
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		switch (0) {
#line 1506 "settings.c"
			default:
			{
#line 260 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				break;
#line 1511 "settings.c"
			}
		}
	}
}


/**
     * reset_values will reset select power and session keys
     */
static void
budgie_settings_manager_reset_values (BudgieSettingsManager* self)
{
	GSettings* _tmp0_;
	guint32* _tmp1_;
	GSettings* _tmp2_;
	gboolean* _tmp3_;
	GSettings* _tmp4_;
	gint* _tmp5_;
	GSettings* _tmp6_;
	gint* _tmp7_;
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->default_idle_delay;
#line 268 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_uint (_tmp0_, "idle-delay", *_tmp1_);
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = self->priv->gnome_power_settings;
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = self->priv->default_idle_dim;
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_boolean (_tmp2_, "idle-dim", *_tmp3_);
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = self->priv->gnome_power_settings;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = self->priv->default_sleep_inactive_ac_timeout;
#line 270 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_int (_tmp4_, "sleep-inactive-ac-timeout", *_tmp5_);
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = self->priv->gnome_power_settings;
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = self->priv->default_sleep_inactive_battery_timeout;
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_int (_tmp6_, "sleep-inactive-battery-timeout", *_tmp7_);
#line 272 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_caffeine_settings_sync (self);
#line 1560 "settings.c"
}


/**
     * Set the button layout to one of left or traditional
     */
static GVariant*
_variant_new1 (const gchar* value)
{
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1572 "settings.c"
}


static void
budgie_settings_manager_set_button_style (BudgieSettingsManager* self,
                                          BudgieButtonPosition style)
{
	GVariant* xset = NULL;
	gchar* wm_set = NULL;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
	GSettings* _tmp8_;
	const gchar* _tmp9_;
	GVariant* _tmp10_;
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	xset = NULL;
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	wm_set = NULL;
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	switch (style) {
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		case BUDGIE_BUTTON_POSITION_LEFT:
#line 1599 "settings.c"
		{
			GVariant* _tmp0_;
			gchar* _tmp1_;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp0_ = budgie_settings_manager_new_filtered_xsetting (self, "close,minimize,maximize:menu");
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_variant_unref0 (xset);
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			xset = _tmp0_;
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp1_ = g_strdup ("close,minimize,maximize:appmenu");
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (wm_set);
#line 285 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			wm_set = _tmp1_;
#line 286 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			break;
#line 1617 "settings.c"
		}
		default:
#line 282 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		case BUDGIE_BUTTON_POSITION_TRADITIONAL:
#line 1622 "settings.c"
		{
			GVariant* _tmp2_;
			gchar* _tmp3_;
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp2_ = budgie_settings_manager_new_filtered_xsetting (self, "menu:minimize,maximize,close");
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_variant_unref0 (xset);
#line 289 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			xset = _tmp2_;
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = g_strdup ("appmenu:minimize,maximize,close");
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (wm_set);
#line 290 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			wm_set = _tmp3_;
#line 291 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			break;
#line 1640 "settings.c"
		}
	}
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = self->priv->xoverrides;
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = xset;
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_value (_tmp4_, "overrides", _tmp5_);
#line 295 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = self->priv->wm_settings;
#line 295 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = wm_set;
#line 295 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_string (_tmp6_, "button-layout", _tmp7_);
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp8_ = self->priv->gnome_wm_settings;
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp9_ = wm_set;
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp10_ = _variant_new1 (_tmp9_);
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_value (_tmp8_, "button-layout", _tmp10_);
#line 296 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (_tmp10_);
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (wm_set);
#line 278 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (xset);
#line 1669 "settings.c"
}


/**
     * set_caffeine_mode will set our various settings for caffeine mode
     */
static gboolean
____lambda14_ (BudgieSettingsManager* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = self->priv->gnome_session_settings;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = g_settings_get_has_unapplied (_tmp1_);
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = _tmp2_;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (!_tmp3_) {
#line 1692 "settings.c"
		GSettings* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = self->priv->gnome_power_settings;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = g_settings_get_has_unapplied (_tmp4_);
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp6_ = _tmp5_;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = !_tmp6_;
#line 1704 "settings.c"
	} else {
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = FALSE;
#line 1708 "settings.c"
	}
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp0_) {
#line 313 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_reset_values (self);
#line 314 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		result = FALSE;
#line 314 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		return result;
#line 1718 "settings.c"
	} else {
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		result = TRUE;
#line 316 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		return result;
#line 1724 "settings.c"
	}
}


static gboolean
_____lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda14_ ((BudgieSettingsManager*) self);
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1736 "settings.c"
}


static gboolean
_budgie_settings_manager_do_disable_gsource_func (gpointer self)
{
	gboolean result;
	result = budgie_settings_manager_do_disable ((BudgieSettingsManager*) self);
#line 344 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1747 "settings.c"
}


static gboolean
___lambda15_ (BudgieSettingsManager* self)
{
	gboolean result = FALSE;
#line 369 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = FALSE;
#line 370 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	result = FALSE;
#line 370 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1761 "settings.c"
}


static gboolean
____lambda15__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda15_ ((BudgieSettingsManager*) self);
#line 368 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 1772 "settings.c"
}


static void
budgie_settings_manager_set_caffeine_mode (BudgieSettingsManager* self,
                                           gboolean enabled,
                                           gboolean disable_notification)
{
	GSettings* _tmp11_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GSettings* _tmp19_;
	gboolean _tmp54_;
	GError* _inner_error0_ = NULL;
#line 302 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 303 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (enabled) {
#line 1792 "settings.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_power_settings;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_boolean (_tmp0_, "idle-dim", FALSE);
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = self->priv->gnome_power_settings;
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_int (_tmp1_, "sleep-inactive-ac-timeout", 0);
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp2_ = self->priv->gnome_power_settings;
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_int (_tmp2_, "sleep-inactive-battery-timeout", 0);
#line 307 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp3_ = self->priv->gnome_session_settings;
#line 307 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_settings_set_uint (_tmp3_, "idle-delay", (guint) 0);
#line 308 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_caffeine_settings_sync (self);
#line 1815 "settings.c"
	} else {
		gboolean _tmp4_ = FALSE;
		GSettings* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = self->priv->gnome_session_settings;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp6_ = g_settings_get_has_unapplied (_tmp5_);
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp7_ = _tmp6_;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp7_) {
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp4_ = TRUE;
#line 1831 "settings.c"
		} else {
			GSettings* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp8_ = self->priv->gnome_power_settings;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp9_ = g_settings_get_has_unapplied (_tmp8_);
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp10_ = _tmp9_;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp4_ = _tmp10_;
#line 1844 "settings.c"
		}
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp4_) {
#line 311 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) 1, _____lambda14__gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 1850 "settings.c"
		} else {
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			budgie_settings_manager_reset_values (self);
#line 1854 "settings.c"
		}
	}
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp11_ = self->priv->wm_settings;
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (g_settings_get_boolean (_tmp11_, "caffeine-mode-toggle-brightness")) {
#line 1861 "settings.c"
		gint32 set_brightness = 0;
		GSettings* _tmp12_;
		gint32 _tmp13_ = 0;
#line 325 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp12_ = self->priv->wm_settings;
#line 325 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		set_brightness = (gint32) g_settings_get_int (_tmp12_, "caffeine-mode-screen-brightness");
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (enabled) {
#line 1871 "settings.c"
			gint32 _tmp14_;
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp14_ = set_brightness;
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp13_ = _tmp14_;
#line 1877 "settings.c"
		} else {
			gint32* _tmp15_;
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp15_ = self->priv->default_brightness;
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp13_ = *_tmp15_;
#line 1884 "settings.c"
		}
#line 326 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_change_brightness (self, _tmp13_);
#line 1888 "settings.c"
	}
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp19_ = self->priv->wm_settings;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (g_settings_get_boolean (_tmp19_, "caffeine-mode-notification")) {
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp18_ = !disable_notification;
#line 1896 "settings.c"
	} else {
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp18_ = FALSE;
#line 1900 "settings.c"
	}
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp18_) {
#line 1904 "settings.c"
		gboolean _tmp20_;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp20_ = self->priv->temporary_notification_disabled;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp17_ = !_tmp20_;
#line 1910 "settings.c"
	} else {
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp17_ = FALSE;
#line 1914 "settings.c"
	}
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp17_) {
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp16_ = notify_is_initted ();
#line 1920 "settings.c"
	} else {
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp16_ = FALSE;
#line 1924 "settings.c"
	}
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp16_) {
#line 1928 "settings.c"
		const gchar* _tmp21_ = NULL;
		gchar* title = NULL;
		gchar* _tmp22_;
		gchar* body = NULL;
		gchar* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* icon = NULL;
		gchar* _tmp27_;
		gint time = 0;
		GSettings* _tmp28_;
		gboolean _tmp29_ = FALSE;
		NotifyNotification* _tmp38_;
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (enabled) {
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp21_ = _ ("Turned on Caffeine Boost");
#line 1945 "settings.c"
		} else {
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp21_ = _ ("Turned off Caffeine Boost");
#line 1949 "settings.c"
		}
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		title = _tmp22_;
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp23_ = g_strdup ("");
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		body = _tmp23_;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (enabled) {
#line 1961 "settings.c"
			const gchar* _tmp25_;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp25_ = self->priv->caffeine_full_cup;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp24_ = _tmp25_;
#line 1967 "settings.c"
		} else {
			const gchar* _tmp26_;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp26_ = self->priv->caffeine_empty_cup;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp24_ = _tmp26_;
#line 1974 "settings.c"
		}
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp27_ = g_strdup (_tmp24_);
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		icon = _tmp27_;
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp28_ = self->priv->wm_settings;
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		time = g_settings_get_int (_tmp28_, "caffeine-mode-timer");
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (enabled) {
#line 1986 "settings.c"
			gint _tmp30_;
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp30_ = time;
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp29_ = _tmp30_ > 0;
#line 1992 "settings.c"
		} else {
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp29_ = FALSE;
#line 1996 "settings.c"
		}
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp29_) {
#line 2000 "settings.c"
			gchar* duration = NULL;
			gchar* _tmp31_;
			gint _tmp32_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			gint _tmp37_;
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp31_ = g_strdup (_ ("Will turn off in a minute"));
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			duration = _tmp31_;
#line 339 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp32_ = time;
#line 339 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			if (_tmp32_ > 1) {
#line 2015 "settings.c"
				gint _tmp33_;
				gchar* _tmp34_;
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp33_ = time;
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp34_ = g_strdup_printf (_ ("Will turn off in %d minutes"), _tmp33_);
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_g_free0 (duration);
#line 340 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				duration = _tmp34_;
#line 2026 "settings.c"
			}
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp35_ = duration;
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp36_ = g_strdup (_tmp35_);
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (body);
#line 343 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			body = _tmp36_;
#line 344 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp37_ = time;
#line 344 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) (_tmp37_ * 60), _budgie_settings_manager_do_disable_gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 336 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (duration);
#line 2042 "settings.c"
		}
#line 347 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp38_ = self->priv->caffeine_notification;
#line 347 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp38_ == NULL) {
#line 2048 "settings.c"
			const gchar* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			NotifyNotification* _tmp42_;
			NotifyNotification* _tmp43_;
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp39_ = title;
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp40_ = body;
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp41_ = icon;
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp42_ = notify_notification_new (_tmp39_, _tmp40_, _tmp41_);
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_object_unref0 (self->priv->caffeine_notification);
#line 348 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			self->priv->caffeine_notification = _tmp42_;
#line 349 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp43_ = self->priv->caffeine_notification;
#line 349 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			notify_notification_set_urgency (_tmp43_, NOTIFY_URGENCY_CRITICAL);
#line 2070 "settings.c"
		} else {
			NotifyNotification* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
			const gchar* _tmp50_;
			{
				NotifyNotification* _tmp44_;
#line 352 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp44_ = self->priv->caffeine_notification;
#line 352 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				notify_notification_close (_tmp44_, &_inner_error0_);
#line 352 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2084 "settings.c"
					goto __catch10_g_error;
				}
			}
			goto __finally10;
			__catch10_g_error:
			{
				GError* e = NULL;
				GError* _tmp45_;
				const gchar* _tmp46_;
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				e = _inner_error0_;
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_inner_error0_ = NULL;
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp45_ = e;
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_tmp46_ = _tmp45_->message;
#line 354 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_warning ("settings.vala:354: Failed to close previous notification: %s", _tmp46_);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_g_error_free0 (e);
#line 2106 "settings.c"
			}
			__finally10:
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_g_free0 (icon);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_g_free0 (body);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				_g_free0 (title);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				g_clear_error (&_inner_error0_);
#line 351 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
				return;
#line 2123 "settings.c"
			}
#line 357 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp47_ = self->priv->caffeine_notification;
#line 357 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp48_ = title;
#line 357 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp49_ = body;
#line 357 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp50_ = icon;
#line 357 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			notify_notification_update (_tmp47_, _tmp48_, _tmp49_, _tmp50_);
#line 2135 "settings.c"
		}
		{
			NotifyNotification* _tmp51_;
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp51_ = self->priv->caffeine_notification;
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			notify_notification_show (_tmp51_, &_inner_error0_);
#line 361 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2145 "settings.c"
				goto __catch11_g_error;
			}
		}
		goto __finally11;
		__catch11_g_error:
		{
			GError* e = NULL;
			GError* _tmp52_;
			const gchar* _tmp53_;
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			e = _inner_error0_;
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_inner_error0_ = NULL;
#line 363 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp52_ = e;
#line 363 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp53_ = _tmp52_->message;
#line 363 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_warning ("settings.vala:363: Failed to send our Caffeine notification: %s", _tmp53_);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_error_free0 (e);
#line 2167 "settings.c"
		}
		__finally11:
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (icon);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (body);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_g_free0 (title);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			g_clear_error (&_inner_error0_);
#line 360 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return;
#line 2184 "settings.c"
		}
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (icon);
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (body);
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (title);
#line 2192 "settings.c"
	}
#line 367 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp54_ = self->priv->temporary_notification_disabled;
#line 367 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp54_) {
#line 368 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_timeout_add_seconds_full (G_PRIORITY_HIGH, (guint) 60, ____lambda15__gsource_func, budgie_settings_manager_ref (self), budgie_settings_manager_unref);
#line 2200 "settings.c"
	}
}


/**
     * set_focus_mode will set the window focus mode
     */
static GVariant*
_variant_new2 (const gchar* value)
{
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2213 "settings.c"
}


static void
budgie_settings_manager_set_focus_mode (BudgieSettingsManager* self,
                                        gboolean enable)
{
	gchar* gfocus_mode = NULL;
	gchar* _tmp0_;
	gint _tmp1_ = 0;
	gint raise_delay = 0;
	GSettings* _tmp3_;
	const gchar* _tmp4_;
	GVariant* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	gint _tmp8_;
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 379 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = g_strdup ("click");
#line 379 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	gfocus_mode = _tmp0_;
#line 380 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (enable) {
#line 380 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = 0;
#line 2241 "settings.c"
	} else {
#line 380 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = 250;
#line 2245 "settings.c"
	}
#line 380 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	raise_delay = _tmp1_;
#line 382 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (enable) {
#line 2251 "settings.c"
		gchar* _tmp2_;
#line 383 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp2_ = g_strdup ("mouse");
#line 383 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (gfocus_mode);
#line 383 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		gfocus_mode = _tmp2_;
#line 2259 "settings.c"
	}
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = self->priv->gnome_wm_settings;
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = gfocus_mode;
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = _variant_new2 (_tmp4_);
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_value (_tmp3_, "focus-mode", _tmp5_);
#line 386 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_variant_unref0 (_tmp5_);
#line 387 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = self->priv->gnome_wm_settings;
#line 387 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_boolean (_tmp6_, "auto-raise", enable);
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = self->priv->gnome_wm_settings;
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp8_ = raise_delay;
#line 388 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_settings_set_int (_tmp7_, "auto-raise-delay", _tmp8_);
#line 378 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (gfocus_mode);
#line 2283 "settings.c"
}


/**
     * set_supported_caffeine_icons will determine whether or not to use the current IconTheme's caffeine icons, if supported.
     * If it is not supported, it will fall back to our budgie vendored icons.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 396 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 2296 "settings.c"
}


static void
budgie_settings_manager_set_supported_caffeine_icons (BudgieSettingsManager* self)
{
	GtkIconTheme* current_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	gchar* full = NULL;
	gchar* _tmp2_;
	gchar* empty = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	GtkIconTheme* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	GtkIconTheme* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp19_;
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 396 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 396 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 396 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	current_theme = _tmp1_;
#line 397 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = g_strdup ("caffeine-cup-full");
#line 397 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	full = _tmp2_;
#line 398 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = g_strdup ("caffeine-cup-empty");
#line 398 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	empty = _tmp3_;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = current_theme;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = full;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (gtk_icon_theme_has_icon (_tmp5_, _tmp6_)) {
#line 2340 "settings.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp7_ = full;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (_tmp4_);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = _tmp8_;
#line 2351 "settings.c"
	} else {
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp9_ = full;
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp10_ = g_strconcat ("budgie-", _tmp9_, NULL);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (_tmp4_);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = _tmp10_;
#line 2363 "settings.c"
	}
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp11_ = g_strdup (_tmp4_);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_full_cup);
#line 399 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->caffeine_full_cup = _tmp11_;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp13_ = current_theme;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp14_ = empty;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (gtk_icon_theme_has_icon (_tmp13_, _tmp14_)) {
#line 2377 "settings.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp15_ = empty;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (_tmp12_);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp12_ = _tmp16_;
#line 2388 "settings.c"
	} else {
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp17_ = empty;
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp18_ = g_strconcat ("budgie-", _tmp17_, NULL);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (_tmp12_);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp12_ = _tmp18_;
#line 2400 "settings.c"
	}
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp19_ = g_strdup (_tmp12_);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_empty_cup);
#line 400 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->caffeine_empty_cup = _tmp19_;
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (_tmp12_);
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (_tmp4_);
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (empty);
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (full);
#line 395 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (current_theme);
#line 2418 "settings.c"
}


/**
     * update_ac_timeout will update our default sleep inactive ac timeout value, if it is a non-Caffeine mode value
     */
static void
budgie_settings_manager_update_ac_timeout (BudgieSettingsManager* self)
{
	gint current_ac_timeout = 0;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
#line 406 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 407 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_settings;
#line 407 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	current_ac_timeout = g_settings_get_int (_tmp0_, "sleep-inactive-ac-timeout");
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = current_ac_timeout;
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp2_ != 0) {
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2444 "settings.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = current_ac_timeout;
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp4_ == 0) {
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2454 "settings.c"
		} else {
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = FALSE;
#line 2458 "settings.c"
		}
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = _tmp3_;
#line 2462 "settings.c"
	}
#line 409 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp1_) {
#line 2466 "settings.c"
		gint _tmp5_;
		gint* _tmp6_;
#line 410 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = current_ac_timeout;
#line 410 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp6_ = __int_dup0 (&_tmp5_);
#line 410 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (self->priv->default_sleep_inactive_ac_timeout);
#line 410 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->default_sleep_inactive_ac_timeout = _tmp6_;
#line 2477 "settings.c"
	}
}


/**
     * update_battery_timeout will update our default sleep inactive battery timeout, if it is a non-Caffeine mode value
     */
static void
budgie_settings_manager_update_battery_timeout (BudgieSettingsManager* self)
{
	gint current_battery_timeout = 0;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
#line 417 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 418 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_power_settings;
#line 418 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	current_battery_timeout = g_settings_get_int (_tmp0_, "sleep-inactive-battery-timeout");
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = current_battery_timeout;
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp2_ != 0) {
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2504 "settings.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = current_battery_timeout;
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp4_ == 0) {
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2514 "settings.c"
		} else {
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = FALSE;
#line 2518 "settings.c"
		}
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = _tmp3_;
#line 2522 "settings.c"
	}
#line 420 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp1_) {
#line 2526 "settings.c"
		gint _tmp5_;
		gint* _tmp6_;
#line 421 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = current_battery_timeout;
#line 421 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp6_ = __int_dup0 (&_tmp5_);
#line 421 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (self->priv->default_sleep_inactive_battery_timeout);
#line 421 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->default_sleep_inactive_battery_timeout = _tmp6_;
#line 2537 "settings.c"
	}
}


/**
     * update_idle_delay will update our default idle delay, if it is a non-Caffeine mode value
     */
static void
budgie_settings_manager_update_idle_delay (BudgieSettingsManager* self)
{
	guint current_idle_delay = 0U;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_;
#line 428 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 429 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->gnome_session_settings;
#line 429 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	current_idle_delay = g_settings_get_uint (_tmp0_, "idle-delay");
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = current_idle_delay;
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp2_ != ((guint) 0)) {
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = TRUE;
#line 2564 "settings.c"
	} else {
		gboolean _tmp3_ = FALSE;
		guint _tmp4_;
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp4_ = current_idle_delay;
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (_tmp4_ == ((guint) 0)) {
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = !budgie_settings_manager_get_caffeine_mode (self);
#line 2574 "settings.c"
		} else {
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			_tmp3_ = FALSE;
#line 2578 "settings.c"
		}
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = _tmp3_;
#line 2582 "settings.c"
	}
#line 431 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (_tmp1_) {
#line 2586 "settings.c"
		guint _tmp5_;
		guint32 _tmp6_;
		guint32* _tmp7_;
#line 432 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp5_ = current_idle_delay;
#line 432 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp6_ = (guint32) _tmp5_;
#line 432 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp7_ = __uint32_dup0 (&_tmp6_);
#line 432 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (self->priv->default_idle_delay);
#line 432 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->default_idle_delay = _tmp7_;
#line 2600 "settings.c"
	}
}


/**
     * update_idle_dim will update our default idle dim, if we are not in Caffeine Mode
     */
static void
budgie_settings_manager_update_idle_dim (BudgieSettingsManager* self)
{
#line 439 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 440 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (!budgie_settings_manager_get_caffeine_mode (self)) {
#line 2615 "settings.c"
		GSettings* _tmp0_;
		gboolean _tmp1_;
		gboolean* _tmp2_;
#line 441 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp0_ = self->priv->gnome_power_settings;
#line 441 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp1_ = g_settings_get_boolean (_tmp0_, "idle-dim");
#line 441 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_tmp2_ = __bool_dup0 (&_tmp1_);
#line 441 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		_g_free0 (self->priv->default_idle_dim);
#line 441 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		self->priv->default_idle_dim = _tmp2_;
#line 2629 "settings.c"
	}
}


GApplication*
budgie_settings_manager_get_parent_app (BudgieSettingsManager* self)
{
	GApplication* result;
	GApplication* _tmp0_;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = self->priv->_parent_app;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return result;
#line 2647 "settings.c"
}


void
budgie_settings_manager_set_parent_app (BudgieSettingsManager* self,
                                        GApplication* value)
{
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->_parent_app = value;
#line 2659 "settings.c"
}


static void
budgie_value_settings_manager_init (GValue* value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	value->data[0].v_pointer = NULL;
#line 2668 "settings.c"
}


static void
budgie_value_settings_manager_free_value (GValue* value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (value->data[0].v_pointer) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_unref (value->data[0].v_pointer);
#line 2679 "settings.c"
	}
}


static void
budgie_value_settings_manager_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (src_value->data[0].v_pointer) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		dest_value->data[0].v_pointer = budgie_settings_manager_ref (src_value->data[0].v_pointer);
#line 2692 "settings.c"
	} else {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2696 "settings.c"
	}
}


static gpointer
budgie_value_settings_manager_peek_pointer (const GValue* value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return value->data[0].v_pointer;
#line 2706 "settings.c"
}


static gchar*
budgie_value_settings_manager_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (collect_values[0].v_pointer) {
#line 2718 "settings.c"
		BudgieSettingsManager * object;
		object = collect_values[0].v_pointer;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		if (object->parent_instance.g_class == NULL) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2725 "settings.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2729 "settings.c"
		}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = budgie_settings_manager_ref (object);
#line 2733 "settings.c"
	} else {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2737 "settings.c"
	}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return NULL;
#line 2741 "settings.c"
}


static gchar*
budgie_value_settings_manager_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	BudgieSettingsManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (!object_p) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2757 "settings.c"
	}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (!value->data[0].v_pointer) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		*object_p = NULL;
#line 2763 "settings.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		*object_p = value->data[0].v_pointer;
#line 2767 "settings.c"
	} else {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		*object_p = budgie_settings_manager_ref (value->data[0].v_pointer);
#line 2771 "settings.c"
	}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return NULL;
#line 2775 "settings.c"
}


GParamSpec*
budgie_param_spec_settings_manager (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	BudgieParamSpecSettingsManager* spec;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BUDGIE_TYPE_SETTINGS_MANAGER), NULL);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return G_PARAM_SPEC (spec);
#line 2795 "settings.c"
}


gpointer
budgie_value_get_settings_manager (const GValue* value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER), NULL);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return value->data[0].v_pointer;
#line 2806 "settings.c"
}


void
budgie_value_set_settings_manager (GValue* value,
                                   gpointer v_object)
{
	BudgieSettingsManager * old;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	old = value->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (v_object) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = v_object;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_ref (value->data[0].v_pointer);
#line 2829 "settings.c"
	} else {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2833 "settings.c"
	}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (old) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_unref (old);
#line 2839 "settings.c"
	}
}


void
budgie_value_take_settings_manager (GValue* value,
                                    gpointer v_object)
{
	BudgieSettingsManager * old;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	old = value->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (v_object) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BUDGIE_TYPE_SETTINGS_MANAGER));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = v_object;
#line 2861 "settings.c"
	} else {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		value->data[0].v_pointer = NULL;
#line 2865 "settings.c"
	}
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (old) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		budgie_settings_manager_unref (old);
#line 2871 "settings.c"
	}
}


static void
budgie_settings_manager_class_init (BudgieSettingsManagerClass * klass)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	budgie_settings_manager_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	((BudgieSettingsManagerClass *) klass)->finalize = budgie_settings_manager_finalize;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_type_class_add_private (klass, sizeof (BudgieSettingsManagerPrivate));
#line 2885 "settings.c"
}


static void
budgie_settings_manager_instance_init (BudgieSettingsManager * self)
{
	gint32 _tmp0_;
	gint32* _tmp1_;
	guint32 _tmp2_;
	guint32* _tmp3_;
	gboolean _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp8_;
	gint* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv = BUDGIE_SETTINGS_MANAGER_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->_parent_app = NULL;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->mutter_settings = NULL;
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_desktop_settings = NULL;
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_power_settings = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_power_props = NULL;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_session_settings = NULL;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_sound_settings = NULL;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->gnome_wm_settings = NULL;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->raven_settings = NULL;
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->wm_settings = NULL;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->xoverrides = NULL;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp0_ = (gint32) 30;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp1_ = __int32_dup0 (&_tmp0_);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->default_brightness = _tmp1_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp2_ = (guint32) 0;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp3_ = __uint32_dup0 (&_tmp2_);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->default_idle_delay = _tmp3_;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp4_ = FALSE;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp5_ = __bool_dup0 (&_tmp4_);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->default_idle_dim = _tmp5_;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp6_ = 0;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp7_ = __int_dup0 (&_tmp6_);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->default_sleep_inactive_ac_timeout = _tmp7_;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp8_ = 0;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp9_ = __int_dup0 (&_tmp8_);
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->default_sleep_inactive_battery_timeout = _tmp9_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp10_ = g_strdup ("");
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->caffeine_full_cup = _tmp10_;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_tmp11_ = g_strdup ("");
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->caffeine_empty_cup = _tmp11_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->caffeine_notification = NULL;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->priv->temporary_notification_disabled = FALSE;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self->ref_count = 1;
#line 2972 "settings.c"
}


static void
budgie_settings_manager_finalize (BudgieSettingsManager * obj)
{
	BudgieSettingsManager * self;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_SETTINGS_MANAGER, BudgieSettingsManager);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_signal_handlers_destroy (self);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->mutter_settings);
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_settings);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_power_props);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_session_settings);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_sound_settings);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->gnome_wm_settings);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->xoverrides);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->default_brightness);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->default_idle_delay);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->default_idle_dim);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->default_sleep_inactive_ac_timeout);
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->default_sleep_inactive_battery_timeout);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_full_cup);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_free0 (self->priv->caffeine_empty_cup);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	_g_object_unref0 (self->priv->caffeine_notification);
#line 3020 "settings.c"
}


/**
 * The SettingsManager currently only has a very simple job, and looks for
 * session wide settings changes to respond to
 */
GType
budgie_settings_manager_get_type (void)
{
	static volatile gsize budgie_settings_manager_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_settings_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { budgie_value_settings_manager_init, budgie_value_settings_manager_free_value, budgie_value_settings_manager_copy_value, budgie_value_settings_manager_peek_pointer, "p", budgie_value_settings_manager_collect_value, "p", budgie_value_settings_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BudgieSettingsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_settings_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieSettingsManager), 0, (GInstanceInitFunc) budgie_settings_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType budgie_settings_manager_type_id;
		budgie_settings_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BudgieSettingsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&budgie_settings_manager_type_id__volatile, budgie_settings_manager_type_id);
	}
	return budgie_settings_manager_type_id__volatile;
}


gpointer
budgie_settings_manager_ref (gpointer instance)
{
	BudgieSettingsManager * self;
	self = instance;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	g_atomic_int_inc (&self->ref_count);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	return instance;
#line 3053 "settings.c"
}


void
budgie_settings_manager_unref (gpointer instance)
{
	BudgieSettingsManager * self;
	self = instance;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		BUDGIE_SETTINGS_MANAGER_GET_CLASS (self)->finalize (self);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/daemon/settings.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3068 "settings.c"
	}
}



