/* animation.c generated by valac 0.40.19, the Vala compiler
 * generated from animation.vala, do not modify */

/*
 * This file is part of budgie-desktop
 * 
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
/**<Target value for end of animation */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

typedef gdouble (*BudgieTweenFunc) (gdouble factor, gpointer user_data);

#define BUDGIE_TYPE_ANIMATION (budgie_animation_get_type ())
#define BUDGIE_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_ANIMATION, BudgieAnimation))
#define BUDGIE_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_ANIMATION, BudgieAnimationClass))
#define BUDGIE_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_ANIMATION))
#define BUDGIE_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_ANIMATION))
#define BUDGIE_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_ANIMATION, BudgieAnimationClass))

typedef struct _BudgieAnimation BudgieAnimation;
typedef struct _BudgieAnimationClass BudgieAnimationClass;
typedef void (*BudgieAnimCompletionFunc) (BudgieAnimation* src, gpointer user_data);

#define BUDGIE_TYPE_PROP_CHANGE (budgie_prop_change_get_type ())
typedef struct _BudgiePropChange BudgiePropChange;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BudgieAnimationPrivate BudgieAnimationPrivate;
enum  {
	BUDGIE_ANIMATION_0_PROPERTY,
	BUDGIE_ANIMATION_NUM_PROPERTIES
};
static GParamSpec* budgie_animation_properties[BUDGIE_ANIMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BudgiePropChange {
	gchar* property;
	GValue old;
	GValue new;
};

struct _BudgieAnimation {
	GObject parent_instance;
	BudgieAnimationPrivate * priv;
	gint64 start_time;
	gint64 length;
	BudgieTweenFunc tween;
	gpointer tween_target;
	BudgiePropChange* changes;
	gint changes_length1;
	GtkWidget* widget;
	GObject* object;
	guint id;
	gboolean can_anim;
	gint64 elapsed;
	gboolean no_reset;
};

struct _BudgieAnimationClass {
	GObjectClass parent_class;
};

struct _BudgieAnimationPrivate {
	BudgieAnimCompletionFunc compl;
	gpointer compl_target;
	GDestroyNotify compl_target_destroy_notify;
};


static gpointer budgie_animation_parent_class = NULL;

GType budgie_animation_get_type (void) G_GNUC_CONST;
GType budgie_prop_change_get_type (void) G_GNUC_CONST;
BudgiePropChange* budgie_prop_change_dup (const BudgiePropChange* self);
void budgie_prop_change_free (BudgiePropChange* self);
void budgie_prop_change_copy (const BudgiePropChange* self,
                              BudgiePropChange* dest);
void budgie_prop_change_destroy (BudgiePropChange* self);
#define BUDGIE_ANIMATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TYPE_ANIMATION, BudgieAnimationPrivate))
static void _vala_BudgiePropChange_array_free (BudgiePropChange * array,
                                        gint array_length);
static gboolean budgie_animation_tick_callback (BudgieAnimation* self,
                                         GtkWidget* widget,
                                         GdkFrameClock* frame);
void budgie_animation_start (BudgieAnimation* self,
                             BudgieAnimCompletionFunc compl,
                             gpointer compl_target);
static gboolean _budgie_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                            GdkFrameClock* frame_clock,
                                                            gpointer self);
void budgie_animation_stop (BudgieAnimation* self);
BudgieAnimation* budgie_animation_new (void);
BudgieAnimation* budgie_animation_construct (GType object_type);
static void budgie_animation_finalize (GObject * obj);
gdouble budgie_sine_ease_in_out (gdouble p);
gdouble budgie_sine_ease_in (gdouble p);
gdouble budgie_sine_ease_out (gdouble p);
gdouble budgie_elastic_ease_in (gdouble p);
gdouble budgie_elastic_ease_out (gdouble p);
gdouble budgie_back_ease_in (gdouble p);
gdouble budgie_back_ease_out (gdouble p);
gdouble budgie_expo_ease_in (gdouble p);
gdouble budgie_expo_ease_out (gdouble p);
gdouble budgie_quad_ease_in (gdouble p);
gdouble budgie_quad_ease_out (gdouble p);
gdouble budgie_quad_ease_in_out (gdouble p);
gdouble budgie_circ_ease_in (gdouble p);
gdouble budgie_circ_ease_out (gdouble p);
#define BUDGIE_MSECOND ((gint64) 1000)


void
budgie_prop_change_copy (const BudgiePropChange* self,
                         BudgiePropChange* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GValue _tmp2_;
	GValue _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	GValue _tmp6_;
	GValue _tmp7_ = {0};
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp0_ = (*self).property;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_g_free0 ((*dest).property);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	(*dest).property = _tmp1_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp2_ = (*self).old;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp3_ = _tmp2_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (G_IS_VALUE (&_tmp3_)) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		g_value_init (&_tmp4_, G_VALUE_TYPE (&_tmp3_));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		g_value_copy (&_tmp3_, &_tmp4_);
#line 157 "animation.c"
	} else {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp4_ = _tmp3_;
#line 161 "animation.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_IS_VALUE (&(*dest).old) ? (g_value_unset (&(*dest).old), NULL) : NULL;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	(*dest).old = _tmp4_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp5_ = (*self).new;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp6_ = _tmp5_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (G_IS_VALUE (&_tmp6_)) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		g_value_copy (&_tmp6_, &_tmp7_);
#line 177 "animation.c"
	} else {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp7_ = _tmp6_;
#line 181 "animation.c"
	}
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_IS_VALUE (&(*dest).new) ? (g_value_unset (&(*dest).new), NULL) : NULL;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	(*dest).new = _tmp7_;
#line 187 "animation.c"
}


void
budgie_prop_change_destroy (BudgiePropChange* self)
{
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_g_free0 ((*self).property);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_IS_VALUE (&(*self).old) ? (g_value_unset (&(*self).old), NULL) : NULL;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_IS_VALUE (&(*self).new) ? (g_value_unset (&(*self).new), NULL) : NULL;
#line 200 "animation.c"
}


BudgiePropChange*
budgie_prop_change_dup (const BudgiePropChange* self)
{
	BudgiePropChange* dup;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	dup = g_new0 (BudgiePropChange, 1);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	budgie_prop_change_copy (self, dup);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return dup;
#line 214 "animation.c"
}


void
budgie_prop_change_free (BudgiePropChange* self)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	budgie_prop_change_destroy (self);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_free (self);
#line 225 "animation.c"
}


GType
budgie_prop_change_get_type (void)
{
	static volatile gsize budgie_prop_change_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_prop_change_type_id__volatile)) {
		GType budgie_prop_change_type_id;
		budgie_prop_change_type_id = g_boxed_type_register_static ("BudgiePropChange", (GBoxedCopyFunc) budgie_prop_change_dup, (GBoxedFreeFunc) budgie_prop_change_free);
		g_once_init_leave (&budgie_prop_change_type_id__volatile, budgie_prop_change_type_id);
	}
	return budgie_prop_change_type_id__volatile;
}


static void
_vala_BudgiePropChange_array_free (BudgiePropChange * array,
                                   gint array_length)
{
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (array != NULL) {
#line 248 "animation.c"
		int i;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			budgie_prop_change_destroy (&array[i]);
#line 254 "animation.c"
		}
	}
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_free (array);
#line 259 "animation.c"
}


static gboolean
budgie_animation_tick_callback (BudgieAnimation* self,
                                GtkWidget* widget,
                                GdkFrameClock* frame)
{
	gboolean result = FALSE;
	gint64 time = 0LL;
	gfloat factor = 0.0F;
	gint64 elapsed = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp25_;
	gint64 _tmp26_;
	BudgiePropChange* _tmp27_;
	gint _tmp27__length1;
	gboolean _tmp48_;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_return_val_if_fail (frame != NULL, FALSE);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	time = gdk_frame_clock_get_frame_time (frame);
#line 48 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	factor = 0.0f;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp0_ = time;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp1_ = self->start_time;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	elapsed = _tmp0_ - _tmp1_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp4_ = elapsed;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp5_ = self->length;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (_tmp4_ >= _tmp5_) {
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp3_ = TRUE;
#line 307 "animation.c"
	} else {
		guint _tmp6_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp6_ = self->id;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp3_ = _tmp6_ == ((guint) 0);
#line 314 "animation.c"
	}
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (_tmp3_) {
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp2_ = TRUE;
#line 320 "animation.c"
	} else {
		gboolean _tmp7_;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp7_ = self->can_anim;
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp2_ = !_tmp7_;
#line 327 "animation.c"
	}
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (_tmp2_) {
#line 331 "animation.c"
		guint _tmp8_;
		gboolean _tmp22_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp8_ = self->id;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		if (_tmp8_ > ((guint) 0)) {
#line 338 "animation.c"
			BudgiePropChange* _tmp9_;
			gint _tmp9__length1;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			_tmp9_ = self->changes;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			_tmp9__length1 = self->changes_length1;
#line 345 "animation.c"
			{
				BudgiePropChange* p_collection = NULL;
				gint p_collection_length1 = 0;
				gint _p_collection_size_ = 0;
				gint p_it = 0;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				p_collection = _tmp9_;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				p_collection_length1 = _tmp9__length1;
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 357 "animation.c"
					BudgiePropChange _tmp10_;
					BudgiePropChange _tmp11_ = {0};
					BudgiePropChange p = {0};
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp10_ = p_collection[p_it];
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					budgie_prop_change_copy (&_tmp10_, &_tmp11_);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					p = _tmp11_;
#line 367 "animation.c"
					{
						GObject* _tmp12_;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
						_tmp12_ = self->object;
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
						if (_tmp12_ == NULL) {
#line 374 "animation.c"
							BudgiePropChange _tmp13_;
							const gchar* _tmp14_;
							BudgiePropChange _tmp15_;
							GValue _tmp16_;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp13_ = p;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp14_ = _tmp13_.property;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp15_ = p;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp16_ = _tmp15_.new;
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							g_object_set_property ((GObject*) widget, _tmp14_, &_tmp16_);
#line 389 "animation.c"
						} else {
							GObject* _tmp17_;
							BudgiePropChange _tmp18_;
							const gchar* _tmp19_;
							BudgiePropChange _tmp20_;
							GValue _tmp21_;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp17_ = self->object;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp18_ = p;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp19_ = _tmp18_.property;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp20_ = p;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							_tmp21_ = _tmp20_.new;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
							g_object_set_property (_tmp17_, _tmp19_, &_tmp21_);
#line 408 "animation.c"
						}
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
						budgie_prop_change_destroy (&p);
#line 412 "animation.c"
					}
				}
			}
		}
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		self->id = (guint) 0;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp22_ = self->can_anim;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		if (_tmp22_) {
#line 423 "animation.c"
			BudgieAnimCompletionFunc _tmp23_;
			void* _tmp23__target;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			self->can_anim = FALSE;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			_tmp23_ = self->priv->compl;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			_tmp23__target = self->priv->compl_target;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			if (_tmp23_ != NULL) {
#line 434 "animation.c"
				BudgieAnimCompletionFunc _tmp24_;
				void* _tmp24__target;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp24_ = self->priv->compl;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp24__target = self->priv->compl_target;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp24_ (self, _tmp24__target);
#line 443 "animation.c"
			}
		}
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		gtk_widget_queue_draw (widget);
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		result = FALSE;
#line 70 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		return result;
#line 452 "animation.c"
	}
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp25_ = elapsed;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp26_ = self->length;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	factor = CLAMP (((gfloat) _tmp25_) / _tmp26_, (gfloat) 0, 1.0f);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp27_ = self->changes;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp27__length1 = self->changes_length1;
#line 464 "animation.c"
	{
		BudgiePropChange* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		c_collection = _tmp27_;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		c_collection_length1 = _tmp27__length1;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 476 "animation.c"
			BudgiePropChange _tmp28_;
			BudgiePropChange _tmp29_ = {0};
			BudgiePropChange c = {0};
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			_tmp28_ = c_collection[c_it];
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			budgie_prop_change_copy (&_tmp28_, &_tmp29_);
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
			c = _tmp29_;
#line 486 "animation.c"
			{
				gdouble old = 0.0;
				gdouble new = 0.0;
				BudgieTweenFunc _tmp30_;
				void* _tmp30__target;
				gdouble delta = 0.0;
				gdouble _tmp33_;
				gdouble _tmp34_;
				gfloat _tmp35_;
				gdouble nprop = 0.0;
				gdouble _tmp36_;
				gdouble _tmp37_;
				GObject* _tmp38_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				old = g_value_get_double (&c.old);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				new = g_value_get_double (&c.new);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp30_ = self->tween;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp30__target = self->tween_target;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				if (_tmp30_ != NULL) {
#line 510 "animation.c"
					BudgieTweenFunc _tmp31_;
					void* _tmp31__target;
					gfloat _tmp32_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp31_ = self->tween;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp31__target = self->tween_target;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp32_ = factor;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					factor = (gfloat) _tmp31_ ((gdouble) _tmp32_, _tmp31__target);
#line 522 "animation.c"
				}
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp33_ = new;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp34_ = old;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp35_ = factor;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				delta = (_tmp33_ - _tmp34_) * _tmp35_;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp36_ = old;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp37_ = delta;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				nprop = (gdouble) (_tmp36_ + _tmp37_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				_tmp38_ = self->object;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				if (_tmp38_ == NULL) {
#line 542 "animation.c"
					BudgiePropChange _tmp39_;
					const gchar* _tmp40_;
					gdouble _tmp41_;
					GValue _tmp42_ = {0};
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp39_ = c;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp40_ = _tmp39_.property;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp41_ = nprop;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_value_init (&_tmp42_, G_TYPE_DOUBLE);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_value_set_double (&_tmp42_, _tmp41_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_object_set_property ((GObject*) widget, _tmp40_, &_tmp42_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					G_IS_VALUE (&_tmp42_) ? (g_value_unset (&_tmp42_), NULL) : NULL;
#line 561 "animation.c"
				} else {
					GObject* _tmp43_;
					BudgiePropChange _tmp44_;
					const gchar* _tmp45_;
					gdouble _tmp46_;
					GValue _tmp47_ = {0};
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp43_ = self->object;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp44_ = c;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp45_ = _tmp44_.property;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					_tmp46_ = nprop;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_value_init (&_tmp47_, G_TYPE_DOUBLE);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_value_set_double (&_tmp47_, _tmp46_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					g_object_set_property (_tmp43_, _tmp45_, &_tmp47_);
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
					G_IS_VALUE (&_tmp47_) ? (g_value_unset (&_tmp47_), NULL) : NULL;
#line 584 "animation.c"
				}
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
				budgie_prop_change_destroy (&c);
#line 588 "animation.c"
			}
		}
	}
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	gtk_widget_queue_draw (widget);
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp48_ = self->can_anim;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = _tmp48_;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 600 "animation.c"
}


/**
     * Start this animation by attaching ourselves to the GdkFrameClock
     *
     * @param compl A completion callback to execute when this animation completes
     */
static gboolean
_budgie_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                   GdkFrameClock* frame_clock,
                                                   gpointer self)
{
	gboolean result;
	result = budgie_animation_tick_callback ((BudgieAnimation*) self, widget, frame_clock);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 618 "animation.c"
}


void
budgie_animation_start (BudgieAnimation* self,
                        BudgieAnimCompletionFunc compl,
                        gpointer compl_target)
{
	gboolean _tmp0_;
	GtkWidget* _tmp3_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_return_if_fail (self != NULL);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp0_ = self->no_reset;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (!_tmp0_) {
#line 635 "animation.c"
		GtkWidget* _tmp1_;
		GdkFrameClock* _tmp2_;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp1_ = self->widget;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp2_ = gtk_widget_get_frame_clock (_tmp1_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		self->start_time = gdk_frame_clock_get_frame_time (_tmp2_);
#line 644 "animation.c"
	}
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl = compl;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target = compl_target;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->can_anim = TRUE;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp3_ = self->widget;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->id = gtk_widget_add_tick_callback (_tmp3_, _budgie_animation_tick_callback_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 666 "animation.c"
}


/**
     * Stop a running animation
     */
void
budgie_animation_stop (BudgieAnimation* self)
{
	guint _tmp0_;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->can_anim = FALSE;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_tmp0_ = self->id;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 685 "animation.c"
		GtkWidget* _tmp1_;
		guint _tmp2_;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp1_ = self->widget;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp2_ = self->id;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		gtk_widget_remove_tick_callback (_tmp1_, _tmp2_);
#line 694 "animation.c"
	}
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->id = (guint) 0;
#line 698 "animation.c"
}


BudgieAnimation*
budgie_animation_construct (GType object_type)
{
	BudgieAnimation * self = NULL;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self = (BudgieAnimation*) g_object_new (object_type, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return self;
#line 710 "animation.c"
}


BudgieAnimation*
budgie_animation_new (void)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return budgie_animation_construct (BUDGIE_TYPE_ANIMATION);
#line 719 "animation.c"
}


static void
budgie_animation_class_init (BudgieAnimationClass * klass)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	budgie_animation_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	g_type_class_add_private (klass, sizeof (BudgieAnimationPrivate));
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_animation_finalize;
#line 732 "animation.c"
}


static void
budgie_animation_instance_init (BudgieAnimation * self)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv = BUDGIE_ANIMATION_GET_PRIVATE (self);
#line 741 "animation.c"
}


static void
budgie_animation_finalize (GObject * obj)
{
	BudgieAnimation * self;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_ANIMATION, BudgieAnimation);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->changes = (_vala_BudgiePropChange_array_free (self->changes, self->changes_length1), NULL);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	_g_object_unref0 (self->object);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target = NULL;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	self->priv->compl_target_destroy_notify = NULL;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	G_OBJECT_CLASS (budgie_animation_parent_class)->finalize (obj);
#line 765 "animation.c"
}


/**
 * Utility to struct to enable easier animations
 * Inspired by Clutter. 
 */
GType
budgie_animation_get_type (void)
{
	static volatile gsize budgie_animation_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_animation_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BudgieAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieAnimation), 0, (GInstanceInitFunc) budgie_animation_instance_init, NULL };
		GType budgie_animation_type_id;
		budgie_animation_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieAnimation", &g_define_type_info, 0);
		g_once_init_leave (&budgie_animation_type_id__volatile, budgie_animation_type_id);
	}
	return budgie_animation_type_id__volatile;
}


gdouble
budgie_sine_ease_in_out (gdouble p)
{
	gdouble result = 0.0;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = 0.5 * (1 - cos (p * G_PI));
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 795 "animation.c"
}


gdouble
budgie_sine_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = sin ((p - 1) * G_PI_2) + 1;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 807 "animation.c"
}


gdouble
budgie_sine_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = sin (p * G_PI_2);
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 819 "animation.c"
}


gdouble
budgie_elastic_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = sin ((13 * G_PI_2) * p) * pow ((gdouble) 2, 10 * (p - 1));
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 831 "animation.c"
}


gdouble
budgie_elastic_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = (sin ((-13 * G_PI_2) * (p + 1)) * pow ((gdouble) 2, -10 * p)) + 1;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 843 "animation.c"
}


gdouble
budgie_back_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = ((p * p) * p) - (p * sin (p * G_PI));
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 855 "animation.c"
}


gdouble
budgie_back_ease_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble f = 0.0;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	f = 1 - p;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = 1 - (((f * f) * f) - (f * sin (f * G_PI)));
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 870 "animation.c"
}


gdouble
budgie_expo_ease_in (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (p == 0.0) {
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = p;
#line 883 "animation.c"
	} else {
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = pow ((gdouble) 2, 10 * (p - 1));
#line 887 "animation.c"
	}
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = _tmp0_;
#line 168 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 893 "animation.c"
}


gdouble
budgie_expo_ease_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (p == 1.0) {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = p;
#line 906 "animation.c"
	} else {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = 1 - pow ((gdouble) 2, -10 * p);
#line 910 "animation.c"
	}
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = _tmp0_;
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 916 "animation.c"
}


gdouble
budgie_quad_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = p * p;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 928 "animation.c"
}


gdouble
budgie_quad_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = -(p * (p - 2));
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 940 "animation.c"
}


gdouble
budgie_quad_ease_in_out (gdouble p)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	if (p < 0.5) {
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = (2 * p) * p;
#line 953 "animation.c"
	} else {
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
		_tmp0_ = (((-2 * p) * p) + (4 * p)) - 1;
#line 957 "animation.c"
	}
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = _tmp0_;
#line 188 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 963 "animation.c"
}


gdouble
budgie_circ_ease_in (gdouble p)
{
	gdouble result = 0.0;
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = 1 - sqrt (1 - (p * p));
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 975 "animation.c"
}


gdouble
budgie_circ_ease_out (gdouble p)
{
	gdouble result = 0.0;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	result = sqrt ((2 - p) * p);
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/animation.vala"
	return result;
#line 987 "animation.c"
}



