/* toplevel.c generated by valac 0.40.19, the Vala compiler
 * generated from toplevel.vala, do not modify */

/*
 * This file is part of budgie-desktop.
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>


#define BUDGIE_TYPE_TOPLEVEL (budgie_toplevel_get_type ())
#define BUDGIE_TOPLEVEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_TOPLEVEL, BudgieToplevel))
#define BUDGIE_TOPLEVEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_TOPLEVEL, BudgieToplevelClass))
#define BUDGIE_IS_TOPLEVEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_TOPLEVEL))
#define BUDGIE_IS_TOPLEVEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_TOPLEVEL))
#define BUDGIE_TOPLEVEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_TOPLEVEL, BudgieToplevelClass))

typedef struct _BudgieToplevel BudgieToplevel;
typedef struct _BudgieToplevelClass BudgieToplevelClass;
typedef struct _BudgieToplevelPrivate BudgieToplevelPrivate;
typedef enum  {
	BUDGIE_PANEL_TRANSPARENCY_NONE = 1 << 0,
	BUDGIE_PANEL_TRANSPARENCY_DYNAMIC = 1 << 1,
	BUDGIE_PANEL_TRANSPARENCY_ALWAYS = 1 << 2
} BudgiePanelTransparency;


#define BUDGIE_TYPE_PANEL_TRANSPARENCY (budgie_panel_transparency_get_type ())
typedef enum  {
	BUDGIE_AUTOHIDE_POLICY_NONE = 1 << 0,
	BUDGIE_AUTOHIDE_POLICY_AUTOMATIC = 1 << 1,
	BUDGIE_AUTOHIDE_POLICY_INTELLIGENT = 1 << 2
} BudgieAutohidePolicy;


#define BUDGIE_TYPE_AUTOHIDE_POLICY (budgie_autohide_policy_get_type ())
enum  {
	BUDGIE_TOPLEVEL_0_PROPERTY,
	BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY,
	BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY,
	BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY,
	BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY,
	BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY,
	BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY,
	BUDGIE_TOPLEVEL_UUID_PROPERTY,
	BUDGIE_TOPLEVEL_POSITION_PROPERTY,
	BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY,
	BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY,
	BUDGIE_TOPLEVEL_NUM_PROPERTIES
};
static GParamSpec* budgie_toplevel_properties[BUDGIE_TOPLEVEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BUDGIE_TOPLEVEL_APPLET_ADDED_SIGNAL,
	BUDGIE_TOPLEVEL_APPLET_REMOVED_SIGNAL,
	BUDGIE_TOPLEVEL_APPLETS_CHANGED_SIGNAL,
	BUDGIE_TOPLEVEL_NUM_SIGNALS
};
static guint budgie_toplevel_signals[BUDGIE_TOPLEVEL_NUM_SIGNALS] = {0};
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BudgieToplevel {
	GtkWindow parent_instance;
	BudgieToplevelPrivate * priv;
};

struct _BudgieToplevelClass {
	GtkWindowClass parent_class;
	GList* (*get_applets) (BudgieToplevel* self);
	gboolean (*can_move_applet_left) (BudgieToplevel* self, BudgieAppletInfo* info);
	gboolean (*can_move_applet_right) (BudgieToplevel* self, BudgieAppletInfo* info);
	void (*move_applet_left) (BudgieToplevel* self, BudgieAppletInfo* info);
	void (*move_applet_right) (BudgieToplevel* self, BudgieAppletInfo* info);
	void (*add_new_applet) (BudgieToplevel* self, const gchar* id);
	void (*remove_applet) (BudgieToplevel* self, BudgieAppletInfo* info);
};

struct _BudgieToplevelPrivate {
	gint _shadow_depth;
	gint _intended_size;
	gboolean _shadow_visible;
	gboolean _theme_regions;
	gboolean _dock_mode;
	gboolean _intersected;
	gchar* _uuid;
	BudgiePanelPosition _position;
	BudgiePanelTransparency _transparency;
	BudgieAutohidePolicy _autohide;
};


static gpointer budgie_toplevel_parent_class = NULL;

GType budgie_toplevel_get_type (void) G_GNUC_CONST;
GType budgie_panel_transparency_get_type (void) G_GNUC_CONST;
GType budgie_autohide_policy_get_type (void) G_GNUC_CONST;
#define BUDGIE_TOPLEVEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TYPE_TOPLEVEL, BudgieToplevelPrivate))
GList* budgie_toplevel_get_applets (BudgieToplevel* self);
static GList* budgie_toplevel_real_get_applets (BudgieToplevel* self);
gboolean budgie_toplevel_can_move_applet_left (BudgieToplevel* self,
                                               BudgieAppletInfo* info);
static gboolean budgie_toplevel_real_can_move_applet_left (BudgieToplevel* self,
                                                    BudgieAppletInfo* info);
gboolean budgie_toplevel_can_move_applet_right (BudgieToplevel* self,
                                                BudgieAppletInfo* info);
static gboolean budgie_toplevel_real_can_move_applet_right (BudgieToplevel* self,
                                                     BudgieAppletInfo* info);
void budgie_toplevel_move_applet_left (BudgieToplevel* self,
                                       BudgieAppletInfo* info);
static void budgie_toplevel_real_move_applet_left (BudgieToplevel* self,
                                            BudgieAppletInfo* info);
void budgie_toplevel_move_applet_right (BudgieToplevel* self,
                                        BudgieAppletInfo* info);
static void budgie_toplevel_real_move_applet_right (BudgieToplevel* self,
                                             BudgieAppletInfo* info);
void budgie_toplevel_add_new_applet (BudgieToplevel* self,
                                     const gchar* id);
static void budgie_toplevel_real_add_new_applet (BudgieToplevel* self,
                                          const gchar* id);
void budgie_toplevel_remove_applet (BudgieToplevel* self,
                                    BudgieAppletInfo* info);
static void budgie_toplevel_real_remove_applet (BudgieToplevel* self,
                                         BudgieAppletInfo* info);
BudgieToplevel* budgie_toplevel_construct (GType object_type);
gint budgie_toplevel_get_shadow_depth (BudgieToplevel* self);
void budgie_toplevel_set_shadow_depth (BudgieToplevel* self,
                                       gint value);
gint budgie_toplevel_get_intended_size (BudgieToplevel* self);
void budgie_toplevel_set_intended_size (BudgieToplevel* self,
                                        gint value);
gboolean budgie_toplevel_get_shadow_visible (BudgieToplevel* self);
void budgie_toplevel_set_shadow_visible (BudgieToplevel* self,
                                         gboolean value);
gboolean budgie_toplevel_get_theme_regions (BudgieToplevel* self);
void budgie_toplevel_set_theme_regions (BudgieToplevel* self,
                                        gboolean value);
gboolean budgie_toplevel_get_dock_mode (BudgieToplevel* self);
void budgie_toplevel_set_dock_mode (BudgieToplevel* self,
                                    gboolean value);
gboolean budgie_toplevel_get_intersected (BudgieToplevel* self);
void budgie_toplevel_set_intersected (BudgieToplevel* self,
                                      gboolean value);
const gchar* budgie_toplevel_get_uuid (BudgieToplevel* self);
void budgie_toplevel_set_uuid (BudgieToplevel* self,
                               const gchar* value);
BudgiePanelPosition budgie_toplevel_get_position (BudgieToplevel* self);
void budgie_toplevel_set_position (BudgieToplevel* self,
                                   BudgiePanelPosition value);
BudgiePanelTransparency budgie_toplevel_get_transparency (BudgieToplevel* self);
void budgie_toplevel_set_transparency (BudgieToplevel* self,
                                       BudgiePanelTransparency value);
BudgieAutohidePolicy budgie_toplevel_get_autohide (BudgieToplevel* self);
void budgie_toplevel_set_autohide (BudgieToplevel* self,
                                   BudgieAutohidePolicy value);
static void budgie_toplevel_finalize (GObject * obj);
static void _vala_budgie_toplevel_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_budgie_toplevel_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
void budgie_set_struts (GtkWindow* window,
                        BudgiePanelPosition position,
                        glong panel_size);
void budgie_unset_struts (GtkWindow* window);
gchar* budgie_position_class_name (BudgiePanelPosition position);


static GList*
budgie_toplevel_real_get_applets (BudgieToplevel* self)
{
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_get_applets'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return NULL;
#line 194 "toplevel.c"
}


GList*
budgie_toplevel_get_applets (BudgieToplevel* self)
{
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return BUDGIE_TOPLEVEL_GET_CLASS (self)->get_applets (self);
#line 205 "toplevel.c"
}


static gboolean
budgie_toplevel_real_can_move_applet_left (BudgieToplevel* self,
                                           BudgieAppletInfo* info)
{
	gboolean _tmp0_ = FALSE;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_can_move_applet_left'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return _tmp0_;
#line 218 "toplevel.c"
}


gboolean
budgie_toplevel_can_move_applet_left (BudgieToplevel* self,
                                      BudgieAppletInfo* info)
{
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return BUDGIE_TOPLEVEL_GET_CLASS (self)->can_move_applet_left (self, info);
#line 230 "toplevel.c"
}


static gboolean
budgie_toplevel_real_can_move_applet_right (BudgieToplevel* self,
                                            BudgieAppletInfo* info)
{
	gboolean _tmp0_ = FALSE;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_can_move_applet_right'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return _tmp0_;
#line 243 "toplevel.c"
}


gboolean
budgie_toplevel_can_move_applet_right (BudgieToplevel* self,
                                       BudgieAppletInfo* info)
{
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return BUDGIE_TOPLEVEL_GET_CLASS (self)->can_move_applet_right (self, info);
#line 255 "toplevel.c"
}


static void
budgie_toplevel_real_move_applet_left (BudgieToplevel* self,
                                       BudgieAppletInfo* info)
{
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_move_applet_left'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return;
#line 267 "toplevel.c"
}


void
budgie_toplevel_move_applet_left (BudgieToplevel* self,
                                  BudgieAppletInfo* info)
{
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	BUDGIE_TOPLEVEL_GET_CLASS (self)->move_applet_left (self, info);
#line 279 "toplevel.c"
}


static void
budgie_toplevel_real_move_applet_right (BudgieToplevel* self,
                                        BudgieAppletInfo* info)
{
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_move_applet_right'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return;
#line 291 "toplevel.c"
}


void
budgie_toplevel_move_applet_right (BudgieToplevel* self,
                                   BudgieAppletInfo* info)
{
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	BUDGIE_TOPLEVEL_GET_CLASS (self)->move_applet_right (self, info);
#line 303 "toplevel.c"
}


static void
budgie_toplevel_real_add_new_applet (BudgieToplevel* self,
                                     const gchar* id)
{
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_add_new_applet'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return;
#line 315 "toplevel.c"
}


void
budgie_toplevel_add_new_applet (BudgieToplevel* self,
                                const gchar* id)
{
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	BUDGIE_TOPLEVEL_GET_CLASS (self)->add_new_applet (self, id);
#line 327 "toplevel.c"
}


static void
budgie_toplevel_real_remove_applet (BudgieToplevel* self,
                                    BudgieAppletInfo* info)
{
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_toplevel_remove_applet'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return;
#line 339 "toplevel.c"
}


void
budgie_toplevel_remove_applet (BudgieToplevel* self,
                               BudgieAppletInfo* info)
{
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 56 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	BUDGIE_TOPLEVEL_GET_CLASS (self)->remove_applet (self, info);
#line 351 "toplevel.c"
}


BudgieToplevel*
budgie_toplevel_construct (GType object_type)
{
	BudgieToplevel * self = NULL;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self = (BudgieToplevel*) g_object_new (object_type, NULL);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return self;
#line 363 "toplevel.c"
}


gint
budgie_toplevel_get_shadow_depth (BudgieToplevel* self)
{
	gint result;
	gint _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_shadow_depth;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 380 "toplevel.c"
}


void
budgie_toplevel_set_shadow_depth (BudgieToplevel* self,
                                  gint value)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_shadow_depth (self) != value) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_shadow_depth = value;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY]);
#line 396 "toplevel.c"
	}
}


gint
budgie_toplevel_get_intended_size (BudgieToplevel* self)
{
	gint result;
	gint _tmp0_;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_intended_size;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 414 "toplevel.c"
}


void
budgie_toplevel_set_intended_size (BudgieToplevel* self,
                                   gint value)
{
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_intended_size (self) != value) {
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_intended_size = value;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY]);
#line 430 "toplevel.c"
	}
}


gboolean
budgie_toplevel_get_shadow_visible (BudgieToplevel* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_shadow_visible;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 448 "toplevel.c"
}


void
budgie_toplevel_set_shadow_visible (BudgieToplevel* self,
                                    gboolean value)
{
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_shadow_visible (self) != value) {
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_shadow_visible = value;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY]);
#line 464 "toplevel.c"
	}
}


gboolean
budgie_toplevel_get_theme_regions (BudgieToplevel* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_theme_regions;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 482 "toplevel.c"
}


void
budgie_toplevel_set_theme_regions (BudgieToplevel* self,
                                   gboolean value)
{
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_theme_regions (self) != value) {
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_theme_regions = value;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY]);
#line 498 "toplevel.c"
	}
}


gboolean
budgie_toplevel_get_dock_mode (BudgieToplevel* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_dock_mode;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 516 "toplevel.c"
}


void
budgie_toplevel_set_dock_mode (BudgieToplevel* self,
                               gboolean value)
{
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_dock_mode (self) != value) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_dock_mode = value;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY]);
#line 532 "toplevel.c"
	}
}


gboolean
budgie_toplevel_get_intersected (BudgieToplevel* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_intersected;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 550 "toplevel.c"
}


void
budgie_toplevel_set_intersected (BudgieToplevel* self,
                                 gboolean value)
{
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_intersected (self) != value) {
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_intersected = value;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY]);
#line 566 "toplevel.c"
	}
}


const gchar*
budgie_toplevel_get_uuid (BudgieToplevel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_uuid;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 584 "toplevel.c"
}


void
budgie_toplevel_set_uuid (BudgieToplevel* self,
                          const gchar* value)
{
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (g_strcmp0 (value, budgie_toplevel_get_uuid (self)) != 0) {
#line 596 "toplevel.c"
		gchar* _tmp0_;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		_tmp0_ = g_strdup (value);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		_g_free0 (self->priv->_uuid);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_uuid = _tmp0_;
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_UUID_PROPERTY]);
#line 606 "toplevel.c"
	}
}


BudgiePanelPosition
budgie_toplevel_get_position (BudgieToplevel* self)
{
	BudgiePanelPosition result;
	BudgiePanelPosition _tmp0_;
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_position;
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 624 "toplevel.c"
}


void
budgie_toplevel_set_position (BudgieToplevel* self,
                              BudgiePanelPosition value)
{
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_position (self) != value) {
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_position = value;
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_POSITION_PROPERTY]);
#line 640 "toplevel.c"
	}
}


BudgiePanelTransparency
budgie_toplevel_get_transparency (BudgieToplevel* self)
{
	BudgiePanelTransparency result;
	BudgiePanelTransparency _tmp0_;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_transparency;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 658 "toplevel.c"
}


void
budgie_toplevel_set_transparency (BudgieToplevel* self,
                                  BudgiePanelTransparency value)
{
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_transparency (self) != value) {
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_transparency = value;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY]);
#line 674 "toplevel.c"
	}
}


BudgieAutohidePolicy
budgie_toplevel_get_autohide (BudgieToplevel* self)
{
	BudgieAutohidePolicy result;
	BudgieAutohidePolicy _tmp0_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_ = self->priv->_autohide;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	result = _tmp0_;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return result;
#line 692 "toplevel.c"
}


void
budgie_toplevel_set_autohide (BudgieToplevel* self,
                              BudgieAutohidePolicy value)
{
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_return_if_fail (self != NULL);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (budgie_toplevel_get_autohide (self) != value) {
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		self->priv->_autohide = value;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_toplevel_properties[BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY]);
#line 708 "toplevel.c"
	}
}


static void
budgie_toplevel_class_init (BudgieToplevelClass * klass)
{
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	budgie_toplevel_parent_class = g_type_class_peek_parent (klass);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_type_class_add_private (klass, sizeof (BudgieToplevelPrivate));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->get_applets = (GList* (*) (BudgieToplevel*)) budgie_toplevel_real_get_applets;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->can_move_applet_left = (gboolean (*) (BudgieToplevel*, BudgieAppletInfo*)) budgie_toplevel_real_can_move_applet_left;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->can_move_applet_right = (gboolean (*) (BudgieToplevel*, BudgieAppletInfo*)) budgie_toplevel_real_can_move_applet_right;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->move_applet_left = (void (*) (BudgieToplevel*, BudgieAppletInfo*)) budgie_toplevel_real_move_applet_left;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->move_applet_right = (void (*) (BudgieToplevel*, BudgieAppletInfo*)) budgie_toplevel_real_move_applet_right;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->add_new_applet = (void (*) (BudgieToplevel*, const gchar*)) budgie_toplevel_real_add_new_applet;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	((BudgieToplevelClass *) klass)->remove_applet = (void (*) (BudgieToplevel*, BudgieAppletInfo*)) budgie_toplevel_real_remove_applet;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_toplevel_get_property;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_toplevel_set_property;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_toplevel_finalize;
#line 740 "toplevel.c"
	/**
	     * Depth of our shadow component, to enable Raven blending
	     */
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY] = g_param_spec_int ("shadow-depth", "shadow-depth", "shadow-depth", G_MININT, G_MAXINT, 5, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 746 "toplevel.c"
	/**
	     * Our required size (height or width dependening on orientation
	     */
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY] = g_param_spec_int ("intended-size", "intended-size", "intended-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY] = g_param_spec_boolean ("shadow-visible", "shadow-visible", "shadow-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY] = g_param_spec_boolean ("theme-regions", "theme-regions", "theme-regions", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY] = g_param_spec_boolean ("dock-mode", "dock-mode", "dock-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY] = g_param_spec_boolean ("intersected", "intersected", "intersected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 760 "toplevel.c"
	/**
	     * Unique identifier for this panel
	     */
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_UUID_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_POSITION_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_POSITION_PROPERTY] = g_param_spec_flags ("position", "position", "position", budgie_panel_position_get_type (), BUDGIE_PANEL_POSITION_BOTTOM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY] = g_param_spec_flags ("transparency", "transparency", "transparency", BUDGIE_TYPE_PANEL_TRANSPARENCY, BUDGIE_PANEL_TRANSPARENCY_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY, budgie_toplevel_properties[BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY] = g_param_spec_flags ("autohide", "autohide", "autohide", BUDGIE_TYPE_AUTOHIDE_POLICY, BUDGIE_AUTOHIDE_POLICY_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	budgie_toplevel_signals[BUDGIE_TOPLEVEL_APPLET_ADDED_SIGNAL] = g_signal_new ("applet-added", BUDGIE_TYPE_TOPLEVEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, budgie_applet_info_get_type ());
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	budgie_toplevel_signals[BUDGIE_TOPLEVEL_APPLET_REMOVED_SIGNAL] = g_signal_new ("applet-removed", BUDGIE_TYPE_TOPLEVEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	budgie_toplevel_signals[BUDGIE_TOPLEVEL_APPLETS_CHANGED_SIGNAL] = g_signal_new ("applets-changed", BUDGIE_TYPE_TOPLEVEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 778 "toplevel.c"
}


static void
budgie_toplevel_instance_init (BudgieToplevel * self)
{
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv = BUDGIE_TOPLEVEL_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_shadow_depth = 5;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_dock_mode = FALSE;
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_intersected = FALSE;
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_transparency = BUDGIE_PANEL_TRANSPARENCY_NONE;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self->priv->_autohide = BUDGIE_AUTOHIDE_POLICY_NONE;
#line 799 "toplevel.c"
}


static void
budgie_toplevel_finalize (GObject * obj)
{
	BudgieToplevel * self;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_TOPLEVEL, BudgieToplevel);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_g_free0 (self->priv->_uuid);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	G_OBJECT_CLASS (budgie_toplevel_parent_class)->finalize (obj);
#line 813 "toplevel.c"
}


GType
budgie_toplevel_get_type (void)
{
	static volatile gsize budgie_toplevel_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_toplevel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BudgieToplevelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_toplevel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieToplevel), 0, (GInstanceInitFunc) budgie_toplevel_instance_init, NULL };
		GType budgie_toplevel_type_id;
		budgie_toplevel_type_id = g_type_register_static (gtk_window_get_type (), "BudgieToplevel", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&budgie_toplevel_type_id__volatile, budgie_toplevel_type_id);
	}
	return budgie_toplevel_type_id__volatile;
}


static void
_vala_budgie_toplevel_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	BudgieToplevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_TOPLEVEL, BudgieToplevel);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	switch (property_id) {
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_int (value, budgie_toplevel_get_shadow_depth (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_int (value, budgie_toplevel_get_intended_size (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_boolean (value, budgie_toplevel_get_shadow_visible (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_boolean (value, budgie_toplevel_get_theme_regions (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_boolean (value, budgie_toplevel_get_dock_mode (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_boolean (value, budgie_toplevel_get_intersected (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_UUID_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_string (value, budgie_toplevel_get_uuid (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_POSITION_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_flags (value, budgie_toplevel_get_position (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_flags (value, budgie_toplevel_get_transparency (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		g_value_set_flags (value, budgie_toplevel_get_autohide (self));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 901 "toplevel.c"
		default:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 907 "toplevel.c"
	}
}


static void
_vala_budgie_toplevel_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	BudgieToplevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_TOPLEVEL, BudgieToplevel);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	switch (property_id) {
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_SHADOW_DEPTH_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_shadow_depth (self, g_value_get_int (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_INTENDED_SIZE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_intended_size (self, g_value_get_int (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_SHADOW_VISIBLE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_shadow_visible (self, g_value_get_boolean (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_THEME_REGIONS_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_theme_regions (self, g_value_get_boolean (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_DOCK_MODE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_dock_mode (self, g_value_get_boolean (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_INTERSECTED_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_intersected (self, g_value_get_boolean (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_UUID_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_uuid (self, g_value_get_string (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_POSITION_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_position (self, g_value_get_flags (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_TRANSPARENCY_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_transparency (self, g_value_get_flags (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_TOPLEVEL_AUTOHIDE_PROPERTY:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		budgie_toplevel_set_autohide (self, g_value_get_flags (value));
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 982 "toplevel.c"
		default:
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		break;
#line 988 "toplevel.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	return self ? g_object_ref (self) : NULL;
#line 998 "toplevel.c"
}


void
budgie_set_struts (GtkWindow* window,
                   BudgiePanelPosition position,
                   glong panel_size)
{
	GdkAtom atom = 0U;
	glong struts[12] = {0};
	glong _tmp0_[12] = {0};
	GdkScreen* screen = NULL;
	GdkScreen* _tmp1_;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GdkMonitor* mon = NULL;
	GdkScreen* _tmp4_;
	GdkDisplay* _tmp5_;
	GdkMonitor* _tmp6_;
	GdkMonitor* _tmp7_;
	GdkRectangle primary_monitor_rect = {0};
	GdkMonitor* _tmp8_;
	GdkRectangle _tmp9_ = {0};
	GdkWindow* _tmp41_;
	GdkAtom _tmp42_;
	GdkWindow* _tmp43_;
	GdkAtom _tmp44_;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[0] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[1] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[2] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[3] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[4] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[5] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[6] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[7] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[8] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[9] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[10] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[11] = (glong) 0;
#line 62 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	memcpy (struts, _tmp0_, 12 * sizeof (glong));
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp1_ = gtk_window_get_screen (window);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp2_ = _tmp1_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	screen = _tmp3_;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp4_ = screen;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp5_ = gdk_screen_get_display (_tmp4_);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp6_ = gdk_display_get_primary_monitor (_tmp5_);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	mon = _tmp7_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp8_ = mon;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	gdk_monitor_get_geometry (_tmp8_, &_tmp9_);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	primary_monitor_rect = _tmp9_;
#line 74 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) window)) {
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		_g_object_unref0 (mon);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		_g_object_unref0 (screen);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		return;
#line 1084 "toplevel.c"
	}
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	switch (position) {
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_TOP:
#line 1090 "toplevel.c"
		{
			GdkRectangle _tmp10_;
			gint _tmp11_;
			GdkRectangle _tmp12_;
			gint _tmp13_;
			GdkRectangle _tmp14_;
			gint _tmp15_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[2] = panel_size;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp10_ = primary_monitor_rect;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp11_ = _tmp10_.x;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[8] = (glong) _tmp11_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp12_ = primary_monitor_rect;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp13_ = _tmp12_.x;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp14_ = primary_monitor_rect;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp15_ = _tmp14_.width;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[9] = (glong) ((_tmp13_ + _tmp15_) - 1);
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			break;
#line 1118 "toplevel.c"
		}
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_LEFT:
#line 1122 "toplevel.c"
		{
			GdkRectangle _tmp16_;
			gint _tmp17_;
			GdkRectangle _tmp18_;
			gint _tmp19_;
			GdkRectangle _tmp20_;
			gint _tmp21_;
			GdkRectangle _tmp22_;
			gint _tmp23_;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			panel_size = panel_size + 5;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp16_ = primary_monitor_rect;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp17_ = _tmp16_.x;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[0] = _tmp17_ + panel_size;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp18_ = primary_monitor_rect;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp19_ = _tmp18_.y;
#line 88 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[4] = (glong) _tmp19_;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp20_ = primary_monitor_rect;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp21_ = _tmp20_.y;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp22_ = primary_monitor_rect;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp23_ = _tmp22_.height;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[5] = (glong) (_tmp21_ + (_tmp23_ - 1));
#line 90 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			break;
#line 1158 "toplevel.c"
		}
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_RIGHT:
#line 1162 "toplevel.c"
		{
			GdkScreen* _tmp24_;
			GdkRectangle _tmp25_;
			gint _tmp26_;
			GdkRectangle _tmp27_;
			gint _tmp28_;
			GdkRectangle _tmp29_;
			gint _tmp30_;
			GdkRectangle _tmp31_;
			gint _tmp32_;
			GdkRectangle _tmp33_;
			gint _tmp34_;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			panel_size = panel_size + 5;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp24_ = screen;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp25_ = primary_monitor_rect;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp26_ = _tmp25_.x;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp27_ = primary_monitor_rect;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp28_ = _tmp27_.width;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[1] = (gdk_screen_get_width (_tmp24_) + panel_size) - (_tmp26_ + _tmp28_);
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp29_ = primary_monitor_rect;
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp30_ = _tmp29_.y;
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[6] = (glong) _tmp30_;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp31_ = primary_monitor_rect;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp32_ = _tmp31_.y;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp33_ = primary_monitor_rect;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp34_ = _tmp33_.height;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[7] = (glong) ((_tmp32_ + _tmp34_) - 1);
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			break;
#line 1207 "toplevel.c"
		}
		default:
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1212 "toplevel.c"
		{
			GdkRectangle _tmp35_;
			gint _tmp36_;
			GdkRectangle _tmp37_;
			gint _tmp38_;
			GdkRectangle _tmp39_;
			gint _tmp40_;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[3] = panel_size;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp35_ = primary_monitor_rect;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp36_ = _tmp35_.x;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[10] = (glong) _tmp36_;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp37_ = primary_monitor_rect;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp38_ = _tmp37_.x;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp39_ = primary_monitor_rect;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp40_ = _tmp39_.width;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			struts[11] = (glong) ((_tmp38_ + _tmp40_) - 1);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			break;
#line 1240 "toplevel.c"
		}
	}
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	atom = gdk_atom_intern ("_NET_WM_STRUT", FALSE);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp41_ = gtk_widget_get_window ((GtkWidget*) window);
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp42_ = atom;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	gdk_property_change (_tmp41_, _tmp42_, gdk_atom_intern ("CARDINAL", FALSE), 32, GDK_PROP_MODE_REPLACE, (const guchar*) ((guint8*) struts), 4);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	atom = gdk_atom_intern ("_NET_WM_STRUT_PARTIAL", FALSE);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp43_ = gtk_widget_get_window ((GtkWidget*) window);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp44_ = atom;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	gdk_property_change (_tmp43_, _tmp44_, gdk_atom_intern ("CARDINAL", FALSE), 32, GDK_PROP_MODE_REPLACE, (const guchar*) ((guint8*) struts), 12);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_g_object_unref0 (mon);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_g_object_unref0 (screen);
#line 1263 "toplevel.c"
}


void
budgie_unset_struts (GtkWindow* window)
{
	GdkAtom atom = 0U;
	glong struts[12] = {0};
	glong _tmp0_[12] = {0};
	GdkWindow* _tmp1_;
	GdkAtom _tmp2_;
	GdkWindow* _tmp3_;
	GdkAtom _tmp4_;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) window)) {
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		return;
#line 1281 "toplevel.c"
	}
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[0] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[1] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[2] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[3] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[4] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[5] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[6] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[7] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[8] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[9] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp0_[10] = (glong) 0;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	memcpy (struts, _tmp0_, 12 * sizeof (glong));
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	atom = gdk_atom_intern ("_NET_WM_STRUT", FALSE);
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) window);
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp2_ = atom;
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	gdk_property_change (_tmp1_, _tmp2_, gdk_atom_intern ("CARDINAL", FALSE), 32, GDK_PROP_MODE_REPLACE, (const guchar*) ((guint8*) struts), 4);
#line 129 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	atom = gdk_atom_intern ("_NET_WM_STRUT_PARTIAL", FALSE);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) window);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	_tmp4_ = atom;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	gdk_property_change (_tmp3_, _tmp4_, gdk_atom_intern ("CARDINAL", FALSE), 32, GDK_PROP_MODE_REPLACE, (const guchar*) ((guint8*) struts), 12);
#line 1323 "toplevel.c"
}


GType
budgie_panel_transparency_get_type (void)
{
	static volatile gsize budgie_panel_transparency_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_panel_transparency_type_id__volatile)) {
		static const GFlagsValue values[] = {{BUDGIE_PANEL_TRANSPARENCY_NONE, "BUDGIE_PANEL_TRANSPARENCY_NONE", "none"}, {BUDGIE_PANEL_TRANSPARENCY_DYNAMIC, "BUDGIE_PANEL_TRANSPARENCY_DYNAMIC", "dynamic"}, {BUDGIE_PANEL_TRANSPARENCY_ALWAYS, "BUDGIE_PANEL_TRANSPARENCY_ALWAYS", "always"}, {0, NULL, NULL}};
		GType budgie_panel_transparency_type_id;
		budgie_panel_transparency_type_id = g_flags_register_static ("BudgiePanelTransparency", values);
		g_once_init_leave (&budgie_panel_transparency_type_id__volatile, budgie_panel_transparency_type_id);
	}
	return budgie_panel_transparency_type_id__volatile;
}


GType
budgie_autohide_policy_get_type (void)
{
	static volatile gsize budgie_autohide_policy_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_autohide_policy_type_id__volatile)) {
		static const GFlagsValue values[] = {{BUDGIE_AUTOHIDE_POLICY_NONE, "BUDGIE_AUTOHIDE_POLICY_NONE", "none"}, {BUDGIE_AUTOHIDE_POLICY_AUTOMATIC, "BUDGIE_AUTOHIDE_POLICY_AUTOMATIC", "automatic"}, {BUDGIE_AUTOHIDE_POLICY_INTELLIGENT, "BUDGIE_AUTOHIDE_POLICY_INTELLIGENT", "intelligent"}, {0, NULL, NULL}};
		GType budgie_autohide_policy_type_id;
		budgie_autohide_policy_type_id = g_flags_register_static ("BudgieAutohidePolicy", values);
		g_once_init_leave (&budgie_autohide_policy_type_id__volatile, budgie_autohide_policy_type_id);
	}
	return budgie_autohide_policy_type_id__volatile;
}


gchar*
budgie_position_class_name (BudgiePanelPosition position)
{
	gchar* result = NULL;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
	switch (position) {
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_TOP:
#line 1363 "toplevel.c"
		{
			gchar* _tmp0_;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp0_ = g_strdup ("top");
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			result = _tmp0_;
#line 152 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			return result;
#line 1372 "toplevel.c"
		}
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1376 "toplevel.c"
		{
			gchar* _tmp1_;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp1_ = g_strdup ("bottom");
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			result = _tmp1_;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			return result;
#line 1385 "toplevel.c"
		}
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_LEFT:
#line 1389 "toplevel.c"
		{
			gchar* _tmp2_;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp2_ = g_strdup ("left");
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			result = _tmp2_;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			return result;
#line 1398 "toplevel.c"
		}
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
		case BUDGIE_PANEL_POSITION_RIGHT:
#line 1402 "toplevel.c"
		{
			gchar* _tmp3_;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp3_ = g_strdup ("right");
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			result = _tmp3_;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			return result;
#line 1411 "toplevel.c"
		}
		default:
		{
			gchar* _tmp4_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			_tmp4_ = g_strdup ("");
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			result = _tmp4_;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/lib/toplevel.vala"
			return result;
#line 1422 "toplevel.c"
		}
	}
}



