/* uuid.c generated by valac 0.40.19, the Vala compiler
 * generated from uuid.vala, do not modify */

/*
 * This file is part of budgie-desktop.
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <uuid.h>

typedef enum  {
	UUID_UUID_FLAGS_LOWER_CASE = 1 << 0,
	UUID_UUID_FLAGS_UPPER_CASE = 1 << 1,
	UUID_UUID_FLAGS_DEFAULT_CASE = 1 << 2,
	UUID_UUID_FLAGS_RANDOM_TYPE = 1 << 3,
	UUID_UUID_FLAGS_DEFAULT_TYPE = 1 << 4,
	UUID_UUID_FLAGS_TIME_TYPE = 1 << 5,
	UUID_UUID_FLAGS_TIME_SAFE_TYPE = 1 << 6
} LibUUIDUUIDFlags;


#define UUID_TYPE_UUID_FLAGS (uuid_uuid_flags_get_type ())



GType uuid_uuid_flags_get_type (void) G_GNUC_CONST;
gchar* uuid_new (LibUUIDUUIDFlags flags);


GType
uuid_uuid_flags_get_type (void)
{
	static volatile gsize uuid_uuid_flags_type_id__volatile = 0;
	if (g_once_init_enter (&uuid_uuid_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{UUID_UUID_FLAGS_LOWER_CASE, "UUID_UUID_FLAGS_LOWER_CASE", "lower-case"}, {UUID_UUID_FLAGS_UPPER_CASE, "UUID_UUID_FLAGS_UPPER_CASE", "upper-case"}, {UUID_UUID_FLAGS_DEFAULT_CASE, "UUID_UUID_FLAGS_DEFAULT_CASE", "default-case"}, {UUID_UUID_FLAGS_RANDOM_TYPE, "UUID_UUID_FLAGS_RANDOM_TYPE", "random-type"}, {UUID_UUID_FLAGS_DEFAULT_TYPE, "UUID_UUID_FLAGS_DEFAULT_TYPE", "default-type"}, {UUID_UUID_FLAGS_TIME_TYPE, "UUID_UUID_FLAGS_TIME_TYPE", "time-type"}, {UUID_UUID_FLAGS_TIME_SAFE_TYPE, "UUID_UUID_FLAGS_TIME_SAFE_TYPE", "time-safe-type"}, {0, NULL, NULL}};
		GType uuid_uuid_flags_type_id;
		uuid_uuid_flags_type_id = g_enum_register_static ("LibUUIDUUIDFlags", values);
		g_once_init_leave (&uuid_uuid_flags_type_id__volatile, uuid_uuid_flags_type_id);
	}
	return uuid_uuid_flags_type_id__volatile;
}


gchar*
uuid_new (LibUUIDUUIDFlags flags)
{
	gchar* result = NULL;
	guint8 time[16] = {0};
	gchar uuid[37] = {0};
	gchar* _tmp0_;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
	if ((flags & UUID_UUID_FLAGS_RANDOM_TYPE) != 0) {
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
		uuid_generate_random (time);
#line 67 "uuid.c"
	} else {
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
		if ((flags & UUID_UUID_FLAGS_TIME_TYPE) != 0) {
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
			uuid_generate_time (time);
#line 73 "uuid.c"
		} else {
#line 31 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
			if ((flags & UUID_UUID_FLAGS_TIME_SAFE_TYPE) != 0) {
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
				uuid_generate_time_safe (time);
#line 79 "uuid.c"
			} else {
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
				uuid_generate (time);
#line 83 "uuid.c"
			}
		}
	}
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
	if ((flags & UUID_UUID_FLAGS_UPPER_CASE) != 0) {
#line 38 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
		uuid_unparse_upper (time, uuid);
#line 91 "uuid.c"
	} else {
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
		if ((flags & UUID_UUID_FLAGS_LOWER_CASE) != 0) {
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
			uuid_unparse_lower (time, uuid);
#line 97 "uuid.c"
		} else {
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
			uuid_unparse (time, uuid);
#line 101 "uuid.c"
		}
	}
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
	_tmp0_ = g_strdup ((const gchar*) uuid);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
	result = _tmp0_;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/uuid.vala"
	return result;
#line 110 "uuid.c"
}



