/* app_sound_control.c generated by valac 0.40.19, the Vala compiler
 * generated from app_sound_control.vala, do not modify */

/*
 * This file is part of budgie-desktop
 * 
 * Copyright © 2015-2019 Budgie Desktop Developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <pulse/pulseaudio.h>
#include <gvc-mixer-stream.h>
#include <stdlib.h>
#include <string.h>
#include <gvc-mixer-control.h>
#include <gio/gdesktopappinfo.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>


#define BUDGIE_TYPE_APP_SOUND_CONTROL (budgie_app_sound_control_get_type ())
#define BUDGIE_APP_SOUND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl))
#define BUDGIE_APP_SOUND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControlClass))
#define BUDGIE_IS_APP_SOUND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_APP_SOUND_CONTROL))
#define BUDGIE_IS_APP_SOUND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_APP_SOUND_CONTROL))
#define BUDGIE_APP_SOUND_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControlClass))

typedef struct _BudgieAppSoundControl BudgieAppSoundControl;
typedef struct _BudgieAppSoundControlClass BudgieAppSoundControlClass;
typedef struct _BudgieAppSoundControlPrivate BudgieAppSoundControlPrivate;
enum  {
	BUDGIE_APP_SOUND_CONTROL_0_PROPERTY,
	BUDGIE_APP_SOUND_CONTROL_NUM_PROPERTIES
};
static GParamSpec* budgie_app_sound_control_properties[BUDGIE_APP_SOUND_CONTROL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _BudgieAppSoundControl {
	GtkBox parent_instance;
	BudgieAppSoundControlPrivate * priv;
	GvcMixerStream* primary_stream;
	GvcMixerStream* stream;
	gchar* app_name;
};

struct _BudgieAppSoundControlClass {
	GtkBoxClass parent_class;
};

struct _BudgieAppSoundControlPrivate {
	GvcMixerControl* mixer;
	GtkBox* app_info_header;
	GtkImage* app_image;
	GtkLabel* app_label;
	GtkButton* app_mute_button;
	GtkScale* volume_slider;
	gboolean manually_toggled_mute;
	gboolean is_pre_muted;
	guint32* volume;
	GtkImage* audio_not_muted;
	GtkImage* audio_muted;
	gulong scale_id;
};


static gpointer budgie_app_sound_control_parent_class = NULL;

GType budgie_app_sound_control_get_type (void) G_GNUC_CONST;
#define BUDGIE_APP_SOUND_CONTROL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControlPrivate))
BudgieAppSoundControl* budgie_app_sound_control_new (GvcMixerControl* c_mixer,
                                                     GvcMixerStream* c_primary,
                                                     GvcMixerStream* c_stream,
                                                     const gchar* c_icon,
                                                     const gchar* c_name);
BudgieAppSoundControl* budgie_app_sound_control_construct (GType object_type,
                                                           GvcMixerControl* c_mixer,
                                                           GvcMixerStream* c_primary,
                                                           GvcMixerStream* c_stream,
                                                           const gchar* c_icon,
                                                           const gchar* c_name);
gboolean budgie_app_sound_control_volume_at_mute_threshold (BudgieAppSoundControl* self);
void budgie_app_sound_control_set_mute_ui (BudgieAppSoundControl* self);
void budgie_app_sound_control_toggle_mute_state (BudgieAppSoundControl* self);
static void _budgie_app_sound_control_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
guint32 budgie_app_sound_control_get_base_volume (BudgieAppSoundControl* self);
static guint32* _uint32_dup (guint32* self);
void budgie_app_sound_control_on_slider_change (BudgieAppSoundControl* self);
static void _budgie_app_sound_control_on_slider_change_gtk_range_value_changed (GtkRange* _sender,
                                                                         gpointer self);
void budgie_app_sound_control_refresh (BudgieAppSoundControl* self);
void budgie_app_sound_control_refresh_volume (BudgieAppSoundControl* self);
static void budgie_app_sound_control_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return self ? g_object_ref (self) : NULL;
#line 114 "app_sound_control.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 137 "app_sound_control.c"
	} else {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 141 "app_sound_control.c"
	}
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 147 "app_sound_control.c"
	} else {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 151 "app_sound_control.c"
	}
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 155 "app_sound_control.c"
		gchar* _tmp2_;
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 163 "app_sound_control.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 191 "app_sound_control.c"
				goto __catch0_g_regex_error;
			}
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 200 "app_sound_control.c"
		}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 214 "app_sound_control.c"
				goto __catch0_g_regex_error;
			}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 223 "app_sound_control.c"
		}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 237 "app_sound_control.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error0_;
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1487 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 251 "app_sound_control.c"
	}
	__finally0:
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 262 "app_sound_control.c"
	}
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 287 "app_sound_control.c"
	} else {
		gchar* _tmp2_;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 296 "app_sound_control.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 317 "app_sound_control.c"
	} else {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 321 "app_sound_control.c"
	}
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 327 "app_sound_control.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 337 "app_sound_control.c"
	}
#line 1412 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 341 "app_sound_control.c"
		glong _tmp3_;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 349 "app_sound_control.c"
	} else {
		glong _tmp4_;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 356 "app_sound_control.c"
	}
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 360 "app_sound_control.c"
		glong _tmp5_;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 366 "app_sound_control.c"
	}
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 378 "app_sound_control.c"
}


static void
_budgie_app_sound_control_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_toggle_mute_state ((BudgieAppSoundControl*) self);
#line 388 "app_sound_control.c"
}


static guint32*
_uint32_dup (guint32* self)
{
	guint32* dup;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	dup = g_new0 (guint32, 1);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	memcpy (dup, self, sizeof (guint32));
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return dup;
#line 402 "app_sound_control.c"
}


static gpointer
__uint32_dup0 (gpointer self)
{
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return self ? _uint32_dup (self) : NULL;
#line 411 "app_sound_control.c"
}


static void
_budgie_app_sound_control_on_slider_change_gtk_range_value_changed (GtkRange* _sender,
                                                                    gpointer self)
{
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_on_slider_change ((BudgieAppSoundControl*) self);
#line 421 "app_sound_control.c"
}


BudgieAppSoundControl*
budgie_app_sound_control_construct (GType object_type,
                                    GvcMixerControl* c_mixer,
                                    GvcMixerStream* c_primary,
                                    GvcMixerStream* c_stream,
                                    const gchar* c_icon,
                                    const gchar* c_name)
{
	BudgieAppSoundControl * self = NULL;
	GvcMixerControl* _tmp0_;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp2_;
	gchar* _tmp3_;
	gchar* alsa_beg = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GDesktopAppInfo* info = NULL;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GDesktopAppInfo* _tmp18_;
	GDesktopAppInfo* _tmp19_;
	GDesktopAppInfo* _tmp20_;
	gchar* stream_name = NULL;
	GvcMixerStream* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	GtkIconTheme* current_theme = NULL;
	GtkIconTheme* _tmp32_;
	GtkIconTheme* _tmp33_;
	gchar* usable_icon_name = NULL;
	gchar* _tmp34_;
	GtkIconTheme* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp43_;
	GtkImage* _tmp53_;
	GtkImage* _tmp54_;
	GtkBox* app_info = NULL;
	GtkBox* _tmp55_;
	GtkBox* _tmp56_;
	const gchar* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkButton* _tmp63_;
	gboolean _tmp64_;
	GtkButton* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkButton* _tmp69_;
	GtkBox* _tmp70_;
	GtkLabel* _tmp71_;
	GtkBox* _tmp72_;
	GtkButton* _tmp73_;
	guint32 max_vol = 0U;
	guint32 stream_volume = 0U;
	GvcMixerStream* _tmp74_;
	guint32 max_vol_step = 0U;
	guint32 _tmp75_;
	guint32 _tmp76_;
	guint32 _tmp77_;
	GtkScale* _tmp78_;
	GtkScale* _tmp79_;
	GtkScale* _tmp80_;
	guint32 _tmp81_;
	guint32 _tmp82_;
	guint32 _tmp83_;
	guint32* _tmp84_;
	GtkScale* _tmp85_;
	guint32 _tmp86_;
	GtkScale* _tmp87_;
	gulong _tmp88_;
	GtkBox* _tmp89_;
	GtkBox* _tmp90_;
	GtkBox* _tmp91_;
	GtkScale* _tmp92_;
	const gchar* _tmp93_;
	GtkImage* _tmp94_;
	GtkImage* _tmp95_;
	GtkBox* _tmp98_;
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (c_mixer != NULL, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (c_primary != NULL, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (c_stream != NULL, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (c_icon != NULL, NULL);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (c_name != NULL, NULL);
#line 33 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self = (BudgieAppSoundControl*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, "margin", 10, NULL);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (c_mixer == NULL) {
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		return self;
#line 525 "app_sound_control.c"
	}
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (c_primary == NULL) {
#line 41 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		return self;
#line 531 "app_sound_control.c"
	}
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = _g_object_ref0 (c_mixer);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->mixer);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->mixer = _tmp0_;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = _g_object_ref0 (c_primary);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->primary_stream);
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->primary_stream = _tmp1_;
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp2_ = _g_object_ref0 (c_stream);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->stream);
#line 46 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->stream = _tmp2_;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp3_ = g_strdup (c_name);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->app_name);
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->app_name = _tmp3_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->is_pre_muted = budgie_app_sound_control_volume_at_mute_threshold (self);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp4_ = g_strdup ("ALSA plug-in [");
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	alsa_beg = _tmp4_;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp5_ = self->app_name;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp6_ = alsa_beg;
#line 58 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (g_str_has_prefix (_tmp5_, _tmp6_)) {
#line 569 "app_sound_control.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp7_ = self->app_name;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp8_ = alsa_beg;
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp9_ = string_replace (_tmp7_, _tmp8_, "");
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 59 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		self->app_name = _tmp9_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp10_ = self->app_name;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp11_ = self->app_name;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp12_ = strlen (_tmp11_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp13_ = _tmp12_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp14_ = string_substring (_tmp10_, (glong) 0, (glong) (_tmp13_ - 1));
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		self->app_name = _tmp14_;
#line 602 "app_sound_control.c"
	}
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp15_ = self->app_name;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp16_ = g_strconcat (_tmp15_, ".desktop", NULL);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp17_ = _tmp16_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp18_ = g_desktop_app_info_new (_tmp17_);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp19_ = _tmp18_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (_tmp17_);
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	info = _tmp19_;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp20_ = info;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp20_ != NULL) {
#line 622 "app_sound_control.c"
		gchar* desktop_app_name = NULL;
		GDesktopAppInfo* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gboolean _tmp24_ = FALSE;
		const gchar* _tmp25_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp21_ = info;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp22_ = g_desktop_app_info_get_string (_tmp21_, "Name");
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		desktop_app_name = _tmp23_;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp25_ = desktop_app_name;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		if (g_strcmp0 (_tmp25_, "") != 0) {
#line 641 "app_sound_control.c"
			const gchar* _tmp26_;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp26_ = desktop_app_name;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp24_ = _tmp26_ != NULL;
#line 647 "app_sound_control.c"
		} else {
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp24_ = FALSE;
#line 651 "app_sound_control.c"
		}
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		if (_tmp24_) {
#line 655 "app_sound_control.c"
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp27_ = desktop_app_name;
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp28_ = g_strdup (_tmp27_);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_g_free0 (self->app_name);
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			self->app_name = _tmp28_;
#line 666 "app_sound_control.c"
		}
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (desktop_app_name);
#line 670 "app_sound_control.c"
	}
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp29_ = self->stream;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp30_ = gvc_mixer_stream_get_name (_tmp29_);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	stream_name = _tmp31_;
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp32_ = gtk_icon_theme_get_default ();
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp33_ = _g_object_ref0 (_tmp32_);
#line 75 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	current_theme = _tmp33_;
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp34_ = g_strdup (c_icon);
#line 76 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	usable_icon_name = _tmp34_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp35_ = current_theme;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp36_ = self->app_name;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (gtk_icon_theme_has_icon (_tmp35_, _tmp36_)) {
#line 696 "app_sound_control.c"
		const gchar* _tmp37_;
		gchar* _tmp38_;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp37_ = self->app_name;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (usable_icon_name);
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		usable_icon_name = _tmp38_;
#line 707 "app_sound_control.c"
	} else {
		GtkIconTheme* _tmp39_;
		const gchar* _tmp40_;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp39_ = current_theme;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp40_ = stream_name;
#line 80 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		if (gtk_icon_theme_has_icon (_tmp39_, _tmp40_)) {
#line 717 "app_sound_control.c"
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp41_ = stream_name;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_g_free0 (usable_icon_name);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			usable_icon_name = _tmp42_;
#line 728 "app_sound_control.c"
		}
	}
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp43_ = usable_icon_name;
#line 84 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (g_strcmp0 (_tmp43_, "applications-multimedia") != 0) {
#line 735 "app_sound_control.c"
		const gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp44_ = self->app_name;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp45_ = string_substring (_tmp44_, (glong) 0, (glong) 1);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp46_ = _tmp45_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp47_ = g_ascii_strup (_tmp46_, (gssize) -1);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp48_ = _tmp47_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp49_ = self->app_name;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp50_ = string_substring (_tmp49_, (glong) 1, (glong) -1);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp51_ = _tmp50_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp52_ = g_strconcat (_tmp48_, _tmp51_, NULL);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		self->app_name = _tmp52_;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (_tmp51_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (_tmp48_);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (_tmp46_);
#line 773 "app_sound_control.c"
	}
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp53_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp53_);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_not_muted);
#line 91 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->audio_not_muted = _tmp53_;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp54_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp54_);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_muted);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->audio_muted = _tmp54_;
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp55_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp55_);
#line 94 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	app_info = _tmp55_;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp56_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp56_);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_info_header);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_info_header = _tmp56_;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp57_ = self->app_name;
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp58_ = (GtkLabel*) gtk_label_new (_tmp57_);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp58_);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_label);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_label = _tmp58_;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp59_ = self->priv->app_label;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_label_set_ellipsize (_tmp59_, PANGO_ELLIPSIZE_END);
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp60_ = self->priv->app_label;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp60_, GTK_ALIGN_START);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp61_ = self->priv->app_label;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_label_set_justify (_tmp61_, GTK_JUSTIFY_LEFT);
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp62_ = self->priv->app_label;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp62_, 10);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp63_ = (GtkButton*) gtk_button_new ();
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp63_);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_mute_button);
#line 103 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_mute_button = _tmp63_;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp64_ = self->priv->is_pre_muted;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp64_) {
#line 843 "app_sound_control.c"
		GvcMixerStream* _tmp65_;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp65_ = self->stream;
#line 106 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		if (gvc_mixer_stream_set_volume (_tmp65_, (guint32) 0)) {
#line 849 "app_sound_control.c"
			GvcMixerStream* _tmp66_;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp66_ = self->stream;
#line 107 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			gvc_mixer_stream_push_volume (_tmp66_);
#line 855 "app_sound_control.c"
		}
	}
#line 111 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp67_ = self->priv->app_mute_button;
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
#line 113 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_style_context_add_class (_tmp68_, "flat");
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp69_ = self->priv->app_mute_button;
#line 114 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_signal_connect_object (_tmp69_, "clicked", (GCallback) _budgie_app_sound_control_toggle_mute_state_gtk_button_clicked, self, 0);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp70_ = self->priv->app_info_header;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp71_ = self->priv->app_label;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_box_pack_start (_tmp70_, (GtkWidget*) _tmp71_, FALSE, TRUE, (guint) 0);
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp72_ = self->priv->app_info_header;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp73_ = self->priv->app_mute_button;
#line 117 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_box_pack_end (_tmp72_, (GtkWidget*) _tmp73_, FALSE, FALSE, (guint) 0);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	max_vol = budgie_app_sound_control_get_base_volume (self);
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp74_ = self->stream;
#line 120 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	stream_volume = gvc_mixer_stream_get_volume (_tmp74_);
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp75_ = max_vol;
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	max_vol_step = _tmp75_ / 20;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp76_ = max_vol;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp77_ = max_vol_step;
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp78_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) _tmp76_, (gdouble) _tmp77_);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp78_);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->volume_slider = _tmp78_;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp79_ = self->priv->volume_slider;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_scale_set_draw_value (_tmp79_, FALSE);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp80_ = self->priv->volume_slider;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp81_ = max_vol_step;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp82_ = max_vol_step;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_range_set_increments ((GtkRange*) _tmp80_, (gdouble) _tmp81_, (gdouble) _tmp82_);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp83_ = stream_volume;
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp84_ = __uint32_dup0 (&_tmp83_);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 127 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->volume = _tmp84_;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp85_ = self->priv->volume_slider;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp86_ = stream_volume;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_range_set_value ((GtkRange*) _tmp85_, (gdouble) _tmp86_);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp87_ = self->priv->volume_slider;
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp88_ = g_signal_connect_object ((GtkRange*) _tmp87_, "value-changed", (GCallback) _budgie_app_sound_control_on_slider_change_gtk_range_value_changed, self, 0);
#line 130 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->scale_id = _tmp88_;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp89_ = app_info;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp90_ = self->priv->app_info_header;
#line 132 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_box_pack_start (_tmp89_, (GtkWidget*) _tmp90_, TRUE, FALSE, (guint) 0);
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp91_ = app_info;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp92_ = self->priv->volume_slider;
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_box_pack_end (_tmp91_, (GtkWidget*) _tmp92_, TRUE, FALSE, (guint) 0);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp93_ = usable_icon_name;
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp94_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp93_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_object_ref_sink (_tmp94_);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_image);
#line 135 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_image = _tmp94_;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp95_ = self->priv->app_image;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp95_ != NULL) {
#line 962 "app_sound_control.c"
		GtkImage* _tmp96_;
		GtkImage* _tmp97_;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp96_ = self->priv->app_image;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp96_, 10);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp97_ = self->priv->app_image;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp97_, FALSE, FALSE, (guint) 0);
#line 973 "app_sound_control.c"
	}
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp98_ = app_info;
#line 142 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp98_, TRUE, TRUE, (guint) 0);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (app_info);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (usable_icon_name);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (current_theme);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (stream_name);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (info);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (alsa_beg);
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return self;
#line 993 "app_sound_control.c"
}


BudgieAppSoundControl*
budgie_app_sound_control_new (GvcMixerControl* c_mixer,
                              GvcMixerStream* c_primary,
                              GvcMixerStream* c_stream,
                              const gchar* c_icon,
                              const gchar* c_name)
{
#line 32 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return budgie_app_sound_control_construct (BUDGIE_TYPE_APP_SOUND_CONTROL, c_mixer, c_primary, c_stream, c_icon, c_name);
#line 1006 "app_sound_control.c"
}


/**
         * get_base_volume will get the recommended base volume based on the stream and primary device stream
         */
guint32
budgie_app_sound_control_get_base_volume (BudgieAppSoundControl* self)
{
	guint32 result = 0U;
	guint32 base_vol = 0U;
	GvcMixerStream* _tmp0_;
	guint32 primary_stream_vol = 0U;
	GvcMixerStream* _tmp1_;
	guint32 _tmp2_ = 0U;
	guint32 _tmp3_;
	guint32 _tmp4_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	base_vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = self->primary_stream;
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	primary_stream_vol = gvc_mixer_stream_get_base_volume (_tmp1_);
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp3_ = base_vol;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp4_ = primary_stream_vol;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp3_ < _tmp4_) {
#line 1040 "app_sound_control.c"
		guint32 _tmp5_;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp5_ = primary_stream_vol;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp2_ = _tmp5_;
#line 1046 "app_sound_control.c"
	} else {
		guint32 _tmp6_;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp6_ = base_vol;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp2_ = _tmp6_;
#line 1053 "app_sound_control.c"
	}
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	result = _tmp2_;
#line 151 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return result;
#line 1059 "app_sound_control.c"
}


/**
         * on_slider_change will handle when our volume_slider scale changes
         */
void
budgie_app_sound_control_on_slider_change (BudgieAppSoundControl* self)
{
	gdouble slider_value = 0.0;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	gulong _tmp2_;
	guint32 stream_vol = 0U;
	gdouble _tmp3_;
	guint32 _tmp4_;
	guint32* _tmp5_;
	gboolean _tmp6_;
	GtkScale* _tmp11_;
	gulong _tmp12_;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->priv->volume_slider;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	slider_value = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = self->priv->volume_slider;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp2_ = self->priv->scale_id;
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_signal_handler_block (_tmp1_, _tmp2_);
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp3_ = slider_value;
#line 161 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	stream_vol = (guint32) _tmp3_;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp4_ = stream_vol;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp5_ = __uint32_dup0 (&_tmp4_);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->volume = _tmp5_;
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp6_ = self->priv->manually_toggled_mute;
#line 165 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (!_tmp6_) {
#line 1108 "app_sound_control.c"
		GvcMixerStream* _tmp7_;
		guint32 _tmp8_;
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp7_ = self->stream;
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp8_ = stream_vol;
#line 166 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		if (gvc_mixer_stream_set_volume (_tmp7_, _tmp8_)) {
#line 1117 "app_sound_control.c"
			GvcMixerStream* _tmp9_;
			gboolean _tmp10_;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp9_ = self->stream;
#line 167 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			gvc_mixer_stream_push_volume (_tmp9_);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			_tmp10_ = self->priv->is_pre_muted;
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
			if (_tmp10_) {
#line 170 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
				self->priv->is_pre_muted = FALSE;
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
				budgie_app_sound_control_set_mute_ui (self);
#line 1132 "app_sound_control.c"
			}
		}
	}
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp11_ = self->priv->volume_slider;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp12_ = self->priv->scale_id;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_signal_handler_unblock (_tmp11_, _tmp12_);
#line 1142 "app_sound_control.c"
}


/**
         * refresh is responsible for performing UI refresh / updating
         */
void
budgie_app_sound_control_refresh (BudgieAppSoundControl* self)
{
	gchar* stream_name = NULL;
	GvcMixerStream* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = gvc_mixer_stream_get_name (_tmp0_);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 183 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	stream_name = _tmp2_;
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp3_ = self->app_name;
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp4_ = stream_name;
#line 185 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) != 0) {
#line 1174 "app_sound_control.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		const gchar* _tmp8_;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp5_ = stream_name;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_g_free0 (self->app_name);
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		self->app_name = _tmp6_;
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp7_ = self->priv->app_label;
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp8_ = stream_name;
#line 187 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_label_set_label (_tmp7_, _tmp8_);
#line 1193 "app_sound_control.c"
	}
#line 190 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_refresh_volume (self);
#line 182 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (stream_name);
#line 1199 "app_sound_control.c"
}


/**
         * refresh_volume is our function for updating the volume slider and mute UI
         */
void
budgie_app_sound_control_refresh_volume (BudgieAppSoundControl* self)
{
	guint32 vol = 0U;
	GvcMixerStream* _tmp0_;
	GtkScale* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp5_;
	guint32* _tmp6_;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 197 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = self->priv->volume_slider;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp2_ = vol;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp1_) != ((gdouble) _tmp2_)) {
#line 1227 "app_sound_control.c"
		GtkScale* _tmp3_;
		guint32 _tmp4_;
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp3_ = self->priv->volume_slider;
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp4_ = vol;
#line 200 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_range_set_value ((GtkRange*) _tmp3_, (gdouble) _tmp4_);
#line 1236 "app_sound_control.c"
	}
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp5_ = vol;
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp6_ = __uint32_dup0 (&_tmp5_);
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->volume = _tmp6_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->is_pre_muted = budgie_app_sound_control_volume_at_mute_threshold (self);
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 1250 "app_sound_control.c"
}


/**
         * set_mute_ui will set the image for the app_mute_button and change dim state of the input
         */
void
budgie_app_sound_control_set_mute_ui (BudgieAppSoundControl* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 211 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = self->priv->manually_toggled_mute;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp1_) {
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp0_ = TRUE;
#line 1270 "app_sound_control.c"
	} else {
		gboolean _tmp2_;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp2_ = self->priv->is_pre_muted;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp0_ = _tmp2_;
#line 1277 "app_sound_control.c"
	}
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp0_) {
#line 1281 "app_sound_control.c"
		GtkButton* _tmp3_;
		GtkImage* _tmp4_;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp3_ = self->priv->app_mute_button;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp4_ = self->priv->audio_muted;
#line 213 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp4_);
#line 1290 "app_sound_control.c"
	} else {
		GtkButton* _tmp5_;
		GtkImage* _tmp6_;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp5_ = self->priv->app_mute_button;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp6_ = self->priv->audio_not_muted;
#line 215 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
#line 1300 "app_sound_control.c"
	}
}


/**
         * toggle_mute_state will toggle the volume and internal muted state
         * This is done because gvc muted value change and tracking is fundamentally broken for apps
         */
void
budgie_app_sound_control_toggle_mute_state (BudgieAppSoundControl* self)
{
	gboolean _tmp0_;
	GtkScale* _tmp1_;
	gulong _tmp2_;
	gboolean _tmp3_;
	GvcMixerStream* _tmp7_;
	GtkScale* _tmp8_;
	gulong _tmp9_;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_if_fail (self != NULL);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->priv->manually_toggled_mute;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->manually_toggled_mute = !_tmp0_;
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp1_ = self->priv->volume_slider;
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp2_ = self->priv->scale_id;
#line 226 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_signal_handler_block (_tmp1_, _tmp2_);
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp3_ = self->priv->manually_toggled_mute;
#line 228 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	if (_tmp3_) {
#line 1335 "app_sound_control.c"
		GvcMixerStream* _tmp4_;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp4_ = self->stream;
#line 229 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gvc_mixer_stream_set_volume (_tmp4_, (guint32) 0);
#line 1341 "app_sound_control.c"
	} else {
		GvcMixerStream* _tmp5_;
		guint32* _tmp6_;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp5_ = self->stream;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		_tmp6_ = self->priv->volume;
#line 231 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
		gvc_mixer_stream_set_volume (_tmp5_, *_tmp6_);
#line 1351 "app_sound_control.c"
	}
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp7_ = self->stream;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	gvc_mixer_stream_push_volume (_tmp7_);
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_set_mute_ui (self);
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp8_ = self->priv->volume_slider;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp9_ = self->priv->scale_id;
#line 237 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_signal_handler_unblock (_tmp8_, _tmp9_);
#line 1365 "app_sound_control.c"
}


/**
         * volume_at_mute_threadshold will return if the stream volume is at a threshold that it should indicate it is muted
         */
gboolean
budgie_app_sound_control_volume_at_mute_threshold (BudgieAppSoundControl* self)
{
	gboolean result = FALSE;
	guint32 base_vol = 0U;
	guint32 stream_volume = 0U;
	GvcMixerStream* _tmp0_;
#line 243 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	base_vol = budgie_app_sound_control_get_base_volume (self);
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = self->stream;
#line 245 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	stream_volume = gvc_mixer_stream_get_volume (_tmp0_);
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	result = stream_volume <= (base_vol / 20);
#line 246 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	return result;
#line 1391 "app_sound_control.c"
}


static void
budgie_app_sound_control_class_init (BudgieAppSoundControlClass * klass)
{
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	budgie_app_sound_control_parent_class = g_type_class_peek_parent (klass);
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	g_type_class_add_private (klass, sizeof (BudgieAppSoundControlPrivate));
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_app_sound_control_finalize;
#line 1404 "app_sound_control.c"
}


static void
budgie_app_sound_control_instance_init (BudgieAppSoundControl * self)
{
	gchar* _tmp0_;
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv = BUDGIE_APP_SOUND_CONTROL_GET_PRIVATE (self);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->mixer = NULL;
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->primary_stream = NULL;
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->stream = NULL;
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_info_header = NULL;
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_image = NULL;
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_label = NULL;
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->app_mute_button = NULL;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->volume_slider = NULL;
#line 22 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->manually_toggled_mute = FALSE;
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->is_pre_muted = FALSE;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->audio_not_muted = NULL;
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->priv->audio_muted = NULL;
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_tmp0_ = g_strdup ("");
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self->app_name = _tmp0_;
#line 1442 "app_sound_control.c"
}


static void
budgie_app_sound_control_finalize (GObject * obj)
{
	BudgieAppSoundControl * self;
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl);
#line 14 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->mixer);
#line 15 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->primary_stream);
#line 16 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->stream);
#line 17 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_info_header);
#line 18 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_image);
#line 19 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_label);
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->app_mute_button);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->priv->volume);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_not_muted);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_object_unref0 (self->priv->audio_muted);
#line 29 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	_g_free0 (self->app_name);
#line 13 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/raven/app_sound_control.vala"
	G_OBJECT_CLASS (budgie_app_sound_control_parent_class)->finalize (obj);
#line 1478 "app_sound_control.c"
}


GType
budgie_app_sound_control_get_type (void)
{
	static volatile gsize budgie_app_sound_control_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_app_sound_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BudgieAppSoundControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_app_sound_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieAppSoundControl), 0, (GInstanceInitFunc) budgie_app_sound_control_instance_init, NULL };
		GType budgie_app_sound_control_type_id;
		budgie_app_sound_control_type_id = g_type_register_static (gtk_box_get_type (), "BudgieAppSoundControl", &g_define_type_info, 0);
		g_once_init_leave (&budgie_app_sound_control_type_id__volatile, budgie_app_sound_control_type_id);
	}
	return budgie_app_sound_control_type_id__volatile;
}



