/* ibus.c generated by valac 0.40.19, the Vala compiler
 * generated from ibus.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2016-2019 Budgie Desktop Developers
 * Copyright (C) GNOME Shell Developers (Heavy inspiration, logic theft)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <ibus.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define BUDGIE_TYPE_IBUS_MANAGER (budgie_ibus_manager_get_type ())
#define BUDGIE_IBUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManager))
#define BUDGIE_IBUS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManagerClass))
#define BUDGIE_IS_IBUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_IBUS_MANAGER))
#define BUDGIE_IS_IBUS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_IBUS_MANAGER))
#define BUDGIE_IBUS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManagerClass))

typedef struct _BudgieIBusManager BudgieIBusManager;
typedef struct _BudgieIBusManagerClass BudgieIBusManagerClass;
typedef struct _BudgieIBusManagerPrivate BudgieIBusManagerPrivate;

#define BUDGIE_TYPE_KEYBOARD_MANAGER (budgie_keyboard_manager_get_type ())
#define BUDGIE_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TYPE_KEYBOARD_MANAGER, BudgieKeyboardManager))
#define BUDGIE_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TYPE_KEYBOARD_MANAGER, BudgieKeyboardManagerClass))
#define BUDGIE_IS_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TYPE_KEYBOARD_MANAGER))
#define BUDGIE_IS_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TYPE_KEYBOARD_MANAGER))
#define BUDGIE_KEYBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TYPE_KEYBOARD_MANAGER, BudgieKeyboardManagerClass))

typedef struct _BudgieKeyboardManager BudgieKeyboardManager;
typedef struct _BudgieKeyboardManagerClass BudgieKeyboardManagerClass;
enum  {
	BUDGIE_IBUS_MANAGER_0_PROPERTY,
	BUDGIE_IBUS_MANAGER_KBM_PROPERTY,
	BUDGIE_IBUS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* budgie_ibus_manager_properties[BUDGIE_IBUS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	BUDGIE_IBUS_MANAGER_READY_SIGNAL,
	BUDGIE_IBUS_MANAGER_NUM_SIGNALS
};
static guint budgie_ibus_manager_signals[BUDGIE_IBUS_MANAGER_NUM_SIGNALS] = {0};

struct _BudgieIBusManager {
	GObject parent_instance;
	BudgieIBusManagerPrivate * priv;
};

struct _BudgieIBusManagerClass {
	GObjectClass parent_class;
};

struct _BudgieIBusManagerPrivate {
	IBusBus* bus;
	gboolean ibus_available;
	GHashTable* engines;
	BudgieKeyboardManager* _kbm;
	gboolean did_ibus_init;
};


static gpointer budgie_ibus_manager_parent_class = NULL;

GType budgie_ibus_manager_get_type (void) G_GNUC_CONST;
GType budgie_keyboard_manager_get_type (void) G_GNUC_CONST;
#define BUDGIE_IBUS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManagerPrivate))
#define BUDGIE_IBUS_MANAGER_ENGINE_SET_TIMEOUT 4000
BudgieIBusManager* budgie_ibus_manager_new (BudgieKeyboardManager* kbm);
BudgieIBusManager* budgie_ibus_manager_construct (GType object_type,
                                                  BudgieKeyboardManager* kbm);
void budgie_ibus_manager_do_init (BudgieIBusManager* self);
static void _g_free0_ (gpointer var);
static void budgie_ibus_manager_ibus_connected (BudgieIBusManager* self);
static void _budgie_ibus_manager_ibus_connected_ibus_bus_connected (IBusBus* _sender,
                                                             gpointer self);
static void budgie_ibus_manager_ibus_disconnected (BudgieIBusManager* self);
static void _budgie_ibus_manager_ibus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                                   gpointer self);
static void budgie_ibus_manager_startup_ibus (BudgieIBusManager* self);
static void budgie_ibus_manager_reset_ibus (BudgieIBusManager* self);
static void budgie_ibus_manager_on_engines_get (BudgieIBusManager* self,
                                         GObject* o,
                                         GAsyncResult* res);
static void _budgie_ibus_manager_on_engines_get_gasync_ready_callback (GObject* source_object,
                                                                GAsyncResult* res,
                                                                gpointer self);
IBusEngineDesc* budgie_ibus_manager_get_engine (BudgieIBusManager* self,
                                                const gchar* name);
void budgie_ibus_manager_set_engine (BudgieIBusManager* self,
                                     const gchar* name);
BudgieKeyboardManager* budgie_ibus_manager_get_kbm (BudgieIBusManager* self);
void budgie_keyboard_manager_release_keyboard (BudgieKeyboardManager* self);
static void __lambda14_ (BudgieIBusManager* self);
static void ___lambda14__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
void budgie_ibus_manager_set_kbm (BudgieIBusManager* self,
                                  BudgieKeyboardManager* value);
static void budgie_ibus_manager_finalize (GObject * obj);
static void _vala_budgie_ibus_manager_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_budgie_ibus_manager_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


/**
     * Construct a new IBusManager which will begin setting up the
     * ibus daemon, as well as registering events to connect to it
     * and monitor it.
     */
BudgieIBusManager*
budgie_ibus_manager_construct (GType object_type,
                               BudgieKeyboardManager* kbm)
{
	BudgieIBusManager * self = NULL;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self = (BudgieIBusManager*) g_object_new (object_type, "kbm", kbm, NULL);
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	return self;
#line 148 "ibus.c"
}


BudgieIBusManager*
budgie_ibus_manager_new (BudgieKeyboardManager* kbm)
{
#line 42 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	return budgie_ibus_manager_construct (BUDGIE_TYPE_IBUS_MANAGER, kbm);
#line 157 "ibus.c"
}


static void
_g_free0_ (gpointer var)
{
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	var = (g_free (var), NULL);
#line 166 "ibus.c"
}


static void
_budgie_ibus_manager_ibus_connected_ibus_bus_connected (IBusBus* _sender,
                                                        gpointer self)
{
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_ibus_connected ((BudgieIBusManager*) self);
#line 176 "ibus.c"
}


static void
_budgie_ibus_manager_ibus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                              gpointer self)
{
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_ibus_disconnected ((BudgieIBusManager*) self);
#line 186 "ibus.c"
}


void
budgie_ibus_manager_do_init (BudgieIBusManager* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	IBusBus* _tmp6_;
	IBusBus* _tmp7_;
	IBusBus* _tmp8_;
	IBusBus* _tmp9_;
	IBusBus* _tmp10_;
#line 47 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = g_find_program_in_path ("ibus-daemon");
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp1_ = _tmp0_;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp2_ = _tmp1_ == NULL;
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_free0 (_tmp1_);
#line 50 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (_tmp2_) {
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_message ("ibus.vala:51: ibus-daemon unsupported on this system");
#line 52 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		self->priv->ibus_available = FALSE;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_signal_emit (self, budgie_ibus_manager_signals[BUDGIE_IBUS_MANAGER_READY_SIGNAL], 0);
#line 54 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return;
#line 224 "ibus.c"
	}
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp3_ = g_str_hash;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_ = g_str_equal;
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, NULL);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_hash_table_unref0 (self->priv->engines);
#line 57 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->engines = _tmp5_;
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp6_ = ibus_bus_new ();
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_object_ref_sink (_tmp6_);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_object_unref0 (self->priv->bus);
#line 60 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->bus = _tmp6_;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp7_ = self->priv->bus;
#line 63 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_signal_connect_object (_tmp7_, "connected", (GCallback) _budgie_ibus_manager_ibus_connected_ibus_bus_connected, self, 0);
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp8_ = self->priv->bus;
#line 64 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_signal_connect_object (_tmp8_, "disconnected", (GCallback) _budgie_ibus_manager_ibus_disconnected_ibus_bus_disconnected, self, 0);
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp9_ = self->priv->bus;
#line 65 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	ibus_bus_set_watch_dbus_signal (_tmp9_, TRUE);
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp10_ = self->priv->bus;
#line 68 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (ibus_bus_is_connected (_tmp10_)) {
#line 69 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_ibus_manager_ibus_connected (self);
#line 262 "ibus.c"
	} else {
#line 72 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_ibus_manager_startup_ibus (self);
#line 266 "ibus.c"
	}
}


/**
     * Launch the daemon as a child process so that it dies when we die
     */
static void
budgie_ibus_manager_startup_ibus (BudgieIBusManager* self)
{
	gchar** cmdline = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint cmdline_length1;
	gint _cmdline_size_;
	GError* _inner_error0_ = NULL;
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = g_strdup ("ibus-daemon");
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp1_ = g_strdup ("--xim");
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp2_ = g_strdup ("--panel");
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp3_ = g_strdup ("disable");
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_[0] = _tmp0_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_[1] = _tmp1_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_[2] = _tmp2_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp4_[3] = _tmp3_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	cmdline = _tmp4_;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	cmdline_length1 = 4;
#line 81 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_cmdline_size_ = cmdline_length1;
#line 312 "ibus.c"
	{
		GSubprocess* _tmp5_;
		GSubprocess* _tmp6_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp5_ = g_subprocess_newv (cmdline, G_SUBPROCESS_FLAGS_NONE, &_inner_error0_);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp6_ = _tmp5_;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_g_object_unref0 (_tmp6_);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "ibus.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		e = _inner_error0_;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_inner_error0_ = NULL;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp7_ = e;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp8_ = _tmp7_->message;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_message ("ibus.vala:85: Failed to launch ibus: %s", _tmp8_);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		self->priv->ibus_available = FALSE;
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_g_error_free0 (e);
#line 348 "ibus.c"
	}
	__finally3:
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		cmdline = (_vala_array_free (cmdline, cmdline_length1, (GDestroyNotify) g_free), NULL);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_clear_error (&_inner_error0_);
#line 82 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return;
#line 361 "ibus.c"
	}
#line 79 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	cmdline = (_vala_array_free (cmdline, cmdline_length1, (GDestroyNotify) g_free), NULL);
#line 365 "ibus.c"
}


/**
     * Something on ibus changed so we'll reset our state
     */
static void
budgie_ibus_manager_reset_ibus (BudgieIBusManager* self)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 93 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = g_str_hash;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp1_ = g_str_equal;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, NULL);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_hash_table_unref0 (self->priv->engines);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->engines = _tmp2_;
#line 390 "ibus.c"
}


static void
budgie_ibus_manager_on_engines_get (BudgieIBusManager* self,
                                    GObject* o,
                                    GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 98 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 402 "ibus.c"
	{
		GList* engines = NULL;
		IBusBus* _tmp0_;
		GList* _tmp1_;
		GList* _tmp2_;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp0_ = self->priv->bus;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp1_ = ibus_bus_list_engines_async_finish (_tmp0_, res, &_inner_error0_);
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		engines = _tmp1_;
#line 101 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 416 "ibus.c"
			goto __catch4_g_error;
		}
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_ibus_manager_reset_ibus (self);
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp2_ = engines;
#line 423 "ibus.c"
		{
			GList* engine_collection = NULL;
			GList* engine_it = NULL;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
			engine_collection = _tmp2_;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
			for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 431 "ibus.c"
				IBusEngineDesc* engine = NULL;
#line 104 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
				engine = (IBusEngineDesc*) engine_it->data;
#line 435 "ibus.c"
				{
					GHashTable* _tmp3_;
					IBusEngineDesc* _tmp4_;
					const gchar* _tmp5_;
					gchar* _tmp6_;
					IBusEngineDesc* _tmp7_;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					_tmp3_ = self->priv->engines;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					_tmp4_ = engine;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					_tmp5_ = ibus_engine_desc_get_name (_tmp4_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					_tmp6_ = g_strdup (_tmp5_);
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					_tmp7_ = engine;
#line 105 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
					g_hash_table_insert (_tmp3_, _tmp6_, _tmp7_);
#line 454 "ibus.c"
				}
			}
		}
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		(engines == NULL) ? NULL : (engines = (g_list_free (engines), NULL));
#line 460 "ibus.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		e = _inner_error0_;
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_inner_error0_ = NULL;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp8_ = e;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp9_ = _tmp8_->message;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_message ("ibus.vala:108: Failed to get engines: %s", _tmp9_);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_ibus_manager_reset_ibus (self);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_g_error_free0 (e);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return;
#line 484 "ibus.c"
	}
	__finally4:
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_clear_error (&_inner_error0_);
#line 100 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return;
#line 495 "ibus.c"
	}
#line 112 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_signal_emit (self, budgie_ibus_manager_signals[BUDGIE_IBUS_MANAGER_READY_SIGNAL], 0);
#line 499 "ibus.c"
}


/**
     * We gained connection to the ibus daemon
     */
static void
_budgie_ibus_manager_on_engines_get_gasync_ready_callback (GObject* source_object,
                                                           GAsyncResult* res,
                                                           gpointer self)
{
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_on_engines_get ((BudgieIBusManager*) self, source_object, res);
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_object_unref (self);
#line 515 "ibus.c"
}


static void
budgie_ibus_manager_ibus_connected (BudgieIBusManager* self)
{
	gboolean _tmp0_;
	IBusBus* _tmp1_;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = self->priv->did_ibus_init;
#line 124 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (!_tmp0_) {
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		ibus_init ();
#line 126 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		self->priv->did_ibus_init = TRUE;
#line 534 "ibus.c"
	}
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp1_ = self->priv->bus;
#line 128 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	ibus_bus_list_engines_async (_tmp1_, -1, NULL, _budgie_ibus_manager_on_engines_get_gasync_ready_callback, g_object_ref (self));
#line 540 "ibus.c"
}


/**
     * Lost connection to ibus
     */
static void
budgie_ibus_manager_ibus_disconnected (BudgieIBusManager* self)
{
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 136 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_reset_ibus (self);
#line 554 "ibus.c"
}


/**
     * Attempt to grab the ibus engine for the given name if it
     * exists, or returns null
     */
IBusEngineDesc*
budgie_ibus_manager_get_engine (BudgieIBusManager* self,
                                const gchar* name)
{
	IBusEngineDesc* result = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 143 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = self->priv->engines;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (_tmp0_ == NULL) {
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		result = NULL;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return result;
#line 582 "ibus.c"
	}
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp1_ = self->priv->engines;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp2_ = g_hash_table_lookup (_tmp1_, name);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	result = (IBusEngineDesc*) _tmp2_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	return result;
#line 592 "ibus.c"
}


/**
     * Set the ibus engine to the specified engine name
     */
static void
__lambda14_ (BudgieIBusManager* self)
{
	BudgieKeyboardManager* _tmp0_;
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = self->priv->_kbm;
#line 164 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_keyboard_manager_release_keyboard (_tmp0_);
#line 607 "ibus.c"
}


static void
___lambda14__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	__lambda14_ ((BudgieIBusManager*) self);
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_object_unref (self);
#line 620 "ibus.c"
}


void
budgie_ibus_manager_set_engine (BudgieIBusManager* self,
                                const gchar* name)
{
	gboolean _tmp0_;
	IBusBus* _tmp2_;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (name != NULL);
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = self->priv->ibus_available;
#line 158 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (!_tmp0_) {
#line 638 "ibus.c"
		BudgieKeyboardManager* _tmp1_;
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		_tmp1_ = self->priv->_kbm;
#line 159 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_keyboard_manager_release_keyboard (_tmp1_);
#line 160 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		return;
#line 646 "ibus.c"
	}
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp2_ = self->priv->bus;
#line 163 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	ibus_bus_set_global_engine_async (_tmp2_, name, BUDGIE_IBUS_MANAGER_ENGINE_SET_TIMEOUT, NULL, ___lambda14__gasync_ready_callback, g_object_ref (self));
#line 652 "ibus.c"
}


BudgieKeyboardManager*
budgie_ibus_manager_get_kbm (BudgieIBusManager* self)
{
	BudgieKeyboardManager* result;
	BudgieKeyboardManager* _tmp0_;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_tmp0_ = self->priv->_kbm;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	return result;
#line 669 "ibus.c"
}


void
budgie_ibus_manager_set_kbm (BudgieIBusManager* self,
                             BudgieKeyboardManager* value)
{
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	if (budgie_ibus_manager_get_kbm (self) != value) {
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		self->priv->_kbm = value;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_ibus_manager_properties[BUDGIE_IBUS_MANAGER_KBM_PROPERTY]);
#line 685 "ibus.c"
	}
}


static void
budgie_ibus_manager_class_init (BudgieIBusManagerClass * klass)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_type_class_add_private (klass, sizeof (BudgieIBusManagerPrivate));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_ibus_manager_get_property;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_ibus_manager_set_property;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_ibus_manager_finalize;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_IBUS_MANAGER_KBM_PROPERTY, budgie_ibus_manager_properties[BUDGIE_IBUS_MANAGER_KBM_PROPERTY] = g_param_spec_object ("kbm", "kbm", "kbm", BUDGIE_TYPE_KEYBOARD_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 705 "ibus.c"
	/**
	     * Ensure that owning process knows we're up and running
	     */
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	budgie_ibus_manager_signals[BUDGIE_IBUS_MANAGER_READY_SIGNAL] = g_signal_new ("ready", BUDGIE_TYPE_IBUS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 711 "ibus.c"
}


static void
budgie_ibus_manager_instance_init (BudgieIBusManager * self)
{
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv = BUDGIE_IBUS_MANAGER_GET_PRIVATE (self);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->bus = NULL;
#line 24 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->ibus_available = TRUE;
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->engines = NULL;
#line 30 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self->priv->did_ibus_init = FALSE;
#line 728 "ibus.c"
}


static void
budgie_ibus_manager_finalize (GObject * obj)
{
	BudgieIBusManager * self;
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManager);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_object_unref0 (self->priv->bus);
#line 26 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	_g_hash_table_unref0 (self->priv->engines);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	G_OBJECT_CLASS (budgie_ibus_manager_parent_class)->finalize (obj);
#line 744 "ibus.c"
}


/**
 * IBusManager is responsible for interfacing with the ibus daemon
 * under Budgie Desktop, enabling extra input sources to be used
 * when using the ibus XIM daemon
 */
GType
budgie_ibus_manager_get_type (void)
{
	static volatile gsize budgie_ibus_manager_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_ibus_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BudgieIBusManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_ibus_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieIBusManager), 0, (GInstanceInitFunc) budgie_ibus_manager_instance_init, NULL };
		GType budgie_ibus_manager_type_id;
		budgie_ibus_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieIBusManager", &g_define_type_info, 0);
		g_once_init_leave (&budgie_ibus_manager_type_id__volatile, budgie_ibus_manager_type_id);
	}
	return budgie_ibus_manager_type_id__volatile;
}


static void
_vala_budgie_ibus_manager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BudgieIBusManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManager);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		case BUDGIE_IBUS_MANAGER_KBM_PROPERTY:
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		g_value_set_object (value, budgie_ibus_manager_get_kbm (self));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		break;
#line 783 "ibus.c"
		default:
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		break;
#line 789 "ibus.c"
	}
}


static void
_vala_budgie_ibus_manager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BudgieIBusManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_IBUS_MANAGER, BudgieIBusManager);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		case BUDGIE_IBUS_MANAGER_KBM_PROPERTY:
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		budgie_ibus_manager_set_kbm (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		break;
#line 810 "ibus.c"
		default:
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/wm/ibus.vala"
		break;
#line 816 "ibus.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



