/* themes.c generated by valac 0.40.19, the Vala compiler
 * generated from themes.vala, do not modify */

/*
 * This file is part of budgie-desktop
 * 
 * Copyright © 2015-2019 Budgie Desktop Developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

typedef enum  {
	THEME_TYPE_ICON_THEME,
	THEME_TYPE_GTK_THEME,
	THEME_TYPE_CURSOR_THEME
} ThemeType;


#define TYPE_THEME_TYPE (theme_type_get_type ())

#define TYPE_THEME_INFO (theme_info_get_type ())
#define THEME_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_INFO, ThemeInfo))
#define THEME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_INFO, ThemeInfoClass))
#define IS_THEME_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_INFO))
#define IS_THEME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_INFO))
#define THEME_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_INFO, ThemeInfoClass))

typedef struct _ThemeInfo ThemeInfo;
typedef struct _ThemeInfoClass ThemeInfoClass;
typedef struct _ThemeInfoPrivate ThemeInfoPrivate;
enum  {
	THEME_INFO_0_PROPERTY,
	THEME_INFO_NUM_PROPERTIES
};
static GParamSpec* theme_info_properties[THEME_INFO_NUM_PROPERTIES];

#define TYPE_THEME_SCANNER (theme_scanner_get_type ())
#define THEME_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_SCANNER, ThemeScanner))
#define THEME_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_SCANNER, ThemeScannerClass))
#define IS_THEME_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_SCANNER))
#define IS_THEME_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_SCANNER))
#define THEME_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_SCANNER, ThemeScannerClass))

typedef struct _ThemeScanner ThemeScanner;
typedef struct _ThemeScannerClass ThemeScannerClass;
typedef struct _ThemeScannerPrivate ThemeScannerPrivate;
enum  {
	THEME_SCANNER_0_PROPERTY,
	THEME_SCANNER_NUM_PROPERTIES
};
static GParamSpec* theme_scanner_properties[THEME_SCANNER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ThemeScannerScanThemesData ThemeScannerScanThemesData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ThemeScannerScanThemesDirData ThemeScannerScanThemesDirData;
typedef struct _ThemeScannerScanOneData ThemeScannerScanOneData;
typedef struct _ThemeScannerMaybeAddGtkThemeData ThemeScannerMaybeAddGtkThemeData;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _ThemeScannerMaybeAddIconThemeData ThemeScannerMaybeAddIconThemeData;
typedef struct _ThemeScannerMaybeAddCursorsData ThemeScannerMaybeAddCursorsData;
typedef struct _ThemeScannerMaybeAddIconsData ThemeScannerMaybeAddIconsData;

struct _ThemeInfo {
	GObject parent_instance;
	ThemeInfoPrivate * priv;
};

struct _ThemeInfoClass {
	GObjectClass parent_class;
};

struct _ThemeInfoPrivate {
	ThemeType theme_type;
	GList* paths;
};

struct _ThemeScanner {
	GObject parent_instance;
	ThemeScannerPrivate * priv;
};

struct _ThemeScannerClass {
	GObjectClass parent_class;
};

struct _ThemeScannerPrivate {
	gchar** xdg_paths;
	gint xdg_paths_length1;
	gint _xdg_paths_size_;
	gchar** gtk_theme_blacklist;
	gint gtk_theme_blacklist_length1;
	gint _gtk_theme_blacklist_size_;
	gchar** icon_theme_blacklist;
	gint icon_theme_blacklist_length1;
	gint _icon_theme_blacklist_size_;
	gchar** normal_suffixes;
	gint normal_suffixes_length1;
	gint _normal_suffixes_size_;
	gchar** legacy_suffixes;
	gint legacy_suffixes_length1;
	gint _legacy_suffixes_size_;
	gchar** gtk_theme_paths;
	gint gtk_theme_paths_length1;
	gint _gtk_theme_paths_size_;
	GHashTable* gtk_themes;
	GHashTable* cursor_themes;
	GHashTable* icon_themes;
};

struct _ThemeScannerScanThemesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** xdg_path_collection;
	gint xdg_path_collection_length1;
	gint _xdg_path_collection_size_;
	gint xdg_path_it;
	gchar* _tmp1_;
	gchar* xdg_path;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* home_dir;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
};

struct _ThemeScannerScanThemesDirData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* base_dir;
	gchar** suffixes;
	gint suffixes_length1;
	gchar** suffix_collection;
	gint suffix_collection_length1;
	gint _suffix_collection_size_;
	gint suffix_it;
	gchar* _tmp0_;
	gchar* suffix;
	gchar* full_path;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* f;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFileEnumerator* en;
	GFile* _tmp6_;
	GFileEnumerator* _tmp7_;
	GList* files;
	GFileEnumerator* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GList* file_collection;
	GList* file_it;
	GFileInfo* _tmp12_;
	GFileInfo* file;
	gchar* display_path;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* sep;
	gchar* _tmp16_;
	gchar* path;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GError* e;
	GError* _tmp24_;
	const gchar* _tmp25_;
	GError* _inner_error0_;
};

struct _ThemeScannerScanOneData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* path_type;
	gchar* full_path;
	gchar* display_name;
	gboolean gtk_theme;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** suffix_collection;
	gint suffix_collection_length1;
	gint _suffix_collection_size_;
	gint suffix_it;
	gchar* _tmp3_;
	gchar* suffix;
	gchar* path;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean added;
	const gchar* _tmp6_;
	gboolean _tmp7_;
};

struct _ThemeScannerMaybeAddGtkThemeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	gint index;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* blacklisted_item;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	ThemeInfo* info;
	GHashTable* _tmp11_;
	gconstpointer _tmp12_;
	ThemeInfo* _tmp13_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp14_;
	GHashTable* _tmp15_;
	gchar* _tmp16_;
	ThemeInfo* _tmp17_;
	ThemeInfo* _tmp18_;
	GHashTable* _tmp19_;
	gconstpointer _tmp20_;
	ThemeInfo* _tmp21_;
};

struct _ThemeScannerMaybeAddIconThemeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gchar* test_path;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean icon_theme;
	GKeyFile* f;
	GKeyFile* _tmp2_;
	GKeyFile* _tmp3_;
	const gchar* _tmp4_;
	GError* e;
	gboolean _tmp5_;
	GKeyFile* _tmp6_;
	GError* _vala1_e;
	gboolean _tmp7_;
	gchar* cursor_path;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_;
};

struct _ThemeScannerMaybeAddCursorsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	ThemeInfo* info;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	ThemeInfo* _tmp2_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	ThemeInfo* _tmp6_;
	ThemeInfo* _tmp7_;
	GHashTable* _tmp8_;
	gconstpointer _tmp9_;
	ThemeInfo* _tmp10_;
};

struct _ThemeScannerMaybeAddIconsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	gint index;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* blacklisted_item;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	ThemeInfo* info;
	GHashTable* _tmp11_;
	gconstpointer _tmp12_;
	ThemeInfo* _tmp13_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp14_;
	GHashTable* _tmp15_;
	gchar* _tmp16_;
	ThemeInfo* _tmp17_;
	ThemeInfo* _tmp18_;
	GHashTable* _tmp19_;
	gconstpointer _tmp20_;
	ThemeInfo* _tmp21_;
};


static gpointer theme_info_parent_class = NULL;
static gpointer theme_scanner_parent_class = NULL;

GType theme_type_get_type (void) G_GNUC_CONST;
GType theme_info_get_type (void) G_GNUC_CONST;
#define THEME_INFO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_THEME_INFO, ThemeInfoPrivate))
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
ThemeInfo* theme_info_new (ThemeType type);
ThemeInfo* theme_info_construct (GType object_type,
                                 ThemeType type);
gboolean theme_info_add_path (ThemeInfo* self,
                              const gchar* path);
gboolean theme_info_contains_path (ThemeInfo* self,
                                   const gchar* path);
static void theme_info_finalize (GObject * obj);
GType theme_scanner_get_type (void) G_GNUC_CONST;
#define THEME_SCANNER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_THEME_SCANNER, ThemeScannerPrivate))
ThemeScanner* theme_scanner_new (void);
ThemeScanner* theme_scanner_construct (GType object_type);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _g_object_unref0_ (gpointer var);
static void theme_scanner_scan_themes_data_free (gpointer _data);
static void theme_scanner_scan_themes_async_ready_wrapper (GObject *source_object,
                                                    GAsyncResult *res,
                                                    void *user_data);
void theme_scanner_scan_themes (ThemeScanner* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
void theme_scanner_scan_themes_finish (ThemeScanner* self,
                                       GAsyncResult* _res_);
static gboolean theme_scanner_scan_themes_co (ThemeScannerScanThemesData* _data_);
static void theme_scanner_scan_themes_dir (ThemeScanner* self,
                                    const gchar* base_dir,
                                    gchar** suffixes,
                                    int suffixes_length1,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void theme_scanner_scan_themes_dir_finish (ThemeScanner* self,
                                           GAsyncResult* _res_);
static void theme_scanner_scan_themes_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void theme_scanner_scan_themes_dir_data_free (gpointer _data);
static void theme_scanner_scan_themes_dir_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data);
static gboolean theme_scanner_scan_themes_dir_co (ThemeScannerScanThemesDirData* _data_);
static void theme_scanner_scan_themes_dir_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void theme_scanner_scan_one (ThemeScanner* self,
                             const gchar* path_type,
                             const gchar* full_path,
                             const gchar* display_name,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static void theme_scanner_scan_one_finish (ThemeScanner* self,
                                    GAsyncResult* _res_);
static void theme_scanner_scan_one_data_free (gpointer _data);
static void theme_scanner_scan_one_async_ready_wrapper (GObject *source_object,
                                                 GAsyncResult *res,
                                                 void *user_data);
static gboolean theme_scanner_scan_one_co (ThemeScannerScanOneData* _data_);
static void theme_scanner_maybe_add_gtk_theme (ThemeScanner* self,
                                        const gchar* path,
                                        const gchar* theme_name,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean theme_scanner_maybe_add_gtk_theme_finish (ThemeScanner* self,
                                                   GAsyncResult* _res_);
static void theme_scanner_scan_one_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static void theme_scanner_maybe_add_icon_theme (ThemeScanner* self,
                                         const gchar* path,
                                         const gchar* theme_name,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void theme_scanner_maybe_add_icon_theme_finish (ThemeScanner* self,
                                                GAsyncResult* _res_);
static void theme_scanner_maybe_add_gtk_theme_data_free (gpointer _data);
static void theme_scanner_maybe_add_gtk_theme_async_ready_wrapper (GObject *source_object,
                                                            GAsyncResult *res,
                                                            void *user_data);
static gboolean theme_scanner_maybe_add_gtk_theme_co (ThemeScannerMaybeAddGtkThemeData* _data_);
gchar** theme_scanner_get_gtk_themes (ThemeScanner* self,
                                      int* result_length1);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar** theme_scanner_get_cursor_themes (ThemeScanner* self,
                                         int* result_length1);
static void _vala_array_add7 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar** theme_scanner_get_icon_themes (ThemeScanner* self,
                                       int* result_length1);
static void _vala_array_add8 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void theme_scanner_maybe_add_icon_theme_data_free (gpointer _data);
static void theme_scanner_maybe_add_icon_theme_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
static gboolean theme_scanner_maybe_add_icon_theme_co (ThemeScannerMaybeAddIconThemeData* _data_);
static void theme_scanner_maybe_add_icons (ThemeScanner* self,
                                    const gchar* path,
                                    const gchar* theme_name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean theme_scanner_maybe_add_icons_finish (ThemeScanner* self,
                                               GAsyncResult* _res_);
static void theme_scanner_maybe_add_icon_theme_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void theme_scanner_maybe_add_cursors (ThemeScanner* self,
                                      const gchar* path,
                                      const gchar* theme_name,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean theme_scanner_maybe_add_cursors_finish (ThemeScanner* self,
                                                 GAsyncResult* _res_);
static void theme_scanner_maybe_add_cursors_data_free (gpointer _data);
static void theme_scanner_maybe_add_cursors_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
static gboolean theme_scanner_maybe_add_cursors_co (ThemeScannerMaybeAddCursorsData* _data_);
static void theme_scanner_maybe_add_icons_data_free (gpointer _data);
static void theme_scanner_maybe_add_icons_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data);
static gboolean theme_scanner_maybe_add_icons_co (ThemeScannerMaybeAddIconsData* _data_);
static void theme_scanner_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType
theme_type_get_type (void)
{
	static volatile gsize theme_type_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_type_id__volatile)) {
		static const GEnumValue values[] = {{THEME_TYPE_ICON_THEME, "THEME_TYPE_ICON_THEME", "icon-theme"}, {THEME_TYPE_GTK_THEME, "THEME_TYPE_GTK_THEME", "gtk-theme"}, {THEME_TYPE_CURSOR_THEME, "THEME_TYPE_CURSOR_THEME", "cursor-theme"}, {0, NULL, NULL}};
		GType theme_type_type_id;
		theme_type_type_id = g_enum_register_static ("ThemeType", values);
		g_once_init_leave (&theme_type_type_id__volatile, theme_type_type_id);
	}
	return theme_type_type_id__volatile;
}


static void
_g_free0_ (gpointer var)
{
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	var = (g_free (var), NULL);
#line 553 "themes.c"
}


static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 562 "themes.c"
}


ThemeInfo*
theme_info_construct (GType object_type,
                      ThemeType type)
{
	ThemeInfo * self = NULL;
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self = (ThemeInfo*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->theme_type = type;
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(self->priv->paths == NULL) ? NULL : (self->priv->paths = (_g_list_free__g_free0_ (self->priv->paths), NULL));
#line 28 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->paths = NULL;
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return self;
#line 581 "themes.c"
}


ThemeInfo*
theme_info_new (ThemeType type)
{
#line 25 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return theme_info_construct (TYPE_THEME_INFO, type);
#line 590 "themes.c"
}


/**
     * Try to add a path
     */
gboolean
theme_info_add_path (ThemeInfo* self,
                     const gchar* path)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 36 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (theme_info_contains_path (self, path)) {
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		result = FALSE;
#line 37 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return result;
#line 613 "themes.c"
	}
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_strdup (path);
#line 39 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->paths = g_list_append (self->priv->paths, _tmp0_);
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = TRUE;
#line 40 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 623 "themes.c"
}


gboolean
theme_info_contains_path (ThemeInfo* self,
                          const gchar* path)
{
	gboolean result = FALSE;
	GList* g = NULL;
	GList* _tmp0_;
	GCompareFunc _tmp1_;
	GList* _tmp2_;
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = self->priv->paths;
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = ((GCompareFunc) g_strcmp0);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_list_find_custom (_tmp0_, path, _tmp1_);
#line 44 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g = _tmp2_;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = g != NULL;
#line 45 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 652 "themes.c"
}


static void
theme_info_class_init (ThemeInfoClass * klass)
{
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_info_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_type_class_add_private (klass, sizeof (ThemeInfoPrivate));
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_info_finalize;
#line 665 "themes.c"
}


static void
theme_info_instance_init (ThemeInfo * self)
{
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv = THEME_INFO_GET_PRIVATE (self);
#line 674 "themes.c"
}


static void
theme_info_finalize (GObject * obj)
{
	ThemeInfo * self;
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_INFO, ThemeInfo);
#line 23 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(self->priv->paths == NULL) ? NULL : (self->priv->paths = (_g_list_free__g_free0_ (self->priv->paths), NULL));
#line 20 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	G_OBJECT_CLASS (theme_info_parent_class)->finalize (obj);
#line 688 "themes.c"
}


GType
theme_info_get_type (void)
{
	static volatile gsize theme_info_type_id__volatile = 0;
	if (g_once_init_enter (&theme_info_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeInfo), 0, (GInstanceInitFunc) theme_info_instance_init, NULL };
		GType theme_info_type_id;
		theme_info_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeInfo", &g_define_type_info, 0);
		g_once_init_leave (&theme_info_type_id__volatile, theme_info_type_id);
	}
	return theme_info_type_id__volatile;
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	for (i = 0; i < stack_length; i++) {
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			return TRUE;
#line 718 "themes.c"
		}
	}
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 723 "themes.c"
}


static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 739 "themes.c"
	}
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 745 "themes.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 754 "themes.c"
}


ThemeScanner*
theme_scanner_construct (GType object_type)
{
	ThemeScanner * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	GHashFunc _tmp14_;
	GEqualFunc _tmp15_;
	GHashTable* _tmp16_;
	GHashFunc _tmp17_;
	GEqualFunc _tmp18_;
	GHashTable* _tmp19_;
	GHashFunc _tmp20_;
	GEqualFunc _tmp21_;
	GHashTable* _tmp22_;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self = (ThemeScanner*) g_object_new (object_type, NULL);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_[0] = _tmp1_;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths = (_vala_array_free (self->priv->xdg_paths, self->priv->xdg_paths_length1, (GDestroyNotify) g_free), NULL);
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths = _tmp2_;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths_length1 = 1;
#line 92 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_xdg_paths_size_ = self->priv->xdg_paths_length1;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp4_ = _tmp3_ = g_get_system_data_dirs ();
#line 799 "themes.c"
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		item_collection = _tmp4_;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		item_collection_length1 = _vala_array_length (_tmp3_);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 811 "themes.c"
			gchar* _tmp5_;
			gchar* item = NULL;
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_tmp5_ = g_strdup (item_collection[item_it]);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			item = _tmp5_;
#line 818 "themes.c"
			{
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp6_ = item;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp7_ = self->priv->xdg_paths;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp7__length1 = self->priv->xdg_paths_length1;
#line 96 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (_vala_string_array_contains (_tmp7_, _tmp7__length1, _tmp6_)) {
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (item);
#line 97 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					continue;
#line 839 "themes.c"
				}
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp8_ = self->priv->xdg_paths;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp8__length1 = self->priv->xdg_paths_length1;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp9_ = item;
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 99 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_vala_array_add5 (&self->priv->xdg_paths, &self->priv->xdg_paths_length1, &self->priv->_xdg_paths_size_, _tmp10_);
#line 95 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_g_free0 (item);
#line 853 "themes.c"
			}
		}
	}
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp11_ = g_strdup_printf ("gtk-%d.0", GTK_MAJOR_VERSION);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp12_ = g_strdup_printf ("gtk-%d-%d", GTK_MAJOR_VERSION, GTK_MINOR_VERSION);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp13_[0] = _tmp11_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp13_[1] = _tmp12_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = (_vala_array_free (self->priv->gtk_theme_paths, self->priv->gtk_theme_paths_length1, (GDestroyNotify) g_free), NULL);
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = _tmp13_;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths_length1 = 2;
#line 102 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_gtk_theme_paths_size_ = self->priv->gtk_theme_paths_length1;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp14_ = g_str_hash;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_ = g_str_equal;
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp16_ = g_hash_table_new_full (_tmp14_, _tmp15_, _g_free0_, _g_object_unref0_);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->gtk_themes);
#line 108 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_themes = _tmp16_;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp17_ = g_str_hash;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp18_ = g_str_equal;
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp19_ = g_hash_table_new_full (_tmp17_, _tmp18_, _g_free0_, _g_object_unref0_);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->cursor_themes);
#line 109 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->cursor_themes = _tmp19_;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp20_ = g_str_hash;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp21_ = g_str_equal;
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp22_ = g_hash_table_new_full (_tmp20_, _tmp21_, _g_free0_, _g_object_unref0_);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->icon_themes);
#line 110 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->icon_themes = _tmp22_;
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return self;
#line 907 "themes.c"
}


ThemeScanner*
theme_scanner_new (void)
{
#line 89 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return theme_scanner_construct (TYPE_THEME_SCANNER);
#line 916 "themes.c"
}


static void
theme_scanner_scan_themes_data_free (gpointer _data)
{
	ThemeScannerScanThemesData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanThemesData, _data_);
#line 929 "themes.c"
}


static void
theme_scanner_scan_themes_async_ready_wrapper (GObject *source_object,
                                               GAsyncResult *res,
                                               void *user_data)
{
	ThemeScannerScanThemesData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 945 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 949 "themes.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return self ? g_object_ref (self) : NULL;
#line 958 "themes.c"
}


void
theme_scanner_scan_themes (ThemeScanner* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	ThemeScannerScanThemesData* _data_;
	ThemeScanner* _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanThemesData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_scan_themes_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 979 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_themes_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_co (_data_);
#line 989 "themes.c"
}


void
theme_scanner_scan_themes_finish (ThemeScanner* self,
                                  GAsyncResult* _res_)
{
	ThemeScannerScanThemesData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1000 "themes.c"
}


/**
     * Scan all theme types
     */
static void
theme_scanner_scan_themes_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	ThemeScannerScanThemesData* _data_;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_task_complete_ = TRUE;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_co (_data_);
#line 1023 "themes.c"
}


static gboolean
theme_scanner_scan_themes_co (ThemeScannerScanThemesData* _data_)
{
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 1034 "themes.c"
		goto _state_0;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 1:
#line 1038 "themes.c"
		goto _state_1;
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 2:
#line 1042 "themes.c"
		goto _state_2;
		default:
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1047 "themes.c"
	}
	_state_0:
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp0_ = _data_->self->priv->xdg_paths;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp0__length1 = _data_->self->priv->xdg_paths_length1;
#line 1054 "themes.c"
	{
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->xdg_path_collection_length1 = 0;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_xdg_path_collection_size_ = 0;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->xdg_path_collection = _data_->_tmp0_;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->xdg_path_collection_length1 = _data_->_tmp0__length1;
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		for (_data_->xdg_path_it = 0; _data_->xdg_path_it < _data_->xdg_path_collection_length1; _data_->xdg_path_it = _data_->xdg_path_it + 1) {
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->_tmp1_ = g_strdup (_data_->xdg_path_collection[_data_->xdg_path_it]);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->xdg_path = _data_->_tmp1_;
#line 1070 "themes.c"
			{
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->xdg_path;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->normal_suffixes;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->normal_suffixes_length1;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_state_ = 1;
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				theme_scanner_scan_themes_dir (_data_->self, _data_->_tmp2_, _data_->_tmp3_, _data_->_tmp3__length1, theme_scanner_scan_themes_ready, _data_);
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				return FALSE;
#line 1084 "themes.c"
				_state_1:
#line 119 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				theme_scanner_scan_themes_dir_finish (_data_->self, _data_->_res_);
#line 118 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_g_free0 (_data_->xdg_path);
#line 1090 "themes.c"
			}
		}
	}
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp4_ = g_get_home_dir ();
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 121 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->home_dir = _data_->_tmp5_;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp7_ = _data_->home_dir;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp7_ == NULL) {
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp6_ = TRUE;
#line 1106 "themes.c"
	} else {
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp8_ = _data_->home_dir;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp9_ = strlen (_data_->_tmp8_);
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->_tmp10_ < 1;
#line 1116 "themes.c"
	}
#line 122 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp6_) {
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_free0 (_data_->home_dir);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1130 "themes.c"
			}
		}
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 123 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 1137 "themes.c"
	}
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->home_dir;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp12_ = _data_->self->priv->legacy_suffixes;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp12__length1 = _data_->self->priv->legacy_suffixes_length1;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_state_ = 2;
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir (_data_->self, _data_->_tmp11_, _data_->_tmp12_, _data_->_tmp12__length1, theme_scanner_scan_themes_ready, _data_);
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 1151 "themes.c"
	_state_2:
#line 125 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_finish (_data_->self, _data_->_res_);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->home_dir);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1165 "themes.c"
		}
	}
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 116 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 1172 "themes.c"
}


static void
theme_scanner_scan_themes_dir_data_free (gpointer _data)
{
	ThemeScannerScanThemesDirData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->base_dir);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanThemesDirData, _data_);
#line 1187 "themes.c"
}


static void
theme_scanner_scan_themes_dir_async_ready_wrapper (GObject *source_object,
                                                   GAsyncResult *res,
                                                   void *user_data)
{
	ThemeScannerScanThemesDirData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1203 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1207 "themes.c"
}


static void
theme_scanner_scan_themes_dir (ThemeScanner* self,
                               const gchar* base_dir,
                               gchar** suffixes,
                               int suffixes_length1,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ThemeScannerScanThemesDirData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanThemesDirData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_scan_themes_dir_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 1232 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_themes_dir_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (base_dir);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->base_dir);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->base_dir = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->suffixes = suffixes;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->suffixes_length1 = suffixes_length1;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_co (_data_);
#line 1252 "themes.c"
}


static void
theme_scanner_scan_themes_dir_finish (ThemeScanner* self,
                                      GAsyncResult* _res_)
{
	ThemeScannerScanThemesDirData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1263 "themes.c"
}


/**
     * Scan a directory for all theme types
     */
static void
theme_scanner_scan_themes_dir_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ThemeScannerScanThemesDirData* _data_;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_task_complete_ = TRUE;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_co (_data_);
#line 1286 "themes.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1295 "themes.c"
}


static gboolean
theme_scanner_scan_themes_dir_co (ThemeScannerScanThemesDirData* _data_)
{
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 1306 "themes.c"
		goto _state_0;
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 1:
#line 1310 "themes.c"
		goto _state_1;
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 2:
#line 1314 "themes.c"
		goto _state_2;
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 3:
#line 1318 "themes.c"
		goto _state_3;
		default:
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1323 "themes.c"
	}
	_state_0:
#line 133 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (!g_file_test (_data_->base_dir, G_FILE_TEST_IS_DIR)) {
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1336 "themes.c"
			}
		}
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 134 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 1343 "themes.c"
	}
	{
		{
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = 0;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->_suffix_collection_size_ = 0;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection = _data_->suffixes;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = _data_->suffixes_length1;
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			for (_data_->suffix_it = 0; _data_->suffix_it < _data_->suffix_collection_length1; _data_->suffix_it = _data_->suffix_it + 1) {
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp0_ = g_strdup (_data_->suffix_collection[_data_->suffix_it]);
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->suffix = _data_->_tmp0_;
#line 1361 "themes.c"
				{
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->suffix;
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp2_ = g_strdup_printf ("%s%s%s", _data_->base_dir, G_DIR_SEPARATOR_S, _data_->_tmp1_);
#line 139 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->full_path = _data_->_tmp2_;
#line 140 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp3_ = _data_->full_path;
#line 140 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					if (!g_file_test (_data_->_tmp3_, G_FILE_TEST_IS_DIR)) {
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->full_path);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 141 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						continue;
#line 1379 "themes.c"
					}
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp4_ = _data_->full_path;
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp5_ = g_file_new_for_path (_data_->_tmp4_);
#line 145 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->f = _data_->_tmp5_;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp6_ = _data_->f;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_state_ = 1;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					g_file_enumerate_children_async (_data_->_tmp6_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, G_PRIORITY_DEFAULT, NULL, theme_scanner_scan_themes_dir_ready, _data_);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					return FALSE;
#line 1395 "themes.c"
					_state_1:
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp7_ = g_file_enumerate_children_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->en = _data_->_tmp7_;
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_object_unref0 (_data_->f);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->full_path);
#line 146 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 1409 "themes.c"
						goto __catch20_g_error;
					}
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					while (TRUE) {
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->_tmp8_ = _data_->en;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->_state_ = 2;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						g_file_enumerator_next_files_async (_data_->_tmp8_, 10, G_PRIORITY_DEFAULT, NULL, theme_scanner_scan_themes_dir_ready, _data_);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						return FALSE;
#line 1422 "themes.c"
						_state_2:
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->_tmp9_ = g_file_enumerator_next_files_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->files = _data_->_tmp9_;
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							_g_object_unref0 (_data_->en);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							_g_object_unref0 (_data_->f);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							_g_free0 (_data_->full_path);
#line 148 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							_g_free0 (_data_->suffix);
#line 1438 "themes.c"
							goto __catch20_g_error;
						}
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->_tmp10_ = _data_->files;
#line 149 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						if (_data_->_tmp10_ == NULL) {
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							(_data_->files == NULL) ? NULL : (_data_->files = (_g_list_free__g_object_unref0_ (_data_->files), NULL));
#line 150 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							break;
#line 1449 "themes.c"
						}
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_data_->_tmp11_ = _data_->files;
#line 1453 "themes.c"
						{
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							_data_->file_collection = _data_->_tmp11_;
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							for (_data_->file_it = _data_->file_collection; _data_->file_it != NULL; _data_->file_it = _data_->file_it->next) {
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
								_data_->_tmp12_ = _g_object_ref0 ((GFileInfo*) _data_->file_it->data);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
								_data_->file = _data_->_tmp12_;
#line 1463 "themes.c"
								{
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp13_ = _data_->file;
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp14_ = g_file_info_get_display_name (_data_->_tmp13_);
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
#line 154 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->display_path = _data_->_tmp15_;
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp16_ = g_strdup (G_DIR_SEPARATOR_S);
#line 155 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->sep = _data_->_tmp16_;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp17_ = _data_->full_path;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp18_ = _data_->sep;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp19_ = _data_->display_path;
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp20_ = g_strdup_printf ("%s%s%s", _data_->_tmp17_, _data_->_tmp18_, _data_->_tmp19_);
#line 156 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->path = _data_->_tmp20_;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp21_ = _data_->suffix;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp22_ = _data_->path;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_tmp23_ = _data_->display_path;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_data_->_state_ = 3;
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									theme_scanner_scan_one (_data_->self, _data_->_tmp21_, _data_->_tmp22_, _data_->_tmp23_, theme_scanner_scan_themes_dir_ready, _data_);
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									return FALSE;
#line 1499 "themes.c"
									_state_3:
#line 157 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									theme_scanner_scan_one_finish (_data_->self, _data_->_res_);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_g_free0 (_data_->path);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_g_free0 (_data_->sep);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_g_free0 (_data_->display_path);
#line 153 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
									_g_object_unref0 (_data_->file);
#line 1511 "themes.c"
								}
							}
						}
#line 147 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						(_data_->files == NULL) ? NULL : (_data_->files = (_g_list_free__g_object_unref0_ (_data_->files), NULL));
#line 1517 "themes.c"
					}
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_object_unref0 (_data_->en);
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_object_unref0 (_data_->f);
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->full_path);
#line 138 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->suffix);
#line 1527 "themes.c"
				}
			}
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->e = _data_->_inner_error0_;
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_inner_error0_ = NULL;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp24_ = _data_->e;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 162 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_message ("themes.vala:162: Error in scan_themes_dir: %s\n", _data_->_tmp25_);
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_error_free0 (_data_->e);
#line 1547 "themes.c"
	}
	__finally20:
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 137 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 1560 "themes.c"
	}
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1570 "themes.c"
		}
	}
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 131 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 1577 "themes.c"
}


static void
theme_scanner_scan_one_data_free (gpointer _data)
{
	ThemeScannerScanOneData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path_type);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->full_path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->display_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanOneData, _data_);
#line 1596 "themes.c"
}


static void
theme_scanner_scan_one_async_ready_wrapper (GObject *source_object,
                                            GAsyncResult *res,
                                            void *user_data)
{
	ThemeScannerScanOneData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1612 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1616 "themes.c"
}


static void
theme_scanner_scan_one (ThemeScanner* self,
                        const gchar* path_type,
                        const gchar* full_path,
                        const gchar* display_name,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ThemeScannerScanOneData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanOneData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_scan_one_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 1643 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_one_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path_type);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path_type);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->path_type = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (full_path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->full_path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->full_path = _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp3_ = g_strdup (display_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->display_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->display_name = _tmp3_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_one_co (_data_);
#line 1671 "themes.c"
}


static void
theme_scanner_scan_one_finish (ThemeScanner* self,
                               GAsyncResult* _res_)
{
	ThemeScannerScanOneData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1682 "themes.c"
}


/**
     * Scan one directory with the given type, i.e. "icons", or "themes"
     */
static void
theme_scanner_scan_one_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ThemeScannerScanOneData* _data_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_task_complete_ = TRUE;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_scan_one_co (_data_);
#line 1705 "themes.c"
}


static gboolean
theme_scanner_scan_one_co (ThemeScannerScanOneData* _data_)
{
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 1716 "themes.c"
		goto _state_0;
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 1:
#line 1720 "themes.c"
		goto _state_1;
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 2:
#line 1724 "themes.c"
		goto _state_2;
		default:
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1729 "themes.c"
	}
	_state_0:
#line 171 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->gtk_theme = FALSE;
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (g_strcmp0 (_data_->path_type, "themes") == 0) {
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp0_ = TRUE;
#line 1738 "themes.c"
	} else {
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp0_ = g_strcmp0 (_data_->path_type, ".themes") == 0;
#line 1742 "themes.c"
	}
#line 172 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp0_) {
#line 173 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->gtk_theme = TRUE;
#line 1748 "themes.c"
	}
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp1_ = _data_->gtk_theme;
#line 176 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp1_) {
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp2_ = _data_->self->priv->gtk_theme_paths;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp2__length1 = _data_->self->priv->gtk_theme_paths_length1;
#line 1758 "themes.c"
		{
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = 0;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->_suffix_collection_size_ = 0;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection = _data_->_tmp2_;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = _data_->_tmp2__length1;
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			for (_data_->suffix_it = 0; _data_->suffix_it < _data_->suffix_collection_length1; _data_->suffix_it = _data_->suffix_it + 1) {
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3_ = g_strdup (_data_->suffix_collection[_data_->suffix_it]);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->suffix = _data_->_tmp3_;
#line 1774 "themes.c"
				{
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp4_ = _data_->suffix;
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp5_ = g_strdup_printf ("%s%s%s", _data_->full_path, G_DIR_SEPARATOR_S, _data_->_tmp4_);
#line 178 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->path = _data_->_tmp5_;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp6_ = _data_->path;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_state_ = 1;
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					theme_scanner_maybe_add_gtk_theme (_data_->self, _data_->_tmp6_, _data_->display_name, theme_scanner_scan_one_ready, _data_);
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					return FALSE;
#line 1790 "themes.c"
					_state_1:
#line 179 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->added = theme_scanner_maybe_add_gtk_theme_finish (_data_->self, _data_->_res_);
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp7_ = _data_->added;
#line 180 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					if (_data_->_tmp7_) {
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->path);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						if (_data_->_state_ != 0) {
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							while (!_data_->_task_complete_) {
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1810 "themes.c"
							}
						}
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						g_object_unref (_data_->_async_result);
#line 181 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						return FALSE;
#line 1817 "themes.c"
					}
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->path);
#line 177 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->suffix);
#line 1823 "themes.c"
				}
			}
		}
	} else {
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_state_ = 2;
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icon_theme (_data_->self, _data_->full_path, _data_->display_name, theme_scanner_scan_one_ready, _data_);
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 1834 "themes.c"
		_state_2:
#line 186 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icon_theme_finish (_data_->self, _data_->_res_);
#line 1838 "themes.c"
	}
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1848 "themes.c"
		}
	}
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 169 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 1855 "themes.c"
}


static void
theme_scanner_maybe_add_gtk_theme_data_free (gpointer _data)
{
	ThemeScannerMaybeAddGtkThemeData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddGtkThemeData, _data_);
#line 1872 "themes.c"
}


static void
theme_scanner_maybe_add_gtk_theme_async_ready_wrapper (GObject *source_object,
                                                       GAsyncResult *res,
                                                       void *user_data)
{
	ThemeScannerMaybeAddGtkThemeData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1888 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1892 "themes.c"
}


static void
theme_scanner_maybe_add_gtk_theme (ThemeScanner* self,
                                   const gchar* path,
                                   const gchar* theme_name,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ThemeScannerMaybeAddGtkThemeData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddGtkThemeData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_maybe_add_gtk_theme_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 1917 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_gtk_theme_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_maybe_add_gtk_theme_co (_data_);
#line 1939 "themes.c"
}


static gboolean
theme_scanner_maybe_add_gtk_theme_finish (ThemeScanner* self,
                                          GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddGtkThemeData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _data_->result;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 1955 "themes.c"
}


/**
     * Attempt to add a unique theme into the set
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1983 "themes.c"
		gchar* _tmp2_;
#line 1085 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1991 "themes.c"
	} else {
#line 1087 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = -1;
#line 1087 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1997 "themes.c"
	}
}


static gboolean
theme_scanner_maybe_add_gtk_theme_co (ThemeScannerMaybeAddGtkThemeData* _data_)
{
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 2009 "themes.c"
		goto _state_0;
		default:
#line 193 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2014 "themes.c"
	}
	_state_0:
	{
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->index = 0;
#line 2020 "themes.c"
		{
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->_tmp0_ = TRUE;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (TRUE) {
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (!_data_->_tmp0_) {
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->index;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->index = _data_->_tmp1_ + 1;
#line 2032 "themes.c"
				}
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp0_ = FALSE;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->index;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->gtk_theme_blacklist;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->gtk_theme_blacklist_length1;
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (!(_data_->_tmp2_ < _data_->_tmp3__length1)) {
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					break;
#line 2046 "themes.c"
				}
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp4_ = _data_->self->priv->gtk_theme_blacklist;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp4__length1 = _data_->self->priv->gtk_theme_blacklist_length1;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp5_ = _data_->index;
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp6_ = _data_->_tmp4_[_data_->_tmp5_];
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 196 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->blacklisted_item = _data_->_tmp7_;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp9_ = _data_->blacklisted_item;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (g_strcmp0 (_data_->_tmp9_, _data_->theme_name) == 0) {
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp8_ = TRUE;
#line 2066 "themes.c"
				} else {
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp10_ = _data_->blacklisted_item;
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp8_ = string_index_of (_data_->theme_name, _data_->_tmp10_, 0) != -1;
#line 2072 "themes.c"
				}
#line 198 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (_data_->_tmp8_) {
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->result = FALSE;
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->blacklisted_item);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					if (_data_->_state_ != 0) {
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						while (!_data_->_task_complete_) {
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2088 "themes.c"
						}
					}
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					g_object_unref (_data_->_async_result);
#line 199 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					return FALSE;
#line 2095 "themes.c"
				}
#line 195 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_g_free0 (_data_->blacklisted_item);
#line 2099 "themes.c"
			}
		}
	}
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->self->priv->gtk_themes;
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp12_ = g_hash_table_lookup (_data_->_tmp11_, _data_->theme_name);
#line 203 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp12_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp13_ = _data_->info;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp13_ == NULL) {
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp14_ = theme_info_new (THEME_TYPE_GTK_THEME);
#line 205 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp14_;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp15_ = _data_->self->priv->gtk_themes;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp16_ = g_strdup (_data_->theme_name);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp17_ = _data_->ninfo;
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp18_ = _g_object_ref0 (_data_->_tmp17_);
#line 206 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp15_, _data_->_tmp16_, _data_->_tmp18_);
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp19_ = _data_->self->priv->gtk_themes;
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp20_ = g_hash_table_lookup (_data_->_tmp19_, _data_->theme_name);
#line 207 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp20_;
#line 204 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 2135 "themes.c"
	}
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp21_ = _data_->info;
#line 209 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp21_, _data_->path)) {
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2151 "themes.c"
			}
		}
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 210 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2158 "themes.c"
	}
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2170 "themes.c"
		}
	}
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 212 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 2177 "themes.c"
}


/**
     * Return a unique list of currently known gtk themes
     */
static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2196 "themes.c"
	}
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2202 "themes.c"
}


gchar**
theme_scanner_get_gtk_themes (ThemeScanner* self,
                              int* result_length1)
{
	gchar** result = NULL;
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 218 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t = _tmp0_;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t_length1 = 0;
#line 219 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 220 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	name = NULL;
#line 221 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	info = NULL;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = self->priv->gtk_themes;
#line 223 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	while (TRUE) {
#line 2241 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		name = _tmp2_;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		info = _tmp3_;
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 224 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			break;
#line 2259 "themes.c"
		}
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5_ = t;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5__length1 = t_length1;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp6_ = name;
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp7_ = g_strconcat ("", _tmp6_, NULL);
#line 225 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_vala_array_add6 (&t, &t_length1, &_t_size_, _tmp7_);
#line 2271 "themes.c"
	}
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8_ = t;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8__length1 = t_length1;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (result_length1) {
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*result_length1 = _tmp8__length1;
#line 2281 "themes.c"
	}
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _tmp8_;
#line 227 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 2287 "themes.c"
}


/**
     * Return a unique list of currently known cursor themes
     */
static void
_vala_array_add7 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2306 "themes.c"
	}
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2312 "themes.c"
}


gchar**
theme_scanner_get_cursor_themes (ThemeScanner* self,
                                 int* result_length1)
{
	gchar** result = NULL;
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 233 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t = _tmp0_;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t_length1 = 0;
#line 234 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 235 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	name = NULL;
#line 236 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	info = NULL;
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = self->priv->cursor_themes;
#line 238 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	while (TRUE) {
#line 2351 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		name = _tmp2_;
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		info = _tmp3_;
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 239 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			break;
#line 2369 "themes.c"
		}
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5_ = t;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5__length1 = t_length1;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp6_ = name;
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp7_ = g_strconcat ("", _tmp6_, NULL);
#line 240 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_vala_array_add7 (&t, &t_length1, &_t_size_, _tmp7_);
#line 2381 "themes.c"
	}
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8_ = t;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8__length1 = t_length1;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (result_length1) {
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*result_length1 = _tmp8__length1;
#line 2391 "themes.c"
	}
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _tmp8_;
#line 242 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 2397 "themes.c"
}


/**
     * Return a unique list of currently known icon themes
     */
static void
_vala_array_add8 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2416 "themes.c"
	}
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2422 "themes.c"
}


gchar**
theme_scanner_get_icon_themes (ThemeScanner* self,
                               int* result_length1)
{
	gchar** result = NULL;
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 248 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t = _tmp0_;
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	t_length1 = 0;
#line 249 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 250 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	name = NULL;
#line 251 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	info = NULL;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = self->priv->icon_themes;
#line 253 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	while (TRUE) {
#line 2461 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		name = _tmp2_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		info = _tmp3_;
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 254 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			break;
#line 2479 "themes.c"
		}
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5_ = t;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp5__length1 = t_length1;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp6_ = name;
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_tmp7_ = g_strconcat ("", _tmp6_, NULL);
#line 255 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_vala_array_add8 (&t, &t_length1, &_t_size_, _tmp7_);
#line 2491 "themes.c"
	}
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8_ = t;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8__length1 = t_length1;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (result_length1) {
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		*result_length1 = _tmp8__length1;
#line 2501 "themes.c"
	}
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _tmp8_;
#line 257 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 2507 "themes.c"
}


static void
theme_scanner_maybe_add_icon_theme_data_free (gpointer _data)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddIconThemeData, _data_);
#line 2524 "themes.c"
}


static void
theme_scanner_maybe_add_icon_theme_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	ThemeScannerMaybeAddIconThemeData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2540 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2544 "themes.c"
}


static void
theme_scanner_maybe_add_icon_theme (ThemeScanner* self,
                                    const gchar* path,
                                    const gchar* theme_name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddIconThemeData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_maybe_add_icon_theme_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 2569 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_icon_theme_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icon_theme_co (_data_);
#line 2591 "themes.c"
}


static void
theme_scanner_maybe_add_icon_theme_finish (ThemeScanner* self,
                                           GAsyncResult* _res_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2602 "themes.c"
}


/**
     * Attempt to add cursor/icon theme to the set
     */
static void
theme_scanner_maybe_add_icon_theme_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_task_complete_ = TRUE;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icon_theme_co (_data_);
#line 2625 "themes.c"
}


static gboolean
theme_scanner_maybe_add_icon_theme_co (ThemeScannerMaybeAddIconThemeData* _data_)
{
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 2636 "themes.c"
		goto _state_0;
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 1:
#line 2640 "themes.c"
		goto _state_1;
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 2:
#line 2644 "themes.c"
		goto _state_2;
		default:
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2649 "themes.c"
	}
	_state_0:
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp0_ = g_strdup_printf ("%s%s%s", _data_->path, G_DIR_SEPARATOR_S, "index.theme");
#line 265 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->test_path = _data_->_tmp0_;
#line 266 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp1_ = _data_->test_path;
#line 266 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (!g_file_test (_data_->_tmp1_, G_FILE_TEST_EXISTS)) {
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2670 "themes.c"
			}
		}
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 267 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2677 "themes.c"
	}
#line 269 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->icon_theme = TRUE;
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp2_ = g_key_file_new ();
#line 271 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->f = _data_->_tmp2_;
#line 2685 "themes.c"
	{
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp3_ = _data_->f;
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp4_ = _data_->test_path;
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_key_file_load_from_file (_data_->_tmp3_, _data_->_tmp4_, G_KEY_FILE_NONE, &_data_->_inner_error0_);
#line 274 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2695 "themes.c"
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->e = _data_->_inner_error0_;
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_inner_error0_ = NULL;
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_error_free0 (_data_->e);
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2720 "themes.c"
			}
		}
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 276 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2727 "themes.c"
	}
	__finally21:
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 273 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2744 "themes.c"
	}
	{
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->f;
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp5_ = g_key_file_has_key (_data_->_tmp6_, "Icon Theme", "Directories", &_data_->_inner_error0_);
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2753 "themes.c"
			goto __catch22_g_error;
		}
#line 280 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (!_data_->_tmp5_) {
#line 281 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->icon_theme = FALSE;
#line 2760 "themes.c"
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_inner_error0_ = NULL;
#line 284 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->icon_theme = FALSE;
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 2774 "themes.c"
	}
	__finally22:
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 279 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2791 "themes.c"
	}
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp7_ = _data_->icon_theme;
#line 287 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp7_) {
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_state_ = 1;
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icons (_data_->self, _data_->path, _data_->theme_name, theme_scanner_maybe_add_icon_theme_ready, _data_);
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2803 "themes.c"
		_state_1:
#line 288 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icons_finish (_data_->self, _data_->_res_);
#line 2807 "themes.c"
	}
#line 292 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp8_ = g_strdup_printf ("%s%s%s", _data_->path, G_DIR_SEPARATOR_S, "cursors");
#line 292 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->cursor_path = _data_->_tmp8_;
#line 293 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp9_ = _data_->cursor_path;
#line 293 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (g_file_test (_data_->_tmp9_, G_FILE_TEST_EXISTS)) {
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_state_ = 2;
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_cursors (_data_->self, _data_->path, _data_->theme_name, theme_scanner_maybe_add_icon_theme_ready, _data_);
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 2823 "themes.c"
		_state_2:
#line 294 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		theme_scanner_maybe_add_cursors_finish (_data_->self, _data_->_res_);
#line 2827 "themes.c"
	}
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->cursor_path);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_key_file_unref0 (_data_->f);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->test_path);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2843 "themes.c"
		}
	}
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 263 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 2850 "themes.c"
}


static void
theme_scanner_maybe_add_cursors_data_free (gpointer _data)
{
	ThemeScannerMaybeAddCursorsData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddCursorsData, _data_);
#line 2867 "themes.c"
}


static void
theme_scanner_maybe_add_cursors_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	ThemeScannerMaybeAddCursorsData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2883 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2887 "themes.c"
}


static void
theme_scanner_maybe_add_cursors (ThemeScanner* self,
                                 const gchar* path,
                                 const gchar* theme_name,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	ThemeScannerMaybeAddCursorsData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddCursorsData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_maybe_add_cursors_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 2912 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_cursors_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_maybe_add_cursors_co (_data_);
#line 2934 "themes.c"
}


static gboolean
theme_scanner_maybe_add_cursors_finish (ThemeScanner* self,
                                        GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddCursorsData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _data_->result;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 2950 "themes.c"
}


/**
     * Try adding unique cursor theme
     */
static gboolean
theme_scanner_maybe_add_cursors_co (ThemeScannerMaybeAddCursorsData* _data_)
{
#line 301 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 301 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 2964 "themes.c"
		goto _state_0;
		default:
#line 301 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2969 "themes.c"
	}
	_state_0:
#line 303 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp0_ = _data_->self->priv->cursor_themes;
#line 303 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp1_ = g_hash_table_lookup (_data_->_tmp0_, _data_->theme_name);
#line 303 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp1_;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp2_ = _data_->info;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp2_ == NULL) {
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp3_ = theme_info_new (THEME_TYPE_CURSOR_THEME);
#line 305 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp3_;
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp4_ = _data_->self->priv->cursor_themes;
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp5_ = g_strdup (_data_->theme_name);
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->ninfo;
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
#line 306 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp4_, _data_->_tmp5_, _data_->_tmp7_);
#line 307 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp8_ = _data_->self->priv->cursor_themes;
#line 307 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp9_ = g_hash_table_lookup (_data_->_tmp8_, _data_->theme_name);
#line 307 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp9_;
#line 304 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 3004 "themes.c"
	}
#line 309 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp10_ = _data_->info;
#line 309 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp10_, _data_->path)) {
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3020 "themes.c"
			}
		}
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 310 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 3027 "themes.c"
	}
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3039 "themes.c"
		}
	}
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 312 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 3046 "themes.c"
}


static void
theme_scanner_maybe_add_icons_data_free (gpointer _data)
{
	ThemeScannerMaybeAddIconsData* _data_;
	_data_ = _data;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddIconsData, _data_);
#line 3063 "themes.c"
}


static void
theme_scanner_maybe_add_icons_async_ready_wrapper (GObject *source_object,
                                                   GAsyncResult *res,
                                                   void *user_data)
{
	ThemeScannerMaybeAddIconsData* _task_data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_task_data_->_callback_ != NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3079 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3083 "themes.c"
}


static void
theme_scanner_maybe_add_icons (ThemeScanner* self,
                               const gchar* path,
                               const gchar* theme_name,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ThemeScannerMaybeAddIconsData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddIconsData);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_callback_ = _callback_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, theme_scanner_maybe_add_icons_async_ready_wrapper, _user_data_);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_callback_ == NULL) {
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_task_complete_ = TRUE;
#line 3108 "themes.c"
	}
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_icons_data_free);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icons_co (_data_);
#line 3130 "themes.c"
}


static gboolean
theme_scanner_maybe_add_icons_finish (ThemeScanner* self,
                                      GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddIconsData* _data_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	result = _data_->result;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return result;
#line 3146 "themes.c"
}


/**
     * Try adding unique icon theme
     */
static gboolean
theme_scanner_maybe_add_icons_co (ThemeScannerMaybeAddIconsData* _data_)
{
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		case 0:
#line 3160 "themes.c"
		goto _state_0;
		default:
#line 318 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 3165 "themes.c"
	}
	_state_0:
	{
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->index = 0;
#line 3171 "themes.c"
		{
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			_data_->_tmp0_ = TRUE;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (TRUE) {
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (!_data_->_tmp0_) {
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->index;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->index = _data_->_tmp1_ + 1;
#line 3183 "themes.c"
				}
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp0_ = FALSE;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->index;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->icon_theme_blacklist;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->icon_theme_blacklist_length1;
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (!(_data_->_tmp2_ < _data_->_tmp3__length1)) {
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					break;
#line 3197 "themes.c"
				}
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp4_ = _data_->self->priv->icon_theme_blacklist;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp4__length1 = _data_->self->priv->icon_theme_blacklist_length1;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp5_ = _data_->index;
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp6_ = _data_->_tmp4_[_data_->_tmp5_];
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 321 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->blacklisted_item = _data_->_tmp7_;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_data_->_tmp9_ = _data_->blacklisted_item;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (g_strcmp0 (_data_->_tmp9_, _data_->theme_name) == 0) {
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp8_ = TRUE;
#line 3217 "themes.c"
				} else {
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp10_ = _data_->blacklisted_item;
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->_tmp8_ = string_index_of (_data_->theme_name, _data_->_tmp10_, 0) != -1;
#line 3223 "themes.c"
				}
#line 323 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				if (_data_->_tmp8_) {
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_data_->result = FALSE;
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					_g_free0 (_data_->blacklisted_item);
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					if (_data_->_state_ != 0) {
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
						while (!_data_->_task_complete_) {
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3239 "themes.c"
						}
					}
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					g_object_unref (_data_->_async_result);
#line 324 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
					return FALSE;
#line 3246 "themes.c"
				}
#line 320 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				_g_free0 (_data_->blacklisted_item);
#line 3250 "themes.c"
			}
		}
	}
#line 328 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->self->priv->icon_themes;
#line 328 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp12_ = g_hash_table_lookup (_data_->_tmp11_, _data_->theme_name);
#line 328 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp12_;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp13_ = _data_->info;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_tmp13_ == NULL) {
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp14_ = theme_info_new (THEME_TYPE_ICON_THEME);
#line 330 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp14_;
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp15_ = _data_->self->priv->icon_themes;
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp16_ = g_strdup (_data_->theme_name);
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp17_ = _data_->ninfo;
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp18_ = _g_object_ref0 (_data_->_tmp17_);
#line 331 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp15_, _data_->_tmp16_, _data_->_tmp18_);
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp19_ = _data_->self->priv->icon_themes;
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->_tmp20_ = g_hash_table_lookup (_data_->_tmp19_, _data_->theme_name);
#line 332 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp20_;
#line 329 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 3286 "themes.c"
	}
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->_tmp21_ = _data_->info;
#line 334 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp21_, _data_->path)) {
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			while (!_data_->_task_complete_) {
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3302 "themes.c"
			}
		}
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 335 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		return FALSE;
#line 3309 "themes.c"
	}
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
		while (!_data_->_task_complete_) {
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3321 "themes.c"
		}
	}
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 337 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	return FALSE;
#line 3328 "themes.c"
}


static void
theme_scanner_class_init (ThemeScannerClass * klass)
{
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	theme_scanner_parent_class = g_type_class_peek_parent (klass);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	g_type_class_add_private (klass, sizeof (ThemeScannerPrivate));
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_scanner_finalize;
#line 3341 "themes.c"
}


static void
theme_scanner_instance_init (ThemeScanner * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv = THEME_SCANNER_GET_PRIVATE (self);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths = NULL;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths_length1 = 0;
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_xdg_paths_size_ = self->priv->xdg_paths_length1;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp0_ = g_strdup ("Adwaita");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp1_ = g_strdup ("Breeze");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp2_ = g_strdup ("Clearlooks");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp3_ = g_strdup ("Crux");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp4_ = g_strdup ("Emacs");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp5_ = g_strdup ("Industrial");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp6_ = g_strdup ("Mist");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp7_ = g_strdup ("Raleigh");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp8_ = g_strdup ("Redmond");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp9_ = g_strdup ("ThinIce");
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_ = g_new0 (gchar*, 10 + 1);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[0] = _tmp0_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[1] = _tmp1_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[2] = _tmp2_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[3] = _tmp3_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[4] = _tmp4_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[5] = _tmp5_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[6] = _tmp6_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[7] = _tmp7_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[8] = _tmp8_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp10_[9] = _tmp9_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist = _tmp10_;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist_length1 = 10;
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_gtk_theme_blacklist_size_ = self->priv->gtk_theme_blacklist_length1;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp11_ = g_strdup ("breeze");
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp12_ = g_strdup ("Papirus-Adapta");
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp13_ = g_strdup ("Papirus-Adapta-Nokto");
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp14_ = g_strdup ("solus-sc");
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_ = g_new0 (gchar*, 4 + 1);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_[0] = _tmp11_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_[1] = _tmp12_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_[2] = _tmp13_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp15_[3] = _tmp14_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist = _tmp15_;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist_length1 = 4;
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_icon_theme_blacklist_size_ = self->priv->icon_theme_blacklist_length1;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp16_ = g_strdup ("themes");
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp17_ = g_strdup ("icons");
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp18_ = g_new0 (gchar*, 2 + 1);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp18_[0] = _tmp16_;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp18_[1] = _tmp17_;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->normal_suffixes = _tmp18_;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->normal_suffixes_length1 = 2;
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_normal_suffixes_size_ = self->priv->normal_suffixes_length1;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp19_ = g_strdup (".themes");
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp20_ = g_strdup (".icons");
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp21_ = g_new0 (gchar*, 2 + 1);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp21_[0] = _tmp19_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_tmp21_[1] = _tmp20_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->legacy_suffixes = _tmp21_;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->legacy_suffixes_length1 = 2;
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_legacy_suffixes_size_ = self->priv->legacy_suffixes_length1;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = NULL;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths_length1 = 0;
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->_gtk_theme_paths_size_ = self->priv->gtk_theme_paths_length1;
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_themes = NULL;
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->cursor_themes = NULL;
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->icon_themes = NULL;
#line 3494 "themes.c"
}


static void
theme_scanner_finalize (GObject * obj)
{
	ThemeScanner * self;
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_SCANNER, ThemeScanner);
#line 51 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->xdg_paths = (_vala_array_free (self->priv->xdg_paths, self->priv->xdg_paths_length1, (GDestroyNotify) g_free), NULL);
#line 53 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist = (_vala_array_free (self->priv->gtk_theme_blacklist, self->priv->gtk_theme_blacklist_length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist = (_vala_array_free (self->priv->icon_theme_blacklist, self->priv->icon_theme_blacklist_length1, (GDestroyNotify) g_free), NULL);
#line 73 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->normal_suffixes = (_vala_array_free (self->priv->normal_suffixes, self->priv->normal_suffixes_length1, (GDestroyNotify) g_free), NULL);
#line 78 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->legacy_suffixes = (_vala_array_free (self->priv->legacy_suffixes, self->priv->legacy_suffixes_length1, (GDestroyNotify) g_free), NULL);
#line 83 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = (_vala_array_free (self->priv->gtk_theme_paths, self->priv->gtk_theme_paths_length1, (GDestroyNotify) g_free), NULL);
#line 85 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->gtk_themes);
#line 86 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->cursor_themes);
#line 87 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->icon_themes);
#line 49 "/builddir/build/BUILD/budgie-desktop-10.5.1/src/panel/settings/themes.vala"
	G_OBJECT_CLASS (theme_scanner_parent_class)->finalize (obj);
#line 3524 "themes.c"
}


GType
theme_scanner_get_type (void)
{
	static volatile gsize theme_scanner_type_id__volatile = 0;
	if (g_once_init_enter (&theme_scanner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeScanner), 0, (GInstanceInitFunc) theme_scanner_instance_init, NULL };
		GType theme_scanner_type_id;
		theme_scanner_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeScanner", &g_define_type_info, 0);
		g_once_init_leave (&theme_scanner_type_id__volatile, theme_scanner_type_id);
	}
	return theme_scanner_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



